/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/network","vs/nls","vs/nls!vs/server/remoteExtensionHostAgent","vs/base/common/errors","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/node/pfs","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/files/common/files","vs/base/common/process","vs/base/common/uuid","os","vs/base/common/cancellation","vs/base/common/extpath","vs/base/common/map","fs","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/configuration/common/configuration","child_process","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetry","vs/base/common/json","vs/base/common/codicons","vs/platform/configuration/common/configurationRegistry","vs/server/remoteUriTransformer","vs/base/common/stream","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/platform/product/common/productService","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/performance","vs/base/common/semver/semver","vs/base/parts/ipc/node/ipc.net","vs/base/common/iterator","vs/base/common/labels","vs/base/common/mime","vs/base/common/uriIpc","vs/editor/common/core/range","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","crypto","vs/platform/files/node/diskFileSystemProvider","vs/platform/request/common/request","url","vs/platform/telemetry/common/telemetryUtils","vs/server/serverEnvironmentService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/severity","vs/base/common/htmlContent","vs/base/common/normalization","vs/base/node/decoder","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/node/processes","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/localizations/node/localizations","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/files/common/fileService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/server/remoteLanguagePacks","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/editor/common/editorService","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/filters","vs/base/common/iconLabels","vs/base/node/languagePacks","vs/base/node/macAddress","util","vs/base/node/extpath","vs/base/node/ports","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/editor/common/modes/languageSelector","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/remoteAgentEnvironmentImpl","vs/nls!vs/server/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/common/ipcFileSystemProvider","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/editor/common/modes","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/argvHelper","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/workspaces/common/workspaces","vs/server/remoteExtensionManagement","vs/server/remoteAgentFileSystemImpl","vs/server/webClientServer","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/testing/common/testId","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/node/extensionPoints","vs/server/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/remoteTerminalChannel","vs/server/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","cookie","vs/base/common/marked/marked","yauzl","yazl","http","vs/server/remoteExtensionHostAgent"],ge=function(Q){for(var e=[],S=0,_=Q.length;S<_;S++)e[S]=me[Q[S]];return e};define(me[110],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class S{static get(){const g=new Map,k=new Map,C=new Map,D=new Map;function d(b,o){b.has(o.detail)||b.set(o.detail,-o.timestamp)}function y(b,o){let u=b.get(o.detail);!u||u>=0||b.set(o.detail,u+o.timestamp)}const i=Q.getStats().slice(0).sort((b,o)=>b.timestamp-o.timestamp);for(const b of i)switch(b.type){case 10:d(g,b);break;case 11:case 12:y(g,b);break;case 21:d(k,b);break;case 22:y(k,b);break;case 33:d(C,b);break;case 34:y(C,b);break;case 31:d(D,b);break;case 32:y(D,b);break}let A=0;C.forEach(b=>A+=b);function E(b){let o=[];return b.forEach((u,w)=>o.push([w,u])),o}return{amdLoad:E(g),amdInvoke:E(k),nodeRequire:E(C),nodeEval:E(D),nodeRequireTotal:A}}static toMarkdownTable(g,k){let C="",D=[];return g.forEach((d,y)=>{D[y]=d.length}),k.forEach(d=>{d.forEach((y,i)=>{typeof y=="undefined"&&(y=d[i]="-");const A=y.toString().length;D[i]=Math.max(A,D[i])})}),g.forEach((d,y)=>{C+=`| ${d+" ".repeat(D[y]-d.toString().length)} `}),C+=`|
`,g.forEach((d,y)=>{C+=`| ${"-".repeat(D[y])} `}),C+=`|
`,k.forEach(d=>{d.forEach((y,i)=>{typeof y!="undefined"&&(C+=`| ${y+" ".repeat(D[i]-y.toString().length)} `)}),C+=`|
`}),C}}e.LoaderStats=S}),define(me[111],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(_,g){if(!_)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=S}),define(me[71],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(C){return(D,d,y)=>{let i=null,A=null;if(typeof y.value=="function"?(i="value",A=y.value):typeof y.get=="function"&&(i="get",A=y.get),!A)throw new Error("not supported");y[i]=C(A,d)}}e.createDecorator=S;function _(C,D,d){let y=null,i=null;if(typeof d.value=="function"?(y="value",i=d.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(y="get",i=d.get),!i)throw new Error("not supported");const A=`$memoize$${D}`;d[y]=function(...E){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,E)}),this[A]}}e.memoize=_;function g(C,D,d){return S((y,i)=>{const A=`$debounce$${i}`,E=`$debounce$result$${i}`;return function(...b){this[E]||(this[E]=d?d():void 0),clearTimeout(this[A]),D&&(this[E]=D(this[E],...b),b=[this[E]]),this[A]=setTimeout(()=>{y.apply(this,b),this[E]=d?d():void 0},C)}})}e.debounce=g;function k(C,D,d){return S((y,i)=>{const A=`$throttle$timer$${i}`,E=`$throttle$result$${i}`,b=`$throttle$lastRun$${i}`,o=`$throttle$pending$${i}`;return function(...u){if(this[E]||(this[E]=d?d():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),D&&(this[E]=D(this[E],...u)),this[o])return;const w=this[b]+C;w<=Date.now()?(this[b]=Date.now(),y.apply(this,[this[E]]),this[E]=d?d():void 0):(this[o]=!0,this[A]=setTimeout(()=>{this[o]=!1,this[b]=Date.now(),y.apply(this,[this[E]]),this[E]=d?d():void 0},w-Date.now()))}})}e.throttle=k}),define(me[11],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=S,e.errorHandler=new S;function _(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=_;function g(a){d(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=g;function k(a){d(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=k;function C(a){if(a instanceof Error){let{name:t,message:s}=a;const n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:n}}return a}e.transformErrorForSerialization=C;const D="Canceled";function d(a){return a instanceof Error&&a.name===D&&a.message===D}e.isPromiseCanceledError=d;class y extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=y;function i(){const a=new Error(D);return a.name=a.message,a}e.canceled=i;function A(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=A;function E(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=E;function b(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function o(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function u(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=u;class w extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=w;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class h extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=h;function f(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function c(a,t=Object.create(null)){const s=new Error(a);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=c}),define(me[20],ge([0,1,11]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function _(q,W=0){return q[q.length-(1+W)]}e.tail=_;function g(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=g;function k(q,W,U=(ie,ne)=>ie===ne){if(q===W)return!0;if(!q||!W||q.length!==W.length)return!1;for(let ie=0,ne=q.length;ie<ne;ie++)if(!U(q[ie],W[ie]))return!1;return!0}e.equals=k;function C(q,W,U){let ie=0,ne=q.length-1;for(;ie<=ne;){const he=(ie+ne)/2|0,ve=U(q[he],W);if(ve<0)ie=he+1;else if(ve>0)ne=he-1;else return he}return-(ie+1)}e.binarySearch=C;function D(q,W){let U=0,ie=q.length;if(ie===0)return 0;for(;U<ie;){const ne=Math.floor((U+ie)/2);W(q[ne])?ie=ne:U=ne+1}return U}e.findFirstInSorted=D;function d(q,W,U){if(q=q|0,q>=W.length)throw new TypeError("invalid index");let ie=W[Math.floor(W.length*Math.random())],ne=[],he=[],ve=[];for(let Ae of W){const Ie=U(Ae,ie);Ie<0?ne.push(Ae):Ie>0?he.push(Ae):ve.push(Ae)}return q<ne.length?d(q,ne,U):q<ne.length+ve.length?ve[0]:d(q-(ne.length+ve.length),he,U)}e.quickSelect=d;function y(q,W){const U=[];let ie;for(const ne of q.slice(0).sort(W))!ie||W(ie[0],ne)!==0?(ie=[ne],U.push(ie)):ie.push(ne);return U}e.groupBy=y;function i(q,W,U){const ie=[];function ne(Ae,Ie,Ue){if(Ie===0&&Ue.length===0)return;const qe=ie[ie.length-1];qe&&qe.start+qe.deleteCount===Ae?(qe.deleteCount+=Ie,qe.toInsert.push(...Ue)):ie.push({start:Ae,deleteCount:Ie,toInsert:Ue})}let he=0,ve=0;for(;;){if(he===q.length){ne(he,0,W.slice(ve));break}if(ve===W.length){ne(he,q.length-he,[]);break}const Ae=q[he],Ie=W[ve],Ue=U(Ae,Ie);Ue===0?(he+=1,ve+=1):Ue<0?(ne(he,1,[]),he+=1):Ue>0&&(ne(he,0,[Ie]),ve+=1)}return ie}e.sortedDiff=i;function A(q,W,U){const ie=i(q,W,U),ne=[],he=[];for(const ve of ie)ne.push(...q.slice(ve.start,ve.start+ve.deleteCount)),he.push(...ve.toInsert);return{removed:ne,added:he}}e.delta=A;function E(q,W,U){if(U===0)return[];const ie=q.slice(0,U).sort(W);return o(q,W,ie,U,q.length),ie}e.top=E;function b(q,W,U,ie,ne){return U===0?Promise.resolve([]):new Promise((he,ve)=>{(async()=>{const Ae=q.length,Ie=q.slice(0,U).sort(W);for(let Ue=U,qe=Math.min(U+ie,Ae);Ue<Ae;Ue=qe,qe=Math.min(qe+ie,Ae)){if(Ue>U&&await new Promise(Ge=>setTimeout(Ge)),ne&&ne.isCancellationRequested)throw(0,S.canceled)();o(q,W,Ie,Ue,qe)}return Ie})().then(he,ve)})}e.topAsync=b;function o(q,W,U,ie,ne){for(const he=U.length;ie<ne;ie++){const ve=q[ie];if(W(ve,U[he-1])<0){U.pop();const Ae=D(U,Ie=>W(ve,Ie)<0);U.splice(Ae,0,ve)}}}function u(q){return q.filter(W=>!!W)}e.coalesce=u;function w(q){let W=0;for(let U=0;U<q.length;U++)q[U]&&(q[W]=q[U],W+=1);q.length=W}e.coalesceInPlace=w;function p(q,W,U){q.splice(U,0,q.splice(W,1)[0])}e.move=p;function h(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=h;function f(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=f;function c(q,W){if(!W)return q.filter((ie,ne)=>q.indexOf(ie)===ne);const U=Object.create(null);return q.filter(ie=>{const ne=W(ie);return U[ne]?!1:(U[ne]=!0,!0)})}e.distinct=c;function a(q){const W=new Set;return q.filter(U=>W.has(U)?!1:(W.add(U),!0))}e.distinctES6=a;function t(q){const W=Object.create(null);return U=>{const ie=q(U);return W[ie]?!1:(W[ie]=!0,!0)}}e.uniqueFilter=t;function s(q,W){for(let U=q.length-1;U>=0;U--){const ie=q[U];if(W(ie))return U}return-1}e.lastIndex=s;function n(q,W){return q.length>0?q[0]:W}e.firstOrDefault=n;function r(q,W,U=(ie,ne)=>ie===ne){let ie=0;for(let ne=0,he=Math.min(q.length,W.length);ne<he&&U(q[ne],W[ne]);ne++)ie++;return ie}e.commonPrefixLength=r;function l(q){return[].concat(...q)}e.flatten=l;function v(q,W){let U=typeof W=="number"?q:0;typeof W=="number"?U=q:(U=0,W=q);const ie=[];if(U<=W)for(let ne=U;ne<W;ne++)ie.push(ne);else for(let ne=U;ne>W;ne--)ie.push(ne);return ie}e.range=v;function P(q,W,U){return q.reduce((ie,ne)=>(ie[W(ne)]=U?U(ne):ne,ie),Object.create(null))}e.index=P;function L(q,W){return q.push(W),()=>R(q,W)}e.insert=L;function R(q,W){const U=q.indexOf(W);if(U>-1)return q.splice(U,1),W}e.remove=R;function m(q,W,U){const ie=q.slice(0,W),ne=q.slice(W);return ie.concat(U,ne)}e.arrayInsert=m;function T(q,W){let U;if(typeof W=="number"){let ie=W;U=()=>{const ne=Math.sin(ie++)*179426549;return ne-Math.floor(ne)}}else U=Math.random;for(let ie=q.length-1;ie>0;ie-=1){const ne=Math.floor(U()*(ie+1)),he=q[ie];q[ie]=q[ne],q[ne]=he}}e.shuffle=T;function I(q,W){const U=q.indexOf(W);U>-1&&(q.splice(U,1),q.unshift(W))}e.pushToStart=I;function B(q,W){const U=q.indexOf(W);U>-1&&(q.splice(U,1),q.push(W))}e.pushToEnd=B;function j(q,W){return Array.isArray(q)?q.map(W):W(q)}e.mapArrayOrNot=j;function ue(q){return Array.isArray(q)?q:[q]}e.asArray=ue;function ce(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=ce;function O(q,W){for(const U of q){const ie=W(U);if(ie!==void 0)return ie}}e.mapFind=O;function $(q,W,U){const ie=ee(q,W),ne=q.length,he=U.length;q.length=ne+he;for(let ve=ne-1;ve>=ie;ve--)q[ve+he]=q[ve];for(let ve=0;ve<he;ve++)q[ve+ie]=U[ve]}e.insertInto=$;function z(q,W,U,ie){const ne=ee(q,W),he=q.splice(ne,U);return $(q,ne,ie),he}e.splice=z;function ee(q,W){return W<0?Math.max(W+q.length,0):Math.min(W,q.length)}function J(q,W){let U=Number.MAX_SAFE_INTEGER,ie=0;return q.forEach((ne,he)=>{const ve=W(ne);ve<U&&(U=ve,ie=he)}),ie}e.minIndex=J;function H(q,W){let U=Number.MIN_SAFE_INTEGER,ie=0;return q.forEach((ne,he)=>{const ve=W(ne);ve>U&&(U=ve,ie=he)}),ie}e.maxIndex=H;class X{constructor(W){this.items=W,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(W){let U=this.firstIdx;for(;U<this.items.length&&W(this.items[U]);)U++;const ie=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,ie}takeFromEndWhile(W){let U=this.lastIdx;for(;U>=0&&W(this.items[U]);)U--;const ie=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,ie}}e.ArrayQueue=X}),define(me[72],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(_){const g=this;let k=!1,C;return function(){return k||(k=!0,C=_.apply(g,arguments)),C}}e.once=S}),define(me[51],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(_){function g(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}_.is=g;const k=Object.freeze([]);function C(){return k}_.empty=C;function*D(a){yield a}_.single=D;function d(a){return a||k}_.from=d;function y(a){return!a||a[Symbol.iterator]().next().done===!0}_.isEmpty=y;function i(a){return a[Symbol.iterator]().next().value}_.first=i;function A(a,t){for(const s of a)if(t(s))return!0;return!1}_.some=A;function E(a,t){for(const s of a)if(t(s))return s}_.find=E;function*b(a,t){for(const s of a)t(s)&&(yield s)}_.filter=b;function*o(a,t){let s=0;for(const n of a)yield t(n,s++)}_.map=o;function*u(...a){for(const t of a)for(const s of t)yield s}_.concat=u;function*w(a){for(const t of a)for(const s of t)yield s}_.concatNested=w;function p(a,t,s){let n=s;for(const r of a)n=t(n,r);return n}_.reduce=p;function*h(a,t,s=a.length){for(t<0&&(t+=a.length),s<0?s+=a.length:s>a.length&&(s=a.length);t<s;t++)yield a[t]}_.slice=h;function f(a,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,a];const n=a[Symbol.iterator]();for(let r=0;r<t;r++){const l=n.next();if(l.done)return[s,_.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return n}}]}_.consume=f;function c(a,t,s=(n,r)=>n===r){const n=a[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const l=n.next(),v=r.next();if(l.done!==v.done)return!1;if(l.done)return!0;if(!s(l.value,v.value))return!1}}_.equals=c})(S=e.Iterable||(e.Iterable={}))}),define(me[38],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var _;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(_=e.SyntaxKind||(e.SyntaxKind={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function C(t,s=!1){let n=0,r=t.length,l="",v=0,P=16,L=0;function R(ce){let O=0,$=0;for(;O<ce;){const z=t.charCodeAt(n);if(z>=48&&z<=57)$=$*16+z-48;else if(z>=65&&z<=70)$=$*16+z-65+10;else if(z>=97&&z<=102)$=$*16+z-97+10;else break;n++,O++}return O<ce&&($=-1),$}function m(ce){n=ce,l="",v=0,P=16,L=0}function T(){const ce=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&y(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&y(t.charCodeAt(n)))for(n++;n<t.length&&y(t.charCodeAt(n));)n++;else return L=3,t.substring(ce,n);let O=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&y(t.charCodeAt(n))){for(n++;n<t.length&&y(t.charCodeAt(n));)n++;O=n}else L=3;return t.substring(ce,O)}function I(){let ce="",O=n;for(;;){if(n>=r){ce+=t.substring(O,n),L=2;break}const $=t.charCodeAt(n);if($===34){ce+=t.substring(O,n),n++;break}if($===92){if(ce+=t.substring(O,n),n++,n>=r){L=2;break}switch(t.charCodeAt(n++)){case 34:ce+='"';break;case 92:ce+="\\";break;case 47:ce+="/";break;case 98:ce+="\b";break;case 102:ce+="\f";break;case 110:ce+=`
`;break;case 114:ce+="\r";break;case 116:ce+="	";break;case 117:const ee=R(4);ee>=0?ce+=String.fromCharCode(ee):L=4;break;default:L=5}O=n;continue}if($>=0&&$<=31)if(d($)){ce+=t.substring(O,n),L=2;break}else L=6;n++}return ce}function B(){if(l="",L=0,v=n,n>=r)return v=r,P=17;let ce=t.charCodeAt(n);if(D(ce)){do n++,l+=String.fromCharCode(ce),ce=t.charCodeAt(n);while(D(ce));return P=15}if(d(ce))return n++,l+=String.fromCharCode(ce),ce===13&&t.charCodeAt(n)===10&&(n++,l+=`
`),P=14;switch(ce){case 123:return n++,P=1;case 125:return n++,P=2;case 91:return n++,P=3;case 93:return n++,P=4;case 58:return n++,P=6;case 44:return n++,P=5;case 34:return n++,l=I(),P=10;case 47:const O=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<r&&!d(t.charCodeAt(n));)n++;return l=t.substring(O,n),P=12}if(t.charCodeAt(n+1)===42){n+=2;const $=r-1;let z=!1;for(;n<$;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,z=!0;break}n++}return z||(n++,L=1),l=t.substring(O,n),P=13}return l+=String.fromCharCode(ce),n++,P=16;case 45:if(l+=String.fromCharCode(ce),n++,n===r||!y(t.charCodeAt(n)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=T(),P=11;default:for(;n<r&&j(ce);)n++,ce=t.charCodeAt(n);if(v!==n){switch(l=t.substring(v,n),l){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return l+=String.fromCharCode(ce),n++,P=16}}function j(ce){if(D(ce)||d(ce))return!1;switch(ce){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let ce;do ce=B();while(ce>=12&&ce<=15);return ce}return{setPosition:m,getPosition:()=>n,scan:s?ue:B,getToken:()=>P,getTokenValue:()=>l,getTokenOffset:()=>v,getTokenLength:()=>n-v,getTokenError:()=>L}}e.createScanner=C;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function A(t,s){const n=[],r=new Object;let l;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function L(R,m,T,I){v.value=R,v.offset=m,v.length=T,v.type=I,v.colonOffset=void 0,l=v}try{f(t,{onObjectBegin:(R,m)=>{if(s<=R)throw r;l=void 0,P=s>R,n.push("")},onObjectProperty:(R,m,T)=>{if(s<m||(L(R,m,T,"property"),n[n.length-1]=R,s<=m+T))throw r},onObjectEnd:(R,m)=>{if(s<=R)throw r;l=void 0,n.pop()},onArrayBegin:(R,m)=>{if(s<=R)throw r;l=void 0,n.push(0)},onArrayEnd:(R,m)=>{if(s<=R)throw r;l=void 0,n.pop()},onLiteralValue:(R,m,T)=>{if(s<m||(L(R,m,T,a(R)),s<=m+T))throw r},onSeparator:(R,m,T)=>{if(s<=m)throw r;if(R===":"&&l&&l.type==="property")l.colonOffset=m,P=!1,l=void 0;else if(R===","){const I=n[n.length-1];typeof I=="number"?n[n.length-1]=I+1:(P=!0,n[n.length-1]=""),l=void 0}}})}catch(R){if(R!==r)throw R}return{path:n,previousNode:l,isAtPropertyKey:P,matches:R=>{let m=0;for(let T=0;m<R.length&&T<n.length;T++)if(R[m]===n[T]||R[m]==="*")m++;else if(R[m]!=="**")return!1;return m===R.length}}}e.getLocation=A;function E(t,s=[],n=k.DEFAULT){let r=null,l=[];const v=[];function P(R){Array.isArray(l)?l.push(R):r!==null&&(l[r]=R)}return f(t,{onObjectBegin:()=>{const R={};P(R),v.push(l),l=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{l=v.pop()},onArrayBegin:()=>{const R=[];P(R),v.push(l),l=R,r=null},onArrayEnd:()=>{l=v.pop()},onLiteralValue:P,onError:(R,m,T)=>{s.push({error:R,offset:m,length:T})}},n),l[0]}e.parse=E;function b(t,s=[],n=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function v(R){return r.children.push(R),R}f(t,{onObjectBegin:R=>{r=v({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,m,T)=>{r=v({type:"property",offset:m,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:m,length:T,parent:r})},onObjectEnd:(R,m)=>{r.length=R+m-r.offset,r=r.parent,l(R+m)},onArrayBegin:(R,m)=>{r=v({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,m)=>{r.length=R+m-r.offset,r=r.parent,l(R+m)},onLiteralValue:(R,m,T)=>{v({type:a(R),offset:m,length:T,parent:r,value:R}),l(m+T)},onSeparator:(R,m,T)=>{r.type==="property"&&(R===":"?r.colonOffset=m:R===","&&l(m))},onError:(R,m,T)=>{s.push({error:R,offset:m,length:T})}},n);const L=r.children[0];return L&&delete L.parent,L}e.parseTree=b;function o(t,s){if(!t)return;let n=t;for(let r of s)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const v of n.children)if(Array.isArray(v.children)&&v.children[0].value===r){n=v.children[1],l=!0;break}if(!l)return}else{const l=r;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}e.findNodeAtLocation=o;function u(t){if(!t.parent||!t.parent.children)return[];const s=u(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;s.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&s.push(n)}return s}e.getNodePath=u;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const s=Object.create(null);for(let n of t.children){const r=n.children[1];r&&(s[n.children[0].value]=w(r))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function p(t,s,n=!1){return s>=t.offset&&s<t.offset+t.length||n&&s===t.offset+t.length}e.contains=p;function h(t,s,n=!1){if(p(t,s,n)){const r=t.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=s;l++){const v=h(r[l],s,n);if(v)return v}return t}}e.findNodeAtOffset=h;function f(t,s,n=k.DEFAULT){const r=C(t,!1);function l(U){return U?()=>U(r.getTokenOffset(),r.getTokenLength()):()=>!0}function v(U){return U?ie=>U(ie,r.getTokenOffset(),r.getTokenLength()):()=>!0}const P=l(s.onObjectBegin),L=v(s.onObjectProperty),R=l(s.onObjectEnd),m=l(s.onArrayBegin),T=l(s.onArrayEnd),I=v(s.onLiteralValue),B=v(s.onSeparator),j=l(s.onComment),ue=v(s.onError),ce=n&&n.disallowComments,O=n&&n.allowTrailingComma;function $(){for(;;){const U=r.scan();switch(r.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:ce||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(U){case 12:case 13:ce?z(10):j();break;case 16:z(1);break;case 15:case 14:break;default:return U}}}function z(U,ie=[],ne=[]){if(ue(U),ie.length+ne.length>0){let he=r.getToken();for(;he!==17;){if(ie.indexOf(he)!==-1){$();break}else if(ne.indexOf(he)!==-1)break;he=$()}}}function ee(U){const ie=r.getTokenValue();return U?I(ie):L(ie),$(),!0}function J(){switch(r.getToken()){case 11:let U=0;try{U=JSON.parse(r.getTokenValue()),typeof U!="number"&&(z(2),U=0)}catch(ie){z(2)}I(U);break;case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return $(),!0}function H(){return r.getToken()!==10?(z(3,[],[2,5]),!1):(ee(!1),r.getToken()===6?(B(":"),$(),W()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function X(){P(),$();let U=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(U||z(4,[],[]),B(","),$(),r.getToken()===2&&O)break}else U&&z(6,[],[]);H()||z(4,[],[2,5]),U=!0}return R(),r.getToken()!==2?z(7,[2],[]):$(),!0}function q(){m(),$();let U=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(U||z(4,[],[]),B(","),$(),r.getToken()===4&&O)break}else U&&z(6,[],[]);W()||z(4,[],[4,5]),U=!0}return T(),r.getToken()!==4?z(8,[4],[]):$(),!0}function W(){switch(r.getToken()){case 3:return q();case 1:return X();case 10:return ee(!0);default:return J()}}return $(),r.getToken()===17?n.allowEmptyContent?!0:(z(4,[],[]),!1):W()?(r.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=f;function c(t,s){let n=C(t),r=[],l,v=0,P;do switch(P=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:v!==P&&r.push(t.substring(v,P)),s!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,s)),v=n.getPosition();break}while(l!==17);return r.join("")}e.stripComments=c;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(me[112],ge([0,1,38]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function _(d,y,i){let A,E,b,o,u;if(y){for(o=y.offset,u=o+y.length,b=o;b>0&&!D(d,b-1);)b--;let v=u;for(;v<d.length&&!D(d,v);)v++;E=d.substring(b,v),A=k(E,i)}else E=d,A=0,b=0,o=0,u=d.length;const w=C(i,d);let p=!1,h=0,f;i.insertSpaces?f=g(" ",i.tabSize||4):f="	";const c=(0,S.createScanner)(E,!1);let a=!1;function t(){return w+g(f,A+h)}function s(){let v=c.scan();for(p=!1;v===15||v===14;)p=p||v===14,v=c.scan();return a=v===16||c.getTokenError()!==0,v}const n=[];function r(v,P,L){!a&&P<u&&L>o&&d.substring(P,L)!==v&&n.push({offset:P,length:L-P,content:v})}let l=s();if(l!==17){const v=c.getTokenOffset()+b,P=g(f,A);r(P,b,v)}for(;l!==17;){let v=c.getTokenOffset()+c.getTokenLength()+b,P=s(),L="";for(;!p&&(P===12||P===13);){const m=c.getTokenOffset()+b;r(" ",v,m),v=c.getTokenOffset()+c.getTokenLength()+b,L=P===12?t():"",P=s()}if(P===2)l!==1&&(h--,L=t());else if(P===4)l!==3&&(h--,L=t());else{switch(l){case 3:case 1:h++,L=t();break;case 5:case 12:L=t();break;case 13:p?L=t():L=" ";break;case 6:L=" ";break;case 10:if(P===6){L="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?L=" ":P!==5&&P!==17&&(a=!0);break;case 16:a=!0;break}p&&(P===12||P===13)&&(L=t())}const R=c.getTokenOffset()+b;r(L,v,R),l=P}return n}e.format=_;function g(d,y){let i="";for(let A=0;A<y;A++)i+=d;return i}function k(d,y){let i=0,A=0;const E=y.tabSize||4;for(;i<d.length;){const b=d.charAt(i);if(b===" ")A++;else if(b==="	")A+=E;else break;i++}return Math.floor(A/E)}function C(d,y){for(let i=0;i<y.length;i++){const A=y.charAt(i);if(A==="\r")return i+1<y.length&&y.charAt(i+1)===`
`?`\r
`:"\r";if(A===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=C;function D(d,y){return`\r
`.indexOf(d.charAt(y))!==-1}e.isEOL=D}),define(me[113],ge([0,1,38,112]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function g(y,i,A){return k(y,i,void 0,A)}e.removeProperty=g;function k(y,i,A,E,b){const o=i.slice(),u=[],w=(0,S.parseTree)(y,u);let p,h;for(;o.length>0&&(h=o.pop(),p=(0,S.findNodeAtLocation)(w,o),p===void 0&&A!==void 0);)typeof h=="string"?A={[h]:A}:A=[A];if(p)if(p.type==="object"&&typeof h=="string"&&Array.isArray(p.children)){const f=(0,S.findNodeAtLocation)(p,[h]);if(f!==void 0)if(A===void 0){if(!f.parent)throw new Error("Malformed AST");const c=p.children.indexOf(f.parent);let a,t=f.parent.offset+f.parent.length;if(c>0){const s=p.children[c-1];a=s.offset+s.length}else a=p.offset+1,p.children.length>1&&(t=p.children[1].offset);return C(y,{offset:a,length:t-a,content:""},E)}else return C(y,{offset:f.offset,length:f.length,content:JSON.stringify(A)},E);else{if(A===void 0)return[];const c=`${JSON.stringify(h)}: ${JSON.stringify(A)}`,a=b?b(p.children.map(s=>s.children[0].value)):p.children.length;let t;if(a>0){const s=p.children[a-1];t={offset:s.offset+s.length,length:0,content:","+c}}else p.children.length===0?t={offset:p.offset+1,length:0,content:c}:t={offset:p.offset+1,length:0,content:c+","};return C(y,t,E)}}else if(p.type==="array"&&typeof h=="number"&&Array.isArray(p.children))if(A!==void 0){const f=`${JSON.stringify(A)}`;let c;if(p.children.length===0||h===0)c={offset:p.offset+1,length:0,content:p.children.length===0?f:f+","};else{const a=h===-1||h>p.children.length?p.children.length:h,t=p.children[a-1];c={offset:t.offset+t.length,length:0,content:","+f}}return C(y,c,E)}else{const f=h,c=p.children[f];let a;if(p.children.length===1)a={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===f){const t=p.children[f-1],s=t.offset+t.length,n=p.offset+p.length;a={offset:s,length:n-2-s,content:""}}else a={offset:c.offset,length:p.children[f+1].offset-c.offset,content:""};return C(y,a,E)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${p.type}`);else{if(A===void 0)throw new Error("Can not delete in empty document");return C(y,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(A)},E)}}e.setProperty=k;function C(y,i,A){let E=D(y,i),b=i.offset,o=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;b>0&&!(0,_.isEOL)(E,b-1);)b--;for(;o<E.length&&!(0,_.isEOL)(E,o);)o++}const u=(0,_.format)(E,{offset:b,length:o-b},A);for(let p=u.length-1;p>=0;p--){const h=u[p];E=D(E,h),b=Math.min(b,h.offset),o=Math.max(o,h.offset+h.length),o+=h.content.length-h.length}const w=y.length-(E.length-o)-b;return[{offset:b,length:w,content:E.substring(b,o)}]}e.withFormatting=C;function D(y,i){return y.substring(0,i.offset)+i.content+y.substring(i.offset+i.length)}e.applyEdit=D;function d(y,i){let A=i.slice(0).sort((b,o)=>{const u=b.offset-o.offset;return u===0?b.length-o.length:u}),E=y.length;for(let b=A.length-1;b>=0;b--){let o=A[b];if(o.offset+o.length<=E)y=D(y,o);else throw new Error("Overlapping edit");E=o.offset}return y}e.applyEdits=d}),define(me[2],ge([0,1,72,51]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const g=!1;let k=null;function C(n){k=n}if(e.setDisposableTracker=C,g){const n="__is_disposable_tracked__";C(new class{trackDisposable(r){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[n]||console.log(l)},3e3)}setParent(r,l){if(r&&r!==h.None)try{r[n]=!0}catch{}}markAsDisposed(r){if(r&&r!==h.None)try{r[n]=!0}catch{}}markAsSingleton(r){}})}function D(n){return k?.trackDisposable(n),n}function d(n){k?.markAsDisposed(n)}function y(n,r){k?.setParent(n,r)}function i(n,r){if(!!k)for(const l of n)k.setParent(l,r)}function A(n){return k?.markAsSingleton(n),n}e.markAsSingleton=A;class E extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=E;function b(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=b;function o(n){if(_.Iterable.is(n)){let r=[];for(const l of n)if(l)try{l.dispose()}catch(v){r.push(v)}if(r.length===1)throw r[0];if(r.length>1)throw new E(r);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=o;function u(...n){const r=w(()=>o(n));return i(n,r),r}e.combinedDisposable=u;function w(n){const r=D({dispose:(0,S.once)(()=>{d(r),n()})});return r}e.toDisposable=w;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}clear(){try{o(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return y(r,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new p,D(this),y(this._store,this)}dispose(){d(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&y(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&y(r,null),r}}e.MutableDisposable=f;class c{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class a{constructor(){this.references=new Map}acquire(r,...l){let v=this.references.get(r);v||(v={counter:0,object:this.createReferencedObject(r,...l)},this.references.set(r,v));const{object:P}=v,L=(0,S.once)(()=>{--v.counter==0&&(this.destroyReferencedObject(r,v.object),this.references.delete(r))});return v.counter++,{object:P,dispose:L}}}e.ReferenceCollection=a;class t{constructor(r){this.referenceCollection=r}async acquire(r,...l){const v=this.referenceCollection.acquire(r,...l);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(P){throw v.dispose(),P}}}e.AsyncReferenceCollection=t;class s{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=s}),define(me[114],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(k){this.element=k,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class _{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let k=this._first;for(;k!==S.Undefined;){const C=k.next;k.prev=S.Undefined,k.next=S.Undefined,k=C}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,C){const D=new S(k);if(this._first===S.Undefined)this._first=D,this._last=D;else if(C){const y=this._last;this._last=D,D.prev=y,y.next=D}else{const y=this._first;this._first=D,D.next=y,y.prev=D}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(D))}}shift(){if(this._first!==S.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==S.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==S.Undefined&&k.next!==S.Undefined){const C=k.prev;C.next=k.next,k.next.prev=C}else k.prev===S.Undefined&&k.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):k.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):k.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==S.Undefined;)yield k.element,k=k.next}}e.LinkedList=_}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(Z,te){for(var le=0;le<te.length;le++){var V=te[le];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(Z,V.key,V)}}function e(Z,te,le){return te&&Q(Z.prototype,te),le&&Q(Z,le),Z}function S(Z,te){if(!!Z){if(typeof Z=="string")return _(Z,te);var le=Object.prototype.toString.call(Z).slice(8,-1);if(le==="Object"&&Z.constructor&&(le=Z.constructor.name),le==="Map"||le==="Set")return Array.from(Z);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return _(Z,te)}}function _(Z,te){(te==null||te>Z.length)&&(te=Z.length);for(var le=0,V=new Array(te);le<te;le++)V[le]=Z[le];return V}function g(Z,te){var le=typeof Symbol!="undefined"&&Z[Symbol.iterator]||Z["@@iterator"];if(le)return(le=le.call(Z)).next.bind(le);if(Array.isArray(Z)||(le=S(Z))||te&&Z&&typeof Z.length=="number"){le&&(Z=le);var V=0;return function(){return V>=Z.length?{done:!0}:{done:!1,value:Z[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var k={exports:{}};function C(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function D(Z){k.exports.defaults=Z}k.exports={defaults:C(),getDefaults:C,changeDefaults:D};var d=/[&<>"']/,y=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(te){return E[te]};function o(Z,te){if(te){if(d.test(Z))return Z.replace(y,b)}else if(i.test(Z))return Z.replace(A,b);return Z}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(Z){return Z.replace(u,function(te,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var p=/(^|[^\[])\^/g;function h(Z,te){Z=Z.source||Z,te=te||"";var le={replace:function(x,se){return se=se.source||se,se=se.replace(p,"$1"),Z=Z.replace(x,se),le},getRegex:function(){return new RegExp(Z,te)}};return le}var f=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(Z,te,le){if(Z){var V;try{V=decodeURIComponent(w(le)).replace(f,"").toLowerCase()}catch(x){return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}te&&!c.test(le)&&(le=l(te,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch(x){return null}return le}var t={},s=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(Z,te){t[" "+Z]||(s.test(Z)?t[" "+Z]=Z+"/":t[" "+Z]=R(Z,"/",!0)),Z=t[" "+Z];var le=Z.indexOf(":")===-1;return te.substring(0,2)==="//"?le?te:Z.replace(n,"$1")+te:te.charAt(0)==="/"?le?te:Z.replace(r,"$1")+te:Z+te}var v={exec:function(){}};function P(Z){for(var te=1,le,V;te<arguments.length;te++){le=arguments[te];for(V in le)Object.prototype.hasOwnProperty.call(le,V)&&(Z[V]=le[V])}return Z}function L(Z,te){var le=Z.replace(/\|/g,function(se,re,Ee){for(var Fe=!1,_e=re;--_e>=0&&Ee[_e]==="\\";)Fe=!Fe;return Fe?"|":" |"}),V=le.split(/ \|/),x=0;if(V[0].trim()||V.shift(),V[V.length-1].trim()||V.pop(),V.length>te)V.splice(te);else for(;V.length<te;)V.push("");for(;x<V.length;x++)V[x]=V[x].trim().replace(/\\\|/g,"|");return V}function R(Z,te,le){var V=Z.length;if(V===0)return"";for(var x=0;x<V;){var se=Z.charAt(V-x-1);if(se===te&&!le)x++;else if(se!==te&&le)x++;else break}return Z.substr(0,V-x)}function m(Z,te){if(Z.indexOf(te[1])===-1)return-1;for(var le=Z.length,V=0,x=0;x<le;x++)if(Z[x]==="\\")x++;else if(Z[x]===te[0])V++;else if(Z[x]===te[1]&&(V--,V<0))return x;return-1}function T(Z){Z&&Z.sanitize&&!Z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Z,te){if(te<1)return"";for(var le="";te>1;)te&1&&(le+=Z),te>>=1,Z+=Z;return le+Z}var B={escape:o,unescape:w,edit:h,cleanUrl:a,resolveUrl:l,noopTest:v,merge:P,splitCells:L,rtrim:R,findClosingBracket:m,checkSanitizeDeprecation:T,repeatString:I},j=k.exports.defaults,ue=B.rtrim,ce=B.splitCells,O=B.escape,$=B.findClosingBracket;function z(Z,te,le,V){var x=te.href,se=te.title?O(te.title):null,re=Z[1].replace(/\\([\[\]])/g,"$1");return Z[0].charAt(0)!=="!"?(V.state.inLink=!0,{type:"link",raw:le,href:x,title:se,text:re,tokens:V.inlineTokens(re,[])}):{type:"image",raw:le,href:x,title:se,text:O(re)}}function ee(Z,te){var le=Z.match(/^(\s+)(?:```)/);if(le===null)return te;var V=le[1];return te.split(`
`).map(function(x){var se=x.match(/^\s+/);if(se===null)return x;var re=se[0];return re.length>=V.length?x.slice(V.length):x}).join(`
`)}var J=function(){function Z(le){this.options=le||j}var te=Z.prototype;return te.space=function(V){var x=this.rules.block.newline.exec(V);if(x)return x[0].length>1?{type:"space",raw:x[0]}:{raw:`
`}},te.code=function(V){var x=this.rules.block.code.exec(V);if(x){var se=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?se:ue(se,`
`)}}},te.fences=function(V){var x=this.rules.block.fences.exec(V);if(x){var se=x[0],re=ee(se,x[3]||"");return{type:"code",raw:se,lang:x[2]?x[2].trim():x[2],text:re}}},te.heading=function(V){var x=this.rules.block.heading.exec(V);if(x){var se=x[2].trim();if(/#$/.test(se)){var re=ue(se,"#");(this.options.pedantic||!re||/ $/.test(re))&&(se=re.trim())}var Ee={type:"heading",raw:x[0],depth:x[1].length,text:se,tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},te.hr=function(V){var x=this.rules.block.hr.exec(V);if(x)return{type:"hr",raw:x[0]}},te.blockquote=function(V){var x=this.rules.block.blockquote.exec(V);if(x){var se=x[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},te.list=function(V){var x=this.rules.block.list.exec(V);if(x){var se,re,Ee,Fe,_e,Me,je,ae,fe,Y,M=x[1].trim(),De=M.length>1,Ce={type:"list",raw:"",ordered:De,start:De?+M.slice(0,-1):"",loose:!1,items:[]};M=De?"\\d{1,9}\\"+M.slice(-1):"\\"+M,this.options.pedantic&&(M=De?M:"[*+-]");for(var Ve=new RegExp("^( {0,3}"+M+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");V&&!(this.rules.block.hr.test(V)||!(x=Ve.exec(V)));){fe=x[2].split(`
`),this.options.pedantic?(Fe=2,Y=fe[0].trimLeft()):(Fe=x[2].search(/[^ ]/),Fe=x[1].length+(Fe>4?1:Fe),Y=fe[0].slice(Fe-x[1].length)),Me=!1,se=x[0],!fe[0]&&/^ *$/.test(fe[1])&&(se=x[1]+fe.slice(0,2).join(`
`)+`
`,Ce.loose=!0,fe=[]);var ze=new RegExp("^ {0,"+Math.min(3,Fe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(_e=1;_e<fe.length;_e++){if(ae=fe[_e],this.options.pedantic&&(ae=ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),ze.test(ae)){se=x[1]+fe.slice(0,_e).join(`
`)+`
`;break}if(!Me){ae.trim()||(Me=!0),ae.search(/[^ ]/)>=Fe?Y+=`
`+ae.slice(Fe):Y+=`
`+ae;continue}if(ae.search(/[^ ]/)>=Fe||!ae.trim()){Y+=`
`+ae.slice(Fe);continue}else{se=x[1]+fe.slice(0,_e).join(`
`)+`
`;break}}Ce.loose||(je?Ce.loose=!0:/\n *\n *$/.test(se)&&(je=!0)),this.options.gfm&&(re=/^\[[ xX]\] /.exec(Y),re&&(Ee=re[0]!=="[ ] ",Y=Y.replace(/^\[[ xX]\] +/,""))),Ce.items.push({type:"list_item",raw:se,task:!!re,checked:Ee,loose:!1,text:Y}),Ce.raw+=se,V=V.slice(se.length)}Ce.items[Ce.items.length-1].raw=se.trimRight(),Ce.items[Ce.items.length-1].text=Y.trimRight(),Ce.raw=Ce.raw.trimRight();var tt=Ce.items.length;for(_e=0;_e<tt;_e++)this.lexer.state.top=!1,Ce.items[_e].tokens=this.lexer.blockTokens(Ce.items[_e].text,[]),Ce.items[_e].tokens.some(function(ct){return ct.type==="space"})&&(Ce.loose=!0,Ce.items[_e].loose=!0);return Ce}},te.html=function(V){var x=this.rules.block.html.exec(V);if(x){var se={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};return this.options.sanitize&&(se.type="paragraph",se.text=this.options.sanitizer?this.options.sanitizer(x[0]):O(x[0]),se.tokens=[],this.lexer.inline(se.text,se.tokens)),se}},te.def=function(V){var x=this.rules.block.def.exec(V);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var se=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:x[0],href:x[2],title:x[3]}}},te.table=function(V){var x=this.rules.block.table.exec(V);if(x){var se={type:"table",header:ce(x[1]).map(function(je){return{text:je}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]?x[3].replace(/\n$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=x[0];var re=se.align.length,Ee,Fe,_e,Me;for(Ee=0;Ee<re;Ee++)/^ *-+: *$/.test(se.align[Ee])?se.align[Ee]="right":/^ *:-+: *$/.test(se.align[Ee])?se.align[Ee]="center":/^ *:-+ *$/.test(se.align[Ee])?se.align[Ee]="left":se.align[Ee]=null;for(re=se.rows.length,Ee=0;Ee<re;Ee++)se.rows[Ee]=ce(se.rows[Ee],se.header.length).map(function(je){return{text:je}});for(re=se.header.length,Fe=0;Fe<re;Fe++)se.header[Fe].tokens=[],this.lexer.inlineTokens(se.header[Fe].text,se.header[Fe].tokens);for(re=se.rows.length,Fe=0;Fe<re;Fe++)for(Me=se.rows[Fe],_e=0;_e<Me.length;_e++)Me[_e].tokens=[],this.lexer.inlineTokens(Me[_e].text,Me[_e].tokens);return se}}},te.lheading=function(V){var x=this.rules.block.lheading.exec(V);if(x){var se={type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:[]};return this.lexer.inline(se.text,se.tokens),se}},te.paragraph=function(V){var x=this.rules.block.paragraph.exec(V);if(x){var se={type:"paragraph",raw:x[0],text:x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1],tokens:[]};return this.lexer.inline(se.text,se.tokens),se}},te.text=function(V){var x=this.rules.block.text.exec(V);if(x){var se={type:"text",raw:x[0],text:x[0],tokens:[]};return this.lexer.inline(se.text,se.tokens),se}},te.escape=function(V){var x=this.rules.inline.escape.exec(V);if(x)return{type:"escape",raw:x[0],text:O(x[1])}},te.tag=function(V){var x=this.rules.inline.tag.exec(V);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):O(x[0]):x[0]}},te.link=function(V){var x=this.rules.inline.link.exec(V);if(x){var se=x[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var re=ue(se.slice(0,-1),"\\");if((se.length-re.length)%2==0)return}else{var Ee=$(x[2],"()");if(Ee>-1){var Fe=x[0].indexOf("!")===0?5:4,_e=Fe+x[1].length+Ee;x[2]=x[2].substring(0,Ee),x[0]=x[0].substring(0,_e).trim(),x[3]=""}}var Me=x[2],je="";if(this.options.pedantic){var ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);ae&&(Me=ae[1],je=ae[3])}else je=x[3]?x[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(se)?Me=Me.slice(1):Me=Me.slice(1,-1)),z(x,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},te.reflink=function(V,x){var se;if((se=this.rules.inline.reflink.exec(V))||(se=this.rules.inline.nolink.exec(V))){var re=(se[2]||se[1]).replace(/\s+/g," ");if(re=x[re.toLowerCase()],!re||!re.href){var Ee=se[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return z(se,re,se[0],this.lexer)}},te.emStrong=function(V,x,se){se===void 0&&(se="");var re=this.rules.inline.emStrong.lDelim.exec(V);if(!!re&&!(re[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=re[1]||re[2]||"";if(!Ee||Ee&&(se===""||this.rules.inline.punctuation.exec(se))){var Fe=re[0].length-1,_e,Me,je=Fe,ae=0,fe=re[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(fe.lastIndex=0,x=x.slice(-1*V.length+Fe);(re=fe.exec(x))!=null;)if(_e=re[1]||re[2]||re[3]||re[4]||re[5]||re[6],!!_e){if(Me=_e.length,re[3]||re[4]){je+=Me;continue}else if((re[5]||re[6])&&Fe%3&&!((Fe+Me)%3)){ae+=Me;continue}if(je-=Me,!(je>0)){if(Me=Math.min(Me,Me+je+ae),Math.min(Fe,Me)%2){var Y=V.slice(1,Fe+re.index+Me);return{type:"em",raw:V.slice(0,Fe+re.index+Me+1),text:Y,tokens:this.lexer.inlineTokens(Y,[])}}var M=V.slice(2,Fe+re.index+Me-1);return{type:"strong",raw:V.slice(0,Fe+re.index+Me+1),text:M,tokens:this.lexer.inlineTokens(M,[])}}}}}},te.codespan=function(V){var x=this.rules.inline.code.exec(V);if(x){var se=x[2].replace(/\n/g," "),re=/[^ ]/.test(se),Ee=/^ /.test(se)&&/ $/.test(se);return re&&Ee&&(se=se.substring(1,se.length-1)),se=O(se,!0),{type:"codespan",raw:x[0],text:se}}},te.br=function(V){var x=this.rules.inline.br.exec(V);if(x)return{type:"br",raw:x[0]}},te.del=function(V){var x=this.rules.inline.del.exec(V);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2],[])}},te.autolink=function(V,x){var se=this.rules.inline.autolink.exec(V);if(se){var re,Ee;return se[2]==="@"?(re=O(this.options.mangle?x(se[1]):se[1]),Ee="mailto:"+re):(re=O(se[1]),Ee=re),{type:"link",raw:se[0],text:re,href:Ee,tokens:[{type:"text",raw:re,text:re}]}}},te.url=function(V,x){var se;if(se=this.rules.inline.url.exec(V)){var re,Ee;if(se[2]==="@")re=O(this.options.mangle?x(se[0]):se[0]),Ee="mailto:"+re;else{var Fe;do Fe=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Fe!==se[0]);re=O(se[0]),se[1]==="www."?Ee="http://"+re:Ee=re}return{type:"link",raw:se[0],text:re,href:Ee,tokens:[{type:"text",raw:re,text:re}]}}},te.inlineText=function(V,x){var se=this.rules.inline.text.exec(V);if(se){var re;return this.lexer.state.inRawBlock?re=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):O(se[0]):se[0]:re=O(this.options.smartypants?x(se[0]):se[0]),{type:"text",raw:se[0],text:re}}},Z}(),H=B.noopTest,X=B.edit,q=B.merge,W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:H,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=X(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=X(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=X(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=X(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=X(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=X(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=q({},W),W.gfm=q({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=X(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=q({},W.normal,{html:X(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:H,paragraph:X(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:H,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:H,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=X(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=X(W._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=X(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=X(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=X(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=X(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=X(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=X(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=X(U.reflink).replace("label",U._label).getRegex(),U.reflinkSearch=X(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=q({},U),U.pedantic=q({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:X(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:X(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=q({},U.normal,{escape:X(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=X(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=q({},U.gfm,{br:X(U.br).replace("{2,}","*").getRegex(),text:X(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ie={block:W,inline:U},ne=J,he=k.exports.defaults,ve=ie.block,Ae=ie.inline,Ie=B.repeatString;function Ue(Z){return Z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function qe(Z){var te="",le,V,x=Z.length;for(le=0;le<x;le++)V=Z.charCodeAt(le),Math.random()>.5&&(V="x"+V.toString(16)),te+="&#"+V+";";return te}var Ge=function(){function Z(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||he,this.options.tokenizer=this.options.tokenizer||new ne,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:ve.normal,inline:Ae.normal};this.options.pedantic?(V.block=ve.pedantic,V.inline=Ae.pedantic):this.options.gfm&&(V.block=ve.gfm,this.options.breaks?V.inline=Ae.breaks:V.inline=Ae.gfm),this.tokenizer.rules=V}Z.lex=function(V,x){var se=new Z(x);return se.lex(V)},Z.lexInline=function(V,x){var se=new Z(x);return se.inlineTokens(V)};var te=Z.prototype;return te.lex=function(V){V=V.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(V,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},te.blockTokens=function(V,x){var se=this;x===void 0&&(x=[]),this.options.pedantic&&(V=V.replace(/^ +$/gm,""));for(var re,Ee,Fe,_e;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(re=je.call({lexer:se},V,x))?(V=V.substring(re.raw.length),x.push(re),!0):!1}))){if(re=this.tokenizer.space(V)){V=V.substring(re.raw.length),re.type&&x.push(re);continue}if(re=this.tokenizer.code(V)){V=V.substring(re.raw.length),Ee=x[x.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+re.raw,Ee.text+=`
`+re.text,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):x.push(re);continue}if(re=this.tokenizer.fences(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.heading(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.hr(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.blockquote(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.list(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.html(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.def(V)){V=V.substring(re.raw.length),Ee=x[x.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+re.raw,Ee.text+=`
`+re.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):this.tokens.links[re.tag]||(this.tokens.links[re.tag]={href:re.href,title:re.title});continue}if(re=this.tokenizer.table(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.lheading(V)){V=V.substring(re.raw.length),x.push(re);continue}if(Fe=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=Infinity,ae=V.slice(1),fe=void 0;se.options.extensions.startBlock.forEach(function(Y){fe=Y.call({lexer:this},ae),typeof fe=="number"&&fe>=0&&(je=Math.min(je,fe))}),je<Infinity&&je>=0&&(Fe=V.substring(0,je+1))}(),this.state.top&&(re=this.tokenizer.paragraph(Fe))){Ee=x[x.length-1],_e&&Ee.type==="paragraph"?(Ee.raw+=`
`+re.raw,Ee.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):x.push(re),_e=Fe.length!==V.length,V=V.substring(re.raw.length);continue}if(re=this.tokenizer.text(V)){V=V.substring(re.raw.length),Ee=x[x.length-1],Ee&&Ee.type==="text"?(Ee.raw+=`
`+re.raw,Ee.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):x.push(re);continue}if(V){var Me="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,x},te.inline=function(V,x){this.inlineQueue.push({src:V,tokens:x})},te.inlineTokens=function(V,x){var se=this;x===void 0&&(x=[]);var re,Ee,Fe,_e=V,Me,je,ae;if(this.tokens.links){var fe=Object.keys(this.tokens.links);if(fe.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(_e))!=null;)fe.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(_e=_e.slice(0,Me.index)+"["+Ie("a",Me[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(_e))!=null;)_e=_e.slice(0,Me.index)+"["+Ie("a",Me[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(_e))!=null;)_e=_e.slice(0,Me.index)+"++"+_e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(je||(ae=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(M){return(re=M.call({lexer:se},V,x))?(V=V.substring(re.raw.length),x.push(re),!0):!1}))){if(re=this.tokenizer.escape(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.tag(V)){V=V.substring(re.raw.length),Ee=x[x.length-1],Ee&&re.type==="text"&&Ee.type==="text"?(Ee.raw+=re.raw,Ee.text+=re.text):x.push(re);continue}if(re=this.tokenizer.link(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(re.raw.length),Ee=x[x.length-1],Ee&&re.type==="text"&&Ee.type==="text"?(Ee.raw+=re.raw,Ee.text+=re.text):x.push(re);continue}if(re=this.tokenizer.emStrong(V,_e,ae)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.codespan(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.br(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.del(V)){V=V.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.autolink(V,qe)){V=V.substring(re.raw.length),x.push(re);continue}if(!this.state.inLink&&(re=this.tokenizer.url(V,qe))){V=V.substring(re.raw.length),x.push(re);continue}if(Fe=V,this.options.extensions&&this.options.extensions.startInline&&function(){var M=Infinity,De=V.slice(1),Ce=void 0;se.options.extensions.startInline.forEach(function(Ve){Ce=Ve.call({lexer:this},De),typeof Ce=="number"&&Ce>=0&&(M=Math.min(M,Ce))}),M<Infinity&&M>=0&&(Fe=V.substring(0,M+1))}(),re=this.tokenizer.inlineText(Fe,Ue)){V=V.substring(re.raw.length),re.raw.slice(-1)!=="_"&&(ae=re.raw.slice(-1)),je=!0,Ee=x[x.length-1],Ee&&Ee.type==="text"?(Ee.raw+=re.raw,Ee.text+=re.text):x.push(re);continue}if(V){var Y="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return x},e(Z,null,[{key:"rules",get:function(){return{block:ve,inline:Ae}}}]),Z}(),rt=k.exports.defaults,it=B.cleanUrl,de=B.escape,be=function(){function Z(le){this.options=le||rt}var te=Z.prototype;return te.code=function(V,x,se){var re=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(V,re);Ee!=null&&Ee!==V&&(se=!0,V=Ee)}return V=V.replace(/\n$/,"")+`
`,re?'<pre><code class="'+this.options.langPrefix+de(re,!0)+'">'+(se?V:de(V,!0))+`</code></pre>
`:"<pre><code>"+(se?V:de(V,!0))+`</code></pre>
`},te.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},te.html=function(V){return V},te.heading=function(V,x,se,re){return this.options.headerIds?"<h"+x+' id="'+this.options.headerPrefix+re.slug(se)+'">'+V+"</h"+x+`>
`:"<h"+x+">"+V+"</h"+x+`>
`},te.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},te.list=function(V,x,se){var re=x?"ol":"ul",Ee=x&&se!==1?' start="'+se+'"':"";return"<"+re+Ee+`>
`+V+"</"+re+`>
`},te.listitem=function(V){return"<li>"+V+`</li>
`},te.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},te.paragraph=function(V){return"<p>"+V+`</p>
`},te.table=function(V,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+x+`</table>
`},te.tablerow=function(V){return`<tr>
`+V+`</tr>
`},te.tablecell=function(V,x){var se=x.header?"th":"td",re=x.align?"<"+se+' align="'+x.align+'">':"<"+se+">";return re+V+"</"+se+`>
`},te.strong=function(V){return"<strong>"+V+"</strong>"},te.em=function(V){return"<em>"+V+"</em>"},te.codespan=function(V){return"<code>"+V+"</code>"},te.br=function(){return this.options.xhtml?"<br/>":"<br>"},te.del=function(V){return"<del>"+V+"</del>"},te.link=function(V,x,se){if(V=it(this.options.sanitize,this.options.baseUrl,V),V===null)return se;var re='<a href="'+de(V)+'"';return x&&(re+=' title="'+x+'"'),re+=">"+se+"</a>",re},te.image=function(V,x,se){if(V=it(this.options.sanitize,this.options.baseUrl,V),V===null)return se;var re='<img src="'+V+'" alt="'+se+'"';return x&&(re+=' title="'+x+'"'),re+=this.options.xhtml?"/>":">",re},te.text=function(V){return V},Z}(),Pe=function(){function Z(){}var te=Z.prototype;return te.strong=function(V){return V},te.em=function(V){return V},te.codespan=function(V){return V},te.del=function(V){return V},te.html=function(V){return V},te.text=function(V){return V},te.link=function(V,x,se){return""+se},te.image=function(V,x,se){return""+se},te.br=function(){return""},Z}(),Re=function(){function Z(){this.seen={}}var te=Z.prototype;return te.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},te.getNextSafeSlug=function(V,x){var se=V,re=0;if(this.seen.hasOwnProperty(se)){re=this.seen[V];do re++,se=V+"-"+re;while(this.seen.hasOwnProperty(se))}return x||(this.seen[V]=re,this.seen[se]=0),se},te.slug=function(V,x){x===void 0&&(x={});var se=this.serialize(V);return this.getNextSafeSlug(se,x.dryrun)},Z}(),Ne=be,He=Pe,Ke=Re,Je=k.exports.defaults,st=B.unescape,oe=function(){function Z(le){this.options=le||Je,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Ke}Z.parse=function(V,x){var se=new Z(x);return se.parse(V)},Z.parseInline=function(V,x){var se=new Z(x);return se.parseInline(V)};var te=Z.prototype;return te.parse=function(V,x){x===void 0&&(x=!0);var se="",re,Ee,Fe,_e,Me,je,ae,fe,Y,M,De,Ce,Ve,ze,tt,ct,gt,ut,dt,mt=V.length;for(re=0;re<mt;re++){if(M=V[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[M.type]&&(dt=this.options.extensions.renderers[M.type].call({parser:this},M),dt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(M.type))){se+=dt||"";continue}switch(M.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(M.tokens),M.depth,st(this.parseInline(M.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(M.text,M.lang,M.escaped);continue}case"table":{for(fe="",ae="",_e=M.header.length,Ee=0;Ee<_e;Ee++)ae+=this.renderer.tablecell(this.parseInline(M.header[Ee].tokens),{header:!0,align:M.align[Ee]});for(fe+=this.renderer.tablerow(ae),Y="",_e=M.rows.length,Ee=0;Ee<_e;Ee++){for(je=M.rows[Ee],ae="",Me=je.length,Fe=0;Fe<Me;Fe++)ae+=this.renderer.tablecell(this.parseInline(je[Fe].tokens),{header:!1,align:M.align[Fe]});Y+=this.renderer.tablerow(ae)}se+=this.renderer.table(fe,Y);continue}case"blockquote":{Y=this.parse(M.tokens),se+=this.renderer.blockquote(Y);continue}case"list":{for(De=M.ordered,Ce=M.start,Ve=M.loose,_e=M.items.length,Y="",Ee=0;Ee<_e;Ee++)tt=M.items[Ee],ct=tt.checked,gt=tt.task,ze="",tt.task&&(ut=this.renderer.checkbox(ct),Ve?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=ut+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=ut+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:ut}):ze+=ut),ze+=this.parse(tt.tokens,Ve),Y+=this.renderer.listitem(ze,gt,ct);se+=this.renderer.list(Y,De,Ce);continue}case"html":{se+=this.renderer.html(M.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(M.tokens));continue}case"text":{for(Y=M.tokens?this.parseInline(M.tokens):M.text;re+1<mt&&V[re+1].type==="text";)M=V[++re],Y+=`
`+(M.tokens?this.parseInline(M.tokens):M.text);se+=x?this.renderer.paragraph(Y):Y;continue}default:{var Pt='Token with "'+M.type+'" type was not found.';if(this.options.silent){console.error(Pt);return}else throw new Error(Pt)}}}return se},te.parseInline=function(V,x){x=x||this.renderer;var se="",re,Ee,Fe,_e=V.length;for(re=0;re<_e;re++){if(Ee=V[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(Fe=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),Fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ee.type))){se+=Fe||"";continue}switch(Ee.type){case"escape":{se+=x.text(Ee.text);break}case"html":{se+=x.html(Ee.text);break}case"link":{se+=x.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,x));break}case"image":{se+=x.image(Ee.href,Ee.title,Ee.text);break}case"strong":{se+=x.strong(this.parseInline(Ee.tokens,x));break}case"em":{se+=x.em(this.parseInline(Ee.tokens,x));break}case"codespan":{se+=x.codespan(Ee.text);break}case"br":{se+=x.br();break}case"del":{se+=x.del(this.parseInline(Ee.tokens,x));break}case"text":{se+=x.text(Ee.text);break}default:{var Me='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return se},Z}(),pe=Ge,Se=oe,Be=J,xe=be,ot=Pe,Qe=Re,at=B.merge,Ze=B.checkSanitizeDeprecation,K=B.escape,we=k.exports.getDefaults,ke=k.exports.changeDefaults,Oe=k.exports.defaults;function Te(Z,te,le){if(typeof Z=="undefined"||Z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");if(typeof te=="function"&&(le=te,te=null),te=at({},Te.defaults,te||{}),Ze(te),le){var V=te.highlight,x;try{x=pe.lex(Z,te)}catch(Fe){return le(Fe)}var se=function(_e){var Me;if(!_e)try{te.walkTokens&&Te.walkTokens(x,te.walkTokens),Me=Se.parse(x,te)}catch(je){_e=je}return te.highlight=V,_e?le(_e):le(null,Me)};if(!V||V.length<3||(delete te.highlight,!x.length))return se();var re=0;Te.walkTokens(x,function(Fe){Fe.type==="code"&&(re++,setTimeout(function(){V(Fe.text,Fe.lang,function(_e,Me){if(_e)return se(_e);Me!=null&&Me!==Fe.text&&(Fe.text=Me,Fe.escaped=!0),re--,re===0&&se()})},0))}),re===0&&se();return}try{var Ee=pe.lex(Z,te);return te.walkTokens&&Te.walkTokens(Ee,te.walkTokens),Se.parse(Ee,te)}catch(Fe){if(Fe.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+K(Fe.message+"",!0)+"</pre>";throw Fe}}Te.options=Te.setOptions=function(Z){return at(Te.defaults,Z),ke(Te.defaults),Te},Te.getDefaults=we,Te.defaults=Oe,Te.use=function(){for(var Z=this,te=arguments.length,le=new Array(te),V=0;V<te;V++)le[V]=arguments[V];var x=at.apply(void 0,[{}].concat(le)),se=Te.defaults.extensions||{renderers:{},childTokens:{}},re;le.forEach(function(Ee){if(Ee.extensions&&(re=!0,Ee.extensions.forEach(function(_e){if(!_e.name)throw new Error("extension name required");if(_e.renderer){var Me=se.renderers?se.renderers[_e.name]:null;Me?se.renderers[_e.name]=function(){for(var je=arguments.length,ae=new Array(je),fe=0;fe<je;fe++)ae[fe]=arguments[fe];var Y=_e.renderer.apply(this,ae);return Y===!1&&(Y=Me.apply(this,ae)),Y}:se.renderers[_e.name]=_e.renderer}if(_e.tokenizer){if(!_e.level||_e.level!=="block"&&_e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");se[_e.level]?se[_e.level].unshift(_e.tokenizer):se[_e.level]=[_e.tokenizer],_e.start&&(_e.level==="block"?se.startBlock?se.startBlock.push(_e.start):se.startBlock=[_e.start]:_e.level==="inline"&&(se.startInline?se.startInline.push(_e.start):se.startInline=[_e.start]))}_e.childTokens&&(se.childTokens[_e.name]=_e.childTokens)})),Ee.renderer&&function(){var _e=Te.defaults.renderer||new xe,Me=function(fe){var Y=_e[fe];_e[fe]=function(){for(var M=arguments.length,De=new Array(M),Ce=0;Ce<M;Ce++)De[Ce]=arguments[Ce];var Ve=Ee.renderer[fe].apply(_e,De);return Ve===!1&&(Ve=Y.apply(_e,De)),Ve}};for(var je in Ee.renderer)Me(je);x.renderer=_e}(),Ee.tokenizer&&function(){var _e=Te.defaults.tokenizer||new Be,Me=function(fe){var Y=_e[fe];_e[fe]=function(){for(var M=arguments.length,De=new Array(M),Ce=0;Ce<M;Ce++)De[Ce]=arguments[Ce];var Ve=Ee.tokenizer[fe].apply(_e,De);return Ve===!1&&(Ve=Y.apply(_e,De)),Ve}};for(var je in Ee.tokenizer)Me(je);x.tokenizer=_e}(),Ee.walkTokens){var Fe=Te.defaults.walkTokens;x.walkTokens=function(_e){Ee.walkTokens.call(Z,_e),Fe&&Fe(_e)}}re&&(x.extensions=se),Te.setOptions(x)})},Te.walkTokens=function(Z,te){for(var le=function(){var re=x.value;switch(te(re),re.type){case"table":{for(var Ee=g(re.header),Fe;!(Fe=Ee()).done;){var _e=Fe.value;Te.walkTokens(_e.tokens,te)}for(var Me=g(re.rows),je;!(je=Me()).done;)for(var ae=je.value,fe=g(ae),Y;!(Y=fe()).done;){var M=Y.value;Te.walkTokens(M.tokens,te)}break}case"list":{Te.walkTokens(re.items,te);break}default:Te.defaults.extensions&&Te.defaults.extensions.childTokens&&Te.defaults.extensions.childTokens[re.type]?Te.defaults.extensions.childTokens[re.type].forEach(function(De){Te.walkTokens(re[De],te)}):re.tokens&&Te.walkTokens(re.tokens,te)}},V=g(Z),x;!(x=V()).done;)le()},Te.parseInline=function(Z,te){if(typeof Z=="undefined"||Z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");te=at({},Te.defaults,te||{}),Ze(te);try{var le=pe.lexInline(Z,te);return te.walkTokens&&Te.walkTokens(le,te.walkTokens),Se.parseInline(le,te)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+K(V.message+"",!0)+"</pre>";throw V}},Te.Parser=Se,Te.parser=Se.parse,Te.Renderer=xe,Te.TextRenderer=ot,Te.Lexer=pe,Te.lexer=pe.lex,Te.Tokenizer=Be,Te.Slugger=Qe,Te.parse=Te;var We=Te;return We}),define(me[115],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function S(C,D,d){return Math.min(Math.max(C,D),d)}e.clamp=S;function _(C,D){return(D+C%D)%D}e.rot=_;class g{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=g;class k{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=k}),function(){function Q(g){const k=[];typeof g=="number"&&k.push("code/timeOrigin",g);function C(d){k.push(d,Date.now())}function D(){const d=[];for(let y=0;y<k.length;y+=2)d.push({name:k[y],startTime:k[y+1]});return d}return{mark:C,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const C of performance.getEntriesByType("mark"))k.push({name:C.name,startTime:Math.round(g+C.startTime)});return k}};if(typeof process=="object"){const g=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function S(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var _;typeof global=="object"?_=global:typeof self=="object"?_=self:_={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(_)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(_):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),_.perf=S(_))}(),define(me[3],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const S="en";let _=!1,g=!1,k=!1,C=!1,D=!1,d=!1,y=!1,i,A=S,E,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?o=e.globals.vscode.process:typeof process!="undefined"&&(o=process);const u=typeof o?.versions?.electron=="string"&&o.type==="renderer";if(e.isElectronSandboxed=u&&o?.sandboxed,typeof navigator=="object"&&!u)b=navigator.userAgent,_=b.indexOf("Windows")>=0,g=b.indexOf("Macintosh")>=0,y=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=b.indexOf("Linux")>=0,d=!0,i=navigator.language,A=i;else if(typeof o=="object"){_=o.platform==="win32",g=o.platform==="darwin",k=o.platform==="linux",C=k&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,i=S,A=S;const n=o.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),l=r.availableLanguages["*"];i=r.locale,A=l||S,E=r._translationsConfigFile}catch(r){}D=!0}else console.error("Unable to resolve platform.");var w;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function p(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let h=0;g?h=1:_?h=3:k&&(h=2),e.isWindows=_,e.isMacintosh=g,e.isLinux=k,e.isLinuxSnap=C,e.isNative=D,e.isWeb=d,e.isIOS=y,e.platform=h,e.userAgent=b,e.language=A;var f;(function(n){function r(){return e.language}n.value=r;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=l;function v(){return e.language==="en"}n.isDefault=v})(f=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=E,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let L=0,R=l.length;L<R;L++){const m=l[L];if(m.id===P.data.vscodeSetImmediateId){l.splice(L,1),m.callback();return}}});let v=0;return P=>{const L=++v;l.push({id:L,callback:P}),e.globals.postMessage({vscodeSetImmediateId:L},"*")}}if(typeof o?.nextTick=="function")return o.nextTick.bind(o);const r=Promise.resolve();return l=>r.then(l)}();var c;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=g||y?2:_?1:3;let a=!0,t=!1;function s(){if(!t){t=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,a=new Uint16Array(n.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=s}),define(me[22],ge([0,1,3]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let _;if(typeof S.globals.vscode!="undefined"&&typeof S.globals.vscode.process!="undefined"){const g=S.globals.vscode.process;_={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()},nextTick(k){return(0,S.setImmediate)(k)}}}else typeof process!="undefined"?_={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(g){return process.nextTick(g)}}:_={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},nextTick(g){return(0,S.setImmediate)(g)},get env(){return{}},cwd(){return"/"}};e.cwd=_.cwd,e.env=_.env,e.platform=_.platform,e.nextTick=_.nextTick,e.arch=_.arch}),define(me[5],ge([0,1,22]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const _=65,g=97,k=90,C=122,D=46,d=47,y=92,i=58,A=63;class E extends Error{constructor(c,a,t){let s;typeof a=="string"&&a.indexOf("not ")===0?(s="must not be",a=a.replace(/^not /,"")):s="must be";const n=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${n} ${s} of type ${a}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function b(f,c){if(typeof f!="string")throw new E(c,"string",f)}function o(f){return f===d||f===y}function u(f){return f===d}function w(f){return f>=_&&f<=k||f>=g&&f<=C}function p(f,c,a,t){let s="",n=0,r=-1,l=0,v=0;for(let P=0;P<=f.length;++P){if(P<f.length)v=f.charCodeAt(P);else{if(t(v))break;v=d}if(t(v)){if(!(r===P-1||l===1))if(l===2){if(s.length<2||n!==2||s.charCodeAt(s.length-1)!==D||s.charCodeAt(s.length-2)!==D){if(s.length>2){const L=s.lastIndexOf(a);L===-1?(s="",n=0):(s=s.slice(0,L),n=s.length-1-s.lastIndexOf(a)),r=P,l=0;continue}else if(s.length!==0){s="",n=0,r=P,l=0;continue}}c&&(s+=s.length>0?`${a}..`:"..",n=2)}else s.length>0?s+=`${a}${f.slice(r+1,P)}`:s=f.slice(r+1,P),n=P-r-1;r=P,l=0}else v===D&&l!==-1?++l:l=-1}return s}function h(f,c){if(c===null||typeof c!="object")throw new E("pathObject","Object",c);const a=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return a?a===c.root?`${a}${t}`:`${a}${f}${t}`:t}e.win32={resolve(...f){let c="",a="",t=!1;for(let s=f.length-1;s>=-1;s--){let n;if(s>=0){if(n=f[s],b(n,"path"),n.length===0)continue}else c.length===0?n=S.cwd():(n=S.env[`=${c}`]||S.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==c.toLowerCase()&&n.charCodeAt(2)===y)&&(n=`${c}\\`));const r=n.length;let l=0,v="",P=!1;const L=n.charCodeAt(0);if(r===1)o(L)&&(l=1,P=!0);else if(o(L))if(P=!0,o(n.charCodeAt(1))){let R=2,m=R;for(;R<r&&!o(n.charCodeAt(R));)R++;if(R<r&&R!==m){const T=n.slice(m,R);for(m=R;R<r&&o(n.charCodeAt(R));)R++;if(R<r&&R!==m){for(m=R;R<r&&!o(n.charCodeAt(R));)R++;(R===r||R!==m)&&(v=`\\\\${T}\\${n.slice(m,R)}`,l=R)}}}else l=1;else w(L)&&n.charCodeAt(1)===i&&(v=n.slice(0,2),l=2,r>2&&o(n.charCodeAt(2))&&(P=!0,l=3));if(v.length>0)if(c.length>0){if(v.toLowerCase()!==c.toLowerCase())continue}else c=v;if(t){if(c.length>0)break}else if(a=`${n.slice(l)}\\${a}`,t=P,P&&c.length>0)break}return a=p(a,!t,"\\",o),t?`${c}\\${a}`:`${c}${a}`||"."},normalize(f){b(f,"path");const c=f.length;if(c===0)return".";let a=0,t,s=!1;const n=f.charCodeAt(0);if(c===1)return u(n)?"\\":f;if(o(n))if(s=!0,o(f.charCodeAt(1))){let l=2,v=l;for(;l<c&&!o(f.charCodeAt(l));)l++;if(l<c&&l!==v){const P=f.slice(v,l);for(v=l;l<c&&o(f.charCodeAt(l));)l++;if(l<c&&l!==v){for(v=l;l<c&&!o(f.charCodeAt(l));)l++;if(l===c)return`\\\\${P}\\${f.slice(v)}\\`;l!==v&&(t=`\\\\${P}\\${f.slice(v,l)}`,a=l)}}}else a=1;else w(n)&&f.charCodeAt(1)===i&&(t=f.slice(0,2),a=2,c>2&&o(f.charCodeAt(2))&&(s=!0,a=3));let r=a<c?p(f.slice(a),!s,"\\",o):"";return r.length===0&&!s&&(r="."),r.length>0&&o(f.charCodeAt(c-1))&&(r+="\\"),t===void 0?s?`\\${r}`:r:s?`${t}\\${r}`:`${t}${r}`},isAbsolute(f){b(f,"path");const c=f.length;if(c===0)return!1;const a=f.charCodeAt(0);return o(a)||c>2&&w(a)&&f.charCodeAt(1)===i&&o(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let c,a;for(let n=0;n<f.length;++n){const r=f[n];b(r,"path"),r.length>0&&(c===void 0?c=a=r:c+=`\\${r}`)}if(c===void 0)return".";let t=!0,s=0;if(typeof a=="string"&&o(a.charCodeAt(0))){++s;const n=a.length;n>1&&o(a.charCodeAt(1))&&(++s,n>2&&(o(a.charCodeAt(2))?++s:t=!1))}if(t){for(;s<c.length&&o(c.charCodeAt(s));)s++;s>=2&&(c=`\\${c.slice(s)}`)}return e.win32.normalize(c)},relative(f,c){if(b(f,"from"),b(c,"to"),f===c)return"";const a=e.win32.resolve(f),t=e.win32.resolve(c);if(a===t||(f=a.toLowerCase(),c=t.toLowerCase(),f===c))return"";let s=0;for(;s<f.length&&f.charCodeAt(s)===y;)s++;let n=f.length;for(;n-1>s&&f.charCodeAt(n-1)===y;)n--;const r=n-s;let l=0;for(;l<c.length&&c.charCodeAt(l)===y;)l++;let v=c.length;for(;v-1>l&&c.charCodeAt(v-1)===y;)v--;const P=v-l,L=r<P?r:P;let R=-1,m=0;for(;m<L;m++){const I=f.charCodeAt(s+m);if(I!==c.charCodeAt(l+m))break;I===y&&(R=m)}if(m!==L){if(R===-1)return t}else{if(P>L){if(c.charCodeAt(l+m)===y)return t.slice(l+m+1);if(m===2)return t.slice(l+m)}r>L&&(f.charCodeAt(s+m)===y?R=m:m===2&&(R=3)),R===-1&&(R=0)}let T="";for(m=s+R+1;m<=n;++m)(m===n||f.charCodeAt(m)===y)&&(T+=T.length===0?"..":"\\..");return l+=R,T.length>0?`${T}${t.slice(l,v)}`:(t.charCodeAt(l)===y&&++l,t.slice(l,v))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const c=e.win32.resolve(f);if(c.length<=2)return f;if(c.charCodeAt(0)===y){if(c.charCodeAt(1)===y){const a=c.charCodeAt(2);if(a!==A&&a!==D)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(w(c.charCodeAt(0))&&c.charCodeAt(1)===i&&c.charCodeAt(2)===y)return`\\\\?\\${c}`;return f},dirname(f){b(f,"path");const c=f.length;if(c===0)return".";let a=-1,t=0;const s=f.charCodeAt(0);if(c===1)return o(s)?f:".";if(o(s)){if(a=t=1,o(f.charCodeAt(1))){let l=2,v=l;for(;l<c&&!o(f.charCodeAt(l));)l++;if(l<c&&l!==v){for(v=l;l<c&&o(f.charCodeAt(l));)l++;if(l<c&&l!==v){for(v=l;l<c&&!o(f.charCodeAt(l));)l++;if(l===c)return f;l!==v&&(a=t=l+1)}}}}else w(s)&&f.charCodeAt(1)===i&&(a=c>2&&o(f.charCodeAt(2))?3:2,t=a);let n=-1,r=!0;for(let l=c-1;l>=t;--l)if(o(f.charCodeAt(l))){if(!r){n=l;break}}else r=!1;if(n===-1){if(a===-1)return".";n=a}return f.slice(0,n)},basename(f,c){c!==void 0&&b(c,"ext"),b(f,"path");let a=0,t=-1,s=!0,n;if(f.length>=2&&w(f.charCodeAt(0))&&f.charCodeAt(1)===i&&(a=2),c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let r=c.length-1,l=-1;for(n=f.length-1;n>=a;--n){const v=f.charCodeAt(n);if(o(v)){if(!s){a=n+1;break}}else l===-1&&(s=!1,l=n+1),r>=0&&(v===c.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=l))}return a===t?t=l:t===-1&&(t=f.length),f.slice(a,t)}for(n=f.length-1;n>=a;--n)if(o(f.charCodeAt(n))){if(!s){a=n+1;break}}else t===-1&&(s=!1,t=n+1);return t===-1?"":f.slice(a,t)},extname(f){b(f,"path");let c=0,a=-1,t=0,s=-1,n=!0,r=0;f.length>=2&&f.charCodeAt(1)===i&&w(f.charCodeAt(0))&&(c=t=2);for(let l=f.length-1;l>=c;--l){const v=f.charCodeAt(l);if(o(v)){if(!n){t=l+1;break}continue}s===-1&&(n=!1,s=l+1),v===D?a===-1?a=l:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||s===-1||r===0||r===1&&a===s-1&&a===t+1?"":f.slice(a,s)},format:h.bind(null,"\\"),parse(f){b(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const a=f.length;let t=0,s=f.charCodeAt(0);if(a===1)return o(s)?(c.root=c.dir=f,c):(c.base=c.name=f,c);if(o(s)){if(t=1,o(f.charCodeAt(1))){let R=2,m=R;for(;R<a&&!o(f.charCodeAt(R));)R++;if(R<a&&R!==m){for(m=R;R<a&&o(f.charCodeAt(R));)R++;if(R<a&&R!==m){for(m=R;R<a&&!o(f.charCodeAt(R));)R++;R===a?t=R:R!==m&&(t=R+1)}}}}else if(w(s)&&f.charCodeAt(1)===i){if(a<=2)return c.root=c.dir=f,c;if(t=2,o(f.charCodeAt(2))){if(a===3)return c.root=c.dir=f,c;t=3}}t>0&&(c.root=f.slice(0,t));let n=-1,r=t,l=-1,v=!0,P=f.length-1,L=0;for(;P>=t;--P){if(s=f.charCodeAt(P),o(s)){if(!v){r=P+1;break}continue}l===-1&&(v=!1,l=P+1),s===D?n===-1?n=P:L!==1&&(L=1):n!==-1&&(L=-1)}return l!==-1&&(n===-1||L===0||L===1&&n===l-1&&n===r+1?c.base=c.name=f.slice(r,l):(c.name=f.slice(r,n),c.base=f.slice(r,l),c.ext=f.slice(n,l))),r>0&&r!==t?c.dir=f.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let c="",a=!1;for(let t=f.length-1;t>=-1&&!a;t--){const s=t>=0?f[t]:S.cwd();b(s,"path"),s.length!==0&&(c=`${s}/${c}`,a=s.charCodeAt(0)===d)}return c=p(c,!a,"/",u),a?`/${c}`:c.length>0?c:"."},normalize(f){if(b(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===d,a=f.charCodeAt(f.length-1)===d;return f=p(f,!c,"/",u),f.length===0?c?"/":a?"./":".":(a&&(f+="/"),c?`/${f}`:f)},isAbsolute(f){return b(f,"path"),f.length>0&&f.charCodeAt(0)===d},join(...f){if(f.length===0)return".";let c;for(let a=0;a<f.length;++a){const t=f[a];b(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(f,c){if(b(f,"from"),b(c,"to"),f===c||(f=e.posix.resolve(f),c=e.posix.resolve(c),f===c))return"";const a=1,t=f.length,s=t-a,n=1,r=c.length-n,l=s<r?s:r;let v=-1,P=0;for(;P<l;P++){const R=f.charCodeAt(a+P);if(R!==c.charCodeAt(n+P))break;R===d&&(v=P)}if(P===l)if(r>l){if(c.charCodeAt(n+P)===d)return c.slice(n+P+1);if(P===0)return c.slice(n+P)}else s>l&&(f.charCodeAt(a+P)===d?v=P:P===0&&(v=0));let L="";for(P=a+v+1;P<=t;++P)(P===t||f.charCodeAt(P)===d)&&(L+=L.length===0?"..":"/..");return`${L}${c.slice(n+v)}`},toNamespacedPath(f){return f},dirname(f){if(b(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===d;let a=-1,t=!0;for(let s=f.length-1;s>=1;--s)if(f.charCodeAt(s)===d){if(!t){a=s;break}}else t=!1;return a===-1?c?"/":".":c&&a===1?"//":f.slice(0,a)},basename(f,c){c!==void 0&&b(c,"ext"),b(f,"path");let a=0,t=-1,s=!0,n;if(c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let r=c.length-1,l=-1;for(n=f.length-1;n>=0;--n){const v=f.charCodeAt(n);if(v===d){if(!s){a=n+1;break}}else l===-1&&(s=!1,l=n+1),r>=0&&(v===c.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=l))}return a===t?t=l:t===-1&&(t=f.length),f.slice(a,t)}for(n=f.length-1;n>=0;--n)if(f.charCodeAt(n)===d){if(!s){a=n+1;break}}else t===-1&&(s=!1,t=n+1);return t===-1?"":f.slice(a,t)},extname(f){b(f,"path");let c=-1,a=0,t=-1,s=!0,n=0;for(let r=f.length-1;r>=0;--r){const l=f.charCodeAt(r);if(l===d){if(!s){a=r+1;break}continue}t===-1&&(s=!1,t=r+1),l===D?c===-1?c=r:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||t===-1||n===0||n===1&&c===t-1&&c===a+1?"":f.slice(c,t)},format:h.bind(null,"/"),parse(f){b(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const a=f.charCodeAt(0)===d;let t;a?(c.root="/",t=1):t=0;let s=-1,n=0,r=-1,l=!0,v=f.length-1,P=0;for(;v>=t;--v){const L=f.charCodeAt(v);if(L===d){if(!l){n=v+1;break}continue}r===-1&&(l=!1,r=v+1),L===D?s===-1?s=v:P!==1&&(P=1):s!==-1&&(P=-1)}if(r!==-1){const L=n===0&&a?1:n;s===-1||P===0||P===1&&s===r-1&&s===n+1?c.base=c.name=f.slice(L,r):(c.name=f.slice(L,s),c.base=f.slice(L,r),c.ext=f.slice(s,r))}return n>0?c.dir=f.slice(0,n-1):a&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[116],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var S;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(S=e.Source||(e.Source={}));var _;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(_=e.TerminateResponseCode||(e.TerminateResponseCode={}));function g(k,...C){const D=C.reduce((i,A)=>(i[A]=!0,i),{}),d=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(i=>!D[i]).forEach(i=>{for(let A=0;A<d.length;A++)if(i.search(d[A])!==-1){delete k[i];break}})}e.sanitizeProcessEnvironment=g}),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var _ in S)(typeof exports=="object"?exports:Q)[_]=S[_]}}(typeof self!="undefined"?self:this,function(){return function(Q){var e={};function S(_){if(e[_])return e[_].exports;var g=e[_]={i:_,l:!1,exports:{}};return Q[_].call(g.exports,g,g.exports,S),g.l=!0,g.exports}return S.m=Q,S.c=e,S.d=function(_,g,k){S.o(_,g)||Object.defineProperty(_,g,{enumerable:!0,get:k})},S.r=function(_){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(_,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(_,"__esModule",{value:!0})},S.t=function(_,g){if(1&g&&(_=S(_)),8&g||4&g&&typeof _=="object"&&_&&_.__esModule)return _;var k=Object.create(null);if(S.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:_}),2&g&&typeof _!="string")for(var C in _)S.d(k,C,function(D){return _[D]}.bind(null,C));return k},S.n=function(_){var g=_&&_.__esModule?function(){return _.default}:function(){return _};return S.d(g,"a",g),g},S.o=function(_,g){return Object.prototype.hasOwnProperty.call(_,g)},S.p="",S(S.s=0)}([function(Q,e,S){(function(_){var g;e=Q.exports=ne,g=typeof _=="object"&&_.env&&_.env.NODE_DEBUG&&/\bsemver\b/i.test(_.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],d=e.src=[],y=0,i=y++;d[i]="0|[1-9]\\d*";var A=y++;d[A]="[0-9]+";var E=y++;d[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=y++;d[b]="("+d[i]+")\\.("+d[i]+")\\.("+d[i]+")";var o=y++;d[o]="("+d[A]+")\\.("+d[A]+")\\.("+d[A]+")";var u=y++;d[u]="(?:"+d[i]+"|"+d[E]+")";var w=y++;d[w]="(?:"+d[A]+"|"+d[E]+")";var p=y++;d[p]="(?:-("+d[u]+"(?:\\."+d[u]+")*))";var h=y++;d[h]="(?:-?("+d[w]+"(?:\\."+d[w]+")*))";var f=y++;d[f]="[0-9A-Za-z-]+";var c=y++;d[c]="(?:\\+("+d[f]+"(?:\\."+d[f]+")*))";var a=y++,t="v?"+d[b]+d[p]+"?"+d[c]+"?";d[a]="^"+t+"$";var s="[v=\\s]*"+d[o]+d[h]+"?"+d[c]+"?",n=y++;d[n]="^"+s+"$";var r=y++;d[r]="((?:<|>)?=?)";var l=y++;d[l]=d[A]+"|x|X|\\*";var v=y++;d[v]=d[i]+"|x|X|\\*";var P=y++;d[P]="[v=\\s]*("+d[v]+")(?:\\.("+d[v]+")(?:\\.("+d[v]+")(?:"+d[p]+")?"+d[c]+"?)?)?";var L=y++;d[L]="[v=\\s]*("+d[l]+")(?:\\.("+d[l]+")(?:\\.("+d[l]+")(?:"+d[h]+")?"+d[c]+"?)?)?";var R=y++;d[R]="^"+d[r]+"\\s*"+d[P]+"$";var m=y++;d[m]="^"+d[r]+"\\s*"+d[L]+"$";var T=y++;d[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=y++;d[I]="(?:~>?)";var B=y++;d[B]="(\\s*)"+d[I]+"\\s+",D[B]=new RegExp(d[B],"g");var j=y++;d[j]="^"+d[I]+d[P]+"$";var ue=y++;d[ue]="^"+d[I]+d[L]+"$";var ce=y++;d[ce]="(?:\\^)";var O=y++;d[O]="(\\s*)"+d[ce]+"\\s+",D[O]=new RegExp(d[O],"g");var $=y++;d[$]="^"+d[ce]+d[P]+"$";var z=y++;d[z]="^"+d[ce]+d[L]+"$";var ee=y++;d[ee]="^"+d[r]+"\\s*("+s+")$|^$";var J=y++;d[J]="^"+d[r]+"\\s*("+t+")$|^$";var H=y++;d[H]="(\\s*)"+d[r]+"\\s*("+s+"|"+d[P]+")",D[H]=new RegExp(d[H],"g");var X=y++;d[X]="^\\s*("+d[P]+")\\s+-\\s+("+d[P]+")\\s*$";var q=y++;d[q]="^\\s*("+d[L]+")\\s+-\\s+("+d[L]+")\\s*$";var W=y++;d[W]="(<|>)?=?\\s*\\*";for(var U=0;U<35;U++)g(U,d[U]),D[U]||(D[U]=new RegExp(d[U]));function ie(oe,pe){if(oe instanceof ne)return oe;if(typeof oe!="string"||oe.length>k||!(pe?D[n]:D[a]).test(oe))return null;try{return new ne(oe,pe)}catch(Se){return null}}function ne(oe,pe){if(oe instanceof ne){if(oe.loose===pe)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof ne))return new ne(oe,pe);g("SemVer",oe,pe),this.loose=pe;var Se=oe.trim().match(pe?D[n]:D[a]);if(!Se)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+Se[1],this.minor=+Se[2],this.patch=+Se[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");Se[4]?this.prerelease=Se[4].split(".").map(function(Be){if(/^[0-9]+$/.test(Be)){var xe=+Be;if(xe>=0&&xe<C)return xe}return Be}):this.prerelease=[],this.build=Se[5]?Se[5].split("."):[],this.format()}e.parse=ie,e.valid=function(oe,pe){var Se=ie(oe,pe);return Se?Se.version:null},e.clean=function(oe,pe){var Se=ie(oe.trim().replace(/^[=v]+/,""),pe);return Se?Se.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(oe){return g("SemVer.compare",this.version,this.loose,oe),oe instanceof ne||(oe=new ne(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},ne.prototype.compareMain=function(oe){return oe instanceof ne||(oe=new ne(oe,this.loose)),ve(this.major,oe.major)||ve(this.minor,oe.minor)||ve(this.patch,oe.patch)},ne.prototype.comparePre=function(oe){if(oe instanceof ne||(oe=new ne(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var pe=0;do{var Se=this.prerelease[pe],Be=oe.prerelease[pe];if(g("prerelease compare",pe,Se,Be),Se===void 0&&Be===void 0)return 0;if(Be===void 0)return 1;if(Se===void 0)return-1;if(Se!==Be)return ve(Se,Be)}while(++pe)},ne.prototype.inc=function(oe,pe){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Se=this.prerelease.length;--Se>=0;)typeof this.prerelease[Se]=="number"&&(this.prerelease[Se]++,Se=-2);Se===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,pe,Se,Be){typeof Se=="string"&&(Be=Se,Se=void 0);try{return new ne(oe,Se).inc(pe,Be).version}catch(xe){return null}},e.diff=function(oe,pe){if(qe(oe,pe))return null;var Se=ie(oe),Be=ie(pe);if(Se.prerelease.length||Be.prerelease.length){for(var xe in Se)if((xe==="major"||xe==="minor"||xe==="patch")&&Se[xe]!==Be[xe])return"pre"+xe;return"prerelease"}for(var xe in Se)if((xe==="major"||xe==="minor"||xe==="patch")&&Se[xe]!==Be[xe])return xe},e.compareIdentifiers=ve;var he=/^[0-9]+$/;function ve(oe,pe){var Se=he.test(oe),Be=he.test(pe);return Se&&Be&&(oe=+oe,pe=+pe),Se&&!Be?-1:Be&&!Se?1:oe<pe?-1:oe>pe?1:0}function Ae(oe,pe,Se){return new ne(oe,Se).compare(new ne(pe,Se))}function Ie(oe,pe,Se){return Ae(oe,pe,Se)>0}function Ue(oe,pe,Se){return Ae(oe,pe,Se)<0}function qe(oe,pe,Se){return Ae(oe,pe,Se)===0}function Ge(oe,pe,Se){return Ae(oe,pe,Se)!==0}function rt(oe,pe,Se){return Ae(oe,pe,Se)>=0}function it(oe,pe,Se){return Ae(oe,pe,Se)<=0}function de(oe,pe,Se,Be){var xe;switch(pe){case"===":typeof oe=="object"&&(oe=oe.version),typeof Se=="object"&&(Se=Se.version),xe=oe===Se;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof Se=="object"&&(Se=Se.version),xe=oe!==Se;break;case"":case"=":case"==":xe=qe(oe,Se,Be);break;case"!=":xe=Ge(oe,Se,Be);break;case">":xe=Ie(oe,Se,Be);break;case">=":xe=rt(oe,Se,Be);break;case"<":xe=Ue(oe,Se,Be);break;case"<=":xe=it(oe,Se,Be);break;default:throw new TypeError("Invalid operator: "+pe)}return xe}function be(oe,pe){if(oe instanceof be){if(oe.loose===pe)return oe;oe=oe.value}if(!(this instanceof be))return new be(oe,pe);g("comparator",oe,pe),this.loose=pe,this.parse(oe),this.semver===Pe?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(oe,pe){return ve(pe,oe)},e.major=function(oe,pe){return new ne(oe,pe).major},e.minor=function(oe,pe){return new ne(oe,pe).minor},e.patch=function(oe,pe){return new ne(oe,pe).patch},e.compare=Ae,e.compareLoose=function(oe,pe){return Ae(oe,pe,!0)},e.rcompare=function(oe,pe,Se){return Ae(pe,oe,Se)},e.sort=function(oe,pe){return oe.sort(function(Se,Be){return e.compare(Se,Be,pe)})},e.rsort=function(oe,pe){return oe.sort(function(Se,Be){return e.rcompare(Se,Be,pe)})},e.gt=Ie,e.lt=Ue,e.eq=qe,e.neq=Ge,e.gte=rt,e.lte=it,e.cmp=de,e.Comparator=be;var Pe={};function Re(oe,pe){if(oe instanceof Re)return oe.loose===pe?oe:new Re(oe.raw,pe);if(oe instanceof be)return new Re(oe.value,pe);if(!(this instanceof Re))return new Re(oe,pe);if(this.loose=pe,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(Se){return this.parseRange(Se.trim())},this).filter(function(Se){return Se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Ne(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function He(oe,pe,Se,Be,xe,ot,Qe,at,Ze,K,we,ke,Oe){return((pe=Ne(Se)?"":Ne(Be)?">="+Se+".0.0":Ne(xe)?">="+Se+"."+Be+".0":">="+pe)+" "+(at=Ne(Ze)?"":Ne(K)?"<"+(+Ze+1)+".0.0":Ne(we)?"<"+Ze+"."+(+K+1)+".0":ke?"<="+Ze+"."+K+"."+we+"-"+ke:"<="+at)).trim()}function Ke(oe,pe){for(var Se=0;Se<oe.length;Se++)if(!oe[Se].test(pe))return!1;if(pe.prerelease.length){for(Se=0;Se<oe.length;Se++)if(g(oe[Se].semver),oe[Se].semver!==Pe&&oe[Se].semver.prerelease.length>0){var Be=oe[Se].semver;if(Be.major===pe.major&&Be.minor===pe.minor&&Be.patch===pe.patch)return!0}return!1}return!0}function Je(oe,pe,Se){try{pe=new Re(pe,Se)}catch(Be){return!1}return pe.test(oe)}function st(oe,pe,Se,Be){var xe,ot,Qe,at,Ze;switch(oe=new ne(oe,Be),pe=new Re(pe,Be),Se){case">":xe=Ie,ot=it,Qe=Ue,at=">",Ze=">=";break;case"<":xe=Ue,ot=rt,Qe=Ie,at="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Je(oe,pe,Be))return!1;for(var K=0;K<pe.set.length;++K){var we=pe.set[K],ke=null,Oe=null;if(we.forEach(function(Te){Te.semver===Pe&&(Te=new be(">=0.0.0")),ke=ke||Te,Oe=Oe||Te,xe(Te.semver,ke.semver,Be)?ke=Te:Qe(Te.semver,Oe.semver,Be)&&(Oe=Te)}),ke.operator===at||ke.operator===Ze||(!Oe.operator||Oe.operator===at)&&ot(oe,Oe.semver)||Oe.operator===Ze&&Qe(oe,Oe.semver))return!1}return!0}be.prototype.parse=function(oe){var pe=this.loose?D[ee]:D[J],Se=oe.match(pe);if(!Se)throw new TypeError("Invalid comparator: "+oe);this.operator=Se[1],this.operator==="="&&(this.operator=""),Se[2]?this.semver=new ne(Se[2],this.loose):this.semver=Pe},be.prototype.toString=function(){return this.value},be.prototype.test=function(oe){return g("Comparator.test",oe,this.loose),this.semver===Pe||(typeof oe=="string"&&(oe=new ne(oe,this.loose)),de(oe,this.operator,this.semver,this.loose))},be.prototype.intersects=function(oe,pe){if(!(oe instanceof be))throw new TypeError("a Comparator is required");var Se;if(this.operator==="")return Se=new Re(oe.value,pe),Je(this.value,Se,pe);if(oe.operator==="")return Se=new Re(this.value,pe),Je(oe.semver,Se,pe);var Be=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),ot=this.semver.version===oe.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),at=de(this.semver,"<",oe.semver,pe)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Ze=de(this.semver,">",oe.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Be||xe||ot&&Qe||at||Ze},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(oe){var pe=this.loose;oe=oe.trim(),g("range",oe,pe);var Se=pe?D[q]:D[X];oe=oe.replace(Se,He),g("hyphen replace",oe),oe=oe.replace(D[H],"$1$2$3"),g("comparator trim",oe,D[H]),oe=(oe=(oe=oe.replace(D[B],"$1~")).replace(D[O],"$1^")).split(/\s+/).join(" ");var Be=pe?D[ee]:D[J],xe=oe.split(" ").map(function(ot){return function(Qe,at){return g("comp",Qe),Qe=function(Ze,K){return Ze.trim().split(/\s+/).map(function(we){return function(ke,Oe){g("caret",ke,Oe);var Te=Oe?D[z]:D[$];return ke.replace(Te,function(We,Z,te,le,V){var x;return g("caret",ke,We,Z,te,le,V),Ne(Z)?x="":Ne(te)?x=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ne(le)?x=Z==="0"?">="+Z+"."+te+".0 <"+Z+"."+(+te+1)+".0":">="+Z+"."+te+".0 <"+(+Z+1)+".0.0":V?(g("replaceCaret pr",V),V.charAt(0)!=="-"&&(V="-"+V),x=Z==="0"?te==="0"?">="+Z+"."+te+"."+le+V+" <"+Z+"."+te+"."+(+le+1):">="+Z+"."+te+"."+le+V+" <"+Z+"."+(+te+1)+".0":">="+Z+"."+te+"."+le+V+" <"+(+Z+1)+".0.0"):(g("no pr"),x=Z==="0"?te==="0"?">="+Z+"."+te+"."+le+" <"+Z+"."+te+"."+(+le+1):">="+Z+"."+te+"."+le+" <"+Z+"."+(+te+1)+".0":">="+Z+"."+te+"."+le+" <"+(+Z+1)+".0.0"),g("caret return",x),x})}(we,K)}).join(" ")}(Qe,at),g("caret",Qe),Qe=function(Ze,K){return Ze.trim().split(/\s+/).map(function(we){return function(ke,Oe){var Te=Oe?D[ue]:D[j];return ke.replace(Te,function(We,Z,te,le,V){var x;return g("tilde",ke,We,Z,te,le,V),Ne(Z)?x="":Ne(te)?x=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ne(le)?x=">="+Z+"."+te+".0 <"+Z+"."+(+te+1)+".0":V?(g("replaceTilde pr",V),V.charAt(0)!=="-"&&(V="-"+V),x=">="+Z+"."+te+"."+le+V+" <"+Z+"."+(+te+1)+".0"):x=">="+Z+"."+te+"."+le+" <"+Z+"."+(+te+1)+".0",g("tilde return",x),x})}(we,K)}).join(" ")}(Qe,at),g("tildes",Qe),Qe=function(Ze,K){return g("replaceXRanges",Ze,K),Ze.split(/\s+/).map(function(we){return function(ke,Oe){ke=ke.trim();var Te=Oe?D[m]:D[R];return ke.replace(Te,function(We,Z,te,le,V,x){g("xRange",ke,We,Z,te,le,V,x);var se=Ne(te),re=se||Ne(le),Ee=re||Ne(V);return Z==="="&&Ee&&(Z=""),se?We=Z===">"||Z==="<"?"<0.0.0":"*":Z&&Ee?(re&&(le=0),Ee&&(V=0),Z===">"?(Z=">=",re?(te=+te+1,le=0,V=0):Ee&&(le=+le+1,V=0)):Z==="<="&&(Z="<",re?te=+te+1:le=+le+1),We=Z+te+"."+le+"."+V):re?We=">="+te+".0.0 <"+(+te+1)+".0.0":Ee&&(We=">="+te+"."+le+".0 <"+te+"."+(+le+1)+".0"),g("xRange return",We),We})}(we,K)}).join(" ")}(Qe,at),g("xrange",Qe),Qe=function(Ze,K){return g("replaceStars",Ze,K),Ze.trim().replace(D[W],"")}(Qe,at),g("stars",Qe),Qe}(ot,pe)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(ot){return!!ot.match(Be)})),xe=xe.map(function(ot){return new be(ot,pe)})},Re.prototype.intersects=function(oe,pe){if(!(oe instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(Se){return Se.every(function(Be){return oe.set.some(function(xe){return xe.every(function(ot){return Be.intersects(ot,pe)})})})})},e.toComparators=function(oe,pe){return new Re(oe,pe).set.map(function(Se){return Se.map(function(Be){return Be.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new ne(oe,this.loose));for(var pe=0;pe<this.set.length;pe++)if(Ke(this.set[pe],oe))return!0;return!1},e.satisfies=Je,e.maxSatisfying=function(oe,pe,Se){var Be=null,xe=null;try{var ot=new Re(pe,Se)}catch(Qe){return null}return oe.forEach(function(Qe){ot.test(Qe)&&(Be&&xe.compare(Qe)!==-1||(xe=new ne(Be=Qe,Se)))}),Be},e.minSatisfying=function(oe,pe,Se){var Be=null,xe=null;try{var ot=new Re(pe,Se)}catch(Qe){return null}return oe.forEach(function(Qe){ot.test(Qe)&&(Be&&xe.compare(Qe)!==1||(xe=new ne(Be=Qe,Se)))}),Be},e.validRange=function(oe,pe){try{return new Re(oe,pe).range||"*"}catch(Se){return null}},e.ltr=function(oe,pe,Se){return st(oe,pe,"<",Se)},e.gtr=function(oe,pe,Se){return st(oe,pe,">",Se)},e.outside=st,e.prerelease=function(oe,pe){var Se=ie(oe,pe);return Se&&Se.prerelease.length?Se.prerelease:null},e.intersects=function(oe,pe,Se){return oe=new Re(oe,Se),pe=new Re(pe,Se),oe.intersects(pe)},e.coerce=function(oe){if(oe instanceof ne)return oe;if(typeof oe!="string")return null;var pe=oe.match(D[T]);return pe==null?null:ie((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,S(1))},function(Q,e){var S,_,g=Q.exports={};function k(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function D(w){if(S===setTimeout)return setTimeout(w,0);if((S===k||!S)&&setTimeout)return S=setTimeout,setTimeout(w,0);try{return S(w,0)}catch(p){try{return S.call(null,w,0)}catch(h){return S.call(this,w,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:k}catch(w){S=k}try{_=typeof clearTimeout=="function"?clearTimeout:C}catch(w){_=C}})();var d,y=[],i=!1,A=-1;function E(){i&&d&&(i=!1,d.length?y=d.concat(y):A=-1,y.length&&b())}function b(){if(!i){var w=D(E);i=!0;for(var p=y.length;p;){for(d=y,y=[];++A<p;)d&&d[A].run();A=-1,p=y.length}d=null,i=!1,function(h){if(_===clearTimeout)return clearTimeout(h);if((_===C||!_)&&clearTimeout)return _=clearTimeout,clearTimeout(h);try{_(h)}catch(f){try{return _.call(null,h)}catch(c){return _.call(this,h)}}}(w)}}function o(w,p){this.fun=w,this.array=p}function u(){}g.nextTick=function(w){var p=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)p[h-1]=arguments[h];y.push(new o(w,p)),y.length!==1||i||D(b)},o.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=u,g.addListener=u,g.once=u,g.off=u,g.removeListener=u,g.removeAllListeners=u,g.emit=u,g.prependListener=u,g.prependOnceListener=u,g.listeners=function(w){return[]},g.binding=function(w){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(w){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(me[117],ge([0,1,3]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const _=S.globals.performance&&typeof S.globals.performance.now=="function";class g{constructor(C){this._highResolution=_&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new g(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=g}),define(me[7],ge([0,1,11,72,2,114,117]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(f){f.None=()=>g.Disposable.None;function c(ce){return(O,$=null,z)=>{let ee=!1,J;return J=ce(H=>{if(!ee)return J?J.dispose():ee=!0,O.call($,H)},null,z),ee&&J.dispose(),J}}f.once=c;function a(ce,O){return v(($,z=null,ee)=>ce(J=>$.call(z,O(J)),null,ee))}f.map=a;function t(ce,O){return v(($,z=null,ee)=>ce(J=>{O(J),$.call(z,J)},null,ee))}f.forEach=t;function s(ce,O){return v(($,z=null,ee)=>ce(J=>O(J)&&$.call(z,J),null,ee))}f.filter=s;function n(ce){return ce}f.signal=n;function r(...ce){return(O,$=null,z)=>(0,g.combinedDisposable)(...ce.map(ee=>ee(J=>O.call($,J),null,z)))}f.any=r;function l(ce,O,$){let z=$;return a(ce,ee=>(z=O(z,ee),z))}f.reduce=l;function v(ce){let O;const $=new E({onFirstListenerAdd(){O=ce($.fire,$)},onLastListenerRemove(){O.dispose()}});return $.event}function P(ce,O,$=100,z=!1,ee){let J,H,X,q=0;const W=new E({leakWarningThreshold:ee,onFirstListenerAdd(){J=ce(U=>{q++,H=O(H,U),z&&!X&&(W.fire(H),H=void 0),clearTimeout(X),X=setTimeout(()=>{const ie=H;H=void 0,X=void 0,(!z||q>1)&&W.fire(ie),q=0},$)})},onLastListenerRemove(){J.dispose()}});return W.event}f.debounce=P;function L(ce,O=($,z)=>$===z){let $=!0,z;return s(ce,ee=>{const J=$||!O(ee,z);return $=!1,z=ee,J})}f.latch=L;function R(ce,O){return[f.filter(ce,O),f.filter(ce,$=>!O($))]}f.split=R;function m(ce,O=!1,$=[]){let z=$.slice(),ee=ce(X=>{z?z.push(X):H.fire(X)});const J=()=>{z&&z.forEach(X=>H.fire(X)),z=null},H=new E({onFirstListenerAdd(){ee||(ee=ce(X=>H.fire(X)))},onFirstListenerDidAdd(){z&&(O?setTimeout(J):J())},onLastListenerRemove(){ee&&ee.dispose(),ee=null}});return H.event}f.buffer=m;class T{constructor(O){this.event=O}map(O){return new T(a(this.event,O))}forEach(O){return new T(t(this.event,O))}filter(O){return new T(s(this.event,O))}reduce(O,$){return new T(l(this.event,O,$))}latch(){return new T(L(this.event))}debounce(O,$=100,z=!1,ee){return new T(P(this.event,O,$,z,ee))}on(O,$,z){return this.event(O,$,z)}once(O,$,z){return c(this.event)(O,$,z)}}function I(ce){return new T(ce)}f.chain=I;function B(ce,O,$=z=>z){const z=(...X)=>H.fire($(...X)),ee=()=>ce.on(O,z),J=()=>ce.removeListener(O,z),H=new E({onFirstListenerAdd:ee,onLastListenerRemove:J});return H.event}f.fromNodeEventEmitter=B;function j(ce,O,$=z=>z){const z=(...X)=>H.fire($(...X)),ee=()=>ce.addEventListener(O,z),J=()=>ce.removeEventListener(O,z),H=new E({onFirstListenerAdd:ee,onLastListenerRemove:J});return H.event}f.fromDOMEventEmitter=j;function ue(ce){return new Promise(O=>c(ce)(O))}f.toPromise=ue})(D=e.Event||(e.Event={}));class d{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${d._idPool++}`}start(c){this._stopWatch=new C.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let y=-1;function i(f){const c=y;return y=f,{dispose(){y=c}}}e.setGlobalLeakWarningThreshold=i;class A{constructor(c,a=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let a=y;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||c<a)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let n,r=0;for(const[l,v]of this._stacks)(!n||r<v)&&(n=l,r=v);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${r}):`),console.warn(n)}return()=>{const n=this._stacks.get(t)||0;this._stacks.set(t,n-1)}}}class E{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=y>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0}get event(){return this._event||(this._event=(c,a,t)=>{this._listeners||(this._listeners=new k.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(a?[c,a]:c);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,a);const r=this._leakageMon?.check(this._listeners.size),l=(0,g.toDisposable)(()=>{r&&r(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof g.DisposableStore?t.add(l):Array.isArray(t)&&t.push(l),l}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(s){(0,S.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=E;class b extends E{async fireAsync(c,a,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,c]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[s,n]=this._asyncDeliveryQueue.shift(),r=[],l={...n,waitUntil:v=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");t&&(v=t(v,typeof s=="function"?s:s[0])),r.push(v)}};try{typeof s=="function"?s.call(void 0,l):s[0].call(s[1],l)}catch(v){(0,S.onUnexpectedError)(v);continue}Object.freeze(r),await Promise.allSettled(r).then(v=>{for(const P of v)P.status==="rejected"&&(0,S.onUnexpectedError)(P.reason)})}}}}e.AsyncEmitter=b;class o extends E{constructor(c){super(c);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=o;class u extends o{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=u;class w{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const a={event:c,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const t=()=>{this.hasListeners&&this.unhook(a);const s=this.events.indexOf(a);this.events.splice(s,1)};return(0,g.toDisposable)((0,_.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(a=>this.emitter.fire(a))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=w;class p{constructor(){this.buffers=[]}wrapEvent(c){return(a,t,s)=>c(n=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>a.call(t,n)):a.call(t,n)},void 0,s)}bufferEvents(c){const a=[];this.buffers.push(a);const t=c();return this.buffers.pop(),a.forEach(s=>s()),t}}e.EventBufferer=p;class h{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=g.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(me[25],ge([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const _=Object.freeze(function(D,d){const y=setTimeout(D.bind(d),0);return{dispose(){clearTimeout(y)}}});var g;(function(D){function d(y){return y===D.None||y===D.Cancelled||y instanceof k?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}D.isCancellationToken=d,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:_})})(g=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?_:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=g.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=g.None}}e.CancellationTokenSource=C}),define(me[39],ge([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class _{constructor(){this._icons=new Map,this._onDidRegister=new S.Emitter}add(A){const E=this._icons.get(A.id);E?A.description?E.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const g=new _;e.iconRegistry=g;function k(i,A){return new D(i,A)}e.registerCodicon=k;function C(i){return i?i.replace(/\$\((.*?)\)/g,(A,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=C;class D{constructor(A,E,b){this.id=A,this.definition=E,this.description=b,g.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function d(i,A){const E=["codicon","codicon-"+i];return A&&E.push("codicon-modifier-"+A),E}e.getClassNamesArray=d;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function E(u){if(u instanceof D)return["codicon","codicon-"+u.id];const w=A.exec(u.id);if(!w)return E(D.error);let[,p,h]=w;const f=["codicon","codicon-"+p];return h&&f.push("codicon-modifier-"+h.substr(1)),f}i.asClassNameArray=E;function b(u){return E(u).join(" ")}i.asClassName=b;function o(u){return"."+E(u).join(".")}i.asCSSSelector=o})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(me[42],ge([0,1,11,2]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function g(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=g;function k(f){const c=f;return c?g(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=k;function C(f,c){return new D(f,c)}e.newWriteableStream=C;class D{constructor(c,a){this.reducer=c,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(a=>a(c))}emitError(c){this.listeners.error.length===0?(0,S.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(a=>a(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,a){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(c,a){if(this.state.destroyed)return;let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(a);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(f,c){const a=[];let t;for(;(t=f.read())!==null;)a.push(t);return c(a)}e.consumeReadable=d;function y(f,c,a){const t=[];let s;for(;(s=f.read())!==null&&t.length<a;)t.push(s);return s===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const n=s;return s=void 0,n}return f.read()}}}e.peekReadable=y;function i(f,c){return new Promise((a,t)=>{const s=[];A(f,{onData:n=>{c&&s.push(n)},onError:n=>{c?t(n):a(void 0)},onEnd:()=>{a(c?c(s):void 0)}})})}e.consumeStream=i;function A(f,c){f.on("error",a=>c.onError(a)),f.on("end",()=>c.onEnd()),f.on("data",a=>c.onData(a))}e.listenStream=A;function E(f,c){return new Promise((a,t)=>{const s=new _.DisposableStore,n=[],r=P=>{if(n.push(P),n.length>c)return s.dispose(),f.pause(),a({stream:f,buffer:n,ended:!1})},l=P=>t(P),v=()=>a({stream:f,buffer:n,ended:!0});s.add((0,_.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),s.add((0,_.toDisposable)(()=>f.removeListener("end",v))),f.on("end",v),s.add((0,_.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}e.peekStream=E;function b(f,c){const a=C(c);return a.end(f),a}e.toStream=b;function o(){const f=C(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=o;function u(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=u;function w(f,c,a){const t=C(a);return A(f,{onData:s=>t.write(c.data(s)),onError:s=>t.error(c.error?c.error(s):s),onEnd:()=>t.end()}),t}e.transform=w;function p(f,c,a){let t=!1;return{read:()=>{const s=c.read();return t?s:(t=!0,s!==null?a([f,s]):f)}}}e.prefixedReadable=p;function h(f,c,a){let t=!1;const s=C(a);return A(c,{onData:n=>t?s.write(n):(t=!0,s.write(a([f,n]))),onError:n=>s.error(n),onEnd:()=>{t||(t=!0,s.write(f)),s.end()}}),s}e.prefixedStream=h}),define(me[17],ge([0,1,42]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const _=typeof Buffer!="undefined";let g,k;class C{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return _?new C(Buffer.allocUnsafe(r)):new C(new Uint8Array(r))}static wrap(r){return _&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new C(r)}static fromString(r,l){return!(l?.dontUseNodeBuffer||!1)&&_?new C(Buffer.from(r)):(g||(g=new TextEncoder),new C(g.encode(r)))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let L=0,R=r.length;L<R;L++)l+=r[L].byteLength}const v=C.alloc(l);let P=0;for(let L=0,R=r.length;L<R;L++){const m=r[L];v.set(m,P),P+=m.byteLength}return v}toString(){return _?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(r,l){return new C(this.buffer.subarray(r,l))}set(r,l){r instanceof C?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return y(this.buffer,r)}writeUInt32BE(r,l){i(this.buffer,r,l)}readUInt32LE(r){return A(this.buffer,r)}writeUInt32LE(r,l){E(this.buffer,r,l)}readUInt8(r){return b(this.buffer,r)}writeUInt8(r,l){o(this.buffer,r,l)}}e.VSBuffer=C;function D(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=D;function d(n,r,l){n[l+0]=r&255,r=r>>>8,n[l+1]=r&255}e.writeUInt16LE=d;function y(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=y;function i(n,r,l){n[l+3]=r,r=r>>>8,n[l+2]=r,r=r>>>8,n[l+1]=r,r=r>>>8,n[l]=r}e.writeUInt32BE=i;function A(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=A;function E(n,r,l){n[l+0]=r&255,r=r>>>8,n[l+1]=r&255,r=r>>>8,n[l+2]=r&255,r=r>>>8,n[l+3]=r&255}e.writeUInt32LE=E;function b(n,r){return n[r]}e.readUInt8=b;function o(n,r,l){n[l]=r}e.writeUInt8=o;function u(n){return S.consumeReadable(n,r=>C.concat(r))}e.readableToBuffer=u;function w(n){return S.toReadable(n)}e.bufferToReadable=w;function p(n){return S.consumeStream(n,r=>C.concat(r))}e.streamToBuffer=p;async function h(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await p(n.stream)])}e.bufferedStreamToBuffer=h;function f(n){return S.toStream(n,r=>C.concat(r))}e.bufferToStream=f;function c(n){return S.transform(n,{data:r=>typeof r=="string"?C.fromString(r):C.wrap(r)},r=>C.concat(r))}e.streamToBufferReadableStream=c;function a(n){return S.newWriteableStream(r=>C.concat(r),n)}e.newWriteableBufferStream=a;function t(n,r){return S.prefixedReadable(n,r,l=>C.concat(l))}e.prefixedBufferReadable=t;function s(n,r){return S.prefixedStream(n,r,l=>C.concat(l))}e.prefixedBufferStream=s}),define(me[15],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function S(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=S;const _=/{(\d+)}/g;function g(K,...we){return we.length===0?K:K.replace(_,function(ke,Oe){const Te=parseInt(Oe,10);return isNaN(Te)||Te<0||Te>=we.length?ke:we[Te]})}e.format=g;const k=/{([^}]+)}/g;function C(K,we){return K.replace(k,(ke,Oe)=>we[Oe]??ke)}e.format2=C;function D(K){return K.replace(/[<>&]/g,function(we){switch(we){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return we}})}e.escape=D;function d(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=d;function y(K,we){let ke=0;const Oe=we.charCodeAt(0);for(let Te=K.length-1;Te>=0;Te--)K.charCodeAt(Te)===Oe&&ke++;return ke}e.count=y;function i(K,we,ke="\u2026"){return K.length<=we?K:`${K.substr(0,we)}${ke}`}e.truncate=i;function A(K,we=" "){const ke=E(K,we);return b(ke,we)}e.trim=A;function E(K,we){if(!K||!we)return K;const ke=we.length;if(ke===0||K.length===0)return K;let Oe=0;for(;K.indexOf(we,Oe)===Oe;)Oe=Oe+ke;return K.substring(Oe)}e.ltrim=E;function b(K,we){if(!K||!we)return K;const ke=we.length,Oe=K.length;if(ke===0||Oe===0)return K;let Te=Oe,We=-1;for(;We=K.lastIndexOf(we,Te-1),!(We===-1||We+ke!==Te);){if(We===0)return"";Te=We}return K.substring(0,Te)}e.rtrim=b;function o(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function u(K){return K.replace(/\*/g,"")}e.stripWildcards=u;function w(K,we,ke={}){if(!K)throw new Error("Cannot create regex from empty string");we||(K=d(K)),ke.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Oe="";return ke.global&&(Oe+="g"),ke.matchCase||(Oe+="i"),ke.multiline&&(Oe+="m"),ke.unicode&&(Oe+="u"),new RegExp(K,Oe)}e.createRegExp=w;function p(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function h(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=h;function f(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=f;function c(K){return K.split(/\r\n|\r|\n/)}e.splitLines=c;function a(K){for(let we=0,ke=K.length;we<ke;we++){const Oe=K.charCodeAt(we);if(Oe!==32&&Oe!==9)return we}return-1}e.firstNonWhitespaceIndex=a;function t(K,we=0,ke=K.length){for(let Oe=we;Oe<ke;Oe++){const Te=K.charCodeAt(Oe);if(Te!==32&&Te!==9)return K.substring(we,Oe)}return K.substring(we,ke)}e.getLeadingWhitespace=t;function s(K,we=K.length-1){for(let ke=we;ke>=0;ke--){const Oe=K.charCodeAt(ke);if(Oe!==32&&Oe!==9)return ke}return-1}e.lastNonWhitespaceIndex=s;function n(K,we){return K<we?-1:K>we?1:0}e.compare=n;function r(K,we,ke=0,Oe=K.length,Te=0,We=we.length){for(;ke<Oe&&Te<We;ke++,Te++){let le=K.charCodeAt(ke),V=we.charCodeAt(Te);if(le<V)return-1;if(le>V)return 1}const Z=Oe-ke,te=We-Te;return Z<te?-1:Z>te?1:0}e.compareSubstring=r;function l(K,we){return v(K,we,0,K.length,0,we.length)}e.compareIgnoreCase=l;function v(K,we,ke=0,Oe=K.length,Te=0,We=we.length){for(;ke<Oe&&Te<We;ke++,Te++){let le=K.charCodeAt(ke),V=we.charCodeAt(Te);if(le===V)continue;const x=le-V;if(!(x===32&&L(V))&&!(x===-32&&L(le)))return P(le)&&P(V)?x:r(K.toLowerCase(),we.toLowerCase(),ke,Oe,Te,We)}const Z=Oe-ke,te=We-Te;return Z<te?-1:Z>te?1:0}e.compareSubstringIgnoreCase=v;function P(K){return K>=97&&K<=122}e.isLowerAsciiLetter=P;function L(K){return K>=65&&K<=90}e.isUpperAsciiLetter=L;function R(K){return P(K)||L(K)}function m(K,we){return K.length===we.length&&T(K,we)}e.equalsIgnoreCase=m;function T(K,we,ke=K.length){for(let Oe=0;Oe<ke;Oe++){const Te=K.charCodeAt(Oe),We=we.charCodeAt(Oe);if(Te!==We){if(R(Te)&&R(We)){const Z=Math.abs(Te-We);if(Z!==0&&Z!==32)return!1}else if(String.fromCharCode(Te).toLowerCase()!==String.fromCharCode(We).toLowerCase())return!1}}return!0}function I(K,we){const ke=we.length;return we.length>K.length?!1:T(K,we,ke)}e.startsWithIgnoreCase=I;function B(K,we){let ke,Oe=Math.min(K.length,we.length);for(ke=0;ke<Oe;ke++)if(K.charCodeAt(ke)!==we.charCodeAt(ke))return ke;return Oe}e.commonPrefixLength=B;function j(K,we){let ke,Oe=Math.min(K.length,we.length);const Te=K.length-1,We=we.length-1;for(ke=0;ke<Oe;ke++)if(K.charCodeAt(Te-ke)!==we.charCodeAt(We-ke))return ke;return Oe}e.commonSuffixLength=j;function ue(K){return 55296<=K&&K<=56319}e.isHighSurrogate=ue;function ce(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ce;function O(K,we){return(K-55296<<10)+(we-56320)+65536}e.computeCodePoint=O;function $(K,we,ke){const Oe=K.charCodeAt(ke);if(ue(Oe)&&ke+1<we){const Te=K.charCodeAt(ke+1);if(ce(Te))return O(Oe,Te)}return Oe}e.getNextCodePoint=$;function z(K,we){const ke=K.charCodeAt(we-1);if(ce(ke)&&we>1){const Oe=K.charCodeAt(we-2);if(ue(Oe))return O(Oe,ke)}return ke}function ee(K,we){const ke=Se.getInstance(),Oe=we,Te=K.length,We=$(K,Te,we);we+=We>=65536?2:1;let Z=ke.getGraphemeBreakType(We);for(;we<Te;){const te=$(K,Te,we),le=ke.getGraphemeBreakType(te);if(oe(Z,le))break;we+=te>=65536?2:1,Z=le}return we-Oe}e.nextCharLength=ee;function J(K,we){const ke=Se.getInstance(),Oe=we,Te=z(K,we);we-=Te>=65536?2:1;let We=ke.getGraphemeBreakType(Te);for(;we>0;){const Z=z(K,we),te=ke.getGraphemeBreakType(Z);if(oe(te,We))break;we-=Z>=65536?2:1,We=te}return Oe-we}e.prevCharLength=J;function H(K,we){const ke=Se.getInstance(),Oe=K.length,Te=we,We=$(K,Oe,we),Z=ke.getGraphemeBreakType(We);we+=We>=65536?2:1;let te=Z;for(;we<Oe;){const V=$(K,Oe,we),x=ke.getGraphemeBreakType(V);if(oe(te,x))break;we+=V>=65536?2:1,te=x}const le=we;for(we=Te,te=Z;we>0;){const V=z(K,we),x=ke.getGraphemeBreakType(V);if(oe(x,te))break;we-=V>=65536?2:1,te=x}return[we,le]}function X(K,we){return we>0&&ce(K.charCodeAt(we))?H(K,we-1):H(K,we)}e.getCharContainingOffset=X;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(K){return q.test(K)}e.containsRTL=W;const U=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ie(K){return U.test(K)}e.containsEmoji=ie;const ne=/^[\t\n\r\x20-\x7E]*$/;function he(K){return ne.test(K)}e.isBasicASCII=he,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ve(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=ve;function Ae(K){for(let we=0,ke=K.length;we<ke;we++)if(Ie(K.charCodeAt(we)))return!0;return!1}e.containsFullWidthCharacter=Ae;function Ie(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=Ie;function Ue(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=Ue;function qe(K,we){if(K.length<we)return K;const ke=/\b/g;let Oe=0;for(;ke.test(K)&&!(K.length-ke.lastIndex<we);)Oe=ke.lastIndex,ke.lastIndex+=1;return K.substring(Oe).replace(/^\s/,"")}e.lcut=qe;const Ge=/\x1B\x5B[12]?K/g,rt=/\x1b\[\d+m/g,it=/\x1b\[0?m/g;function de(K){return K&&(K=K.replace(Ge,""),K=K.replace(rt,""),K=K.replace(it,"")),K}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Pe(K){return be(K)?K.substr(1):K}e.stripUTF8BOM=Pe;function Re(K,we){if(!K||!we||K.length<we.length)return!1;const ke=we.length,Oe=K.toLowerCase();let Te=0,We=-1;for(;Te<ke;){const Z=Oe.indexOf(we[Te],We+1);if(Z<0)return!1;We=Z,Te++}return!0}e.fuzzyContains=Re;function Ne(K,we=!1){return K?(we&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Ne;function He(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=He;function Ke(K,we=1){if(we===0)return"";let ke=-1;do ke=K.indexOf(`
`,ke+1),we--;while(we>0&&ke>=0);return ke===-1?K:(K[ke-1]==="\r"&&ke--,K.substr(0,ke))}e.getNLines=Ke;function Je(K){const we=90-65+1;return K=K%(2*we),K<we?String.fromCharCode(97+K):String.fromCharCode(65+K-we)}e.singleLetterHash=Je;function st(K){return Se.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=st;function oe(K,we){return K===0?we!==5&&we!==7:K===2&&we===3?!1:K===4||K===2||K===3||we===4||we===2||we===3?!0:!(K===8&&(we===8||we===9||we===11||we===12)||(K===11||K===9)&&(we===9||we===10)||(K===12||K===10)&&we===10||we===5||we===13||we===7||K===1||K===13&&we===14||K===6&&we===6)}e.breakBetweenGraphemeBreakType=oe;var pe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Se{constructor(){this._data=Be()}static getInstance(){return Se._INSTANCE||(Se._INSTANCE=new Se),Se._INSTANCE}getGraphemeBreakType(we){if(we<32)return we===10?3:we===13?2:4;if(we<127)return 0;const ke=this._data,Oe=ke.length/3;let Te=1;for(;Te<=Oe;)if(we<ke[3*Te])Te=2*Te;else if(we>ke[3*Te+1])Te=2*Te+1;else return ke[3*Te+2];return 0}}Se._INSTANCE=null;function Be(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function xe(K,we){if(K===0)return 0;const ke=ot(K,we);if(ke!==void 0)return ke;const Oe=z(we,K);return K-=Qe(Oe),K}e.getLeftDeleteOffset=xe;function ot(K,we){let ke=z(we,K);for(K-=Qe(ke);at(ke)||ke===65039||ke===8419;){if(K===0)return;ke=z(we,K),K-=Qe(ke)}if(!!Ue(ke)){if(K>=0){const Oe=z(we,K);Oe===8205&&(K-=Qe(Oe))}return K}}function Qe(K){return K>=65536?2:1}function at(K){return 127995<=K&&K<=127999}var Ze;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={}))}),define(me[118],ge([0,1,15]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function _(p){return g(p,0)}e.hash=_;function g(p,h){switch(typeof p){case"object":return p===null?k(349,h):Array.isArray(p)?d(p,h):y(p,h);case"string":return D(p,h);case"boolean":return C(p,h);case"number":return k(p,h);case"undefined":return k(937,h);default:return k(617,h)}}e.doHash=g;function k(p,h){return(h<<5)-h+p|0}function C(p,h){return k(p?433:863,h)}function D(p,h){h=k(149417,h);for(let f=0,c=p.length;f<c;f++)h=k(p.charCodeAt(f),h);return h}e.stringHash=D;function d(p,h){return h=k(104579,h),p.reduce((f,c)=>g(c,f),h)}function y(p,h){return h=k(181387,h),Object.keys(p).sort().reduce((f,c)=>(f=D(c,f),g(p[c],f)),h)}class i{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=g(h,this._value),this._value}}e.Hasher=i;var A;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function E(p,h,f=32){const c=f-h,a=~((1<<c)-1);return(p<<h|(a&p)>>>c)>>>0}function b(p,h=0,f=p.byteLength,c=0){for(let a=0;a<f;a++)p[h+a]=c}function o(p,h,f="0"){for(;p.length<h;)p=f+p;return p}function u(p,h=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(f=>f.toString(16).padStart(2,"0")).join(""):o((p>>>0).toString(16),h/4)}e.toHexString=u;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const f=h.length;if(f===0)return;const c=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,s,n;for(t!==0?(s=t,n=-1,t=0):(s=h.charCodeAt(0),n=0);;){let r=s;if(S.isHighSurrogate(s))if(n+1<f){const l=h.charCodeAt(n+1);S.isLowSurrogate(l)?(n++,r=S.computeCodePoint(s,l)):r=65533}else{t=s;break}else S.isLowSurrogate(s)&&(r=65533);if(a=this._push(c,a,r),n++,n<f)s=h.charCodeAt(n);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(h,f,c){return c<128?h[f++]=c:c<2048?(h[f++]=192|(c&1984)>>>6,h[f++]=128|(c&63)>>>0):c<65536?(h[f++]=224|(c&61440)>>>12,h[f++]=128|(c&4032)>>>6,h[f++]=128|(c&63)>>>0):(h[f++]=240|(c&1835008)>>>18,h[f++]=128|(c&258048)>>>12,h[f++]=128|(c&4032)>>>6,h[f++]=128|(c&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=w._bigBlock32,f=this._buffDV;for(let P=0;P<64;P+=4)h.setUint32(P,f.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)h.setUint32(P,E(h.getUint32(P-12,!1)^h.getUint32(P-32,!1)^h.getUint32(P-56,!1)^h.getUint32(P-64,!1),1),!1);let c=this._h0,a=this._h1,t=this._h2,s=this._h3,n=this._h4,r,l,v;for(let P=0;P<80;P++)P<20?(r=a&t|~a&s,l=1518500249):P<40?(r=a^t^s,l=1859775393):P<60?(r=a&t|a&s|t&s,l=2400959708):(r=a^t^s,l=3395469782),v=E(c,5)+r+n+l+h.getUint32(P*4,!1)&4294967295,n=s,s=t,t=E(a,30),a=c,c=v;this._h0=this._h0+c&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[73],ge([0,1,15]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var _;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(_||(_={})),function(g){const k="error",C="warning",D="warn",d="info",y="ignore";function i(E){return E?S.equalsIgnoreCase(k,E)?g.Error:S.equalsIgnoreCase(C,E)||S.equalsIgnoreCase(D,E)?g.Warning:S.equalsIgnoreCase(d,E)?g.Info:g.Ignore:g.Ignore}g.fromValue=i;function A(E){switch(E){case g.Error:return k;case g.Warning:return C;case g.Info:return d;default:return y}}g.toString=A}(_||(_={})),e.default=_}),define(me[12],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(L){return Array.isArray(L)}e.isArray=S;function _(L){return typeof L=="string"}e.isString=_;function g(L){return Array.isArray(L)&&L.every(R=>_(R))}e.isStringArray=g;function k(L){return typeof L=="object"&&L!==null&&!Array.isArray(L)&&!(L instanceof RegExp)&&!(L instanceof Date)}e.isObject=k;function C(L){return typeof L=="number"&&!isNaN(L)}e.isNumber=C;function D(L){return!!L&&typeof L[Symbol.iterator]=="function"}e.isIterable=D;function d(L){return L===!0||L===!1}e.isBoolean=d;function y(L){return typeof L=="undefined"}e.isUndefined=y;function i(L){return!A(L)}e.isDefined=i;function A(L){return y(L)||L===null}e.isUndefinedOrNull=A;function E(L,R){if(!L)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=E;function b(L){if(A(L))throw new Error("Assertion Failed: argument is undefined or null");return L}e.assertIsDefined=b;function o(...L){const R=[];for(let m=0;m<L.length;m++){const T=L[m];if(A(T))throw new Error(`Assertion Failed: argument at index ${m} is undefined or null`);R.push(T)}return R}e.assertAllDefined=o;const u=Object.prototype.hasOwnProperty;function w(L){if(!k(L))return!1;for(let R in L)if(u.call(L,R))return!1;return!0}e.isEmptyObject=w;function p(L){return typeof L=="function"}e.isFunction=p;function h(...L){return L.length>0&&L.every(p)}e.areFunctions=h;function f(L,R){const m=Math.min(L.length,R.length);for(let T=0;T<m;T++)c(L[T],R[T])}e.validateConstraints=f;function c(L,R){if(_(R)){if(typeof L!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(p(R)){try{if(L instanceof R)return}catch{}if(!A(L)&&L.constructor===R||R.length===1&&R.call(void 0,L)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function a(L){let R=[],m=Object.getPrototypeOf(L);for(;Object.prototype!==m;)R=R.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return R}e.getAllPropertyNames=a;function t(L){const R=[];for(const m of a(L))typeof L[m]=="function"&&R.push(m);return R}e.getAllMethodNames=t;function s(L,R){const m=I=>function(){const B=Array.prototype.slice.call(arguments,0);return R(I,B)};let T={};for(const I of L)T[I]=m(I);return T}e.createProxyObject=s;function n(L){return L===null?void 0:L}e.withNullAsUndefined=n;function r(L){return typeof L=="undefined"?null:L}e.withUndefinedAsNull=r;function l(L){return class{constructor(){return new Proxy({},{get(R,m){if(R[m])return R[m];throw new Error(`Not Implemented: ${L}->${String(m)}`)}})}}}e.NotImplementedProxy=l;function v(L,R="Unreachable"){throw new Error(R)}e.assertNever=v;function P(L){return!!L&&typeof L.then=="function"&&typeof L.catch=="function"}e.isPromise=P}),define(me[26],ge([0,1,5,3,15,12]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(n){return n===47||n===92}e.isPathSeparator=C;function D(n){return n.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=D;function d(n){return n.indexOf("/")===-1&&(n=D(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=d;function y(n,r=S.posix.sep){if(!n)return"";const l=n.length,v=n.charCodeAt(0);if(C(v)){if(C(n.charCodeAt(1))&&!C(n.charCodeAt(2))){let L=3;const R=L;for(;L<l&&!C(n.charCodeAt(L));L++);if(R!==L&&!C(n.charCodeAt(L+1))){for(L+=1;L<l;L++)if(C(n.charCodeAt(L)))return n.slice(0,L+1).replace(/[\\/]/g,r)}}return r}else if(p(v)&&n.charCodeAt(1)===58)return C(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let P=n.indexOf("://");if(P!==-1){for(P+=3;P<l;P++)if(C(n.charCodeAt(P)))return n.slice(0,P+1)}return""}e.getRoot=y;function i(n){if(!_.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let l=2;const v=l;for(;l<n.length&&(r=n.charCodeAt(l),r!==92);l++);return!(v===l||(r=n.charCodeAt(l+1),isNaN(r)||r===92))}e.isUNC=i;const A=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(n,r=_.isWindows){const l=r?A:E;return!(!n||n.length===0||/^\s+$/.test(n)||(l.lastIndex=0,l.test(n))||r&&b.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=o;function u(n,r,l){const v=n===r;return!l||v?v:!n||!r?!1:(0,g.equalsIgnoreCase)(n,r)}e.isEqual=u;function w(n,r,l,v=S.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(l){if(!(0,g.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let L=r.length;return r.charAt(r.length-1)===v&&L--,n.charAt(L)===v}return r.charAt(r.length-1)!==v&&(r+=v),n.indexOf(r)===0}e.isEqualOrParent=w;function p(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=p;function h(n,r){return _.isWindows&&n.endsWith(":")&&(n+=S.sep),(0,S.isAbsolute)(n)||(n=(0,S.join)(r,n)),n=(0,S.normalize)(n),_.isWindows?(n=(0,g.rtrim)(n,S.sep),n.endsWith(":")&&(n+=S.sep)):(n=(0,g.rtrim)(n,S.sep),n||(n=S.sep)),n}e.sanitizeFilePath=h;function f(n){const r=(0,S.normalize)(n);return _.isWindows?n.length>3?!1:c(r)&&(n.length===2||r.charCodeAt(2)===92):r===S.posix.sep}e.isRootOrDriveLetter=f;function c(n){return _.isWindows?p(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function a(n){return c(n)?n[0]:void 0}e.getDriveLetter=a;function t(n,r,l){return r.length>n.length?-1:n===r?0:(l&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=t;function s(n){const r=n.split(":");let l,v,P;if(r.forEach(L=>{const R=Number(L);(0,k.isNumber)(R)?v===void 0?v=R:P===void 0&&(P=R):l=l?[l,L].join(":"):L}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:v!==void 0?v:void 0,column:P!==void 0?P:v!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(me[18],ge([0,1,12]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function _(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const w=Array.isArray(u)?[]:{};return Object.keys(u).forEach(p=>{u[p]&&typeof u[p]=="object"?w[p]=_(u[p]):w[p]=u[p]}),w}e.deepClone=_;function g(u){if(!u||typeof u!="object")return u;const w=[u];for(;w.length>0;){const p=w.shift();Object.freeze(p);for(const h in p)if(k.call(p,h)){const f=p[h];typeof f=="object"&&!Object.isFrozen(f)&&w.push(f)}}return u}e.deepFreeze=g;const k=Object.prototype.hasOwnProperty;function C(u,w){return D(u,w,new Set)}e.cloneAndChange=C;function D(u,w,p){if((0,S.isUndefinedOrNull)(u))return u;const h=w(u);if(typeof h!="undefined")return h;if((0,S.isArray)(u)){const f=[];for(const c of u)f.push(D(c,w,p));return f}if((0,S.isObject)(u)){if(p.has(u))throw new Error("Cannot clone recursive data-structure");p.add(u);const f={};for(let c in u)k.call(u,c)&&(f[c]=D(u[c],w,p));return p.delete(u),f}return u}function d(u,w,p=!0){return(0,S.isObject)(u)?((0,S.isObject)(w)&&Object.keys(w).forEach(h=>{h in u?p&&((0,S.isObject)(u[h])&&(0,S.isObject)(w[h])?d(u[h],w[h],p):u[h]=w[h]):u[h]=w[h]}),u):w}e.mixin=d;function y(u,w){if(u===w)return!0;if(u==null||w===null||w===void 0||typeof u!=typeof w||typeof u!="object"||Array.isArray(u)!==Array.isArray(w))return!1;let p,h;if(Array.isArray(u)){if(u.length!==w.length)return!1;for(p=0;p<u.length;p++)if(!y(u[p],w[p]))return!1}else{const f=[];for(h in u)f.push(h);f.sort();const c=[];for(h in w)c.push(h);if(c.sort(),!y(f,c))return!1;for(p=0;p<f.length;p++)if(!y(u[f[p]],w[f[p]]))return!1}return!0}e.equals=y;function i(u){const w=new Set;return JSON.stringify(u,(p,h)=>{if((0,S.isObject)(h)||Array.isArray(h)){if(w.has(h))return"[Circular]";w.add(h)}return h})}e.safeStringify=i;function A(u,w,p){const h=w(u);return typeof h=="undefined"?p:h}e.getOrDefault=A;function E(u,w){const p=Object.create(null);return!u||!w||Object.keys(w).forEach(f=>{const c=u[f],a=w[f];y(c,a)||(p[f]=a)}),p}e.distinct=E;function b(u,w){const p=w.toLowerCase(),h=Object.keys(u).find(f=>f.toLowerCase()===p);return h?u[h]:u[w]}e.getCaseInsensitive=b;function o(u,w){const p=Object.create(null);for(const h of Object.keys(u))w(h,u[h])&&(p[h]=u[h]);return p}e.filter=o}),define(me[4],ge([0,1,5,3]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,k=/^\//,C=/^\/\//;function D(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!g.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!k.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(n,r){return!n&&!r?"file":n}function y(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==A&&(r=A+r):r=A;break}return r}const i="",A="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(r,l,v,P,L,R=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=d(r,R),this.authority=l||i,this.path=y(this.scheme,v||i),this.query=P||i,this.fragment=L||i,D(this,R))}static isUri(r){return r instanceof b?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return f(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:v,path:P,query:L,fragment:R}=r;return l===void 0?l=this.scheme:l===null&&(l=i),v===void 0?v=this.authority:v===null&&(v=i),P===void 0?P=this.path:P===null&&(P=i),L===void 0?L=this.query:L===null&&(L=i),R===void 0?R=this.fragment:R===null&&(R=i),l===this.scheme&&v===this.authority&&P===this.path&&L===this.query&&R===this.fragment?this:new u(l,v,P,L,R)}static parse(r,l=!1){const v=E.exec(r);return v?new u(v[2]||i,s(v[4]||i),s(v[5]||i),s(v[7]||i),s(v[9]||i),l):new u(i,i,i,i,i)}static file(r){let l=i;if(_.isWindows&&(r=r.replace(/\\/g,A)),r[0]===A&&r[1]===A){const v=r.indexOf(A,2);v===-1?(l=r.substring(2),r=A):(l=r.substring(2,v),r=r.substring(v)||A)}return new u("file",l,r,i,i)}static from(r){const l=new u(r.scheme,r.authority,r.path,r.query,r.fragment);return D(l,!0),l}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return _.isWindows&&r.scheme==="file"?v=b.file(S.win32.join(f(r,!0),...l)).path:v=S.posix.join(r.path,...l),r.with({path:v})}toString(r=!1){return c(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof b)return r;{const l=new u(r);return l._formatted=r.external,l._fsPath=r._sep===o?r.fsPath:null,l}}else return r}}e.URI=b;const o=_.isWindows?1:void 0;class u extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(r=!1){return r?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=o),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(n,r){let l,v=-1;for(let P=0;P<n.length;P++){const L=n.charCodeAt(P);if(L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57||L===45||L===46||L===95||L===126||r&&L===47)v!==-1&&(l+=encodeURIComponent(n.substring(v,P)),v=-1),l!==void 0&&(l+=n.charAt(P));else{l===void 0&&(l=n.substr(0,P));const R=w[L];R!==void 0?(v!==-1&&(l+=encodeURIComponent(n.substring(v,P)),v=-1),l+=R):v===-1&&(v=P)}}return v!==-1&&(l+=encodeURIComponent(n.substring(v))),l!==void 0?l:n}function h(n){let r;for(let l=0;l<n.length;l++){const v=n.charCodeAt(l);v===35||v===63?(r===void 0&&(r=n.substr(0,l)),r+=w[v]):r!==void 0&&(r+=n[l])}return r!==void 0?r:n}function f(n,r){let l;return n.authority&&n.path.length>1&&n.scheme==="file"?l=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?l=n.path.substr(1):l=n.path[1].toLowerCase()+n.path.substr(2):l=n.path,_.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=f;function c(n,r){const l=r?h:p;let v="",{scheme:P,authority:L,path:R,query:m,fragment:T}=n;if(P&&(v+=P,v+=":"),(L||P==="file")&&(v+=A,v+=A),L){let I=L.indexOf("@");if(I!==-1){const B=L.substr(0,I);L=L.substr(I+1),I=B.indexOf(":"),I===-1?v+=l(B,!1):(v+=l(B.substr(0,I),!1),v+=":",v+=l(B.substr(I+1),!1)),v+="@"}L=L.toLowerCase(),I=L.indexOf(":"),I===-1?v+=l(L,!1):(v+=l(L.substr(0,I),!1),v+=L.substr(I))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const I=R.charCodeAt(1);I>=65&&I<=90&&(R=`/${String.fromCharCode(I+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const I=R.charCodeAt(0);I>=65&&I<=90&&(R=`${String.fromCharCode(I+32)}:${R.substr(2)}`)}v+=l(R,!0)}return m&&(v+="?",v+=l(m,!1)),T&&(v+="#",v+=r?T:p(T,!1)),v}function a(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(t)?n.replace(t,r=>a(r)):n}}),define(me[119],ge([0,1,4]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function _(y){const i=y;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=_;function g(y){const i=[];let A;try{const E=JSON.parse(y.arguments),b=E[E.length-1];b&&b.__$stack&&(E.pop(),A=b.__$stack),i.push(...E)}catch(E){i.push("Unable to log remote console arguments",y.arguments)}return{args:i,stack:A}}e.parse=g;function k(y){if(typeof y!="string")return k(g(y).stack);const i=y;if(i){const A=C(i),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(A||"");if(E&&E.length===4)return{uri:S.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=k;function C(y){if(!y)return y;const i=y.indexOf(`
`);return i===-1?y:y.substring(0,i)}function D(y,i){const{args:A,stack:E}=g(y),b=typeof A[0]=="string"&&A.length===1;let o=C(E);o&&(o=`(${o.trim()})`);let u=[];if(typeof A[0]=="string"?o&&b?u=[`%c[${i}] %c${A[0]} %c${o}`,d("blue"),d(""),d("grey")]:u=[`%c[${i}] %c${A[0]}`,d("blue"),d(""),...A.slice(1)]:u=[`%c[${i}]%`,d("blue"),...A],o&&!b&&u.push(o),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,u)}e.log=D;function d(y){return`color: ${y}`}});var It=this&&this.__classPrivateFieldSet||function(Q,e,S,_,g){if(_==="m")throw new TypeError("Private method is not writable");if(_==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!g:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return _==="a"?g.call(Q,S):g?g.value=S:e.set(Q,S),S},lt=this&&this.__classPrivateFieldGet||function(Q,e,S,_){if(S==="a"&&!_)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!_:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?_:S==="a"?_.call(Q):_?_.value:e.get(Q)};define(me[27],ge([0,1,15,4]),function(Q,e,S,_){"use strict";var g,k,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,s,n){let r=t.get(s);return r===void 0&&(r=n,t.set(s,r)),r}e.getOrSet=D;function d(t){const s=[];return t.forEach((n,r)=>{s.push(`${r} => ${n}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=d;function y(t){const s=[];return t.forEach(n=>{s.push(n)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const n=s.charCodeAt(0),r=this._value.charCodeAt(this._pos);return n-r}value(){return this._value[this._pos]}}e.StringIterator=i;class A{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,S.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class E{constructor(s=!0,n=!0){this._splitOnBackslash=s,this._caseSensitive=n}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,S.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class o{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,S.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,S.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,S.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,S.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class u{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(s){this._iter=s}static forUris(s=()=>!1){return new w(new o(s))}static forPaths(){return new w(new E)}static forStrings(){return new w(new i)}static forConfigKeys(){return new w(new A)}clear(){this._root=void 0}set(s,n){const r=this._iter.reset(s);let l;for(this._root||(this._root=new u,this._root.segment=r.value()),l=this._root;;){const P=r.cmp(l.segment);if(P>0)l.left||(l.left=new u,l.left.segment=r.value()),l=l.left;else if(P<0)l.right||(l.right=new u,l.right.segment=r.value()),l=l.right;else if(r.hasNext())r.next(),l.mid||(l.mid=new u,l.mid.segment=r.value()),l=l.mid;else break}const v=l.value;return l.value=n,l.key=s,v}get(s){return this._getNode(s)?.value}_getNode(s){const n=this._iter.reset(s);let r=this._root;for(;r;){const l=n.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(n.hasNext())n.next(),r=r.mid;else break}return r}has(s){const n=this._getNode(s);return!(n?.value===void 0&&n?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,n){const r=this._iter.reset(s),l=[];let v=this._root;for(;v;){const P=r.cmp(v.segment);if(P>0)l.push([1,v]),v=v.left;else if(P<0)l.push([-1,v]),v=v.right;else if(r.hasNext())r.next(),l.push([0,v]),v=v.mid;else{for(n?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;l.length>0&&v.isEmpty();){let[L,R]=l.pop();switch(L){case 1:R.left=void 0;break;case 0:R.mid=void 0;break;case-1:R.right=void 0;break}v=R}break}}}findSubstr(s){const n=this._iter.reset(s);let r=this._root,l;for(;r;){const v=n.cmp(r.segment);if(v>0)r=r.left;else if(v<0)r=r.right;else if(n.hasNext())n.next(),l=r.value||l,r=r.mid;else break}return r&&r.value||l}findSuperstr(s){const n=this._iter.reset(s);let r=this._root;for(;r;){const l=n.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(n.hasNext())n.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(s){for(const[n,r]of this)s(r,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const n=[s];for(;n.length>0;){const r=n.pop();r&&(r.value&&(yield[r.key,r.value]),r.left&&n.push(r.left),r.mid&&n.push(r.mid),r.right&&n.push(r.right))}}}e.TernarySearchTree=w;class p{constructor(s,n){this[g]="ResourceMap",s instanceof p?(this.map=new Map(s.map),this.toKey=n??p.defaultToKey):(this.map=new Map,this.toKey=s??p.defaultToKey)}set(s,n){return this.map.set(this.toKey(s),n),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,n){typeof n!="undefined"&&(s=s.bind(n));for(let[r,l]of this.map)s(l,_.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield _.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[_.URI.parse(s[0]),s[1]]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[_.URI.parse(s[0]),s[1]]}}e.ResourceMap=p,p.defaultToKey=t=>t.toString();var h;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class f{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,n=0){const r=this._map.get(s);if(!!r)return n!==0&&this.touch(r,n),r.value}set(s,n,r=0){let l=this._map.get(s);if(l)l.value=n,r!==0&&this.touch(l,r);else{switch(l={key:s,value:n,next:void 0,previous:void 0},r){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(s,l),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const n=this._map.get(s);if(!!n)return this._map.delete(s),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,n){const r=this._state;let l=this._head;for(;l;){if(n?s.bind(n)(l.value,l.key,this):s(l.value,l.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const s=this,n=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==n)throw new Error("LinkedMap got modified during iteration.");if(r){const v={value:r.key,done:!1};return r=r.next,v}else return{value:void 0,done:!0}}};return l}values(){const s=this,n=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==n)throw new Error("LinkedMap got modified during iteration.");if(r){const v={value:r.value,done:!1};return r=r.next,v}else return{value:void 0,done:!0}}};return l}entries(){const s=this,n=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==n)throw new Error("LinkedMap got modified during iteration.");if(r){const v={value:[r.key,r.value],done:!1};return r=r.next,v}else return{value:void 0,done:!0}}};return l}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let n=this._head,r=this.size;for(;n&&r>s;)this._map.delete(n.key),n=n.next,r--;this._head=n,this._size=r,n&&(n.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const n=s.next,r=s.previous;if(!n||!r)throw new Error("Invalid list");n.previous=r,r.next=n}s.next=void 0,s.previous=void 0,this._state++}touch(s,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(s===this._head)return;const r=s.next,l=s.previous;s===this._tail?(l.next=void 0,this._tail=l):(r.previous=l,l.next=r),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(n===2){if(s===this._tail)return;const r=s.next,l=s.previous;s===this._head?(r.previous=void 0,this._head=r):(r.previous=l,l.next=r),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((n,r)=>{s.push([r,n])}),s}fromJSON(s){this.clear();for(const[n,r]of s)this.set(n,r)}}e.LinkedMap=f;class c extends f{constructor(s,n=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,n=2){return super.get(s,n)}peek(s){return super.get(s,0)}set(s,n){return super.set(s,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class a{constructor(s){C.set(this,void 0),It(this,C,s,"f")}get size(){return lt(this,C,"f").size}forEach(s,n){lt(this,C,"f").forEach(s,n)}get(s){return lt(this,C,"f").get(s)}has(s){return lt(this,C,"f").has(s)}entries(){return lt(this,C,"f").entries()}keys(){return lt(this,C,"f").keys()}values(){return lt(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return lt(this,C,"f").entries()}}e.ReadonlyMapView=a}),define(me[120],ge([0,1,27,15]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function g(...de){return function(be,Pe){for(let Re=0,Ne=de.length;Re<Ne;Re++){const He=de[Re](be,Pe);if(He)return He}return null}}e.or=g,e.matchesStrictPrefix=k.bind(void 0,!1),e.matchesPrefix=k.bind(void 0,!0);function k(de,be,Pe){if(!Pe||Pe.length<be.length)return null;let Re;return de?Re=_.startsWithIgnoreCase(Pe,be):Re=Pe.indexOf(be)===0,Re?be.length>0?[{start:0,end:be.length}]:[]:null}function C(de,be){const Pe=be.toLowerCase().indexOf(de.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+de.length}]}e.matchesContiguousSubString=C;function D(de,be){return d(de.toLowerCase(),be.toLowerCase(),0,0)}e.matchesSubString=D;function d(de,be,Pe,Re){if(Pe===de.length)return[];if(Re===be.length)return null;if(de[Pe]===be[Re]){let Ne=null;return(Ne=d(de,be,Pe+1,Re+1))?p({start:Re,end:Re+1},Ne):null}return d(de,be,Pe,Re+1)}function y(de){return 97<=de&&de<=122}function i(de){return 65<=de&&de<=90}e.isUpper=i;function A(de){return 48<=de&&de<=57}function E(de){return de===32||de===9||de===10||de===13}const b=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(de=>b.add(de.charCodeAt(0)));function o(de){return E(de)||b.has(de)}function u(de,be){return de===be||o(de)&&o(be)}function w(de){return y(de)||i(de)||A(de)}function p(de,be){return be.length===0?be=[de]:de.end===be[0].start?be[0].start=de.start:be.unshift(de),be}function h(de,be){for(let Pe=be;Pe<de.length;Pe++){const Re=de.charCodeAt(Pe);if(i(Re)||A(Re)||Pe>0&&!w(de.charCodeAt(Pe-1)))return Pe}return de.length}function f(de,be,Pe,Re){if(Pe===de.length)return[];if(Re===be.length)return null;if(de[Pe]!==be[Re].toLowerCase())return null;{let Ne=null,He=Re+1;for(Ne=f(de,be,Pe+1,Re+1);!Ne&&(He=h(be,He))<be.length;)Ne=f(de,be,Pe+1,He),He++;return Ne===null?null:p({start:Re,end:Re+1},Ne)}}function c(de){let be=0,Pe=0,Re=0,Ne=0,He=0;for(let pe=0;pe<de.length;pe++)He=de.charCodeAt(pe),i(He)&&be++,y(He)&&Pe++,w(He)&&Re++,A(He)&&Ne++;const Ke=be/de.length,Je=Pe/de.length,st=Re/de.length,oe=Ne/de.length;return{upperPercent:Ke,lowerPercent:Je,alphaPercent:st,numericPercent:oe}}function a(de){const{upperPercent:be,lowerPercent:Pe}=de;return Pe===0&&be>.6}function t(de){const{upperPercent:be,lowerPercent:Pe,alphaPercent:Re,numericPercent:Ne}=de;return Pe>.2&&be<.8&&Re>.6&&Ne<.2}function s(de){let be=0,Pe=0,Re=0,Ne=0;for(let He=0;He<de.length;He++)Re=de.charCodeAt(He),i(Re)&&be++,y(Re)&&Pe++,E(Re)&&Ne++;return(be===0||Pe===0)&&Ne===0?de.length<=30:be<=5}function n(de,be){if(!be||(be=be.trim(),be.length===0)||!s(de)||be.length>60)return null;const Pe=c(be);if(!t(Pe)){if(!a(Pe))return null;be=be.toLowerCase()}let Re=null,Ne=0;for(de=de.toLowerCase();Ne<be.length&&(Re=f(de,be,0,Ne))===null;)Ne=h(be,Ne+1);return Re}e.matchesCamelCase=n;function r(de,be,Pe=!1){if(!be||be.length===0)return null;let Re=null,Ne=0;for(de=de.toLowerCase(),be=be.toLowerCase();Ne<be.length&&(Re=l(de,be,0,Ne,Pe))===null;)Ne=v(be,Ne+1);return Re}e.matchesWords=r;function l(de,be,Pe,Re,Ne){if(Pe===de.length)return[];if(Re===be.length)return null;if(u(de.charCodeAt(Pe),be.charCodeAt(Re))){let He=null,Ke=Re+1;if(He=l(de,be,Pe+1,Re+1,Ne),!Ne)for(;!He&&(Ke=v(be,Ke))<be.length;)He=l(de,be,Pe+1,Ke,Ne),Ke++;return He===null?null:p({start:Re,end:Re+1},He)}else return null}function v(de,be){for(let Pe=be;Pe<de.length;Pe++)if(o(de.charCodeAt(Pe))||Pe>0&&o(de.charCodeAt(Pe-1)))return Pe;return de.length}const P=g(e.matchesPrefix,n,C),L=g(e.matchesPrefix,n,D),R=new S.LRUCache(1e4);function m(de,be,Pe=!1){if(typeof de!="string"||typeof be!="string")return null;let Re=R.get(de);Re||(Re=new RegExp(_.convertSimple2RegExpPattern(de),"i"),R.set(de,Re));const Ne=Re.exec(be);return Ne?[{start:Ne.index,end:Ne.index+Ne[0].length}]:Pe?L(de,be):P(de,be)}e.matchesFuzzy=m;function T(de,be){const Pe=Ae(de,de.toLowerCase(),0,be,be.toLowerCase(),0,!0);return Pe?B(Pe):null}e.matchesFuzzy2=T;function I(de,be,Pe,Re,Ne,He){const Ke=Math.min(13,de.length);for(;Pe<Ke;Pe++){const Je=Ae(de,be,Pe,Re,Ne,He,!1);if(Je)return Je}return[0,He]}e.anyScore=I;function B(de){if(typeof de=="undefined")return[];const be=[],Pe=de[1];for(let Re=de.length-1;Re>1;Re--){const Ne=de[Re]+Pe,He=be[be.length-1];He&&He.end===Ne?He.end=Ne+1:be.push({start:Ne,end:Ne+1})}return be}e.createMatches=B;const j=128;function ue(){const de=[],be=[];for(let Pe=0;Pe<=j;Pe++)be[Pe]=0;for(let Pe=0;Pe<=j;Pe++)de.push(be.slice(0));return de}function ce(de){const be=[];for(let Pe=0;Pe<=de;Pe++)be[Pe]=0;return be}const O=ce(2*j),$=ce(2*j),z=ue(),ee=ue(),J=ue(),H=!1;function X(de,be,Pe,Re,Ne){function He(Je,st,oe=" "){for(;Je.length<st;)Je=oe+Je;return Je}let Ke=` |   |${Re.split("").map(Je=>He(Je,3)).join("|")}
`;for(let Je=0;Je<=Pe;Je++)Je===0?Ke+=" |":Ke+=`${be[Je-1]}|`,Ke+=de[Je].slice(0,Ne+1).map(st=>He(st.toString(),3)).join("|")+`
`;return Ke}function q(de,be,Pe,Re){de=de.substr(be),Pe=Pe.substr(Re),console.log(X(ee,de,de.length,Pe,Pe.length)),console.log(X(J,de,de.length,Pe,Pe.length)),console.log(X(z,de,de.length,Pe,Pe.length))}function W(de,be){if(be<0||be>=de.length)return!1;const Pe=de.codePointAt(be);switch(Pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!_.isEmojiImprecise(Pe)}}function U(de,be){if(be<0||be>=de.length)return!1;switch(de.charCodeAt(be)){case 32:case 9:return!0;default:return!1}}function ie(de,be,Pe){return be[de]!==Pe[de]}function ne(de,be,Pe,Re,Ne,He,Ke=!1){for(;be<Pe&&Ne<He;)de[be]===Re[Ne]&&(Ke&&(O[be]=Ne),be+=1),Ne+=1;return be===Pe}e.isPatternInWord=ne;var he;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(he||(he={}));var ve;(function(de){de.Default=[-100,0];function be(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}de.isDefault=be})(ve=e.FuzzyScore||(e.FuzzyScore={}));function Ae(de,be,Pe,Re,Ne,He,Ke){const Je=de.length>j?j:de.length,st=Re.length>j?j:Re.length;if(Pe>=Je||He>=st||Je-Pe>st-He||!ne(be,Pe,Je,Ne,He,st,!0))return;Ie(Je,st,Pe,He,be,Ne);let oe=1,pe=1,Se=Pe,Be=He;const xe=[!1];for(oe=1,Se=Pe;Se<Je;oe++,Se++){const K=O[Se],we=$[Se],ke=Se+1<Je?$[Se+1]:st;for(pe=K-He+1,Be=K;Be<ke;pe++,Be++){let Oe=Number.MIN_SAFE_INTEGER,Te=!1;Be<=we&&(Oe=Ue(de,be,Se,Pe,Re,Ne,Be,st,He,z[oe-1][pe-1]===0,xe));let We=0;Oe!==Number.MAX_SAFE_INTEGER&&(Te=!0,We=Oe+ee[oe-1][pe-1]);const Z=Be>K,te=Z?ee[oe][pe-1]+(z[oe][pe-1]>0?-5:0):0,le=Be>K+1&&z[oe][pe-1]>0,V=le?ee[oe][pe-2]+(z[oe][pe-2]>0?-5:0):0;if(le&&(!Z||V>=te)&&(!Te||V>=We))ee[oe][pe]=V,J[oe][pe]=3,z[oe][pe]=0;else if(Z&&(!Te||te>=We))ee[oe][pe]=te,J[oe][pe]=2,z[oe][pe]=0;else if(Te)ee[oe][pe]=We,J[oe][pe]=1,z[oe][pe]=z[oe-1][pe-1]+1;else throw new Error("not possible")}}if(H&&q(de,Pe,Re,He),!xe[0]&&!Ke)return;oe--,pe--;const ot=[ee[oe][pe],He];let Qe=0,at=0;for(;oe>=1;){let K=pe;do{const we=J[oe][K];if(we===3)K=K-2;else if(we===2)K=K-1;else break}while(K>=1);Qe>1&&be[Pe+oe-1]===Ne[He+pe-1]&&!ie(K+He-1,Re,Ne)&&Qe+1>z[oe][K]&&(K=pe),K===pe?Qe++:Qe=1,at||(at=K),oe--,pe=K-1,ot.push(pe)}st===Je&&(ot[0]+=2);const Ze=at-Je;return ot[0]-=Ze,ot}e.fuzzyScore=Ae;function Ie(de,be,Pe,Re,Ne,He){let Ke=de-1,Je=be-1;for(;Ke>=Pe&&Je>=Re;)Ne[Ke]===He[Je]&&($[Ke]=Je,Ke--),Je--}function Ue(de,be,Pe,Re,Ne,He,Ke,Je,st,oe,pe){if(be[Pe]!==He[Ke])return Number.MIN_SAFE_INTEGER;let Se=1,Be=!1;return Ke===Pe-Re?Se=de[Pe]===Ne[Ke]?7:5:ie(Ke,Ne,He)&&(Ke===0||!ie(Ke-1,Ne,He))?(Se=de[Pe]===Ne[Ke]?7:5,Be=!0):W(He,Ke)&&(Ke===0||!W(He,Ke-1))?Se=5:(W(He,Ke-1)||U(He,Ke-1))&&(Se=5,Be=!0),Se>1&&Pe===Re&&(pe[0]=!0),Be||(Be=ie(Ke,Ne,He)||W(He,Ke-1)||U(He,Ke-1)),Pe===Re?Ke>st&&(Se-=Be?3:5):oe?Se+=Be?2:0:Se+=Be?0:1,Ke+1===Je&&(Se-=Be?3:5),Se}function qe(de,be,Pe,Re,Ne,He,Ke){return rt(de,be,Pe,Re,Ne,He,!0,Ke)}e.fuzzyScoreGracefulAggressive=qe;function Ge(de,be,Pe,Re,Ne,He,Ke){return rt(de,be,Pe,Re,Ne,He,!1,Ke)}e.fuzzyScoreGraceful=Ge;function rt(de,be,Pe,Re,Ne,He,Ke,Je){let st=Ae(de,be,Pe,Re,Ne,He,Je);if(st&&!Ke)return st;if(de.length>=3){const oe=Math.min(7,de.length-1);for(let pe=Pe+1;pe<oe;pe++){const Se=it(de,pe);if(Se){const Be=Ae(Se,Se.toLowerCase(),Pe,Re,Ne,He,Je);Be&&(Be[0]-=3,(!st||Be[0]>st[0])&&(st=Be))}}}return st}function it(de,be){if(be+1>=de.length)return;const Pe=de[be],Re=de[be+1];if(Pe!==Re)return de.slice(0,be)+Re+Pe+de.slice(be+2)}}),define(me[121],ge([0,1,39,120,15]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const k=new RegExp(`\\$\\(${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${k.source}`,"g");function D(u){return u.replace(C,(w,p)=>p?w:`\\${w}`)}e.escapeIcons=D;const d=new RegExp(`\\\\${k.source}`,"g");function y(u){return u.replace(d,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=y;const i=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function A(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(i,(w,p,h,f)=>h?w:p||f||"")}e.stripIcons=A;function E(u){const w=u.indexOf(e.iconStartMarker);return w===-1?{text:u}:b(u,w)}e.parseLabelWithIcons=E;function b(u,w){const p=[];let h="";function f(v){if(v){h+=v;for(const P of v)p.push(t)}}let c=-1,a="",t=0,s,n,r=w;const l=u.length;for(f(u.substr(0,w));r<l;)s=u[r],n=u[r+1],s===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(c=r,f(a),a=e.iconStartMarker,r++):s===")"&&c!==-1?(t+=r-c+1,c=-1,a=""):c!==-1?/^[a-z0-9\-]$/i.test(s)?a+=s:(f(a),c=-1,a=""):f(s),r++;return f(a),{text:h,iconOffsets:p}}function o(u,w,p=!1){const{text:h,iconOffsets:f}=w;if(!f||f.length===0)return(0,_.matchesFuzzy)(u,h,p);const c=(0,g.ltrim)(h," "),a=h.length-c.length,t=(0,_.matchesFuzzy)(u,c,p);if(t)for(const s of t){const n=f[s.start+a]+a;s.start+=n,s.end+=n}return t}e.matchesFuzzyIconAware=o}),define(me[74],ge([0,1,11,121]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(E){E[E.Paragraph=0]="Paragraph",E[E.Break=1]="Break"})(g=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class k{constructor(b="",o=!1){if(this.value=b,typeof this.value!="string")throw(0,S.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1)}appendText(b,o=0){return this.value+=y(this.supportThemeIcons?(0,_.escapeIcons)(b):b).replace(/([ \t]+)/g,(u,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(b){return this.value+=b,this}appendCodeblock(b,o){return this.value+="\n```",this.value+=b,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=k;function C(E){return D(E)?!E.value:Array.isArray(E)?E.every(C):!0}e.isEmptyMarkdownString=C;function D(E){return E instanceof k?!0:E&&typeof E=="object"?typeof E.value=="string"&&(typeof E.isTrusted=="boolean"||E.isTrusted===void 0)&&(typeof E.supportThemeIcons=="boolean"||E.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function d(E,b){return E===b?!0:!E||!b?!1:E.value===b.value&&E.isTrusted===b.isTrusted&&E.supportThemeIcons===b.supportThemeIcons}e.markdownStringEqual=d;function y(E){return E.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=y;function i(E){return E&&E.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function A(E){const b=[],o=E.split("|").map(w=>w.trim());E=o[0];const u=o[1];if(u){const w=/height=(\d+)/.exec(u),p=/width=(\d+)/.exec(u),h=w?w[1]:"",f=p?p[1]:"",c=isFinite(parseInt(f)),a=isFinite(parseInt(h));c&&b.push(`width="${f}"`),a&&b.push(`height="${h}"`)}return{href:E,dimensions:b}}e.parseHrefAndDimensions=A}),define(me[46],ge([0,1,17,15,4]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(i){return JSON.stringify(i,d)}e.stringify=k;function C(i){let A=JSON.parse(i);return A=y(A),A}e.parse=C;var D;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(D=e.MarshalledId||(e.MarshalledId={}));function d(i,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,_.regExpFlags)(A)}:A}function y(i,A=0){if(!i||A>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return g.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof S.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let E=0;E<i.length;++E)i[E]=y(i[E],A+1);else for(const E in i)Object.hasOwnProperty.call(i,E)&&(i[E]=y(i[E],A+1))}return i}e.revive=y}),define(me[8],ge([0,1,3,4]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var g;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(g=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,y,i){this._hosts[d]=y,this._ports[d]=i}setConnectionToken(d,y){this._connectionTokens[d]=y}rewrite(d){if(this._delegate)return this._delegate(d);const y=d.authority;let i=this._hosts[y];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const A=this._ports[y],E=this._connectionTokens[y];let b=`path=${encodeURIComponent(d.path)}`;return typeof E=="string"&&(b+=`&tkn=${encodeURIComponent(E)}`),_.URI.from({scheme:S.isWeb?this._preferredWebSchema:g.vscodeRemoteResource,authority:`${i}:${A}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new k;class C{asBrowserUri(d,y){const i=this.toUri(d,y);return i.scheme===g.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===g.file&&(S.isNative||typeof S.globals.importScripts=="function"&&S.globals.origin===`${g.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?i.with({scheme:g.vscodeFileResource,authority:i.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(d,y){const i=this.toUri(d,y);return i.scheme===g.vscodeFileResource?i.with({scheme:g.file,authority:i.authority!==C.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(d,y){return _.URI.isUri(d)?d:_.URI.parse(y.toUrl(d))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C}),define(me[75],ge([0,1,27]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const _=new S.LRUCache(1e4);function g(y){return d(y,"NFC",_)}e.normalizeNFC=g;const k=new S.LRUCache(1e4);function C(y){return d(y,"NFD",k)}e.normalizeNFD=C;const D=/[^\u0000-\u0080]/;function d(y,i,A){if(!y)return y;const E=A.get(y);if(E)return E;let b;return D.test(y)?b=y.normalize(i):b=y,A.set(y,b),b}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(i){return C(i).replace(y,"")}}()}),define(me[19],ge([0,1,26,8,5,3,15,4]),function(Q,e,S,_,g,k,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(b){return(0,D.uriToFsPath)(b,!0)}e.originalFSPath=d;class y{constructor(o){this._ignorePathCasing=o}compare(o,u,w=!1){return o===u?0:(0,C.compare)(this.getComparisonKey(o,w),this.getComparisonKey(u,w))}isEqual(o,u,w=!1){return o===u?!0:!o||!u?!1:this.getComparisonKey(o,w)===this.getComparisonKey(u,w)}getComparisonKey(o,u=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,u,w=!1){if(o.scheme===u.scheme){if(o.scheme===_.Schemas.file)return S.isEqualOrParent(d(o),d(u),this._ignorePathCasing(o))&&o.query===u.query&&(w||o.fragment===u.fragment);if((0,e.isEqualAuthority)(o.authority,u.authority))return S.isEqualOrParent(o.path,u.path,this._ignorePathCasing(o),"/")&&o.query===u.query&&(w||o.fragment===u.fragment)}return!1}joinPath(o,...u){return D.URI.joinPath(o,...u)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return g.posix.basename(o.path)}extname(o){return g.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let u;return o.scheme===_.Schemas.file?u=D.URI.file(g.dirname(d(o))).path:(u=g.posix.dirname(o.path),o.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),u="/")),o.with({path:u})}normalizePath(o){if(!o.path.length)return o;let u;return o.scheme===_.Schemas.file?u=D.URI.file(g.normalize(d(o))).path:u=g.posix.normalize(o.path),o.with({path:u})}relativePath(o,u){if(o.scheme!==u.scheme||!(0,e.isEqualAuthority)(o.authority,u.authority))return;if(o.scheme===_.Schemas.file){const h=g.relative(d(o),d(u));return k.isWindows?S.toSlashes(h):h}let w=o.path||"/",p=u.path||"/";if(this._ignorePathCasing(o)){let h=0;for(const f=Math.min(w.length,p.length);h<f&&!(w.charCodeAt(h)!==p.charCodeAt(h)&&w.charAt(h).toLowerCase()!==p.charAt(h).toLowerCase());h++);w=p.substr(0,h)+w.substr(h)}return g.posix.relative(w,p)}resolvePath(o,u){if(o.scheme===_.Schemas.file){const w=D.URI.file(g.resolve(d(o),u));return o.with({authority:w.authority,path:w.path})}return u=S.toPosixPath(u),o.with({path:g.posix.resolve(o.path,u)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,u){return o===u||(0,C.equalsIgnoreCase)(o,u)}hasTrailingPathSeparator(o,u=g.sep){if(o.scheme===_.Schemas.file){const w=d(o);return w.length>S.getRoot(w).length&&w[w.length-1]===u}else{const w=o.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,u=g.sep){return(0,e.hasTrailingPathSeparator)(o,u)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,u=g.sep){let w=!1;if(o.scheme===_.Schemas.file){const p=d(o);w=p!==void 0&&p.length===S.getRoot(p).length&&p[p.length-1]===u}else{u="/";const p=o.path;w=p.length===1&&p.charCodeAt(p.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(o,u)?o.with({path:o.path+"/"}):o}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(b=>b.scheme===_.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new y(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(b,o){const u=[];for(let w=0;w<b.length;w++){const p=o(b[w]);b.some((h,f)=>f===w?!1:(0,e.isEqualOrParent)(p,o(h)))||u.push(b[w])}return u}e.distinctParents=i;var A;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function o(u){const w=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,a]=f.split(":");c&&a&&w.set(c,a)});const h=u.path.substring(0,u.path.indexOf(";"));return h&&w.set(b.META_DATA_MIME,h),w}b.parseMetaData=o})(A=e.DataUri||(e.DataUri={}));function E(b,o,u){if(o){let w=b.path;return w&&w[0]!==g.posix.sep&&(w=g.posix.sep+w),b.with({scheme:u,authority:o,path:w})}return b.with({scheme:u})}e.toLocalResource=E}),define(me[13],ge([0,1,25,11,7,2,19]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D($){return!!$&&typeof $.then=="function"}e.isThenable=D;function d($){const z=new S.CancellationTokenSource,ee=$(z.token),J=new Promise((H,X)=>{const q=z.token.onCancellationRequested(()=>{q.dispose(),z.dispose(),X((0,_.canceled)())});Promise.resolve(ee).then(W=>{q.dispose(),z.dispose(),H(W)},W=>{q.dispose(),z.dispose(),X(W)})});return new class{cancel(){z.cancel()}then(H,X){return J.then(H,X)}catch(H){return this.then(void 0,H)}finally(H){return J.finally(H)}}}e.createCancelablePromise=d;function y($,z,ee){return Promise.race([$,new Promise(J=>z.onCancellationRequested(()=>J(ee)))])}e.raceCancellation=y;async function i($){let z=-1;const ee=$.map((H,X)=>H.then(q=>(z=X,q))),J=await Promise.race(ee);return $.forEach((H,X)=>{X!==z&&H.cancel()}),J}e.raceCancellablePromises=i;function A($,z,ee){let J;const H=setTimeout(()=>{J?.(void 0),ee?.()},z);return Promise.race([$.finally(()=>clearTimeout(H)),new Promise(X=>J=X)])}e.raceTimeout=A;function E($){return new Promise((z,ee)=>{const J=$();D(J)?J.then(z,ee):z(J)})}e.asPromise=E;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const ee=()=>{this.queuedPromise=null;const J=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,J};this.queuedPromise=new Promise(J=>{this.activePromise.then(ee,ee).then(J)})}return new Promise((ee,J)=>{this.queuedPromise.then(ee,J)})}return this.activePromise=z(),new Promise((ee,J)=>{this.activePromise.then(H=>{this.activePromise=null,ee(H)},H=>{this.activePromise=null,J(H)})})}}e.Throttler=b;class o{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=o;class u{constructor(){this.promiseMap=new Map}queue(z,ee){const H=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.promiseMap.get(z)===H&&this.promiseMap.delete(z)});return this.promiseMap.set(z,H),H}}e.SequencerByKey=u;class w{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,ee=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((J,H)=>{this.doResolve=J,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const J=this.task;return this.task=null,J()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ee),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,_.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class p{constructor(z){this.delayer=new w(z),this.throttler=new b}trigger(z,ee){return this.delayer.trigger(()=>this.throttler.queue(z),ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class h{constructor(){this._isOpen=!1,this._promise=new Promise((z,ee)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=h;class f extends h{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function c($,z){return z?new Promise((ee,J)=>{const H=setTimeout(()=>{X.dispose(),ee()},$),X=z.onCancellationRequested(()=>{clearTimeout(H),X.dispose(),J((0,_.canceled)())})}):d(ee=>c($,ee))}e.timeout=c;function a($,z=0){const ee=setTimeout($,z);return(0,k.toDisposable)(()=>clearTimeout(ee))}e.disposableTimeout=a;function t($){const z=[];let ee=0;const J=$.length;function H(){return ee<J?$[ee++]():null}function X(q){q!=null&&z.push(q);const W=H();return W?W.then(X):Promise.resolve(z)}return Promise.resolve(null).then(X)}e.sequence=t;function s($,z=J=>!!J,ee=null){let J=0;const H=$.length,X=()=>{if(J>=H)return Promise.resolve(ee);const q=$[J++];return Promise.resolve(q()).then(U=>z(U)?Promise.resolve(U):X())};return X()}e.first=s;function n($,z=J=>!!J,ee=null){if($.length===0)return Promise.resolve(ee);let J=$.length;const H=()=>{J=-1;for(const X of $)X.cancel?.()};return new Promise((X,q)=>{for(const W of $)W.then(U=>{--J>=0&&z(U)?(H(),X(U)):J===0&&X(ee)}).catch(U=>{--J>=0&&(H(),q(U))})})}e.firstParallel=n;class r{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new g.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((ee,J)=>{this.outstandingPromises.push({factory:z,c:ee,e:J}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const ee=z.factory();ee.then(z.c,z.e),ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class l extends r{constructor(){super(1)}}e.Queue=l;class v{constructor(){this.queues=new Map}queueFor(z,ee=C.extUri){const J=ee.getComparisonKey(z);let H=this.queues.get(J);return H||(H=new l,g.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(J)}),this.queues.set(J,H)),H}dispose(){this.queues.forEach(z=>z.dispose()),this.queues.clear()}}e.ResourceQueue=v;class P{constructor(z,ee){this._token=-1,typeof z=="function"&&typeof ee=="number"&&this.setIfNotSet(z,ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},ee)}setIfNotSet(z,ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},ee))}}e.TimeoutTimer=P;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,ee){this.cancel(),this._token=setInterval(()=>{z()},ee)}}e.IntervalTimer=L;class R{constructor(z,ee){this.timeoutToken=-1,this.runner=z,this.timeout=ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class m extends R{constructor(z,ee){super(z,ee);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=m;class T extends k.Disposable{constructor(z,ee,J,H){super();this.maxWorkChunkSize=z,this.maxPendingWork=ee,this.throttleDelay=J,this.handler=H,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=z=>{const ee=setTimeout(()=>z($));let J=!1;return{dispose(){J||(J=!0,clearTimeout(ee))}}}}else e.runWhenIdle=($,z)=>{const ee=requestIdleCallback($,typeof z=="number"?{timeout:z}:void 0);let J=!1;return{dispose(){J||(J=!0,cancelIdleCallback(ee))}}}}();class I{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(ee){this._error=ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=I;async function B($,z,ee){let J;for(let H=0;H<ee;H++)try{return await $()}catch(X){J=X,await c(z)}throw J}e.retry=B;class j{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,ee,J){return this._pending={taskId:z,cancel:()=>J?.(),promise:ee},ee.then(()=>this.donePending(z),()=>this.donePending(z)),ee}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let ee,J;const H=new Promise((X,q)=>{ee=X,J=q});this._next={run:z,promise:H,promiseResolve:ee,promiseReject:J}}return this._next.promise}}e.TaskSequentializer=j;class ue{constructor(z){this.interval=z,this.lastIncrementTime=0,this.value=0}increment(){const z=Date.now();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=ue;class ce{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,ee)=>{this.completeCallback=z,this.errorCallback=ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(ee=>{this.completeCallback(z),this.resolved=!0,ee()})}error(z){return new Promise(ee=>{this.errorCallback(z),this.rejected=!0,ee()})}cancel(){new Promise(z=>{this.errorCallback((0,_.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=ce;var O;(function($){async function z(ee){let J;const H=await Promise.all(ee.map(X=>X.then(q=>q,q=>{J||(J=q)})));if(typeof J!="undefined")throw J;return H}$.settled=z})(O=e.Promises||(e.Promises={}))}),define(me[47],ge([0,1,13,26,27,5,15]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const d="**",y="/",i="[/\\\\]",A="[^/\\\\]",E=/\//g;function b(H){switch(H){case 0:return"";case 1:return`${A}*?`;default:return`(?:${i}|${A}+${i}|${i}${A}+)*?`}}function o(H,X){if(!H)return[];const q=[];let W=!1,U=!1,ie="";for(const ne of H){switch(ne){case X:if(!W&&!U){q.push(ie),ie="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":U=!0;break;case"]":U=!1;break}ie+=ne}return ie&&q.push(ie),q}e.splitGlobAware=o;function u(H){if(!H)return"";let X="";const q=o(H,y);if(q.every(W=>W===d))X=".*";else{let W=!1;q.forEach((U,ie)=>{if(U===d){W||(X+=b(2),W=!0);return}let ne=!1,he="",ve=!1,Ae="";for(const Ie of U){if(Ie!=="}"&&ne){he+=Ie;continue}if(ve&&(Ie!=="]"||!Ae)){let Ue;Ie==="-"?Ue=Ie:(Ie==="^"||Ie==="!")&&!Ae?Ue="^":Ie===y?Ue="":Ue=C.escapeRegExpCharacters(Ie),Ae+=Ue;continue}switch(Ie){case"{":ne=!0;continue;case"[":ve=!0;continue;case"}":X+=`(?:${o(he,",").map(Ge=>u(Ge)).join("|")})`,ne=!1,he="";break;case"]":X+="["+Ae+"]",ve=!1,Ae="";break;case"?":X+=A;continue;case"*":X+=b(1);continue;default:X+=C.escapeRegExpCharacters(Ie)}}ie<q.length-1&&(q[ie+1]!==d||ie+2<q.length)&&(X+=i),W=!1})}return X}const w=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new g.LRUCache(1e4),s=function(){return!1},n=function(){return null};function r(H,X){if(!H)return n;let q;typeof H!="string"?q=H.pattern:q=H,q=q.trim();const W=`${q}_${!!X.trimForExclusions}`;let U=t.get(W);if(U)return l(U,H);let ie;if(w.test(q)){const ne=q.substr(4);U=function(he,ve){return typeof he=="string"&&he.endsWith(ne)?q:null}}else(ie=p.exec(v(q,X)))?U=P(ie[1],q):(X.trimForExclusions?f:h).test(q)?U=L(q,X):(ie=c.exec(v(q,X)))?U=R(ie[1].substr(1),q,!0):(ie=a.exec(v(q,X)))?U=R(ie[1],q,!1):U=m(q);return t.set(W,U),l(U,H)}function l(H,X){return typeof X=="string"?H:function(q,W){return _.isEqualOrParent(q,X.base)?H(k.relative(X.base,q),W):null}}function v(H,X){return X.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function P(H,X){const q=`/${H}`,W=`\\${H}`,U=function(ne,he){return typeof ne!="string"?null:he?he===H?X:null:ne===H||ne.endsWith(q)||ne.endsWith(W)?X:null},ie=[H];return U.basenames=ie,U.patterns=[X],U.allBasenames=ie,U}function L(H,X){const q=J(H.slice(1,-1).split(",").map(he=>r(he,X)).filter(he=>he!==n),H),W=q.length;if(!W)return n;if(W===1)return q[0];const U=function(he,ve){for(let Ae=0,Ie=q.length;Ae<Ie;Ae++)if(q[Ae](he,ve))return H;return null},ie=q.find(he=>!!he.allBasenames);ie&&(U.allBasenames=ie.allBasenames);const ne=q.reduce((he,ve)=>ve.allPaths?he.concat(ve.allPaths):he,[]);return ne.length&&(U.allPaths=ne),U}function R(H,X,q){const W=k.sep===k.posix.sep,U=W?H:H.replace(E,k.sep),ie=k.sep+U,ne=k.posix.sep+H,he=q?function(ve,Ae){return typeof ve=="string"&&(ve===U||ve.endsWith(ie)||!W&&(ve===H||ve.endsWith(ne)))?X:null}:function(ve,Ae){return typeof ve=="string"&&(ve===U||!W&&ve===H)?X:null};return he.allPaths=[(q?"*/":"./")+H],he}function m(H){try{const X=new RegExp(`^${u(H)}$`);return function(q){return X.lastIndex=0,typeof q=="string"&&X.test(q)?H:null}}catch(X){return n}}function T(H,X,q){return!H||typeof X!="string"?!1:I(H)(X,void 0,q)}e.match=T;function I(H,X={}){if(!H)return s;if(typeof H=="string"||ce(H)){const q=r(H,X);if(q===n)return s;const W=function(U,ie){return!!q(U,ie)};return q.allBasenames&&(W.allBasenames=q.allBasenames),q.allPaths&&(W.allPaths=q.allPaths),W}return z(H,X)}e.parse=I;function B(H){if(!H)return;let X;return q=>(X||(X=(H()||Promise.resolve([])).then(W=>W?ue(W):{})),X.then(W=>!!W[q]))}e.hasSiblingPromiseFn=B;function j(H){if(!H)return;let X;return q=>{if(!X){const W=H();X=W?ue(W):{}}return!!X[q]}}e.hasSiblingFn=j;function ue(H){const X={};for(const q of H)X[q]=!0;return X}function ce(H){const X=H;return X&&typeof X.base=="string"&&typeof X.pattern=="string"}e.isRelativePattern=ce;function O(H){return H.allBasenames||[]}e.getBasenameTerms=O;function $(H){return H.allPaths||[]}e.getPathTerms=$;function z(H,X){const q=J(Object.getOwnPropertyNames(H).map(he=>ee(he,H[he],X)).filter(he=>he!==n)),W=q.length;if(!W)return n;if(!q.some(he=>!!he.requiresSiblings)){if(W===1)return q[0];const he=function(Ie,Ue){for(let qe=0,Ge=q.length;qe<Ge;qe++){const rt=q[qe](Ie,Ue);if(rt)return rt}return null},ve=q.find(Ie=>!!Ie.allBasenames);ve&&(he.allBasenames=ve.allBasenames);const Ae=q.reduce((Ie,Ue)=>Ue.allPaths?Ie.concat(Ue.allPaths):Ie,[]);return Ae.length&&(he.allPaths=Ae),he}const U=function(he,ve,Ae){let Ie;for(let Ue=0,qe=q.length;Ue<qe;Ue++){const Ge=q[Ue];Ge.requiresSiblings&&Ae&&(ve||(ve=k.basename(he)),Ie||(Ie=ve.substr(0,ve.length-k.extname(he).length)));const rt=Ge(he,ve,Ie,Ae);if(rt)return rt}return null},ie=q.find(he=>!!he.allBasenames);ie&&(U.allBasenames=ie.allBasenames);const ne=q.reduce((he,ve)=>ve.allPaths?he.concat(ve.allPaths):he,[]);return ne.length&&(U.allPaths=ne),U}function ee(H,X,q){if(X===!1)return n;const W=r(H,q);if(W===n)return n;if(typeof X=="boolean")return W;if(X){const U=X.when;if(typeof U=="string"){const ie=(ne,he,ve,Ae)=>{if(!Ae||!W(ne,he))return null;const Ie=U.replace("$(basename)",ve),Ue=Ae(Ie);return(0,S.isThenable)(Ue)?Ue.then(qe=>qe?H:null):Ue?H:null};return ie.requiresSiblings=!0,ie}}return W}function J(H,X){const q=H.filter(he=>!!he.basenames);if(q.length<2)return H;const W=q.reduce((he,ve)=>{const Ae=ve.basenames;return Ae?he.concat(Ae):he},[]);let U;if(X){U=[];for(let he=0,ve=W.length;he<ve;he++)U.push(X)}else U=q.reduce((he,ve)=>{const Ae=ve.patterns;return Ae?he.concat(Ae):he},[]);const ie=function(he,ve){if(typeof he!="string")return null;if(!ve){let Ie;for(Ie=he.length;Ie>0;Ie--){const Ue=he.charCodeAt(Ie-1);if(Ue===47||Ue===92)break}ve=he.substr(Ie)}const Ae=W.indexOf(ve);return Ae!==-1?U[Ae]:null};ie.basenames=W,ie.patterns=U,ie.allBasenames=W;const ne=H.filter(he=>!he.basenames);return ne.push(ie),ne}}),define(me[52],ge([0,1,26,8,5,3,19,15,4]),function(Q,e,S,_,g,k,C,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(r,l,v){if(typeof r=="string"&&(r=d.URI.file(r)),v){const L=v.getWorkspaceFolder(r);if(L){const R=v.getWorkspace().folders.length>1;let m;if((0,C.isEqual)(L.uri,r)?m="":m=(0,C.relativePath)(L.uri,r),R){const T=L.name?L.name:(0,C.basename)(L.uri);m=m?T+" \u2022 "+m:T}return m}}if(r.scheme!==_.Schemas.file&&r.scheme!==_.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(r.fsPath))return(0,g.normalize)(A(r.fsPath));let P=(0,g.normalize)(r.fsPath);return!k.isWindows&&l?.userHome&&(P=b(P,l.userHome.fsPath)),P}e.getPathLabel=y;function i(r){if(!r)return;typeof r=="string"&&(r=d.URI.file(r));const l=(0,C.basename)(r)||(r.scheme===_.Schemas.file?r.fsPath:r.path);return k.isWindows&&(0,S.isRootOrDriveLetter)(l)?A(l):l}e.getBaseLabel=i;function A(r){return(0,S.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=A;let E=Object.create(null);function b(r,l){if(k.isWindows||!r||!l)return r;let v=E.original===l?E.normalized:void 0;return v||(v=`${(0,D.rtrim)(l,g.posix.sep)}${g.posix.sep}`,E={original:l,normalized:v}),(k.isLinux?r.startsWith(v):(0,D.startsWithIgnoreCase)(r,v))&&(r=`~/${r.substr(v.length)}`),r}e.tildify=b;function o(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=o;const u="\u2026",w="\\\\",p="~";function h(r,l=g.sep){const v=new Array(r.length);let P=!1;for(let L=0;L<r.length;L++){let R=r[L];if(R===""){v[L]=`.${l}`;continue}if(!R){v[L]=R;continue}P=!0;let m="";R.indexOf(w)===0?(m=R.substr(0,R.indexOf(w)+w.length),R=R.substr(R.indexOf(w)+w.length)):R.indexOf(l)===0?(m=R.substr(0,R.indexOf(l)+l.length),R=R.substr(R.indexOf(l)+l.length)):R.indexOf(p)===0&&(m=R.substr(0,R.indexOf(p)+p.length),R=R.substr(R.indexOf(p)+p.length));const T=R.split(l);for(let I=1;P&&I<=T.length;I++)for(let B=T.length-I;P&&B>=0;B--){P=!1;let j=T.slice(B,B+I).join(l);for(let ue=0;!P&&ue<r.length;ue++)if(ue!==L&&r[ue]&&r[ue].indexOf(j)>-1){const ce=B+I===T.length,O=B>0&&r[ue].indexOf(l)>-1?l+j:j,$=r[ue].endsWith(O);P=!ce||$}if(!P){let ue="";(T[0].endsWith(":")||m!=="")&&(B===1&&(B=0,I++,j=T[0]+l+j),B>0&&(ue=T[0]+l),ue=m+ue),B>0&&(ue=ue+u+l),ue=ue+j,B+I<T.length&&(ue=ue+l+u),v[L]=ue}}P&&(v[L]=R)}return v}e.shorten=h;var f;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function c(r,l=Object.create(null)){const v=[];let P=!1,L="";for(const R of r)if(R==="$"||P&&R==="{")L&&v.push({value:L,type:f.TEXT}),L="",P=!0;else if(R==="}"&&P){const m=l[L];if(typeof m=="string")m.length&&v.push({value:m,type:f.VARIABLE});else if(m){const T=v[v.length-1];(!T||T.type!==f.SEPARATOR)&&v.push({value:m.label,type:f.SEPARATOR})}L="",P=!1}else L+=R;return L&&!P&&v.push({value:L,type:f.TEXT}),v.filter((R,m)=>{if(R.type===f.SEPARATOR){const T=v[m-1],I=v[m+1];return[T,I].every(B=>B&&(B.type===f.VARIABLE||B.type===f.TEXT)&&B.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=c;function a(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):r.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function t(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):k.isWindows?r.replace(/&&|&/g,v=>v==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=s;function n(r){const l=r.indexOf("/")!==-1?g.posix:g.win32,v=l.basename(r),P=l.dirname(r);return v.length?{name:v,parentPath:P}:{name:P,parentPath:""}}e.splitName=n}),define(me[53],ge([0,1,47,8,5,19,15]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(D=e.Mimes||(e.Mimes={}));let d=[],y=[],i=[];function A(r,l=!1){const v=E(r);d.push(v),v.userConfigured?i.push(v):y.push(v),l&&!v.userConfigured&&d.forEach(P=>{P.mime===v.mime||P.userConfigured||(v.extension&&P.extension===v.extension&&console.warn(`Overwriting extension <<${v.extension}>> to now point to mime <<${v.mime}>>`),v.filename&&P.filename===v.filename&&console.warn(`Overwriting filename <<${v.filename}>> to now point to mime <<${v.mime}>>`),v.filepattern&&P.filepattern===v.filepattern&&console.warn(`Overwriting filepattern <<${v.filepattern}>> to now point to mime <<${v.mime}>>`),v.firstline&&P.firstline===v.firstline&&console.warn(`Overwriting firstline <<${v.firstline}>> to now point to mime <<${v.mime}>>`))})}e.registerTextMime=A;function E(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,S.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(g.posix.sep)>=0:!1}}function b(r){r?(d=d.filter(l=>!l.userConfigured),i=[]):(d=[],y=[],i=[])}e.clearTextMimes=b;function o(r,l){let v;if(r)switch(r.scheme){case _.Schemas.file:v=r.fsPath;break;case _.Schemas.data:v=k.DataUri.parseMetaData(r).get(k.DataUri.META_DATA_LABEL);break;default:v=r.path}if(!v)return[D.unknown];v=v.toLowerCase();const P=(0,g.basename)(v),L=u(v,P,i);if(L)return[L,D.text];const R=u(v,P,y);if(R)return[R,D.text];if(l){const m=w(l);if(m)return[m,D.text]}return[D.unknown]}e.guessMimeTypes=o;function u(r,l,v){let P=null,L=null,R=null;for(let m=v.length-1;m>=0;m--){const T=v[m];if(l===T.filenameLowercase){P=T;break}if(T.filepattern&&(!L||T.filepattern.length>L.filepattern.length)){const I=T.filepatternOnPath?r:l;T.filepatternLowercase?.(I)&&(L=T)}T.extension&&(!R||T.extension.length>R.extension.length)&&l.endsWith(T.extensionLowercase)&&(R=T)}return P?P.mime:L?L.mime:R?R.mime:null}function w(r){if((0,C.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let l=d.length-1;l>=0;l--){const v=d[l];if(!v.firstline)continue;const P=r.match(v.firstline);if(P&&P.length>0)return v.mime}return null}function p(r){return r?typeof r=="string"?r===D.binary||r===D.text||r===D.unknown:r.length===1&&p(r[0]):!0}e.isUnspecific=p;const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(r){const l=(0,g.extname)(r),v=h[l.toLowerCase()];return v!==void 0?v:a(r)}e.getMediaOrTextMime=c;function a(r){const l=(0,g.extname)(r);return f[l.toLowerCase()]}e.getMediaMime=a;function t(r){for(const l in f)if(f[l]===r)return l}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function n(r,l){const v=s.exec(r);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:l?void 0:r}e.normalizeMimeType=n}),define(me[54],ge([0,1,4]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function _(i){return i.toJSON()}class g{constructor(A){this._uriTransformer=A}transformIncoming(A){const E=this._uriTransformer.transformIncoming(A);return E===A?A:_(S.URI.from(E))}transformOutgoing(A){const E=this._uriTransformer.transformOutgoing(A);return E===A?A:_(S.URI.from(E))}transformOutgoingURI(A){const E=this._uriTransformer.transformOutgoing(A);return E===A?A:S.URI.from(E)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=g,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function k(i,A,E){if(!i||E>200)return null;if(typeof i=="object"){if(i instanceof S.URI)return A.transformOutgoing(i);for(let b in i)if(Object.hasOwnProperty.call(i,b)){const o=k(i[b],A,E+1);o!==null&&(i[b]=o)}}return null}function C(i,A){const E=k(i,A,0);return E===null?i:E}e.transformOutgoingURIs=C;function D(i,A,E,b){if(!i||b>200)return null;if(typeof i=="object"){if(i.$mid===1)return E?S.URI.revive(A.transformIncoming(i)):A.transformIncoming(i);for(let o in i)if(Object.hasOwnProperty.call(i,o)){const u=D(i[o],A,E,b+1);u!==null&&(i[o]=u)}}return null}function d(i,A){const E=D(i,A,!1,0);return E===null?i:E}e.transformIncomingURIs=d;function y(i,A){const E=D(i,A,!0,0);return E===null?i:E}e.transformAndReviveIncomingURIs=y}),define(me[23],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function _(d){return S.test(d)}e.isUUID=_;const g=new Uint8Array(16),k=[];for(let d=0;d<256;d++)k.push(d.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(d){for(let y=0;y<d.length;y++)d[y]=Math.floor(Math.random()*256);return d};function D(){C(g),g[6]=g[6]&15|64,g[8]=g[8]&63|128;let d=0,y="";return y+=k[g[d++]],y+=k[g[d++]],y+=k[g[d++]],y+=k[g[d++]],y+="-",y+=k[g[d++]],y+=k[g[d++]],y+="-",y+=k[g[d++]],y+=k[g[d++]],y+="-",y+=k[g[d++]],y+=k[g[d++]],y+="-",y+=k[g[d++]],y+=k[g[d++]],y+=k[g[d++]],y+=k[g[d++]],y+=k[g[d++]],y+=k[g[d++]],y}e.generateUuid=D}),define(me[76],ge([0,1,242]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class _{constructor(k="utf8"){this.stringDecoder=new S.StringDecoder(k),this.remaining=null}write(k){const C=[],D=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(D.length<1)return C;let d=0,y,i=d;for(;i<D.length;)if(y=D.charCodeAt(i),y===13||y===10){if(C.push(D.substring(d,i)),i++,i<D.length){const A=y;y=D.charCodeAt(i),(A===13&&y===10||A===10&&y===13)&&i++}d=i}else i++;return this.remaining=d<D.length?D.substr(d):null,C}end(){return this.remaining}}e.LineDecoder=_}),function(){"use strict";function Q(e,S,_,g){function k(o){return new Promise(u=>_.exists(o,u))}function C(o){return new Promise((u,w)=>{const p=new Date;_.utimes(o,p,p,h=>h?w(h):u())})}function D(o){return new Promise((u,w)=>_.mkdir(o,{recursive:!0},p=>p&&p.code!=="EEXIST"?w(p):u(o)))}function d(o){return new Promise((u,w)=>_.rmdir(o,{recursive:!0},p=>p&&p.code!=="ENOENT"?w(p):u()))}function y(o){return new Promise((u,w)=>_.readFile(o,"utf8",(p,h)=>p?w(p):u(h)))}function i(o,u){return new Promise((w,p)=>_.writeFile(o,u,"utf8",h=>h?p(h):w()))}function A(o){const u=S.join(o,"languagepacks.json");try{return e(u)}catch(w){}}function E(o,u){try{for(;u;){if(o[u])return u;{const w=u.lastIndexOf("-");if(w>0)u=u.substring(0,w);else return}}}catch(w){console.error("Resolving language pack configuration failed.",w)}}function b(o,u,w,p){if(p==="pseudo")return Promise.resolve({locale:p,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:p,availableLanguages:{}});if(p&&(p==="en"||p==="en-us"))return Promise.resolve({locale:p,availableLanguages:{}});const h=p;g.mark("code/willGenerateNls");const f=function(c){return g.mark("code/didGenerateNls"),Promise.resolve({locale:c,availableLanguages:{}})};try{if(!o)return f(h);const c=A(u);if(!c||(p=E(c,p),!p))return f(h);const a=c[p];let t;return!a||typeof a.hash!="string"||!a.translations||typeof(t=a.translations.vscode)!="string"?f(h):k(t).then(s=>{if(!s)return f(h);const n=a.hash+"."+p,r=S.join(u,"clp",n),l=S.join(r,o),v=S.join(r,"tcf.json"),P=S.join(r,"corrupted.info"),L={locale:h,availableLanguages:{"*":p},_languagePackId:n,_translationsConfigFile:v,_cacheRoot:r,_resolvedLanguagePackCoreLocation:l,_corruptedFile:P};return k(P).then(R=>{let m;return R?m=d(r):m=Promise.resolve(void 0),m.then(()=>k(l).then(T=>T?(C(l).catch(()=>{}),g.mark("code/didGenerateNls"),L):D(l).then(()=>Promise.all([y(w),y(t)])).then(I=>{const B=JSON.parse(I[0]),j=JSON.parse(I[1]).contents,ue=Object.keys(B.bundles),ce=[];for(const O of ue){const $=B.bundles[O],z=Object.create(null);for(const ee of $){const J=B.keys[ee],H=B.messages[ee],X=j[ee];let q;if(X){q=[];for(let W=0;W<J.length;W++){const U=J[W],ie=typeof U=="string"?U:U.key;let ne=X[ie];ne===void 0&&(ne=H[W]),q.push(ne)}}else q=H;z[ee]=q}ce.push(i(S.join(l,O.replace(/\//g,"!")+".nls.json"),JSON.stringify(z)))}return ce.push(i(v,JSON.stringify(a.translations))),Promise.all(ce)}).then(()=>(g.mark("code/didGenerateNls"),L)).catch(I=>(console.error("Generating translation files failed.",I),f(p)))))})})}catch(c){return console.error("Generating translation files failed.",c),f(p)}}return{getNLSConfiguration:b}}if(typeof define=="function")define(me[122],ge([0,77,28,48]),function(e,S,_,g){return Q(e.__$__nodeRequire,S,_,g)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("fs"),_=require("../common/performance");module.exports=Q(require,e,S,_)}else throw new Error("Unknown context")}(),define(me[123],ge([0,1,24]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const _=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function g(D){const d=D.replace(/\-/g,":").toLowerCase();return!_.has(d)}function k(){return new Promise(async(D,d)=>{const y=setTimeout(()=>d("Unable to retrieve mac address (timeout after 10s)"),1e4);try{D(await C())}catch(i){d(i)}finally{clearTimeout(y)}})}e.getMac=k;function C(){return new Promise((D,d)=>{try{const y=(0,S.networkInterfaces)();for(let i in y){const A=y[i];if(A){for(const{mac:E}of A)if(g(E))return D(E)}}d("Unable to retrieve mac address (unexpected format)")}catch(y){d(y)}})}}),define(me[78],ge([0,1,24,11,27,23,123]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=g.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,A=0;const E=(0,S.networkInterfaces)();for(let b in E){const o=E[b];if(o)for(const{mac:u,internal:w}of o)w||(A+=1,this._isVirtualMachineMacAddress(u.toUpperCase())&&(i+=1))}this._value=A>0?i/A:0}return this._value}};let D;async function d(){return D||(D=(async()=>await y()||k.generateUuid())()),D}e.getMachineId=d;async function y(){try{const i=await new Promise((E,b)=>{Q(["crypto"],E,b)}),A=await(0,C.getMac)();return i.createHash("sha256").update(A,"utf8").digest("hex")}catch(i){_.onUnexpectedError(i);return}}}),define(me[16],ge([0,1,28,24,124,13,26,75,5,3,19,4,23]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function o(O,$=b.UNLINK){if((0,C.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return $===b.UNLINK?w(O):u(O)}async function u(O){try{const $=(0,d.join)((0,_.tmpdir)(),(0,E.generateUuid)());try{await e.Promises.rename(O,$)}catch(z){return w(O)}w($).catch(z=>{})}catch($){if($.code!=="ENOENT")throw $}}async function w(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function p(O){if((0,C.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");S.rmdirSync(O,{recursive:!0})}e.rimrafSync=p;async function h(O,$){return a(await($?f(O):(0,g.promisify)(S.readdir)(O)))}async function f(O){try{return await(0,g.promisify)(S.readdir)(O,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const $=[],z=await h(O);for(const ee of z){let J=!1,H=!1,X=!1;try{const q=await e.Promises.lstat((0,d.join)(O,ee));J=q.isFile(),H=q.isDirectory(),X=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}$.push({name:ee,isFile:()=>J,isDirectory:()=>H,isSymbolicLink:()=>X})}return $}function c(O){return a(S.readdirSync(O))}e.readdirSync=c;function a(O){return O.map($=>typeof $=="string"?y.isMacintosh?(0,D.normalizeNFC)($):$:($.name=y.isMacintosh?(0,D.normalizeNFC)($.name):$.name,$))}async function t(O){const $=await h(O),z=[];for(const ee of $)await n.existsDirectory((0,d.join)(O,ee))&&z.push(ee);return z}function s(O,$=1e3){return new Promise(z=>{let ee=!1;const J=setInterval(()=>{ee||(ee=!0,S.access(O,H=>{ee=!1,H&&(clearInterval(J),z(void 0))}))},$)})}e.whenDeleted=s;var n;(function(O){async function $(J){let H;try{if(H=await e.Promises.lstat(J),!H.isSymbolicLink())return{stat:H}}catch(X){}try{return{stat:await e.Promises.stat(J),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(y.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw q}throw X}}O.stat=$;async function z(J){try{const{stat:H,symbolicLink:X}=await O.stat(J);return H.isFile()&&X?.dangling!==!0}catch(H){}return!1}O.existsFile=z;async function ee(J){try{const{stat:H,symbolicLink:X}=await O.stat(J);return H.isDirectory()&&X?.dangling!==!0}catch(H){}return!1}O.existsDirectory=ee})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new k.ResourceQueue;function l(O,$,z){return r.queueFor(A.URI.file(O),i.extUriBiasedIgnorePathCase).queue(()=>{const ee=R(z);return new Promise((J,H)=>P(O,$,ee,X=>X?H(X):J()))})}let v=!0;function P(O,$,z,ee){if(!v)return S.writeFile(O,$,{mode:z.mode,flag:z.flag},ee);S.open(O,z.flag,z.mode,(J,H)=>{if(J)return ee(J);S.writeFile(H,$,X=>{if(X)return S.close(H,()=>ee(X));S.fdatasync(H,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),v=!1),S.close(H,W=>ee(W))))})})}function L(O,$,z){const ee=R(z);if(!v)return S.writeFileSync(O,$,{mode:ee.mode,flag:ee.flag});const J=S.openSync(O,ee.flag,ee.mode);try{S.writeFileSync(J,$);try{S.fdatasyncSync(J)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),v=!1}}finally{S.closeSync(J)}}e.writeFileSync=L;function R(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function m(O,$){if(O===$)return;async function z(ee){try{const J=await e.Promises.lstat(ee);if(J.isDirectory()||J.isSymbolicLink())return;await e.Promises.utimes(ee,J.atime,new Date)}catch(J){}}try{await e.Promises.rename(O,$),await z($)}catch(ee){if(O.toLowerCase()!==$.toLowerCase()&&ee.code==="EXDEV"||O.endsWith("."))await T(O,$,{preserveSymlinks:!1}),await o(O,b.MOVE),await z($);else throw ee}}async function T(O,$,z){return B(O,$,{root:{source:O,target:$},options:z,handledSourcePaths:new Set})}const I=511;async function B(O,$,z){if(z.handledSourcePaths.has(O))return;z.handledSourcePaths.add(O);const{stat:ee,symbolicLink:J}=await n.stat(O);if(J){if(z.options.preserveSymlinks)try{return await ce(O,$,z)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(J.dangling)return}return ee.isDirectory()?j(O,$,ee.mode&I,z):ue(O,$,ee.mode&I)}async function j(O,$,z,ee){await e.Promises.mkdir($,{recursive:!0,mode:z});const J=await h(O);for(const H of J)await B((0,d.join)(O,H),(0,d.join)($,H),ee)}async function ue(O,$,z){await e.Promises.copyFile(O,$),await e.Promises.chmod($,z)}async function ce(O,$,z){let ee=await e.Promises.readlink(O);(0,C.isEqualOrParent)(ee,z.root.source,!y.isLinux)&&(ee=(0,d.join)(z.root.target,ee.substr(z.root.source.length+1))),await e.Promises.symlink(ee,$)}e.Promises=new class{get access(){return(0,g.promisify)(S.access)}get stat(){return(0,g.promisify)(S.stat)}get lstat(){return(0,g.promisify)(S.lstat)}get utimes(){return(0,g.promisify)(S.utimes)}get read(){return(0,g.promisify)(S.read)}get readFile(){return(0,g.promisify)(S.readFile)}get write(){return(0,g.promisify)(S.write)}get appendFile(){return(0,g.promisify)(S.appendFile)}get fdatasync(){return(0,g.promisify)(S.fdatasync)}get truncate(){return(0,g.promisify)(S.truncate)}get rename(){return(0,g.promisify)(S.rename)}get copyFile(){return(0,g.promisify)(S.copyFile)}get open(){return(0,g.promisify)(S.open)}get close(){return(0,g.promisify)(S.close)}get symlink(){return(0,g.promisify)(S.symlink)}get readlink(){return(0,g.promisify)(S.readlink)}get chmod(){return(0,g.promisify)(S.chmod)}get mkdir(){return(0,g.promisify)(S.mkdir)}get unlink(){return(0,g.promisify)(S.unlink)}get rmdir(){return(0,g.promisify)(S.rmdir)}get realpath(){return(0,g.promisify)(S.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return o}get move(){return m}get copy(){return T}}}),define(me[125],ge([0,1,28,5,15,16]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function C(i){const A=(0,_.dirname)(i);if(i===A)return i;const E=((0,_.basename)(i)||i).toLowerCase();try{const o=(0,k.readdirSync)(A).filter(u=>u.toLowerCase()===E);if(o.length===1){const u=C(A);if(u)return(0,_.join)(u,o[0])}else if(o.length>1){const u=o.indexOf(E);if(u>=0){const w=C(A);if(w)return(0,_.join)(w,o[u])}}}catch(b){}return null}e.realcaseSync=C;async function D(i){try{return await k.Promises.realpath(i)}catch(A){const E=y(i);return await k.Promises.access(E,S.constants.R_OK),E}}e.realpath=D;function d(i){try{return S.realpathSync(i)}catch(A){const E=y(i);return S.accessSync(E,S.constants.R_OK),E}}e.realpathSync=d;function y(i){return(0,g.rtrim)((0,_.normalize)(i),_.sep)}}),define(me[126],ge([0,1,79]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function _(D,d,y,i=1){let A=!1;return new Promise(E=>{const b=setTimeout(()=>{if(!A)return A=!0,E(0)},y);g(D,d,i,o=>{if(!A)return A=!0,clearTimeout(b),E(o)})})}e.findFreePort=_;function g(D,d,y,i){if(d===0)return i(0);const A=new S.Socket;A.once("connect",()=>(C(A),g(D+y,d-1,y,i))),A.once("data",()=>{}),A.once("error",E=>(C(A),E.code!=="ECONNREFUSED"?g(D+y,d-1,y,i):i(D))),A.connect(D,"127.0.0.1")}function k(D,d,y){let i=!1,A,E=1;const b=S.createServer({pauseOnConnect:!0});function o(u,w){i||(i=!0,b.removeAllListeners(),b.close(),A&&clearTimeout(A),w(u))}return new Promise(u=>{A=setTimeout(()=>{o(0,u)},y),b.on("listening",()=>{o(D,u)}),b.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&E<d?(D++,E++,b.listen(D,"127.0.0.1")):o(0,u)}),b.on("close",()=>{o(0,u)}),b.listen(D,"127.0.0.1")})}e.findFreePortFaster=k;function C(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(d){console.error(d)}}}),define(me[80],ge([0,1,24,5,16]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,C=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var d;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(d||(d={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class A{constructor(a,t,s){this.exePath=a,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await g.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:c=!1}={}){return c?y===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:c=!1,findPreview:a=!1}={}){const t=E({useAlternateBitness:c});if(!t)return null;const s=_.join(t,"PowerShell");if(!await g.SymlinkSupport.existsDirectory(s))return null;let n=-1,r=null;for(const P of await g.Promises.readdir(s)){let L=-1;if(a){const m=P.indexOf("-");if(m<0)continue;const T=P.substring(0,m);if(!k.test(T)||P.substring(m+1)!=="preview")continue;L=parseInt(T,10)}else{if(!k.test(P))continue;L=parseInt(P,10)}if(L<=n)continue;const R=_.join(s,P,"pwsh.exe");!await g.SymlinkSupport.existsFile(R)||(r=R,n=L)}if(!r)return null;const l=t.includes("x86")?" (x86)":"",v=a?" Preview":"";return new A(r,`PowerShell${v}${l}`,!0)}async function o({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const a=_.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await g.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=c?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const n of await g.Promises.readdir(a))if(t.test(n)){const r=_.join(a,n,"pwsh.exe");return new A(r,s)}return null}function u(){const c=_.join(S.homedir(),".dotnet","tools","pwsh.exe");return new A(c,".NET Core PowerShell Global Tool")}function w(){const c=_.join(process.env.windir,y===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new A(c,"Windows PowerShell",!0)}async function*p(){let c=await b();c&&(yield c),c=await b({useAlternateBitness:!0}),c&&(yield c),c=await o(),c&&(yield c),c=u(),c&&(yield c),c=await b({findPreview:!0}),c&&(yield c),c=await o({findPreview:!0}),c&&(yield c),c=await b({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=w(),c&&(yield c)}async function*h(){for await(const c of p())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=h;async function f(){for await(const c of h())return c;return null}e.getFirstAvailablePowerShellInstallation=f}),define(me[81],ge([0,1,35,8]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function g(C){return new Promise((D,d)=>{let y;const i=new Map;function A(b,o,u,w,p){const h=i.get(o);if(b===C||h){const f={name:E(u),cmd:u,pid:b,ppid:o,load:w,mem:p};i.set(b,f),b===C&&(y=f),h&&(h.children||(h.children=[]),h.children.push(f),h.children.length>1&&(h.children=h.children.sort((c,a)=>c.pid-a.pid)))}}function E(b){const o=/--disable-blink-features=Auxclick/,u=/\\watcher\\win32\\CodeHelper\.exe/,w=/--crashes-directory/,p=/\\pipe\\winpty-control/,h=/conhost\.exe/,f=/--type=([a-zA-Z-]+)/;if(u.exec(b))return"watcherService ";if(w.exec(b))return"electron-crash-reporter";if(p.exec(b))return"winpty-process";if(h.exec(b))return"console-window-host (Windows internal process)";let c=f.exec(b);if(c&&c.length===2)return c[1]==="renderer"?o.exec(b)?"shared-process":"window":c[1];const a=/[a-zA-Z-]+\.js/g;let t="";do c=a.exec(b),c&&(t+=c+" ");while(c);return t&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron_node ${t}`:b}if(process.platform==="win32"){const b=o=>o.indexOf("\\\\?\\")===0||o.indexOf("\\??\\")===0?o.substr(4):o.indexOf('"\\\\?\\')===0||o.indexOf('"\\??\\')===0?'"'+o.substr(5):o;new Promise((o,u)=>{Q(["windows-process-tree"],o,u)}).then(o=>{o.getProcessList(C,u=>{o.getProcessCpuUsage(u,w=>{const p=new Map;w.forEach(h=>{const f=b(h.commandLine||"");p.set(h.pid,{name:E(f),cmd:f,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),y=p.get(C),y?(p.forEach(h=>{const f=p.get(h.ppid);f&&(f.children||(f.children=[]),f.children.push(h))}),p.forEach(h=>{h.children&&(h.children=h.children.sort((f,c)=>f.pid-c.pid))}),D(y)):d(new Error(`Root process ${C} not found`))})},o.ProcessDataFlag.CommandLine|o.ProcessDataFlag.Memory)})}else{let b=function(){let o=[y];const u=[];for(;o.length;){const p=o.shift();p&&(u.push(p.pid),p.children&&(o=o.concat(p.children)))}let w=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);w+=" "+u.join(" "),(0,S.exec)(w,{},(p,h,f)=>{if(p||f)d(p||new Error(f.toString()));else{const c=h.toString().split(`
`);for(let a=0;a<u.length;a++){const t=i.get(u[a]);t.load=parseFloat(c[a])}if(!y){d(new Error(`Root process ${C} not found`));return}D(y)}})};(0,S.exec)("which ps",{},(o,u,w)=>{if(o||w)if(process.platform!=="linux")d(o||new Error(w.toString()));else{const p=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,S.exec)(p,{},(h,f,c)=>{h||c?d(h||new Error(c.toString())):(k(f,A),b())})}else{const p=u.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${p} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,c,a)=>{f||a&&!a.includes("screen size is bogus")?d(f||new Error(a.toString())):(k(c,A),process.platform==="linux"?b():y?D(y):d(new Error(`Root process ${C} not found`)))})}})}})}e.listProcesses=g;function k(C,D){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=C.toString().split(`
`);for(const i of y){const A=d.exec(i.trim());A&&A.length===6&&D(parseInt(A[1]),parseInt(A[2]),A[5],parseFloat(A[3]),parseFloat(A[4]))}}}),define(me[127],ge([0,1,28,26,2,75,5,3,16]),function(Q,e,S,_,g,k,C,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(E,b,o){return A({path:E,isDirectory:!1},b,o)}e.watchFile=y;function i(E,b,o){return A({path:E,isDirectory:!0},b,o)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function A(E,b,o){if(D.isMacintosh&&(0,_.isEqualOrParent)(E.path,"/Volumes/"))return o(`Refusing to watch ${E.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),g.Disposable.None;const u=(0,C.basename)(E.path),w=new Map;let p=!1,h=[(0,g.toDisposable)(()=>{w.forEach(f=>(0,g.dispose)(f)),w.clear()})];try{const f=(0,S.watch)(E.path);h.push((0,g.toDisposable)(()=>{f.removeAllListeners(),f.close()}));const c=new Set;E.isDirectory&&d.Promises.readdir(E.path).then(a=>a.forEach(t=>c.add(t))),f.on("error",(a,t)=>{p||o(`Failed to watch ${E.path} for changes using fs.watch() (${a}, ${t})`)}),f.on("change",(a,t)=>{if(p)return;let s="";if(t&&(s=t.toString(),D.isMacintosh&&(s=(0,k.normalizeNFC)(s))),!s||a!=="change"&&a!=="rename")return;const n=E.isDirectory?(0,C.join)(E.path,s):E.path;if(E.isDirectory)if(a==="rename"){const r=w.get(n);r&&(0,g.dispose)(r);const l=setTimeout(async()=>{w.delete(n);const v=await d.Promises.exists(n);if(p)return;let P;v?c.has(s)?P="changed":(P="added",c.add(s)):(c.delete(s),P="deleted"),b(P,n)},e.CHANGE_BUFFER_DELAY);w.set(n,(0,g.toDisposable)(()=>clearTimeout(l)))}else{let r;c.has(s)?r="changed":(r="added",c.add(s)),b(r,n)}else if(a==="rename"||s!==u){const r=setTimeout(async()=>{const l=await d.Promises.exists(n);p||(l?(b("changed",n),h=[A(E,b,o)]):b("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,g.dispose)(h),h=[(0,g.toDisposable)(()=>clearTimeout(r))]}else b("changed",n)})}catch(f){d.Promises.exists(E.path).then(c=>{c&&!p&&o(`Failed to watch ${E.path} for changes using fs.watch() (${f.toString()})`)})}return(0,g.toDisposable)(()=>{p=!0,h=(0,g.dispose)(h)})}});var Le=this&&this.__decorate||function(Q,e,S,_){var g=arguments.length,k=g<3?e:_===null?_=Object.getOwnPropertyDescriptor(e,S):_,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Q,e,S,_);else for(var D=Q.length-1;D>=0;D--)(C=Q[D])&&(k=(g<3?C(k):g>3?C(e,S,k):C(e,S))||k);return g>3&&k&&Object.defineProperty(e,S,k),k};define(me[36],ge([0,1,20,13,17,25,71,11,7,2,46,15,12]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function o(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(u=e.ResponseType||(e.ResponseType={}));function w(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(p||(p={}));class h{constructor(H){this.buffer=H,this.pos=0}read(H){const X=this.buffer.slice(this.pos,this.pos+H);return this.pos+=X.byteLength,X}}class f{constructor(){this.buffers=[]}get buffer(){return g.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}var c;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object"})(c||(c={}));function a(J){const H=g.VSBuffer.alloc(4);return H.writeUInt32BE(J,0),H}function t(J){return J.read(4).readUInt32BE(0)}function s(J){const H=g.VSBuffer.alloc(1);return H.writeUInt8(J,0),H}const n={Undefined:s(c.Undefined),String:s(c.String),Buffer:s(c.Buffer),VSBuffer:s(c.VSBuffer),Array:s(c.Array),Object:s(c.Object)},r=typeof Buffer!="undefined";function l(J,H){if(typeof H=="undefined")J.write(n.Undefined);else if(typeof H=="string"){const X=g.VSBuffer.fromString(H);J.write(n.String),J.write(a(X.byteLength)),J.write(X)}else if(r&&Buffer.isBuffer(H)){const X=g.VSBuffer.wrap(H);J.write(n.Buffer),J.write(a(X.byteLength)),J.write(X)}else if(H instanceof g.VSBuffer)J.write(n.VSBuffer),J.write(a(H.byteLength)),J.write(H);else if(Array.isArray(H)){J.write(n.Array),J.write(a(H.length));for(const X of H)l(J,X)}else{const X=g.VSBuffer.fromString(JSON.stringify(H));J.write(n.Object),J.write(a(X.byteLength)),J.write(X)}}function v(J){switch(J.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return J.read(t(J)).toString();case c.Buffer:return J.read(t(J)).buffer;case c.VSBuffer:return J.read(t(J));case c.Array:{const X=t(J),q=[];for(let W=0;W<X;W++)q.push(v(J));return q}case c.Object:return JSON.parse(J.read(t(J)).toString())}}class P{constructor(H,X,q=null,W=1e3){this.protocol=H,this.ctx=X,this.logger=q,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(U=>this.onRawMessage(U)),this.sendResponse({type:200})}registerChannel(H,X){this.channels.set(H,X),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const X=this.send([H.type]);this.logger&&this.logger.logOutgoing(X,0,1,w(H.type));return}case 201:case 202:case 204:case 203:{const X=this.send([H.type,H.id],H.data);this.logger&&this.logger.logOutgoing(X,H.id,1,w(H.type),H.data);return}}}send(H,X=void 0){const q=new f;return l(q,H),l(q,X),this.sendBuffer(q.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch(X){return 0}}onRawMessage(H){const X=new h(H),q=v(X),W=v(X),U=q[0];switch(U){case 100:return this.logger&&this.logger.logIncoming(H.byteLength,q[1],1,`${o(U)}: ${q[2]}.${q[3]}`,W),this.onPromise({type:U,id:q[1],channelName:q[2],name:q[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(H.byteLength,q[1],1,`${o(U)}: ${q[2]}.${q[3]}`,W),this.onEventListen({type:U,id:q[1],channelName:q[2],name:q[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(H.byteLength,q[1],1,`${o(U)}`),this.disposeActiveRequest({type:U,id:q[1]});case 103:return this.logger&&this.logger.logIncoming(H.byteLength,q[1],1,`${o(U)}`),this.disposeActiveRequest({type:U,id:q[1]})}}onPromise(H){const X=this.channels.get(H.channelName);if(!X){this.collectPendingRequest(H);return}const q=new k.CancellationTokenSource;let W;try{W=X.call(this.ctx,H.name,H.arg,q.token)}catch(ne){W=Promise.reject(ne)}const U=H.id;W.then(ne=>{this.sendResponse({id:U,data:ne,type:201}),this.activeRequests.delete(H.id)},ne=>{ne instanceof Error?this.sendResponse({id:U,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:202}):this.sendResponse({id:U,data:ne,type:203}),this.activeRequests.delete(H.id)});const ie=(0,y.toDisposable)(()=>q.cancel());this.activeRequests.set(H.id,ie)}onEventListen(H){const X=this.channels.get(H.channelName);if(!X){this.collectPendingRequest(H);return}const q=H.id,U=X.listen(this.ctx,H.name,H.arg)(ie=>this.sendResponse({id:q,data:ie,type:204}));this.activeRequests.set(H.id,U)}disposeActiveRequest(H){const X=this.activeRequests.get(H.id);X&&(X.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let X=this.pendingRequests.get(H.channelName);X||(X=[],this.pendingRequests.set(H.channelName,X));const q=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:H,timeoutTimer:q})}flushPendingRequests(H){const X=this.pendingRequests.get(H);if(X){for(const q of X)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(H=>H.dispose()),this.activeRequests.clear()}}e.ChannelServer=P;var L;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(L=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(H,X=null){this.protocol=H,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=X}getChannel(H){const X=this;return{call(q,W,U){return X.isDisposed?Promise.reject(D.canceled()):X.requestPromise(H,q,W,U)},listen(q,W){return X.isDisposed?Promise.reject(D.canceled()):X.requestEvent(H,q,W)}}}requestPromise(H,X,q,W=k.CancellationToken.None){const U=this.lastRequestId++,ne={id:U,type:100,channelName:H,name:X,arg:q};if(W.isCancellationRequested)return Promise.reject(D.canceled());let he;return new Promise((Ae,Ie)=>{if(W.isCancellationRequested)return Ie(D.canceled());const Ue=()=>{const it=de=>{switch(de.type){case 201:this.handlers.delete(U),Ae(de.data);break;case 202:this.handlers.delete(U);const be=new Error(de.data.message);be.stack=de.data.stack,be.name=de.data.name,Ie(be);break;case 203:this.handlers.delete(U),Ie(de.data);break}};this.handlers.set(U,it),this.sendRequest(ne)};let qe=null;this.state===p.Idle?Ue():(qe=(0,_.createCancelablePromise)(it=>this.whenInitialized()),qe.then(()=>{qe=null,Ue()}));const Ge=()=>{qe?(qe.cancel(),qe=null):this.sendRequest({id:U,type:101}),Ie(D.canceled())},rt=W.onCancellationRequested(Ge);he=(0,y.combinedDisposable)((0,y.toDisposable)(Ge),rt),this.activeRequests.add(he)}).finally(()=>{this.activeRequests.delete(he)})}requestEvent(H,X,q){const W=this.lastRequestId++,ie={id:W,type:102,channelName:H,name:X,arg:q};let ne=null;const he=new d.Emitter({onFirstListenerAdd:()=>{ne=(0,_.createCancelablePromise)(Ae=>this.whenInitialized()),ne.then(()=>{ne=null,this.activeRequests.add(he),this.sendRequest(ie)})},onLastListenerRemove:()=>{ne?(ne.cancel(),ne=null):(this.activeRequests.delete(he),this.sendRequest({id:W,type:103}))}}),ve=Ae=>he.fire(Ae.data);return this.handlers.set(W,ve),he.event}sendRequest(H){switch(H.type){case 100:case 102:{const X=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger&&this.logger.logOutgoing(X,H.id,0,`${o(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const X=this.send([H.type,H.id]);this.logger&&this.logger.logOutgoing(X,H.id,0,o(H.type));return}}}send(H,X=void 0){const q=new f;return l(q,H),l(q,X),this.sendBuffer(q.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch(X){return 0}}onBuffer(H){const X=new h(H),q=v(X),W=v(X),U=q[0];switch(U){case 200:return this.logger&&this.logger.logIncoming(H.byteLength,0,0,w(U)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(H.byteLength,q[1],0,w(U),W),this.onResponse({type:q[0],id:q[1],data:W})}}onResponse(H){if(H.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(H.id);X&&X(H)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(H=>H.dispose()),this.activeRequests.clear()}}Le([C.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class m{constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:X,onDidClientDisconnect:q})=>{d.Event.once(X.onMessage)(U=>{const ie=new h(U),ne=v(ie),he=new P(X,ne),ve=new R(X);this.channels.forEach((Ie,Ue)=>he.registerChannel(Ue,Ie));const Ae={channelServer:he,channelClient:ve,ctx:ne};this._connections.add(Ae),this._onDidAddConnection.fire(Ae),q(()=>{he.dispose(),ve.dispose(),this._connections.delete(Ae),this._onDidRemoveConnection.fire(Ae)})})})}get connections(){const H=[];return this._connections.forEach(X=>H.push(X)),H}getChannel(H,X){const q=this;return{call(W,U,ie){let ne;if((0,E.isFunction)(X)){let ve=(0,S.getRandomElement)(q.connections.filter(X));ne=ve?Promise.resolve(ve):d.Event.toPromise(d.Event.filter(q.onDidAddConnection,X))}else ne=X.routeCall(q,W,U);const he=ne.then(ve=>ve.channelClient.getChannel(H));return I(he).call(W,U,ie)},listen(W,U){if((0,E.isFunction)(X))return q.getMulticastEvent(H,X,W,U);const ie=X.routeEvent(q,W,U).then(ne=>ne.channelClient.getChannel(H));return I(ie).listen(W,U)}}}getMulticastEvent(H,X,q,W){const U=this;let ie=new y.DisposableStore;const ne=new d.Emitter({onFirstListenerAdd:()=>{ie=new y.DisposableStore;const he=new d.EventMultiplexer,ve=new Map,Ae=Ue=>{const Ge=Ue.channelClient.getChannel(H).listen(q,W),rt=he.add(Ge);ve.set(Ue,rt)},Ie=Ue=>{const qe=ve.get(Ue);!qe||(qe.dispose(),ve.delete(Ue))};U.connections.filter(X).forEach(Ae),d.Event.filter(U.onDidAddConnection,X)(Ae,void 0,ie),U.onDidRemoveConnection(Ie,void 0,ie),he.event(ne.fire,ne,ie),ie.add(he)},onLastListenerRemove:()=>{ie.dispose()}});return ne.event}registerChannel(H,X){this.channels.set(H,X),this._connections.forEach(q=>{q.channelServer.registerChannel(H,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=m;class T{constructor(H,X,q=null){const W=new f;l(W,X),H.send(W.buffer),this.channelClient=new R(H,q),this.channelServer=new P(H,X,q)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,X){this.channelServer.registerChannel(H,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function I(J){return{call(H,X,q){return J.then(W=>W.call(H,X,q))},listen(H,X){const q=new d.Relay;return J.then(W=>q.input=W.listen(H,X)),q.event}}}e.getDelayedChannel=I;function B(J){let H=!1;return{call(X,q,W){return H?J.call(X,q,W):(0,_.timeout)(0).then(()=>H=!0).then(()=>J.call(X,q,W))},listen(X,q){if(H)return J.listen(X,q);const W=new d.Relay;return(0,_.timeout)(0).then(()=>H=!0).then(()=>W.input=J.listen(X,q)),W.event}}}e.getNextTickChannel=B;class j{constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const X of H.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await d.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=j;var ue;(function(J){function H(W,U){const ie=W,ne=U&&U.disableMarshalling,he=new Map;for(const ve in ie)q(ve)&&he.set(ve,d.Event.buffer(ie[ve],!0));return new class{listen(ve,Ae){const Ie=he.get(Ae);if(Ie)return Ie;throw new Error(`Event not found: ${Ae}`)}call(ve,Ae,Ie){const Ue=ie[Ae];if(typeof Ue=="function"){if(!ne&&Array.isArray(Ie))for(let qe=0;qe<Ie.length;qe++)Ie[qe]=(0,i.revive)(Ie[qe]);return Ue.apply(ie,Ie)}throw new Error(`Method not found: ${Ae}`)}}}J.fromService=H;function X(W,U){const ie=U&&U.disableMarshalling;return new Proxy({},{get(ne,he){if(typeof he=="string")return U?.properties?.has(he)?U.properties.get(he):q(he)?W.listen(he):async function(...ve){let Ae;U&&!(0,E.isUndefinedOrNull)(U.context)?Ae=[U.context,...ve]:Ae=ve;const Ie=await W.call(he,Ae);return ie?Ie:(0,i.revive)(Ie)};throw new Error(`Property not found: ${String(he)}`)}})}J.toService=X;function q(W){return W[0]==="o"&&W[1]==="n"&&A.isUpperAsciiLetter(W.charCodeAt(2))}})(ue=e.ProxyChannel||(e.ProxyChannel={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){let H=J.toString();if(H!=="[object Object]")return H}return J}function $(J){return Array.isArray(J)?J.map(O):O(J)}function z(J,H,X,q,W,U,ie){ie=$(ie);const ne=ce[W],he=ne[q%ne.length];let ve=[`%c[${J}]%c[${String(H).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${U}`,"color: darkgreen","color: grey","color: grey",`color: ${he}`];/\($/.test(U)?(ve=ve.concat(ie),ve.push(")")):ve.push(ie),console.log.apply(console,ve)}e.logWithColors=z;class ee{constructor(H,X){this._outgoingPrefix=H,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,X,q,W,U){this._totalOutgoing+=H,z(this._outgoingPrefix,this._totalOutgoing,H,X,q,W,U)}logIncoming(H,X,q,W,U){this._totalIncoming+=H,z(this._incomingPrefix,this._totalIncoming,H,X,q,W,U)}}e.IPCLogger=ee}),define(me[82],ge([0,1,17,7,2,3,22,36]),function(Q,e,S,_,g,k,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var d;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function i(){return y||(y=S.VSBuffer.alloc(0)),y}class A{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,l){if(r===0)return i();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return l&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let v=S.VSBuffer.alloc(r),P=0,L=0;for(;r>0;){const R=this._chunks[L];if(R.byteLength>r){const m=R.slice(0,r);v.set(m,P),P+=r,l&&(this._chunks[L]=R.slice(r),this._totalLength-=r),r-=r}else v.set(R,P),P+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):L++,r-=R.byteLength}return v}}e.ChunkStream=A;var E;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(E||(E={}));var b;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class o{constructor(r,l,v,P){this.type=r,this.id=l,this.ack=v,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends g.Disposable{constructor(r){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new A,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const v=this._state.messageType,P=this._state.id,L=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new o(v,P,L,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=S.VSBuffer.alloc(13);l.writeUInt8(r.type,0),l.writeUInt32BE(r.id,1),l.writeUInt32BE(r.ack,5),l.writeUInt32BE(r.data.byteLength,9),this._writeSoon(l,r.data)}_bufferAdd(r,l){const v=this._totalLength===0;return this._data.push(r,l),this._totalLength+=r.byteLength+l.byteLength,v}_bufferTake(){const r=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,l){this._bufferAdd(r,l)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class p extends g.Disposable{constructor(r){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new u(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new o(1,0,0,r))}}e.Protocol=p;class h extends D.IPCClient{constructor(r,l,v=null){super(r,l,v);this.protocol=r}static fromSocket(r,l){return new h(new p(r),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=h;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,C.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class c{constructor(r){this.data=r,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],l=0,v=this._first;for(;v;)r[l++]=v.data,v=v.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const l=new c(r);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class t{constructor(){this.lastRuns=[];const r=Date.now();for(let l=0;l<t._HISTORY_LENGTH;l++)this.lastRuns[l]=r-1e3*l;setInterval(()=>{for(let l=t._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const r=Date.now(),l=(1+t._HISTORY_LENGTH)*1e3;let v=0;for(let P=0;P<t._HISTORY_LENGTH;P++)r-this.lastRuns[P]<=l&&v++;return 1-v/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(r,l=null,v=t.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=v,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.push(this._socket.onClose(P=>this._onSocketClose.fire(P))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,g.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new o(5,0,0,i());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const l=new o(4,0,0,i());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,l){this._isReconnecting=!0,this._socketDisposables=(0,g.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let l=0,v=r.length;l<v;l++)this._socketWriter.write(r[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new o(6,0,0,i())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const l=this._outgoingUnackMsg.toArray();for(let v=0,P=l.length;v<P;v++)this._socketWriter.write(l[v]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const v=new o(1,l,this._incomingAckId,r);this._outgoingUnackMsg.push(v),this._isReconnecting||(this._socketWriter.write(v),this._recvAckCheck())}sendControl(r){const l=new o(2,0,0,r);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),l=Date.now()-r.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new o(3,0,this._incomingAckId,i());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(me[128],ge([0,1,13,7,2,12]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var C;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(C=e.StorageHint||(e.StorageHint={}));var D;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(D||(D={}));class d extends g.Disposable{constructor(A,E=Object.create(null)){super();this.database=A,this.options=E,this._onDidChangeStorage=this._register(new _.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=D.None,this.cache=new Map,this.flushDelayer=new S.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(A=>this.onDidChangeItemsExternal(A)))}onDidChangeItemsExternal(A){A.changed?.forEach((E,b)=>this.accept(b,E)),A.deleted?.forEach(E=>this.accept(E,void 0))}accept(A,E){if(this.state===D.Closed)return;let b=!1;(0,k.isUndefinedOrNull)(E)?b=this.cache.delete(A):this.cache.get(A)!==E&&(this.cache.set(A,E),b=!0),b&&this._onDidChangeStorage.fire(A)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===D.None&&(this.state=D.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(A,E){const b=this.cache.get(A);return(0,k.isUndefinedOrNull)(b)?E:b}getBoolean(A,E){const b=this.get(A);return(0,k.isUndefinedOrNull)(b)?E:b==="true"}getNumber(A,E){const b=this.get(A);return(0,k.isUndefinedOrNull)(b)?E:parseInt(b,10)}async set(A,E){if(this.state===D.Closed)return;if((0,k.isUndefinedOrNull)(E))return this.delete(A);const b=String(E);if(this.cache.get(A)!==b)return this.cache.set(A,b),this.pendingInserts.set(A,b),this.pendingDeletes.delete(A),this._onDidChangeStorage.fire(A),this.flushDelayer.trigger(()=>this.flushPending())}async delete(A){if(!(this.state===D.Closed||!this.cache.delete(A)))return this.pendingDeletes.has(A)||this.pendingDeletes.add(A),this.pendingInserts.delete(A),this._onDidChangeStorage.fire(A),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=D.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(A){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const A={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(A).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(A=>this.whenFlushedCallbacks.push(A))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=_.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(A){A.insert&&A.insert.forEach((E,b)=>this.items.set(b,E)),A.delete&&A.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=y}),define(me[83],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class S{constructor(g,k){this.lineNumber=g,this.column=k}with(g=this.lineNumber,k=this.column){return g===this.lineNumber&&k===this.column?this:new S(g,k)}delta(g=0,k=0){return this.with(this.lineNumber+g,this.column+k)}equals(g){return S.equals(this,g)}static equals(g,k){return!g&&!k?!0:!!g&&!!k&&g.lineNumber===k.lineNumber&&g.column===k.column}isBefore(g){return S.isBefore(this,g)}static isBefore(g,k){return g.lineNumber<k.lineNumber?!0:k.lineNumber<g.lineNumber?!1:g.column<k.column}isBeforeOrEqual(g){return S.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,k){return g.lineNumber<k.lineNumber?!0:k.lineNumber<g.lineNumber?!1:g.column<=k.column}static compare(g,k){let C=g.lineNumber|0,D=k.lineNumber|0;if(C===D){let d=g.column|0,y=k.column|0;return d-y}return C-D}clone(){return new S(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new S(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}}e.Position=S}),define(me[55],ge([0,1,83]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class _{constructor(k,C,D,d){k>D||k===D&&C>d?(this.startLineNumber=D,this.startColumn=d,this.endLineNumber=k,this.endColumn=C):(this.startLineNumber=k,this.startColumn=C,this.endLineNumber=D,this.endColumn=d)}isEmpty(){return _.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return _.containsPosition(this,k)}static containsPosition(k,C){return!(C.lineNumber<k.startLineNumber||C.lineNumber>k.endLineNumber||C.lineNumber===k.startLineNumber&&C.column<k.startColumn||C.lineNumber===k.endLineNumber&&C.column>k.endColumn)}containsRange(k){return _.containsRange(this,k)}static containsRange(k,C){return!(C.startLineNumber<k.startLineNumber||C.endLineNumber<k.startLineNumber||C.startLineNumber>k.endLineNumber||C.endLineNumber>k.endLineNumber||C.startLineNumber===k.startLineNumber&&C.startColumn<k.startColumn||C.endLineNumber===k.endLineNumber&&C.endColumn>k.endColumn)}strictContainsRange(k){return _.strictContainsRange(this,k)}static strictContainsRange(k,C){return!(C.startLineNumber<k.startLineNumber||C.endLineNumber<k.startLineNumber||C.startLineNumber>k.endLineNumber||C.endLineNumber>k.endLineNumber||C.startLineNumber===k.startLineNumber&&C.startColumn<=k.startColumn||C.endLineNumber===k.endLineNumber&&C.endColumn>=k.endColumn)}plusRange(k){return _.plusRange(this,k)}static plusRange(k,C){let D,d,y,i;return C.startLineNumber<k.startLineNumber?(D=C.startLineNumber,d=C.startColumn):C.startLineNumber===k.startLineNumber?(D=C.startLineNumber,d=Math.min(C.startColumn,k.startColumn)):(D=k.startLineNumber,d=k.startColumn),C.endLineNumber>k.endLineNumber?(y=C.endLineNumber,i=C.endColumn):C.endLineNumber===k.endLineNumber?(y=C.endLineNumber,i=Math.max(C.endColumn,k.endColumn)):(y=k.endLineNumber,i=k.endColumn),new _(D,d,y,i)}intersectRanges(k){return _.intersectRanges(this,k)}static intersectRanges(k,C){let D=k.startLineNumber,d=k.startColumn,y=k.endLineNumber,i=k.endColumn,A=C.startLineNumber,E=C.startColumn,b=C.endLineNumber,o=C.endColumn;return D<A?(D=A,d=E):D===A&&(d=Math.max(d,E)),y>b?(y=b,i=o):y===b&&(i=Math.min(i,o)),D>y||D===y&&d>i?null:new _(D,d,y,i)}equalsRange(k){return _.equalsRange(this,k)}static equalsRange(k,C){return!!k&&!!C&&k.startLineNumber===C.startLineNumber&&k.startColumn===C.startColumn&&k.endLineNumber===C.endLineNumber&&k.endColumn===C.endColumn}getEndPosition(){return _.getEndPosition(this)}static getEndPosition(k){return new S.Position(k.endLineNumber,k.endColumn)}getStartPosition(){return _.getStartPosition(this)}static getStartPosition(k){return new S.Position(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,C){return new _(this.startLineNumber,this.startColumn,k,C)}setStartPosition(k,C){return new _(k,C,this.endLineNumber,this.endColumn)}collapseToStart(){return _.collapseToStart(this)}static collapseToStart(k){return new _(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}static fromPositions(k,C=k){return new _(k.lineNumber,k.column,C.lineNumber,C.column)}static lift(k){return k?new _(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,C){return!(k.endLineNumber<C.startLineNumber||k.endLineNumber===C.startLineNumber&&k.endColumn<C.startColumn||C.endLineNumber<k.startLineNumber||C.endLineNumber===k.startLineNumber&&C.endColumn<k.startColumn)}static areIntersecting(k,C){return!(k.endLineNumber<C.startLineNumber||k.endLineNumber===C.startLineNumber&&k.endColumn<=C.startColumn||C.endLineNumber<k.startLineNumber||C.endLineNumber===k.startLineNumber&&C.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,C){if(k&&C){const y=k.startLineNumber|0,i=C.startLineNumber|0;if(y===i){const A=k.startColumn|0,E=C.startColumn|0;if(A===E){const b=k.endLineNumber|0,o=C.endLineNumber|0;if(b===o){const u=k.endColumn|0,w=C.endColumn|0;return u-w}return b-o}return A-E}return y-i}return(k?1:0)-(C?1:0)}static compareRangesUsingEnds(k,C){return k.endLineNumber===C.endLineNumber?k.endColumn===C.endColumn?k.startLineNumber===C.startLineNumber?k.startColumn-C.startColumn:k.startLineNumber-C.startLineNumber:k.endColumn-C.endColumn:k.endLineNumber-C.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}}e.Range=_}),define(me[129],ge([0,1,47,5]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function g(k,C,D,d){if(Array.isArray(k)){let y=0;for(const i of k){const A=g(i,C,D,d);if(A===10)return A;A>y&&(y=A)}return y}else{if(typeof k=="string")return d?k==="*"?5:k===D?10:0:0;if(k){const{language:y,pattern:i,scheme:A,hasAccessToAllModels:E}=k;if(!d&&!E)return 0;let b=0;if(A)if(A===C.scheme)b=10;else if(A==="*")b=5;else return 0;if(y)if(y===D)b=10;else if(y==="*")b=Math.max(b,5);else return 0;if(i){let o;if(typeof i=="string"?o=i:o={...i,base:(0,_.normalize)(i.base)},o===C.fsPath||(0,S.match)(o,C.fsPath))b=10;else return 0}return b}else return 0}}e.score=g}),define(me[130],ge([0,1,7,2]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class g{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,D){return this._map.set(C,D),this.fire([C]),(0,_.toDisposable)(()=>{this._map.get(C)===D&&(this._map.delete(C),this.fire([C]))})}registerPromise(C,D){let d=null,y=!1;return this._promises.set(C,D.then(i=>{this._promises.delete(C),!(y||!i)&&(d=this.register(C,i))})),(0,_.toDisposable)(()=>{y=!0,d&&d.dispose()})}getPromise(C){const D=this.get(C);if(D)return Promise.resolve(D);const d=this._promises.get(C);return d?d.then(y=>this.get(C)):null}get(C){return this._map.get(C)||null}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=g}),define(me[131],ge([9,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(me[132],ge([0,1,131]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const _=60,g=_*60,k=g*24,C=k*7,D=k*30,d=k*365;function y(A,E){typeof A!="number"&&(A=A.getTime());const b=Math.round((new Date().getTime()-A)/1e3);if(b<-30)return(0,S.localize)(0,null,y(new Date().getTime()+b*1e3,!1));if(b<30)return(0,S.localize)(1,null);let o;return b<_?(o=b,E?o===1?(0,S.localize)(2,null,o):(0,S.localize)(3,null,o):o===1?(0,S.localize)(4,null,o):(0,S.localize)(5,null,o)):b<g?(o=Math.floor(b/_),E?o===1?(0,S.localize)(6,null,o):(0,S.localize)(7,null,o):o===1?(0,S.localize)(8,null,o):(0,S.localize)(9,null,o)):b<k?(o=Math.floor(b/g),E?o===1?(0,S.localize)(10,null,o):(0,S.localize)(11,null,o):o===1?(0,S.localize)(12,null,o):(0,S.localize)(13,null,o)):b<C?(o=Math.floor(b/k),E?o===1?(0,S.localize)(14,null,o):(0,S.localize)(15,null,o):o===1?(0,S.localize)(16,null,o):(0,S.localize)(17,null,o)):b<D?(o=Math.floor(b/C),E?o===1?(0,S.localize)(18,null,o):(0,S.localize)(19,null,o):o===1?(0,S.localize)(20,null,o):(0,S.localize)(21,null,o)):b<d?(o=Math.floor(b/D),E?o===1?(0,S.localize)(22,null,o):(0,S.localize)(23,null,o):o===1?(0,S.localize)(24,null,o):(0,S.localize)(25,null,o)):(o=Math.floor(b/d),E?o===1?(0,S.localize)(26,null,o):(0,S.localize)(27,null,o):o===1?(0,S.localize)(28,null,o):(0,S.localize)(29,null,o))}e.fromNow=y;function i(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(me[133],ge([9,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(me[43],ge([0,1,20,12,133]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(y,i){return i&&(y.stack||y.stacktrace)?g.localize(0,null,D(y),C(y.stack)||C(y.stacktrace)):D(y)}function C(y){return Array.isArray(y)?y.join(`
`):y}function D(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?g.localize(1,null,y.message):y.message||g.localize(2,null)}function d(y=null,i=!1){if(!y)return g.localize(3,null);if(Array.isArray(y)){const A=S.coalesce(y),E=d(A[0],i);return A.length>1?g.localize(4,null,E,A.length):E}if(_.isString(y))return y;if(y.detail){const A=y.detail;if(A.error)return k(A.error,i);if(A.exception)return k(A.exception,i)}return y.stack?k(y,i):y.message?y.message:g.localize(5,null)}e.toErrorMessage=d}),define(me[134],ge([9,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(me[135],ge([0,1,134]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function _(g){switch(g){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.getParseErrorMessage=_}),define(me[136],ge([9,10]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(me[84],ge([0,1,35,26,8,18,5,3,22,12,76,16,136]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function b(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function o(c,a){if(D.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const s=S.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],t);return new Promise(n=>{s.once("error",r=>{n({success:!1,error:r})}),s.once("exit",(r,l)=>{n(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?b(t.status):1})}else if(D.isLinux||D.isMacintosh)try{const t=g.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(s=>{S.execFile(t,[c.pid.toString()],{encoding:"utf8",shell:!0},(n,r,l)=>{s(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function u(c=d.env){return c.comspec||"cmd.exe"}e.getWindowsShell=u;class w{constructor(a,t,s,n){if(t!==void 0&&s!==void 0&&n!==void 0)this.cmd=a,this.args=t,this.shell=s,this.options=n;else{const r=a;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(d.env).forEach(l=>{r[l]=d.env[l]}),Object.keys(this.options.env).forEach(l=>{r[l]=this.options.env[l]}),this.options.env=r}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(C.sep);return t!==-1&&(a=a.substring(t+1)),w.WellKnowCommands[a]?a:"other"}start(a){return D.isWindows&&(this.options&&this.options.cwd&&_.isUNC(this.options.cwd)||!this.options&&_.isUNC(d.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(t=>{let s,n;const r=new Promise((l,v)=>{s=l,n=v});if(t){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=S.exec(l,this.options,(v,P,L)=>{this.childProcess=null;const R=v;R&&R.killed?n({killed:this.terminateRequested,stdout:P.toString(),stderr:L.toString()}):this.handleExec(s,a,v,P,L)})}else{let l=null;const v=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,s,a,n);const L={terminated:this.terminateRequested};y.isNumber(P)&&(L.cmdCode=P),s(L)};if(this.shell&&D.isWindows){const P=k.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let L=!1,R=!1;const m=[];let T=this.ensureQuotes(this.cmd);m.push(T.value),L=T.quoted,this.args&&this.args.forEach(B=>{T=this.ensureQuotes(B),m.push(T.value),R=R&&T.quoted});const I=["/s","/c"];L?R?I.push('"'+m.join(" ")+'"'):m.length>1?I.push('"'+m[0]+'" '+m.slice(1).join(" ")):I.push('"'+m[0]+'"'):I.push(m.join(" ")),l=S.spawn(u(),I,P)}else this.cmd&&(l=S.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(y.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",P=>{this.childProcess=null,n({terminated:this.terminateRequested,error:P})}),l.pid&&(this.childProcess.on("close",v),this.handleSpawn(l,s,a,n,!0)))}return r})}handleClose(a,t,s,n){}ensureQuotes(a){return w.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,o(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!D.isWindows)return a(!1);const t=S.spawn(u(),["/s","/c"]);t.on("error",s=>a(!0)),t.on("exit",s=>a(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class p extends w{constructor(a,t,s,n){super(a,t,s,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,s,n,r){[n,r].forEach((l,v)=>{const P=new i.LineDecoder;P.write(l).forEach(m=>{t({line:m,source:v===0?0:1})});const R=P.end();R&&t({line:R,source:v===0?0:1})}),a({terminated:this.terminateRequested,error:s})}handleSpawn(a,t,s,n,r){const l=new i.LineDecoder,v=new i.LineDecoder;a.stdout.on("data",P=>{l.write(P).forEach(R=>s({line:R,source:0}))}),a.stderr.on("data",P=>{v.write(P).forEach(R=>s({line:R,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=v}handleClose(a,t,s,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&s({line:r,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&s({line:l,source:1})}}e.LineProcess=p;function h(c){let a=[],t=!1;const s=function(n){if(t){a.push(n);return}(!c.send(n,l=>{if(l&&console.error(l),t=!1,a.length>0){const v=a.slice(0);a=[],v.forEach(P=>s(P))}})||D.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=h;var f;(function(c){async function a(t,s,n){if(C.isAbsolute(t))return t;if(s===void 0&&(s=d.cwd()),C.dirname(t)!=="."||(n===void 0&&y.isString(d.env.PATH)&&(n=d.env.PATH.split(C.delimiter)),n===void 0||n.length===0))return C.join(s,t);async function l(v){if(await A.Promises.exists(v)){let P;try{P=await A.Promises.stat(v)}catch(L){L.message.startsWith("EACCES")&&(P=await A.Promises.lstat(v))}return P?!P.isDirectory():!1}return!1}for(let v of n){let P;if(C.isAbsolute(v)?P=C.join(v,t):P=C.join(s,v,t),await l(P))return P;let L=P+".com";if(await l(L)||(L=P+".exe",await l(L)))return L}return C.join(s,t)}c.findExecutable=a})(f=e.win32||(e.win32={}))}),define(me[137],ge([0,1,24,3,80,84]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function C(b,o){return b===1?_.isWindows?A():k.getWindowsShell(o):y(b,o)}e.getSystemShell=C;function D(b,o){return b===1?_.isWindows?E(o):k.getWindowsShell(o):y(b,o)}e.getSystemShellSync=D;let d=null;function y(b,o){if(_.isLinux&&b===2||_.isMacintosh&&b===3)return"/bin/bash";if(!d){let u;if(_.isWindows)u="/bin/bash";else{if(u=o.SHELL,!u)try{u=(0,S.userInfo)().shell}catch(w){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}d=u}return d}let i=null;async function A(){return i||(i=(await(0,g.getFirstAvailablePowerShellInstallation)()).exePath),i}function E(b){if(i)return i;const o=_.isWindows&&parseFloat((0,S.release)())>=10,u=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${b.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return o?w:k.getWindowsShell(b)}}),define(me[56],ge([0,1,35,13,17,25,119,11,7,2,18,3,84,36]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class o extends b.ChannelServer{constructor(p){super({send:h=>{try{process.send&&process.send(h.buffer.toString("base64"))}catch(f){}},onMessage:d.Event.fromNodeEventEmitter(process,"message",h=>g.VSBuffer.wrap(Buffer.from(h,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=o;class u{constructor(p,h){this.modulePath=p,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new _.Delayer(f),this.child=null,this._client=null}getChannel(p){const h=this;return{call(f,c,a){return h.requestPromise(p,f,c,a)},listen(f,c){return h.requestEvent(p,f,c)}}}requestPromise(p,h,f,c=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(p),t=(0,_.createCancelablePromise)(r=>a.call(h,f,r)),s=c.onCancellationRequested(()=>t.cancel()),n=(0,y.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{s.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(p,h,f){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let c;const a=new d.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(p).listen(h,f)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),A.isMacintosh&&h.env&&delete h.env.DYLD_LIBRARY_PATH,this.child=(0,S.fork)(this.modulePath,p,h);const f=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,C.isRemoteConsoleLog)(l)){(0,C.log)(l,`IPC Library: ${this.options.serverName}`);return}f.fire(g.VSBuffer.wrap(Buffer.from(l,"base64")))});const a=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,t=l=>this.child&&this.child.connected&&a.send(l.buffer.toString("base64")),s=f.event,n={send:t,onMessage:s};this._client=new b.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,v)=>{process.removeListener("exit",r),this.activeRequests.forEach(P=>(0,y.dispose)(P)),this.activeRequests.clear(),l!==0&&v!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+v),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:v})})}return this._client}getCachedChannel(p){let h=this.channels.get(p);return h||(h=this.client.getChannel(p),this.channels.set(p,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=u}),define(me[138],ge([9,10]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(me[139],ge([9,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[140],ge([9,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(me[141],ge([9,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(me[142],ge([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(me[143],ge([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[144],ge([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(me[145],ge([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(me[146],ge([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(me[147],ge([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(me[148],ge([9,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[149],ge([9,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(me[150],ge([9,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(me[151],ge([9,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(me[152],ge([9,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(me[153],ge([9,10]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(me[154],ge([9,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(me[155],ge([9,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(me[156],ge([9,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(me[157],ge([9,10]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(me[158],ge([9,10]),function(Q,e){return Q.create("vs/server/remoteAgentEnvironmentImpl",e)}),define(me[159],ge([9,10]),function(Q,e){return Q.create("vs/server/serverEnvironmentService",e)}),define(me[160],ge([9,10]),function(Q,e){return Q.create("vs/workbench/common/editor",e)}),define(me[161],ge([9,10]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[162],ge([9,10]),function(Q,e){return Q.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(me[163],ge([0,1,7,2]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class g{constructor(){this._onCloseEmitter=new S.Emitter,this._onReloadEmitter=new S.Emitter,this._onTerminateEmitter=new S.Emitter,this._onAttachEmitter=new S.Emitter}call(D,d,y){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(D,d,y){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=g,g.ChannelName="extensionhostdebugservice";class k extends _.Disposable{constructor(D){super();this.channel=D}reload(D){this.channel.call("reload",[D])}get onReload(){return this.channel.listen("reload")}close(D){this.channel.call("close",[D])}get onClose(){return this.channel.listen("close")}attachSession(D,d,y){this.channel.call("attach",[D,d,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(D,d){this.channel.call("terminate",[D,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(D,d,y){return this.channel.call("openExtensionDevelopmentHostWindow",[D,d||{},y])}}e.ExtensionHostDebugChannelClient=k}),define(me[164],ge([0,1,4]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class _{constructor(C){this.service=C}listen(C,D,d){throw new Error("Invalid listen")}call(C,D,d){switch(D){case"download":return this.service.download(S.URI.revive(d[0]),S.URI.revive(d[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=_;class g{constructor(C,D){this.channel=C,this.getUriTransformer=D}async download(C,D){const d=this.getUriTransformer();d&&(C=d.transformOutgoingURI(C),D=d.transformOutgoingURI(D)),await this.channel.call("download",[C,D])}}e.DownloadServiceChannelClient=g}),define(me[165],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var S;(function(C){C[C.ACTIVATE=1]="ACTIVATE",C[C.RESTORE=2]="RESTORE",C[C.PRESERVE=3]="PRESERVE"})(S=e.EditorActivation||(e.EditorActivation={}));var _;(function(C){C[C.PICK=0]="PICK",C[C.DISABLED=1]="DISABLED",C[C.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(_=e.EditorResolution||(e.EditorResolution={}));var g;(function(C){C[C.API=0]="API",C[C.USER=1]="USER"})(g=e.EditorOpenContext||(e.EditorOpenContext={}));var k;(function(C){C[C.Center=0]="Center",C[C.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",C[C.NearTop=2]="NearTop",C[C.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(k=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[166],ge([0,1,132,71,8,5,22,19,4]),function(Q,e,S,_,g,k,C,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(o,u,w){this._args=o,this.paths=u,this.productService=w}get appRoot(){return(0,k.dirname)(g.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,D.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const o=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",o)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(d.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return d.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return d.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const o=C.env.VSCODE_PORTABLE;return o?d.URI.file((0,k.join)(o,"argv.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,D.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const o=this.args["builtin-extensions-dir"];return o?(0,k.resolve)(o):(0,k.normalize)((0,k.join)(g.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const o=this.args["extensions-download-dir"];return o?(0,k.resolve)(o):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const o=this.args["extensions-dir"];if(o)return(0,k.resolve)(o);const u=C.env.VSCODE_EXTENSIONS;if(u)return u;const w=C.env.VSCODE_PORTABLE;return w?(0,k.join)(w,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const o=this.args.extensionDevelopmentPath;if(Array.isArray(o))return o.map(u=>/^[^:/?#]+?:\/\//.test(u)?d.URI.parse(u):d.URI.file((0,k.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(o=>o==="ui"||o==="workspace"||o==="web"?o:"workspace")}get extensionTestsLocationURI(){const o=this.args.extensionTestsPath;if(o)return/^[^:/?#]+?:\/\//.test(o)?d.URI.parse(o):d.URI.file((0,k.normalize)(o))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const o=this.args["disable-extension"];if(o){if(typeof o=="string")return[o];if(Array.isArray(o)&&o.length>0)return o}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,D.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return d.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}Le([_.memoize],y.prototype,"appRoot",null),Le([_.memoize],y.prototype,"userHome",null),Le([_.memoize],y.prototype,"userDataPath",null),Le([_.memoize],y.prototype,"appSettingsHome",null),Le([_.memoize],y.prototype,"tmpDir",null),Le([_.memoize],y.prototype,"userRoamingDataHome",null),Le([_.memoize],y.prototype,"settingsResource",null),Le([_.memoize],y.prototype,"userDataSyncHome",null),Le([_.memoize],y.prototype,"userDataSyncLogResource",null),Le([_.memoize],y.prototype,"sync",null),Le([_.memoize],y.prototype,"machineSettingsResource",null),Le([_.memoize],y.prototype,"globalStorageHome",null),Le([_.memoize],y.prototype,"workspaceStorageHome",null),Le([_.memoize],y.prototype,"keybindingsResource",null),Le([_.memoize],y.prototype,"keyboardLayoutResource",null),Le([_.memoize],y.prototype,"argvResource",null),Le([_.memoize],y.prototype,"snippetsHome",null),Le([_.memoize],y.prototype,"isExtensionDevelopment",null),Le([_.memoize],y.prototype,"untitledWorkspacesHome",null),Le([_.memoize],y.prototype,"installSourcePath",null),Le([_.memoize],y.prototype,"builtinExtensionsPath",null),Le([_.memoize],y.prototype,"extensionsPath",null),Le([_.memoize],y.prototype,"extensionDevelopmentLocationURI",null),Le([_.memoize],y.prototype,"extensionDevelopmentKind",null),Le([_.memoize],y.prototype,"extensionTestsLocationURI",null),Le([_.memoize],y.prototype,"debugExtensionHost",null),Le([_.memoize],y.prototype,"serviceMachineIdResource",null),Le([_.memoize],y.prototype,"telemetryLogResource",null),Le([_.memoize],y.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=y;function i(b,o){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,o,b.debugId)}e.parseExtensionHostPort=i;function A(b,o){return E(b["inspect-search"],b["inspect-brk-search"],5876,o)}e.parseSearchPort=A;function E(b,o,u,w,p){const f=Number(o||b)||(w?null:u),c=f?Boolean(!!o):!1;return{port:f,break:c,debugId:p}}}),define(me[57],ge([0,1,243,3,140]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,g.localize)(0,null),e:(0,g.localize)(1,null),t:(0,g.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,g.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,g.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,g.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,g.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,g.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,g.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,g.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,g.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,g.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,g.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,g.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,g.localize)(14,null)},category:{type:"string",cat:"e",description:(0,g.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,g.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,g.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,g.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,g.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,g.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,g.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,g.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,g.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,g.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,g.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,g.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,g.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,g.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,g.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,g.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,g.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{}};function D(o,u,w=C){const p={},h=[],f=[];for(let s in u){const n=u[s];n.alias&&(p[s]=n.alias),n.type==="string"||n.type==="string[]"?(h.push(s),n.deprecates&&h.push(n.deprecates)):n.type==="boolean"&&(f.push(s),n.deprecates&&f.push(n.deprecates))}const c=S(o,{string:h,boolean:f,alias:p}),a={},t=c;a._=c._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in u){const n=u[s];n.alias&&delete t[n.alias];let r=t[s];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(r||(r=t[n.deprecates]),delete t[n.deprecates]),typeof r!="undefined"&&(n.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):n.type==="string"&&Array.isArray(r)&&(r=r.pop(),w.onMultipleValues(s,r)),a[s]=r),delete t[s]}for(let s in t)w.onUnknownOption(s);return a}e.parseArgs=D;function d(o,u){let w="";return u.args&&(Array.isArray(u.args)?w=` <${u.args.join("> <")}>`:w=` <${u.args}>`),u.alias?`-${u.alias} --${o}${w}`:`--${o}${w}`}function y(o,u){let w=0,p=[];for(const a in o){const t=o[a],s=d(a,t);w=Math.max(w,s.length),p.push([s,t.description])}let h=w+2+1;if(u-h<25)return p.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let f=u-h-1,c=[];for(const a of p){let t=a[0],s=A(a[1],f),n=i(h-t.length-2);c.push("  "+t+n+s[0]);for(let r=1;r<s.length;r++)c.push(i(h)+s[r])}return c}e.formatOptions=y;function i(o){return" ".repeat(o)}function A(o,u){let w=[];for(;o.length;){let p=o.length<u?o.length:o.lastIndexOf(" ",u),h=o.slice(0,p).trim();o=o.slice(p),w.push(h)}return w}function E(o,u,w,p,h=!0){const f=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${o} ${w}`];c.push(""),c.push(`${(0,g.localize)(32,null)}: ${u} [${(0,g.localize)(33,null)}][${(0,g.localize)(34,null)}...]`),c.push(""),h&&(_.isWindows?c.push((0,g.localize)(35,null,u)):c.push((0,g.localize)(36,null,u)),c.push(""));const a={};for(const t in p){const s=p[t];if(s.description&&s.cat){let n=a[s.cat];n||(a[s.cat]=n={}),n[t]=s}}for(let t in a){const s=t;let n=a[s];n&&(c.push(k[s]),c.push(...y(n,f)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=E;function b(o,u){return`${o||(0,g.localize)(37,null)}
${u||(0,g.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=b}),function(){"use strict";function Q(e,S,_,g){function k(D){const d=C(D),y=[d];return e.isAbsolute(d)||y.unshift(g),e.resolve(...y)}function C(D){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,_);const i=D["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const A=process.env.USERPROFILE;if(typeof A!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(A,"AppData","Roaming")}break;case"darwin":y=e.join(S.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,_)}return{getUserDataPath:k}}if(typeof define=="function")define(me[167],ge([0,77,24,8,19,22]),function(e,S,_,g,k,C){const D=k.dirname(g.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(k.joinPath(D,"package.json").fsPath);return Q(S,_,d.name,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),_=require("os");module.exports=Q(S,_,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(me[168],ge([0,1,24,166,167]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends _.AbstractNativeEnvironmentService{constructor(D,d){super(D,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,g.getUserDataPath)(D)},d)}}e.NativeEnvironmentService=k}),define(me[169],ge([0,1,7,2,18,4,54]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function D(o,u){return k.URI.revive(u?u.transformIncoming(o):o)}function d(o,u){return u?u.transformOutgoingURI(o):o}function y(o,u){u=u||C.DefaultURITransformer;const w=o.manifest;return{...(0,C.transformAndReviveIncomingURIs)({...o,manifest:void 0},u),manifest:w}}function i(o,u){return u?(0,g.cloneAndChange)(o,w=>w instanceof k.URI?u.transformOutgoingURI(w):void 0):o}class A{constructor(u,w){this.service=u,this.getUriTransformer=w,this.onInstallExtension=S.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=S.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=S.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(u.onDidUninstallExtension,!0)}listen(u,w){const p=this.getUriTransformer(u);switch(w){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return S.Event.map(this.onDidInstallExtensions,h=>h.map(f=>({...f,local:f.local?i(f.local,p):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(u,w,p){const h=this.getUriTransformer(u);switch(w){case"zip":return this.service.zip(y(p[0],h)).then(f=>d(f,h));case"unzip":return this.service.unzip(D(p[0],h));case"install":return this.service.install(D(p[0],h),p[1]);case"getManifest":return this.service.getManifest(D(p[0],h));case"canInstall":return this.service.canInstall(p[0]);case"installFromGallery":return this.service.installFromGallery(p[0],p[1]);case"uninstall":return this.service.uninstall(y(p[0],h),p[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(y(p[0],h));case"getInstalled":return this.service.getInstalled(p[0]).then(f=>f.map(c=>i(c,h)));case"updateMetadata":return this.service.updateMetadata(y(p[0],h),p[1]).then(f=>i(f,h));case"updateExtensionScope":return this.service.updateExtensionScope(y(p[0],h),p[1]).then(f=>i(f,h));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=A;class E extends _.Disposable{constructor(u){super();this.channel=u,this._onInstallExtension=this._register(new S.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new S.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new S.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new S.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(w=>this._onInstallExtension.fire({identifier:w.identifier,source:this.isUriComponents(w.source)?k.URI.revive(w.source):w.source}))),this._register(this.channel.listen("onDidInstallExtensions")(w=>this._onDidInstallExtensions.fire(w.map(p=>({...p,local:p.local?y(p.local,null):p.local,source:this.isUriComponents(p.source)?k.URI.revive(p.source):p.source}))))),this._register(this.channel.listen("onUninstallExtension")(w=>this._onUninstallExtension.fire(w))),this._register(this.channel.listen("onDidUninstallExtension")(w=>this._onDidUninstallExtension.fire(w)))}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(w=>k.URI.revive(w)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,w){return Promise.resolve(this.channel.call("install",[u,w])).then(p=>y(p,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}async canInstall(u){return!0}installFromGallery(u,w){return Promise.resolve(this.channel.call("installFromGallery",[u,w])).then(p=>y(p,null))}uninstall(u,w){return Promise.resolve(this.channel.call("uninstall",[u,w]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u]))}getInstalled(u=null){return Promise.resolve(this.channel.call("getInstalled",[u])).then(w=>w.map(p=>y(p,null)))}updateMetadata(u,w){return Promise.resolve(this.channel.call("updateMetadata",[u,w])).then(p=>y(p,null))}updateExtensionScope(u,w){return Promise.resolve(this.channel.call("updateExtensionScope",[u,w])).then(p=>y(p,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=E;class b{constructor(u){this.service=u}listen(u,w){throw new Error("Invalid listen")}call(u,w,p){switch(w){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(me[170],ge([0,1,18]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const _=/^%([\w\d.-]+)%$/i;function g(k,C){const D=d=>{if(typeof d!="string")return;const y=_.exec(d);if(!y)return;const i=C[y[1]]??d;return typeof i=="string"?i:typeof i.message=="string"?i.message:d};return(0,S.cloneAndChange)(k,D)}e.localizeManifest=g}),define(me[58],ge([0,1,148]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function k(E){return E=E.trim(),E==="*"||_.test(E)}e.isValidVersionStr=k;function C(E){if(!k(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=E.match(_);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=C;function D(E){if(!E)return null;let b=E.majorBase,o=E.majorMustEqual,u=E.minorBase,w=E.minorMustEqual,p=E.patchBase,h=E.patchMustEqual;E.hasCaret&&(b===0||(w=!1),h=!1);let f=0;if(E.preRelease){const c=g.exec(E.preRelease);if(c){const[,a,t,s]=c;f=Date.UTC(Number(a),Number(t)-1,Number(s))}}return{majorBase:b,majorMustEqual:o,minorBase:u,minorMustEqual:w,patchBase:p,patchMustEqual:h,isMinimum:E.hasGreaterEquals,notBefore:f}}e.normalizeVersion=D;function d(E,b,o){let u;typeof E=="string"?u=D(C(E)):u=E;let w;b instanceof Date?w=b.getTime():typeof b=="string"&&(w=new Date(b).getTime());let p;if(typeof o=="string"?p=D(C(o)):p=o,!u||!p)return!1;let h=u.majorBase,f=u.minorBase,c=u.patchBase,a=p.majorBase,t=p.minorBase,s=p.patchBase,n=p.notBefore,r=p.majorMustEqual,l=p.minorMustEqual,v=p.patchMustEqual;return p.isMinimum?h>a?!0:h<a?!1:f>t?!0:f<t||w&&w<n?!1:c>=s:(h===1&&a===0&&(!r||!l||!v)&&(a=1,t=0,s=0,r=!0,l=!1,v=!1),h<a?!1:h>a?!r:f<t?!1:f>t?!l:c<s?!1:c>s?!v:!(w&&w<n))}e.isValidVersion=d;function y(E,b,o,u){return o.isBuiltin||typeof o.main=="undefined"?!0:A(E,b,o.engines.vscode,u)}e.isValidExtensionVersion=y;function i(E,b,o){return E==="*"||A(b,o,E)}e.isEngineValid=i;function A(E,b,o,u=[]){let w=D(C(o));if(!w)return u.push(S.localize(0,null,o)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return u.push(S.localize(1,null,o)),!1}else if(!w.majorMustEqual)return u.push(S.localize(2,null,o)),!1;return d(E,b,w)?!0:(u.push(S.localize(3,null,E,o)),!1)}}),define(me[171],ge([0,1,17,43,11,7,2,42,4,23]),function(Q,e,S,_,g,k,C,D,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCFileSystemProvider=void 0;class i extends C.Disposable{constructor(E){super();this.channel=E,this.session=(0,y.generateUuid)(),this._onDidChange=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new k.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event,this._capabilities=2|4|16|8|8192,this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(E=>{if(Array.isArray(E)){const b=E;this._onDidChange.fire(b.map(o=>({resource:d.URI.revive(o.resource),type:o.type})))}else{const b=E;this._onDidWatchErrorOccur.fire(b)}}))}setCaseSensitive(E){E?this._capabilities|=1024:this._capabilities&=~1024,this._onDidChangeCapabilities.fire(void 0)}stat(E){return this.channel.call("stat",[E])}open(E,b){return this.channel.call("open",[E,b])}close(E){return this.channel.call("close",[E])}async read(E,b,o,u,w){const[p,h]=await this.channel.call("read",[E,b,w]);return o.set(p.buffer.slice(0,h),u),h}async readFile(E){return(await this.channel.call("readFile",[E])).buffer}readFileStream(E,b,o){const u=(0,D.newWriteableStream)(p=>S.VSBuffer.concat(p.map(h=>S.VSBuffer.wrap(h))).buffer),w=this.channel.listen("readFileStream",[E,b])(p=>{if(p instanceof S.VSBuffer)u.write(p.buffer);else{if(p==="end")u.end();else{let h=p;h instanceof Error||(h=new Error((0,_.toErrorMessage)(h))),u.error(h),u.end()}w.dispose()}});return o.onCancellationRequested(()=>{u.error((0,g.canceled)()),u.end(),w.dispose()}),u}write(E,b,o,u,w){return this.channel.call("write",[E,b,S.VSBuffer.wrap(o),u,w])}writeFile(E,b,o){return this.channel.call("writeFile",[E,S.VSBuffer.wrap(b),o])}delete(E,b){return this.channel.call("delete",[E,b])}mkdir(E){return this.channel.call("mkdir",[E])}readdir(E){return this.channel.call("readdir",[E])}rename(E,b,o){return this.channel.call("rename",[E,b,o])}copy(E,b,o){return this.channel.call("copy",[E,b,o])}watch(E,b){const o=Math.random();return this.channel.call("watch",[this.session,o,E,b]),(0,C.toDisposable)(()=>this.channel.call("unwatch",[this.session,o]))}}e.IPCFileSystemProvider=i}),define(me[172],ge([0,1,2,8,36,56]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class C extends S.Disposable{constructor(d,y,i,A){super();this.folders=d,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=A,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new k.Client(_.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=C.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService((0,g.getNextTickChannel)(d.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.setFolders(this.folders)}setVerboseLogging(d){this.verboseLogging=d,!this.isDisposed&&this.service&&this.service.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${d}`})}setFolders(d){this.folders=d,this.service&&this.service.setRoots(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=C,C.MAX_RESTARTS=5}),define(me[173],ge([0,1,2,8,36,56]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class C extends S.Disposable{constructor(d,y,i,A,E={}){super();this.folders=d,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=A,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new k.Client(_.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=C.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService((0,g.getNextTickChannel)(d.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.service.setRoots(this.folders)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${d}`})}setVerboseLogging(d){this.verboseLogging=d,this.service&&this.service.setVerboseLogging(d)}setFolders(d){this.folders=d,this.service&&this.service.setRoots(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=C,C.MAX_RESTARTS=5}),define(me[174],ge([0,1,35,47,8,76]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class C{constructor(d,y,i,A,E){this.watchedFolder=d,this.eventCallback=i,this.logCallback=A,this.verboseLogging=E,this.restartCounter=0,Array.isArray(y)?this.ignored=y.map(b=>(0,_.parse)(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${d}, excludes: ${y.join(",")}`),this.startWatcher()}startWatcher(){const d=[this.watchedFolder];this.verboseLogging&&d.push("-verbose"),this.handle=(0,S.spawn)(g.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",Q).fsPath,d);const y=new k.LineDecoder;this.handle.stdout.on("data",i=>{const A=[];for(const E of y.write(i)){const b=E.split("|");if(b.length===2){const o=Number(b[0]),u=b[1];if(o>=0&&o<3){if(this.ignored&&this.ignored.some(w=>w(u))){this.verboseLogging&&this.log(u);continue}A.push({type:C.changeTypeMap[o],path:u})}else this.log(b[1])}}A.length>0&&this.eventCallback(A)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,A)=>this.onExit(i,A))}onError(d){this.error("process error: "+d.toString())}onExit(d,y){this.handle&&(this.error(`terminated unexpectedly (code: ${d}, signal: ${y})`),this.restartCounter<=C.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(d){this.logCallback({type:"error",message:`[File Watcher (C#)] ${d}`})}log(d){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${d}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=C,C.MAX_RESTARTS=5,C.changeTypeMap=[0,1,2]}),define(me[175],ge([0,1,5,15,174]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(D,d,y,i){this.onDidFilesChange=d,this.onLogMessage=y,this.verboseLogging=i,this.service=void 0,this.folder=D[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(S.posix.sep)&&(this.folder.path=(0,_.rtrim)(this.folder.path,S.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new g.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,D=>this.onFileEvents(D),D=>this.onLogMessage(D),this.verboseLogging)}setVerboseLogging(D){this.verboseLogging=D,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(D){this.isDisposed||D.length>0&&this.onDidFilesChange(D)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(me[59],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(g,k=[],C=!1){this.ctor=g,this.staticArguments=k,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=S}),define(me[176],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=S;class _{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let C of this._nodes.values())C.outgoing.size===0&&k.push(C);return k}insertEdge(k,C){const D=this.lookupOrInsertNode(k),d=this.lookupOrInsertNode(C);D.outgoing.set(this._hashFn(C),d),d.incoming.set(this._hashFn(k),D)}removeNode(k){const C=this._hashFn(k);this._nodes.delete(C);for(let D of this._nodes.values())D.outgoing.delete(C),D.incoming.delete(C)}lookupOrInsertNode(k){const C=this._hashFn(k);let D=this._nodes.get(C);return D||(D=new S(k),this._nodes.set(C,D)),D}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[C,D]of this._nodes)k.push(`${C}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,C]of this._nodes){const D=new Set([k]),d=this._findCycle(C,D);if(d)return d}}_findCycle(k,C){for(let[D,d]of k.outgoing){if(C.has(D))return[...C,D].join(" -> ");C.add(D);const y=this._findCycle(d,C);if(y)return y;C.delete(D)}}}e.Graph=_}),define(me[6],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function d(y){return y[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=d})(S=e._util||(e._util={})),e.IInstantiationService=g("instantiationService");function _(D,d,y,i){d[S.DI_TARGET]===d?d[S.DI_DEPENDENCIES].push({id:D,index:y,optional:i}):(d[S.DI_DEPENDENCIES]=[{id:D,index:y,optional:i}],d[S.DI_TARGET]=d)}function g(D){if(S.serviceIds.has(D))return S.serviceIds.get(D);const d=function(y,i,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");_(d,y,A,!1)};return d.toString=()=>D,S.serviceIds.set(D,d),d}e.createDecorator=g;function k(D){return D}e.refineServiceDecorator=k;function C(D){return function(d,y,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");_(D,d,i,!0)}}e.optional=C}),define(me[177],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,S.createDecorator)("modelService");function _(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.shouldSynchronizeModel=_}),define(me[178],ge([0,1,7,118,2,27,115,129,177]),function(Q,e,S,_,g,k,C,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function y(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(y):!!u.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new S.Emitter}get onDidChange(){return this._onDidChange.event}register(w,p){let h={selector:w,provider:p,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,g.toDisposable)(()=>{if(h){let f=this._entries.indexOf(h);f>=0&&(this._entries.splice(f,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(w){return this.all(w).length>0}all(w){if(!w)return[];this._updateScores(w);const p=[];for(let h of this._entries)h._score>0&&p.push(h.provider);return p}ordered(w){const p=[];return this._orderedForEach(w,h=>p.push(h.provider)),p}orderedGroups(w){const p=[];let h,f;return this._orderedForEach(w,c=>{h&&f===c._score?h.push(c.provider):(f=c._score,h=[c.provider],p.push(h))}),p}_orderedForEach(w,p){if(!!w){this._updateScores(w);for(const h of this._entries)h._score>0&&p(h)}}_updateScores(w){let p={uri:w.uri.toString(),language:w.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===p.language&&this._lastCandidate.uri===p.uri)){this._lastCandidate=p;for(let h of this._entries)if(h._score=(0,D.score)(h.selector,w.uri,w.getLanguageIdentifier().language,(0,d.shouldSynchronizeModel)(w)),y(h.selector)&&h._score>0){for(let f of this._entries)f._score=0;h._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(w,p){return w._score<p._score?1:w._score>p._score?-1:w._time<p._time?1:w._time>p._time?-1:0}}e.LanguageFeatureRegistry=i;const A=new WeakMap;let E=0;function b(u){let w=A.get(u);return w===void 0&&(w=++E,A.set(u,w)),w}class o{constructor(w,p,h=Number.MAX_SAFE_INTEGER){this._registry=w,this.min=p,this.max=h,this._cache=new k.LRUCache(50,.7)}_key(w){return w.id+this._registry.all(w).reduce((p,h)=>(0,_.doHash)(b(h),p),0)}_clamp(w){return w===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(w*1.3)))}get(w){const p=this._key(w),h=this._cache.get(p);return this._clamp(h?.value)}update(w,p){const h=this._key(w);let f=this._cache.get(h);return f||(f=new C.MovingAverage,this._cache.set(h,f)),f.update(p),this.get(w)}}e.LanguageFeatureRequestDelays=o}),define(me[179],ge([0,1,4,55,178,130,39]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(m){m[m.Null=0]="Null",m[m.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class d{constructor(T,I){this.language=T,this.id=I}}e.LanguageIdentifier=d;var y;(function(m){m[m.NotSet=-1]="NotSet",m[m.None=0]="None",m[m.Italic=1]="Italic",m[m.Bold=2]="Bold",m[m.Underline=4]="Underline"})(y=e.FontStyle||(e.FontStyle={}));var i;(function(m){m[m.None=0]="None",m[m.DefaultForeground=1]="DefaultForeground",m[m.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var A;(function(m){m[m.Other=0]="Other",m[m.Comment=1]="Comment",m[m.String=2]="String",m[m.RegEx=4]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var E;(function(m){m[m.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",m[m.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",m[m.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",m[m.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",m[m.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",m[m.ITALIC_MASK=2048]="ITALIC_MASK",m[m.BOLD_MASK=4096]="BOLD_MASK",m[m.UNDERLINE_MASK=8192]="UNDERLINE_MASK",m[m.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",m[m.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",m[m.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",m[m.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",m[m.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",m[m.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",m[m.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",m[m.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",m[m.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",m[m.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(E=e.MetadataConsts||(e.MetadataConsts={}));class b{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&1792)>>>8}static getFontStyle(T){return(T&14336)>>>11}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){let I=this.getForeground(T),B="mtk"+I,j=this.getFontStyle(T);return j&1&&(B+=" mtki"),j&2&&(B+=" mtkb"),j&4&&(B+=" mtku"),B}static getInlineStyleFromMetadata(T,I){const B=this.getForeground(T),j=this.getFontStyle(T);let ue=`color: ${I[B]};`;return j&1&&(ue+="font-style: italic;"),j&2&&(ue+="font-weight: bold;"),j&4&&(ue+="text-decoration: underline;"),ue}}e.TokenMetadata=b;var o;(function(m){m[m.Method=0]="Method",m[m.Function=1]="Function",m[m.Constructor=2]="Constructor",m[m.Field=3]="Field",m[m.Variable=4]="Variable",m[m.Class=5]="Class",m[m.Struct=6]="Struct",m[m.Interface=7]="Interface",m[m.Module=8]="Module",m[m.Property=9]="Property",m[m.Event=10]="Event",m[m.Operator=11]="Operator",m[m.Unit=12]="Unit",m[m.Value=13]="Value",m[m.Constant=14]="Constant",m[m.Enum=15]="Enum",m[m.EnumMember=16]="EnumMember",m[m.Keyword=17]="Keyword",m[m.Text=18]="Text",m[m.Color=19]="Color",m[m.File=20]="File",m[m.Reference=21]="Reference",m[m.Customcolor=22]="Customcolor",m[m.Folder=23]="Folder",m[m.TypeParameter=24]="TypeParameter",m[m.User=25]="User",m[m.Issue=26]="Issue",m[m.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let m=Object.create(null);return m[0]="symbol-method",m[1]="symbol-function",m[2]="symbol-constructor",m[3]="symbol-field",m[4]="symbol-variable",m[5]="symbol-class",m[6]="symbol-struct",m[7]="symbol-interface",m[8]="symbol-module",m[9]="symbol-property",m[10]="symbol-event",m[11]="symbol-operator",m[12]="symbol-unit",m[13]="symbol-value",m[14]="symbol-constant",m[15]="symbol-enum",m[16]="symbol-enum-member",m[17]="symbol-keyword",m[27]="symbol-snippet",m[18]="symbol-text",m[19]="symbol-color",m[20]="symbol-file",m[21]="symbol-reference",m[22]="symbol-customcolor",m[23]="symbol-folder",m[24]="symbol-type-parameter",m[25]="account",m[26]="issues",function(T){const I=m[T];let B=I&&C.iconRegistry.get(I);return B||(console.info("No codicon found for CompletionItemKind "+T),B=C.Codicon.symbolProperty),B.classNames}}(),e.completionKindFromString=function(){let m=Object.create(null);return m.method=0,m.function=1,m.constructor=2,m.field=3,m.variable=4,m.class=5,m.struct=6,m.interface=7,m.module=8,m.property=9,m.event=10,m.operator=11,m.unit=12,m.value=13,m.constant=14,m.enum=15,m["enum-member"]=16,m.enumMember=16,m.keyword=17,m.snippet=27,m.text=18,m.color=19,m.file=20,m.reference=21,m.customcolor=22,m.folder=23,m["type-parameter"]=24,m.typeParameter=24,m.account=25,m.issue=26,function(T,I){let B=m[T];return typeof B=="undefined"&&!I&&(B=9),B}}();var u;(function(m){m[m.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(m){m[m.KeepWhitespace=1]="KeepWhitespace",m[m.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(m){m[m.Invoke=0]="Invoke",m[m.TriggerCharacter=1]="TriggerCharacter",m[m.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var h;(function(m){m[m.Automatic=0]="Automatic",m[m.Explicit=1]="Explicit"})(h=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(m){m[m.Invoke=1]="Invoke",m[m.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(m){m[m.Invoke=1]="Invoke",m[m.TriggerCharacter=2]="TriggerCharacter",m[m.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var a;(function(m){m[m.Text=0]="Text",m[m.Read=1]="Read",m[m.Write=2]="Write"})(a=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(m){return m&&S.URI.isUri(m.uri)&&_.Range.isIRange(m.range)&&(_.Range.isIRange(m.originSelectionRange)||_.Range.isIRange(m.targetSelectionRange))}e.isLocationLink=t;var s;(function(m){m[m.File=0]="File",m[m.Module=1]="Module",m[m.Namespace=2]="Namespace",m[m.Package=3]="Package",m[m.Class=4]="Class",m[m.Method=5]="Method",m[m.Property=6]="Property",m[m.Field=7]="Field",m[m.Constructor=8]="Constructor",m[m.Enum=9]="Enum",m[m.Interface=10]="Interface",m[m.Function=11]="Function",m[m.Variable=12]="Variable",m[m.Constant=13]="Constant",m[m.String=14]="String",m[m.Number=15]="Number",m[m.Boolean=16]="Boolean",m[m.Array=17]="Array",m[m.Object=18]="Object",m[m.Key=19]="Key",m[m.Null=20]="Null",m[m.EnumMember=21]="EnumMember",m[m.Struct=22]="Struct",m[m.Event=23]="Event",m[m.Operator=24]="Operator",m[m.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var n;(function(m){m[m.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var r;(function(m){const T=new Map;T.set("file",0),T.set("module",1),T.set("namespace",2),T.set("package",3),T.set("class",4),T.set("method",5),T.set("property",6),T.set("field",7),T.set("constructor",8),T.set("enum",9),T.set("interface",10),T.set("function",11),T.set("variable",12),T.set("constant",13),T.set("string",14),T.set("number",15),T.set("boolean",16),T.set("array",17),T.set("object",18),T.set("key",19),T.set("null",20),T.set("enum-member",21),T.set("struct",22),T.set("event",23),T.set("operator",24),T.set("type-parameter",25);const I=new Map;I.set(0,"file"),I.set(1,"module"),I.set(2,"namespace"),I.set(3,"package"),I.set(4,"class"),I.set(5,"method"),I.set(6,"property"),I.set(7,"field"),I.set(8,"constructor"),I.set(9,"enum"),I.set(10,"interface"),I.set(11,"function"),I.set(12,"variable"),I.set(13,"constant"),I.set(14,"string"),I.set(15,"number"),I.set(16,"boolean"),I.set(17,"array"),I.set(18,"object"),I.set(19,"key"),I.set(20,"null"),I.set(21,"enum-member"),I.set(22,"struct"),I.set(23,"event"),I.set(24,"operator"),I.set(25,"type-parameter");function B(ce){return T.get(ce)}m.fromString=B;function j(ce){return I.get(ce)}m.toString=j;function ue(ce,O){const $=I.get(ce);let z=$&&C.iconRegistry.get("symbol-"+$);return z||(console.info("No codicon found for SymbolKind "+ce),z=C.Codicon.symbolProperty),`${O?"inline":"block"} ${z.classNames}`}m.toCssClassName=ue})(r=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(T){this.value=T}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var v;(function(m){m[m.Collapsed=0]="Collapsed",m[m.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var P;(function(m){m[m.Editing=0]="Editing",m[m.Preview=1]="Preview"})(P=e.CommentMode||(e.CommentMode={}));var L;(function(m){m[m.Other=0]="Other",m[m.Type=1]="Type",m[m.Parameter=2]="Parameter"})(L=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new g.LanguageFeatureRegistry,e.RenameProviderRegistry=new g.LanguageFeatureRegistry,e.CompletionProviderRegistry=new g.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new g.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new g.LanguageFeatureRegistry,e.HoverProviderRegistry=new g.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new g.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new g.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new g.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new g.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new g.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new g.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new g.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new g.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new g.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new g.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new g.LanguageFeatureRegistry,e.LinkProviderRegistry=new g.LanguageFeatureRegistry,e.ColorProviderRegistry=new g.LanguageFeatureRegistry,e.SelectionRangeRegistry=new g.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new g.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new g.LanguageFeatureRegistry,e.TokenizationRegistry=new k.TokenizationRegistryImpl;var R;(function(m){m[m.None=0]="None",m[m.Option=1]="Option",m[m.Default=2]="Default",m[m.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[60],ge([0,1,3,15,6]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=S.userAgent||"";const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",S.isMacintosh),C.set("isLinux",S.isLinux),C.set("isWindows",S.isWindows),C.set("isWeb",S.isWeb),C.set("isMacNative",S.isMacintosh&&!S.isWeb),C.set("isEdge",k.indexOf("Edg/")>=0),C.set("isFirefox",k.indexOf("Firefox")>=0),C.set("isChrome",k.indexOf("Chrome")>=0),C.set("isSafari",k.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var d;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(d=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return A.INSTANCE}static true(){return E.INSTANCE}static has(I){return b.create(I)}static equals(I,B){return o.create(I,B)}static notEquals(I,B){return p.create(I,B)}static regex(I,B){return s.create(I,B)}static in(I,B){return u.create(I,B)}static not(I){return h.create(I)}static and(...I){return r.create(I,null)}static or(...I){return l.create(I,null,!0)}static greater(I,B){return f.create(I,B)}static less(I,B){return a.create(I,B)}static deserialize(I,B=!1){if(!!I)return this._deserializeOrExpression(I,B)}static _deserializeOrExpression(I,B){let j=I.split("||");return l.create(j.map(ue=>this._deserializeAndExpression(ue,B)),null,!0)}static _deserializeAndExpression(I,B){let j=I.split("&&");return r.create(j.map(ue=>this._deserializeOne(ue,B)),null)}static _deserializeOne(I,B){if(I=I.trim(),I.indexOf("!=")>=0){let j=I.split("!=");return p.create(j[0].trim(),this._deserializeValue(j[1],B))}if(I.indexOf("==")>=0){let j=I.split("==");return o.create(j[0].trim(),this._deserializeValue(j[1],B))}if(I.indexOf("=~")>=0){let j=I.split("=~");return s.create(j[0].trim(),this._deserializeRegexValue(j[1],B))}if(I.indexOf(" in ")>=0){let j=I.split(" in ");return u.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(I)){const j=I.split(">=");return c.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(I)){const j=I.split(">");return f.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(I)){const j=I.split("<=");return t.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(I)){const j=I.split("<");return a.create(j[0].trim(),j[1].trim())}return/^\!\s*/.test(I)?h.create(I.substr(1).trim()):b.create(I)}static _deserializeValue(I,B){if(I=I.trim(),I==="true")return!0;if(I==="false")return!1;let j=/^'([^']*)'$/.exec(I);return j?j[1].trim():I}static _deserializeRegexValue(I,B){if((0,_.isFalsyOrWhitespace)(I)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let j=I.indexOf("/"),ue=I.lastIndexOf("/");if(j===ue||j<0){if(B)throw new Error(`bad regexp-value '${I}', missing /-enclosure`);return console.warn(`bad regexp-value '${I}', missing /-enclosure`),null}let ce=I.slice(j+1,ue),O=I[ue+1]==="i"?"i":"";try{return new RegExp(ce,O)}catch($){if(B)throw new Error(`bad regexp-value '${I}', parse error: ${$}`);return console.warn(`bad regexp-value '${I}', parse error: ${$}`),null}}}e.ContextKeyExpr=y;function i(T,I){return T.cmp(I)}class A{constructor(){this.type=0}cmp(I){return this.type-I.type}equals(I){return I.type===this.type}evaluate(I){return!1}serialize(){return"false"}keys(){return[]}map(I){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=A,A.INSTANCE=new A;class E{constructor(){this.type=1}cmp(I){return this.type-I.type}equals(I){return I.type===this.type}evaluate(I){return!0}serialize(){return"true"}keys(){return[]}map(I){return this}negate(){return A.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class b{constructor(I,B){this.key=I,this.negated=B,this.type=2}static create(I,B=null){const j=C.get(I);return typeof j=="boolean"?j?E.INSTANCE:A.INSTANCE:new b(I,B)}cmp(I){return I.type!==this.type?this.type-I.type:P(this.key,I.key)}equals(I){return I.type===this.type?this.key===I.key:!1}evaluate(I){return!!I.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(I){return I.mapDefined(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class o{constructor(I,B,j){this.key=I,this.value=B,this.negated=j,this.type=4}static create(I,B,j=null){if(typeof B=="boolean")return B?b.create(I,j):h.create(I,j);const ue=C.get(I);return typeof ue=="boolean"?B===(ue?"true":"false")?E.INSTANCE:A.INSTANCE:new o(I,B,j)}cmp(I){return I.type!==this.type?this.type-I.type:L(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}evaluate(I){return I.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(I){return I.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=o;class u{constructor(I,B){this.key=I,this.valueKey=B,this.type=10,this.negated=null}static create(I,B){return new u(I,B)}cmp(I){return I.type!==this.type?this.type-I.type:L(this.key,this.valueKey,I.key,I.valueKey)}equals(I){return I.type===this.type?this.key===I.key&&this.valueKey===I.valueKey:!1}evaluate(I){const B=I.getValue(this.valueKey),j=I.getValue(this.key);return Array.isArray(B)?B.indexOf(j)>=0:typeof j=="string"&&typeof B=="object"&&B!==null?D.call(B,j):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(I){return I.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=u;class w{constructor(I){this._actual=I,this.type=11}static create(I){return new w(I)}cmp(I){return I.type!==this.type?this.type-I.type:this._actual.cmp(I._actual)}equals(I){return I.type===this.type?this._actual.equals(I._actual):!1}evaluate(I){return!this._actual.evaluate(I)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(I){return new w(this._actual.map(I))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class p{constructor(I,B,j){this.key=I,this.value=B,this.negated=j,this.type=5}static create(I,B,j=null){if(typeof B=="boolean")return B?h.create(I,j):b.create(I,j);const ue=C.get(I);return typeof ue=="boolean"?B===(ue?"true":"false")?A.INSTANCE:E.INSTANCE:new p(I,B,j)}cmp(I){return I.type!==this.type?this.type-I.type:L(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}evaluate(I){return I.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(I){return I.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class h{constructor(I,B){this.key=I,this.negated=B,this.type=3}static create(I,B=null){const j=C.get(I);return typeof j=="boolean"?j?A.INSTANCE:E.INSTANCE:new h(I,B)}cmp(I){return I.type!==this.type?this.type-I.type:P(this.key,I.key)}equals(I){return I.type===this.type?this.key===I.key:!1}evaluate(I){return!I.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(I){return I.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=h;class f{constructor(I,B,j){this.key=I,this.value=B,this.negated=j,this.type=12}static create(I,B,j=null){return new f(I,B,j)}cmp(I){return I.type!==this.type?this.type-I.type:L(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}evaluate(I){return parseFloat(I.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(I){return I.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class c{constructor(I,B,j){this.key=I,this.value=B,this.negated=j,this.type=13}static create(I,B,j=null){return new c(I,B,j)}cmp(I){return I.type!==this.type?this.type-I.type:L(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}evaluate(I){return parseFloat(I.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(I){return I.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class a{constructor(I,B,j){this.key=I,this.value=B,this.negated=j,this.type=14}static create(I,B,j=null){return new a(I,B,j)}cmp(I){return I.type!==this.type?this.type-I.type:L(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}evaluate(I){return parseFloat(I.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(I){return I.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class t{constructor(I,B,j){this.key=I,this.value=B,this.negated=j,this.type=15}static create(I,B,j=null){return new t(I,B,j)}cmp(I){return I.type!==this.type?this.type-I.type:L(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}evaluate(I){return parseFloat(I.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(I){return I.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(I,B){this.key=I,this.regexp=B,this.type=7,this.negated=null}static create(I,B){return new s(I,B)}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.key<I.key)return-1;if(this.key>I.key)return 1;const B=this.regexp?this.regexp.source:"",j=I.regexp?I.regexp.source:"";return B<j?-1:B>j?1:0}equals(I){if(I.type===this.type){const B=this.regexp?this.regexp.source:"",j=I.regexp?I.regexp.source:"";return this.key===I.key&&B===j}return!1}evaluate(I){let B=I.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const I=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${I}`}keys(){return[this.key]}map(I){return I.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class n{constructor(I){this._actual=I,this.type=8}static create(I){return new n(I)}cmp(I){return I.type!==this.type?this.type-I.type:this._actual.cmp(I._actual)}equals(I){return I.type===this.type?this._actual.equals(I._actual):!1}evaluate(I){return!this._actual.evaluate(I)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(I){return new n(this._actual.map(I))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class r{constructor(I,B){this.expr=I,this.negated=B,this.type=6}static create(I,B){return r._normalizeArr(I,B)}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.expr.length<I.expr.length)return-1;if(this.expr.length>I.expr.length)return 1;for(let B=0,j=this.expr.length;B<j;B++){const ue=i(this.expr[B],I.expr[B]);if(ue!==0)return ue}return 0}equals(I){if(I.type===this.type){if(this.expr.length!==I.expr.length)return!1;for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].equals(I.expr[B]))return!1;return!0}return!1}evaluate(I){for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].evaluate(I))return!1;return!0}static _normalizeArr(I,B){const j=[];let ue=!1;for(const ce of I)if(!!ce){if(ce.type===1){ue=!0;continue}if(ce.type===0)return A.INSTANCE;if(ce.type===6){j.push(...ce.expr);continue}j.push(ce)}if(j.length===0&&ue)return E.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(i);for(let ce=1;ce<j.length;ce++)j[ce-1].equals(j[ce])&&(j.splice(ce,1),ce--);if(j.length===1)return j[0];for(;j.length>1;){const ce=j[j.length-1];if(ce.type!==9)break;j.pop();const O=j.pop(),$=j.length===0,z=l.create(ce.expr.map(ee=>r.create([ee,O],null)),null,$);z&&(j.push(z),j.sort(i))}return j.length===1?j[0]:new r(j,B)}}serialize(){return this.expr.map(I=>I.serialize()).join(" && ")}keys(){const I=[];for(let B of this.expr)I.push(...B.keys());return I}map(I){return new r(this.expr.map(B=>B.map(I)),null)}negate(){if(!this.negated){const I=[];for(let B of this.expr)I.push(B.negate());this.negated=l.create(I,this,!0)}return this.negated}}class l{constructor(I,B){this.expr=I,this.negated=B,this.type=9}static create(I,B,j){return l._normalizeArr(I,B,j)}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.expr.length<I.expr.length)return-1;if(this.expr.length>I.expr.length)return 1;for(let B=0,j=this.expr.length;B<j;B++){const ue=i(this.expr[B],I.expr[B]);if(ue!==0)return ue}return 0}equals(I){if(I.type===this.type){if(this.expr.length!==I.expr.length)return!1;for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].equals(I.expr[B]))return!1;return!0}return!1}evaluate(I){for(let B=0,j=this.expr.length;B<j;B++)if(this.expr[B].evaluate(I))return!0;return!1}static _normalizeArr(I,B,j){let ue=[],ce=!1;if(I){for(let O=0,$=I.length;O<$;O++){const z=I[O];if(!!z){if(z.type===0){ce=!0;continue}if(z.type===1)return E.INSTANCE;if(z.type===9){ue=ue.concat(z.expr);continue}ue.push(z)}}if(ue.length===0&&ce)return A.INSTANCE;ue.sort(i)}if(ue.length!==0){if(ue.length===1)return ue[0];for(let O=1;O<ue.length;O++)ue[O-1].equals(ue[O])&&(ue.splice(O,1),O--);if(ue.length===1)return ue[0];if(j){for(let O=0;O<ue.length;O++)for(let $=O+1;$<ue.length;$++)R(ue[O],ue[$])&&(ue.splice($,1),$--);if(ue.length===1)return ue[0]}return new l(ue,B)}}serialize(){return this.expr.map(I=>I.serialize()).join(" || ")}keys(){const I=[];for(let B of this.expr)I.push(...B.keys());return I}map(I){return new l(this.expr.map(B=>B.map(I)),null)}negate(){if(!this.negated){let I=[];for(let B of this.expr)I.push(B.negate());for(;I.length>1;){const B=I.shift(),j=I.shift(),ue=[];for(const O of m(B))for(const $ of m(j))ue.push(r.create([O,$],null));const ce=I.length===0;I.unshift(l.create(ue,null,ce))}this.negated=I[0]}return this.negated}}class v extends b{constructor(I,B,j){super(I,null);this._defaultValue=B,typeof j=="object"?v._info.push({...j,key:I}):j!==!0&&v._info.push({key:I,description:j,type:B!=null?typeof B:void 0})}static all(){return v._info.values()}bindTo(I){return I.createKey(this.key,this._defaultValue)}getValue(I){return I.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(I){return o.create(this.key,I)}notEqualsTo(I){return p.create(this.key,I)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,g.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P(T,I){return T<I?-1:T>I?1:0}function L(T,I,B,j){return T<B?-1:T>B?1:I<j?-1:I>j?1:0}function R(T,I){if(I.type===6&&T.type!==9&&T.type!==6){for(const ue of I.expr)if(T.equals(ue))return!0}const B=T.negate(),j=m(B).concat(m(I));j.sort(i);for(let ue=0;ue<j.length;ue++){const O=j[ue].negate();for(let $=ue+1;$<j.length;$++){const z=j[$];if(O.equals(z))return!0}}return!1}e.implies=R;function m(T){return T.type===9?T.expr:[T]}}),define(me[180],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function _(g){return!!g.hostName&&!!g.errorMessage}e.isRemoteDiagnosticError=_}),define(me[85],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,S.createDecorator)("downloadService")}),define(me[29],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(me[32],ge([0,1,8,3,22,143,6]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.CURRENT_TARGET_PLATFORM=e.getTargetPlatform=e.getTargetPlatformFromOS=e.toTargetPlatform=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var D;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));function d(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=d;function y(p,h){let f;switch(p){case 1:f=3;break;case 3:f=2;break;case 2:f=1;break}return i(f,h)}e.getTargetPlatformFromOS=y;function i(p,h){switch(p){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=i,e.CURRENT_TARGET_PLATFORM=_.isWeb?"web":i(_.platform,g.arch);function A(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=A;var E;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=5]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var b;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var o;(function(p){p.Install="install",p.Uninstall="uninstall"})(o=e.StatisticType||(e.StatisticType={}));var u;(function(p){p[p.None=0]="None",p[p.Install=1]="Install",p[p.Update=2]="Update"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class w extends Error{constructor(h,f){super(h);this.code=f,this.name=f}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=S.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(me[44],ge([0,1,15,6]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function g(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=g;function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));class D{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,E){if(typeof A=="undefined"||A===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof A=="string"||typeof E=="string"){let b=typeof A=="string"?A:A.value,o=typeof E=="string"?E:E.value;return S.equalsIgnoreCase(b,o)}return A._lower===E._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=D;function d(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=d;function y(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,_.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[33],ge([0,1,15,44]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function g(o,u){return o.uuid&&u.uuid?o.uuid===u.uuid:o.id===u.id?!0:(0,S.compareIgnoreCase)(o.id,u.id)===0}e.areSameExtensions=g;class k{constructor(u,w){this.version=w,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof k?g(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=k;function C(o,u){return`${o}.${u}`}e.getExtensionId=C;function D(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function d(o,u){return D(C(o,u))}e.getGalleryExtensionId=d;function y(o,u){const w=[],p=h=>{for(const f of w)if(f.some(c=>g(u(c),u(h))))return f;return null};for(const h of o){const f=p(h);f?f.push(h):w.push([h])}return w}e.groupByExtension=y;function i(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function A(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new _.ExtensionIdentifier("pprice.better-merge");function E(o){const u=new Set;for(const w of o)w.malicious&&u.add(w.id.id);return u}e.getMaliciousExtensionsSet=E;function b(o,u){const w=[],p=u.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const h=p.shift();if(h&&w.every(f=>!g(f.identifier,{id:h}))){const f=o.filter(c=>g(c.identifier,{id:h}));f.length===1&&(w.push(f[0]),p.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=b});var Xe=this&&this.__param||function(Q,e){return function(S,_){e(S,_,Q)}};define(me[86],ge([0,1,25,11,52,8,49,4,144,32,33,44]),function(Q,e,S,_,g,k,C,D,d,y,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=e.getIdAndVersion=void 0;const E=h=>(0,d.localize)(0,null,h),b=(0,d.localize)(1,null,"ms-dotnettools.csharp");function o(h,f){return f?`${h.publisher}.${h.name}@${h.version}`:`${h.publisher}.${h.name}`}const u=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function w(h){const f=u.exec(h);return f&&f[1]?[(0,i.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,i.adoptToGalleryExtensionId)(h),void 0]}e.getIdAndVersion=w;let p=class{constructor(f,c){this.extensionManagementService=f,this.extensionGalleryService=c}get location(){}async listExtensions(f,c,a=console){let t=await this.extensionManagementService.getInstalled(1);const s=A.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(c&&c!==""){if(s.indexOf(c.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}t=t.filter(r=>r.manifest.categories?r.manifest.categories.map(v=>v.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){a.log("Possible Categories: "),s.forEach(r=>{a.log(r)});return}this.location&&a.log((0,d.localize)(2,null,this.location)),t=t.sort((r,l)=>r.identifier.id.localeCompare(l.identifier.id));let n;for(let r of t)n!==r.identifier.id&&(n=r.identifier.id,a.log(o(r.manifest,f)))}async installExtensions(f,c,a,t,s=console){const n=[],r=[];f.length&&s.log(this.location?(0,d.localize)(3,null,this.location):(0,d.localize)(4,null));const l=await this.extensionManagementService.getInstalled(1),v=(R,m)=>{const T=l.find(I=>(0,i.areSameExtensions)(I.identifier,{id:R}));if(T){if(!m&&!t)return s.log((0,d.localize)(5,null,R,T.manifest.version,R)),!1;if(m&&T.manifest.version===m)return s.log((0,d.localize)(6,null,`${R}@${m}`)),!1}return!0},P=[],L=[];for(const R of f)if(R instanceof D.URI)P.push(R);else{const[m,T]=w(R);v(m,T)&&L.push({id:m,version:T,installOptions:{isBuiltin:!1,isMachineScoped:a}})}for(const R of c){const[m,T]=w(R);v(m,T)&&L.push({id:m,version:T,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(P.length&&await Promise.all(P.map(async R=>{try{const m=await this.installVSIX(R,{isBuiltin:!1,isMachineScoped:a},t,s);m&&r.push(m)}catch(m){s.error(m.message||m.stack||m),n.push(R.toString())}})),L.length){const R=await this.getGalleryExtensions(L);await Promise.all(L.map(async m=>{const T=R.get(m.id.toLowerCase());if(T)try{const I=await this.installFromGallery(m,T,l,t,s);I&&r.push(I)}catch(I){s.error(I.message||I.stack||I),n.push(m.id)}else s.error(`${E(m.version?`${m.id}@${m.version}`:m.id)}
${b}`),n.push(m.id)}))}if(n.length)throw new Error((0,d.localize)(7,null,n.join(", ")))}async installVSIX(f,c,a,t){const s=await this.extensionManagementService.getManifest(f);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,a,t))try{return await this.extensionManagementService.install(f,c),t.log((0,d.localize)(8,null,(0,g.getBaseLabel)(f))),s}catch(r){if((0,_.isPromiseCanceledError)(r))return t.log((0,d.localize)(9,null,(0,g.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const c=new Map,a=await this.extensionGalleryService.getExtensions(f,S.CancellationToken.None);for(const t of a)c.set(t.identifier.id.toLowerCase(),t);return c}async installFromGallery({id:f,version:c,installOptions:a},t,s,n,r){const l=await this.extensionGalleryService.getManifest(t,S.CancellationToken.None);if(l&&!this.validateExtensionKind(l,r))return null;const v=s.find(P=>(0,i.areSameExtensions)(P.identifier,t.identifier));if(v){if(t.version===v.manifest.version)return r.log((0,d.localize)(10,null,c?`${f}@${c}`:f)),null;r.log((0,d.localize)(11,null,f,t.version))}try{return a.isBuiltin?r.log(c?(0,d.localize)(12,null,f,c):(0,d.localize)(13,null,f)):r.log(c?(0,d.localize)(14,null,f,c):(0,d.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(t,{...a,installGivenVersion:!!c}),r.log((0,d.localize)(16,null,f,t.version)),l}catch(P){if((0,_.isPromiseCanceledError)(P))return r.log((0,d.localize)(17,null,f)),null;throw P}}validateExtensionKind(f,c){return!0}async validateVSIX(f,c,a){const t={id:(0,i.getGalleryExtensionId)(f.publisher,f.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,i.areSameExtensions)(t,r.identifier)&&(0,C.gt)(r.manifest.version,f.version));return n&&!c?(a.log((0,d.localize)(18,null,n.identifier.id,n.manifest.version,f.version)),!1):this.validateExtensionKind(f,a)}async uninstallExtensions(f,c,a=console){const t=async n=>{if(n instanceof D.URI){const r=await this.extensionManagementService.getManifest(n);return o(r)}return n},s=[];for(const n of f){const r=await t(n),v=(await this.extensionManagementService.getInstalled()).filter(P=>(0,i.areSameExtensions)(P.identifier,{id:r}));if(!v.length)throw new Error(`${this.notInstalled(r)}
${b}`);if(v.some(P=>P.type===0)){a.log((0,d.localize)(19,null,r));return}if(!c&&v.some(P=>P.isBuiltin)){a.log((0,d.localize)(20,null,r));return}a.log((0,d.localize)(21,null,r));for(const P of v)await this.extensionManagementService.uninstall(P),s.push(P);this.location?a.log((0,d.localize)(22,null,r,this.location)):a.log((0,d.localize)(23,null,r))}}async locateExtension(f,c=console){const a=await this.extensionManagementService.getInstalled();f.forEach(t=>{a.forEach(s=>{if(s.identifier.id===t&&s.location.scheme===k.Schemas.file){c.log(s.location.fsPath);return}})})}notInstalled(f){return this.location?(0,d.localize)(24,null,f,this.location):(0,d.localize)(25,null,f)}};p=Le([Xe(0,y.IExtensionManagementService),Xe(1,y.IExtensionGalleryService)],p),e.ExtensionManagementCLIService=p}),define(me[181],ge([0,1,2,5,16,44]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class C extends S.Disposable{constructor(d,y){super();this.environmentService=d,this.extensionsManifestCache=(0,_.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(y.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(y.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(d){d.some(y=>!!y.local)&&this.invalidate()}onDidUnInstallExtension(d){d.error||this.invalidate()}invalidate(){g.Promises.rm(this.extensionsManifestCache,g.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=C}),define(me[21],ge([0,1,27,5,15,12,4,150,6]),function(Q,e,S,_,g,k,C,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function y(O){return O.create===!0}e.isFileOpenForWriteOptions=y;var i;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var A;(function(O){O[O.Readonly=1]="Readonly"})(A=e.FilePermission||(e.FilePermission={}));var E;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=b;function o(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=o;function u(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function w(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=w;var p;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor($,z){super($);this.code=z}}e.FileSystemProviderError=h;function f(O,$){const z=new h(O.toString(),$);return a(z,$),z}e.createFileSystemProviderError=f;function c(O){return O||f((0,D.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=c;function a(O,$){return O.name=$?`${$} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=a;function t(O){if(!O)return p.Unknown;if(O instanceof h)return O.code;const $=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!$)return p.Unknown;switch($[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=t;function s(O){if(O instanceof L)return O.fileOperationResult;switch(t(O)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var n;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor($,z,ee){this.resource=$,this.operation=z,this.target=ee}isOperation($){return this.operation===$}}e.FileOperationEvent=r;var l;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class v{constructor($,z){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const ee of $)switch(ee.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>z)),this.added.set(ee.resource,ee);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>z)),this.updated.set(ee.resource,ee);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>z)),this.deleted.set(ee.resource,ee);break}}contains($,...z){return this.doContains($,{includeChildren:!1},...z)}affects($,...z){return this.doContains($,{includeChildren:!0},...z)}doContains($,z,...ee){if(!$)return!1;const J=ee.length>0;return!!((!J||ee.includes(1))&&(this.added?.get($)||z.includeChildren&&this.added?.findSuperstr($))||(!J||ee.includes(0))&&(this.updated?.get($)||z.includeChildren&&this.updated?.findSuperstr($))||(!J||ee.includes(2))&&(this.deleted?.findSubstr($)||z.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=v;function P(O,$,z){return!O||!$||O===$||$.length>O.length?!1:($.charAt($.length-1)!==_.sep&&($+=_.sep),z?(0,g.startsWithIgnoreCase)(O,$):O.indexOf($)===0)}e.isParent=P;class L extends Error{constructor($,z,ee){super($);this.fileOperationResult=z,this.options=ee}}e.FileOperationError=L;class R extends L{constructor($,z,ee){super($,2,ee);this.stat=z}}e.NotModifiedSinceFileOperationError=R;var m;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(m=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function I(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=I;async function B(O,$){if(!$.canHandleResource(C.URI.from({scheme:O.scheme})))return new Promise(z=>{const ee=$.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===O.scheme&&J.added&&(ee.dispose(),z())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize($){return(0,k.isNumber)($)||($=0),$<j.KB?(0,D.localize)(1,null,$.toFixed(0)):$<j.MB?(0,D.localize)(2,null,($/j.KB).toFixed(2)):$<j.GB?(0,D.localize)(3,null,($/j.MB).toFixed(2)):$<j.TB?(0,D.localize)(4,null,($/j.GB).toFixed(2)):(0,D.localize)(5,null,($/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;var ue;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(ue=e.Arch||(e.Arch={}));function ce(O){return{maxFileSize:O===0?300*j.MB:16*j.GB,maxHeapSize:O===0?700*j.MB:2*700*j.MB}}e.getPlatformLimits=ce}),define(me[182],ge([0,1,244,141,57,21]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function C(E,b){const o={onUnknownOption:w=>{console.warn((0,_.localize)(0,null,w))},onMultipleValues:(w,p)=>{console.warn((0,_.localize)(1,null,w,p))}},u=(0,g.parseArgs)(E,g.OPTIONS,b?o:void 0);return u.goto&&u._.forEach(w=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,_.localize)(2,null))),u["max-memory"]&&S(parseInt(u["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),u}function D(E){const b=E.findIndex(o=>!/^-/.test(o));if(b>-1)return[...E.slice(0,b),...E.slice(b+1)]}function d(E){let[,...b]=E;process.env.VSCODE_DEV&&(b=D(b)||[]);const o=!A(process.env);return C(b,o)}e.parseMainProcessArgv=d;function y(E){const[,,...b]=E;return C(b,!0)}e.parseCLIProcessArgv=y;function i(E,...b){const o=E.indexOf("--");return o===-1?E.push(...b):E.splice(o,0,...b),E}e.addArg=i;function A(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=A}),define(me[61],ge([0,1,35,77,25,43,11,3,23,137,182]),function(Q,e,S,_,g,k,C,D,d,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function A(o,u,w){return u["force-disable-user-env"]?(o.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):D.isWindows?(o.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,i.isLaunchedFromCli)(w)&&!u["force-user-env"]?(o.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,i.isLaunchedFromCli)(w)?o.trace("resolveShellEnv(): running (--force-user-env)"):o.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=new Promise(async p=>{const h=new g.CancellationTokenSource,f=setTimeout(()=>{o.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),h.dispose(!0),p({})},1e4);try{const c=await b(o,h.token);p(c)}catch(c){(0,C.isPromiseCanceledError)(c)||o.error(`[resolve shell env] Unable to resolve shell environment (${c}). Proceeding without shell environment...`),p({})}finally{clearTimeout(f),h.dispose()}})),E)}e.resolveShellEnv=A;let E;async function b(o,u){const w=new Promise(async(p,h)=>{const f=process.env.ELECTRON_RUN_AS_NODE;o.trace("getUnixShellEnvironment#runAsNode",f);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;o.trace("getUnixShellEnvironment#noAttach",c);const a=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};o.trace("getUnixShellEnvironment#env",s);const n=await(0,y.getSystemShell)(D.OS,s);if(o.trace("getUnixShellEnvironment#shell",n),u.isCancellationRequested)return h(C.canceled);const r=_.basename(n);let l,v;/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,v=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,v=["-ilc"]),o.trace("getUnixShellEnvironment#spawn",JSON.stringify(v),l);const P=(0,S.spawn)(n,[...v,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});u.onCancellationRequested(()=>(P.kill(),h(C.canceled))),P.on("error",m=>{o.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(m)),p({})});const L=[];P.stdout.on("data",m=>L.push(m));const R=[];P.stderr.on("data",m=>R.push(m)),P.on("close",(m,T)=>{const I=Buffer.concat(L).toString("utf8");o.trace("getUnixShellEnvironment#raw",I);const B=Buffer.concat(R).toString("utf8");if(B.trim()&&o.trace("getUnixShellEnvironment#stderr",B),m||T)return h(new Error(`Failed to get environment (code ${m}, signal ${T})`));const j=t.exec(I),ue=j?j[1]:"{}";try{const ce=JSON.parse(ue);f?ce.ELECTRON_RUN_AS_NODE=f:delete ce.ELECTRON_RUN_AS_NODE,c?ce.ELECTRON_NO_ATTACH_CONSOLE=c:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.XDG_RUNTIME_DIR,o.trace("getUnixShellEnvironment#result",ce),p(ce)}catch(ce){o.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(ce)),h(ce)}})});try{return await w}catch(p){return o.error("getUnixShellEnvironment#error",(0,k.toErrorMessage)(p)),{}}}}),define(me[87],ge([0,1,3,4,21]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(d){return d.map(y=>({type:y.type,resource:_.URI.file(y.path)}))}e.toFileChanges=k;function C(d){const y=new D;for(const i of d)y.processEvent(i);return y.normalize()}e.normalizeFileChanges=C;class D{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(y){const i=this.mapPathToChange.get(y.path);if(i){const A=i.type,E=y.type;A===1&&E===2?(this.mapPathToChange.delete(y.path),this.normalized.splice(this.normalized.indexOf(i),1)):A===2&&E===1?i.type=0:A===1&&E===0||(i.type=E)}else this.normalized.push(y),this.mapPathToChange.set(y.path,y)}normalize(){const y=[],i=[];return this.normalized.filter(A=>A.type!==2?(y.push(A),!1):!0).sort((A,E)=>A.path.length-E.path.length).filter(A=>i.some(E=>(0,g.isParent)(A.path,E,!S.isLinux))?!1:(i.push(A.path),!0)).concat(y)}}}),define(me[183],ge([0,1,13,2,5,125,16,127,87]),function(Q,e,S,_,g,k,C,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y extends _.Disposable{constructor(A,E,b,o){super();this.path=A,this.onDidFilesChange=E,this.onLogMessage=b,this.verboseLogging=o,this.fileChangesDelayer=this._register(new S.ThrottledDelayer(D.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(A){this.verboseLogging=A}async startWatching(){try{const{stat:A,symbolicLink:E}=await C.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(E)try{b=await(0,k.realpath)(b)}catch(o){if(this.onError(o),E.dangling)return}A.isDirectory()?this._register((0,D.watchFolder)(b,(o,u)=>{this.onFileChange({type:o==="changed"?0:o==="added"?1:2,path:(0,g.join)(this.path,(0,g.basename)(u))})},o=>this.onError(o))):this._register((0,D.watchFile)(b,o=>{this.onFileChange({type:o==="changed"?0:2,path:this.path})},o=>this.onError(o)))}catch(A){A.code!=="ENOENT"&&this.onError(A)}}onFileChange(A){this.fileChangesBuffer.push(A),this.verboseLogging&&this.onVerbose(`${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,d.normalizeFileChanges)(E);if(this.verboseLogging)for(const o of b)this.onVerbose(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);b.length>0&&this.onDidFilesChange(b)})}onError(A){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${A}`})}onVerbose(A){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${A}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=y}),define(me[62],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...g){this._entries=new Map;for(let[k,C]of g)this.set(k,C)}set(g,k){const C=this._entries.get(g);return this._entries.set(g,k),C}has(g){return this._entries.has(g)}get(g){return this._entries.get(g)}}e.ServiceCollection=S}),define(me[88],ge([0,1,13,11,59,176,6,62]),function(Q,e,S,_,g,k,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const d=!1;class y extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class i{constructor(o=new D.ServiceCollection,u=!1,w){this._activeInstantiations=new Set,this._services=o,this._strict=u,this._parent=w,this._services.set(C.IInstantiationService,this)}createChild(o){return new i(o,this._strict,this)}invokeFunction(o,...u){let w=E.traceInvocation(o),p=!1;try{return o({get:(f,c)=>{if(p)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(f,w);if(!a&&c!==C.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return a}},...u)}finally{p=!0,w.stop()}}createInstance(o,...u){let w,p;return o instanceof g.SyncDescriptor?(w=E.traceCreation(o.ctor),p=this._createInstance(o.ctor,o.staticArguments.concat(u),w)):(w=E.traceCreation(o),p=this._createInstance(o,u,w)),w.stop(),p}_createInstance(o,u=[],w){let p=C._util.getServiceDependencies(o).sort((c,a)=>c.index-a.index),h=[];for(const c of p){let a=this._getOrCreateServiceInstance(c.id,w);if(!a&&this._strict&&!c.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${c.id}.`);h.push(a)}let f=p.length>0?p[0].index:u.length;if(u.length!==f){console.warn(`[createInstance] First service dependency of ${o.name} at position ${f+1} conflicts with ${u.length} static arguments`);let c=f-u.length;c>0?u=u.concat(new Array(c)):u=u.slice(0,f)}return new o(...[...u,...h])}_setServiceInstance(o,u){if(this._services.get(o)instanceof g.SyncDescriptor)this._services.set(o,u);else if(this._parent)this._parent._setServiceInstance(o,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let u=this._services.get(o);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):u}_getOrCreateServiceInstance(o,u){let w=this._getServiceInstanceOrDescriptor(o);return w instanceof g.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,w,u.branch(o,!0)):(u.branch(o,!1),w)}_safeCreateAndCacheServiceInstance(o,u,w){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,u,w)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,u,w){const p=new k.Graph(c=>c.id.toString());let h=0;const f=[{id:o,desc:u,_trace:w}];for(;f.length;){const c=f.pop();if(p.lookupOrInsertNode(c),h++>1e3)throw new y(p);for(let a of C._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${o} depends on ${a.id} which is NOT registered.`),t instanceof g.SyncDescriptor){const s={id:a.id,desc:t,_trace:c._trace.branch(a.id,!0)};p.insertEdge(c,s),f.push(s)}}}for(;;){const c=p.roots();if(c.length===0){if(!p.isEmpty())throw new y(p);break}for(const{data:a}of c){if(this._getServiceInstanceOrDescriptor(a.id)instanceof g.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}p.removeNode(a)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,u,w=[],p,h){if(this._services.get(o)instanceof g.SyncDescriptor)return this._createServiceInstance(u,w,p,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,u,w,p,h);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(o,u=[],w,p){if(w){const h=new S.IdleValue(()=>this._createInstance(o,u,p));return new Proxy(Object.create(null),{get(f,c){if(c in f)return f[c];let a=h.value,t=a[c];return typeof t!="function"||(t=t.bind(a),f[c]=t),t},set(f,c,a){return h.value[c]=a,!0}})}else return this._createInstance(o,u,p)}}e.InstantiationService=i;var A;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(A||(A={}));class E{constructor(o,u){this.type=o,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return d?new E(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(o){return d?new E(0,o.name):E._None}branch(o,u){let w=new E(2,o.toString());return this._dep.push([o,u,w]),w}stop(){let o=Date.now()-this._start;E._totals+=o;let u=!1;function w(h,f){let c=[],a=new Array(h+1).join("	");for(const[t,s,n]of f._dep)if(s&&n){u=!0,c.push(`${a}CREATES -> ${t}`);let r=w(h+1,n);r&&c.push(r)}else c.push(`${a}uses -> ${t}`);return c.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(o>2||u)&&console.log(p.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(me[184],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,S.createDecorator)("labelService")}),define(me[63],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,S.createDecorator)("localizationsService");function _(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const k of g.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}e.isValidLocalization=_}),define(me[14],ge([0,1,43,7,2,3,6]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function D(){return new Date().toISOString()}var d;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;class y extends g.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class i extends y{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(d.Trace)&&this.log(d.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(d.Debug)&&this.log(d.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(d.Info)&&this.log(d.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(d.Warning)&&this.log(d.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(d.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(d.Error,this.format(n))}else this.log(d.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(d.Critical)&&this.log(d.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let n=0;n<t.length;n++){let r=t[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}s+=(n>0?" ":"")+r}return s}}e.AbstractMessageLogger=i;class A extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...s){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...s):console.log(`[main ${D()}]`,t,...s))}debug(t,...s){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...s):console.log(`[main ${D()}]`,t,...s))}info(t,...s){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...s):console.log(`[main ${D()}]`,t,...s))}warn(t,...s){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...s):console.warn(`[main ${D()}]`,t,...s))}error(t,...s){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...s):console.error(`[main ${D()}]`,t,...s))}critical(t,...s){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...s):console.error(`[main ${D()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=A;class E extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=E;class b extends y{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,S.toErrorMessage)(t,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class o extends y{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const n of this.logServices)n.trace(t,...s)}debug(t,...s){for(const n of this.logServices)n.debug(t,...s)}info(t,...s){for(const n of this.logServices)n.info(t,...s)}warn(t,...s){for(const n of this.logServices)n.warn(t,...s)}error(t,...s){for(const n of this.logServices)n.error(t,...s)}critical(t,...s){for(const n of this.logServices)n.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=o;class u extends g.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=u;class w extends g.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,s?.always?d.Trace:this.logLevel,s),this.loggers.set(t.toString(),n),s?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class p{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(t){}getLevel(){return d.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=p;function h(a){if(a.verbose)return d.Trace;if(typeof a.logLevel=="string"){const t=f(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function f(a){switch(a){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=f;function c(a){switch(a){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=c}),define(me[185],ge([0,1,13,11,2,3,19,49,4,23,16,29,32,33,21,14]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends g.Disposable{constructor(f,c,a,t){super();this.fileService=c,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=d.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,c){await this.cleanUpPromise;const a=this.getName(f),t=(0,C.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const s=(0,C.joinPath)(this.extensionsDownloadDir,`.${(0,y.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(f,s,c);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(s)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,s.path),n}}return t}async delete(f){}async rename(f,c,a){try{await i.Promises.rename(f.fsPath,c.fsPath)}catch(t){if(k.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${f} to ${c} with 'EPERM' error. Trying again...`),this.rename(f,c,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const c=[],a=[];for(const n of f.children){const r=this.parse(n.name);r&&a.push([r,n])}const t=(0,b.groupByExtension)(a,([n])=>n),s=[];for(const n of t)n.sort((r,l)=>D.rcompare(r[0].version,l[0].version)),c.push(...n.slice(1).map(r=>r[1].resource)),s.push(n[0][1]);s.sort((n,r)=>n.mtime-r.mtime),c.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(n=>n.resource)),await S.Promises.settled(c.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new b.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,y.generateUuid)()}parse(f){const c=w.exec(f);return c&&c[1]&&c[2]?new b.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};p=Le([Xe(0,A.INativeEnvironmentService),Xe(1,o.IFileService),Xe(2,E.IExtensionGalleryService),Xe(3,u.ILogService)],p),e.ExtensionsDownloader=p}),define(me[186],ge([0,1,35,13,43,7,2,8,5,16,29,14]),function(Q,e,S,_,g,k,C,D,d,y,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let E=class extends C.Disposable{constructor(o,u){super();this.environmentService=o,this.logService=u,this.processesLimiter=new _.Limiter(5)}async postUninstall(o){const u=this.parseScript(o,"uninstall");return u&&(this.logService.info(o.identifier.id,o.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(u.script,"uninstall",u.args,!0,o).then(()=>this.logService.info(o.identifier.id,o.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(o.identifier.id,o.manifest.version,`Failed to run post uninstall script: ${w}`)))),y.Promises.rm(this.getExtensionStoragePath(o)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(o,u){const w=`vscode:${u}`;if(o.location.scheme===D.Schemas.file&&o.manifest&&o.manifest.scripts&&typeof o.manifest.scripts[w]=="string"){const p=o.manifest.scripts[w].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(o.identifier.id,o.manifest.version,`${w} should be a node script`),null):{script:(0,d.join)(o.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(o,u,w,p,h){return new Promise((f,c)=>{const a=this.start(o,u,w,h);let t;const s=n=>{t&&(clearTimeout(t),t=null),n?c(n):f(void 0)};a.on("error",n=>{s((0,g.toErrorMessage)(n)||"Unknown")}),a.on("exit",(n,r)=>{s(n?`post-${u} process exited with code ${n}`:void 0)}),p&&(t=setTimeout(()=>{t=null,a.kill(),c("timed out")},5e3))})}start(o,u,w,p){const h={silent:!0,execArgv:void 0},f=(0,S.fork)(o,[`--type=extension-post-${u}`,...w],h);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const c=k.Event.fromNodeEventEmitter(f.stdout,"data"),a=k.Event.fromNodeEventEmitter(f.stderr,"data");c(n=>this.logService.info(p.identifier.id,p.manifest.version,`post-${u}`,n)),a(n=>this.logService.error(p.identifier.id,p.manifest.version,`post-${u}`,n));const t=k.Event.any(k.Event.map(c,n=>({data:`%c${n}`,format:[""]})),k.Event.map(a,n=>({data:`%c${n}`,format:["color: red"]})));return k.Event.debounce(t,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(p.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(o){return(0,d.join)(this.environmentService.globalStorageHome.fsPath,o.identifier.id.toLowerCase())}};E=Le([Xe(0,i.IEnvironmentService),Xe(1,A.ILogService)],E),e.ExtensionsLifecycle=E}),define(me[187],ge([0,1,7,2,19,4,29,33,21,14]),function(Q,e,S,_,g,k,C,D,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends _.Disposable{constructor(E,b,o,u){super();this.extensionsManagementService=E,this.logService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new S.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(h=>{this.installedExtensions=h.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(E.onInstallExtension(h=>this.onInstallExtension(h))),this._register(E.onDidInstallExtensions(h=>this.onDidInstallExtensions(h))),this._register(E.onDidUninstallExtension(h=>this.onDidUninstallExtension(h)));const w=k.URI.file(o.extensionsPath),p=new g.ExtUri(h=>!b.hasCapability(h,1024));this._register(b.watch(w)),this._register(S.Event.filter(b.onDidChangeFilesRaw,h=>h.changes.some(f=>this.doesChangeAffects(f,w,p)))(()=>this.onDidChange()))}doesChangeAffects(E,b,o){return o.isEqual(o.dirname(E.resource),b)?o.isEqual(E.resource,o.joinPath(b,".obsolete"))?!0:!(E.type!==1&&E.type!==2||o.basename(E.resource).startsWith(".")):!1}onInstallExtension(E){this.addInstallingExtension(E.identifier)}onDidInstallExtensions(E){for(const b of E)this.removeInstallingExtension(b.identifier),b.local&&this.addInstalledExtension(b.identifier)}onDidUninstallExtension(E){E.error||this.removeInstalledExtension(E.identifier)}addInstallingExtension(E){this.removeInstallingExtension(E),this.installingExtensions.push(E)}removeInstallingExtension(E){this.installingExtensions=this.installingExtensions.filter(b=>!(0,D.areSameExtensions)(b,E))}addInstalledExtension(E){this.installedExtensions&&(this.removeInstalledExtension(E),this.installedExtensions.push(E))}removeInstalledExtension(E){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,D.areSameExtensions)(b,E)))}async onDidChange(){if(this.installedExtensions){const E=await this.extensionsManagementService.getInstalled(1),b=E.filter(u=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,D.areSameExtensions)(w,u.identifier))?!1:u.installedTimestamp&&u.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",u.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",u.identifier.id),!1)),o=this.installedExtensions.filter(u=>this.installingExtensions.some(w=>(0,D.areSameExtensions)(w,u))?!1:E.every(w=>!(0,D.areSameExtensions)(w.identifier,u))?(this.logService.info("Detected extension removed from another source",u.id),!0):!1);this.installedExtensions=E.map(u=>u.identifier),(b.length||o.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:o})}}};i=Le([Xe(1,d.IFileService),Xe(2,C.INativeEnvironmentService),Xe(3,y.ILogService)],i),e.ExtensionsWatcher=i}),define(me[89],ge([0,1,64,20,13,2,8,5,16,29,32,33,63,14]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let o=class extends k.Disposable{constructor(p,h,f){super();this.extensionManagementService=p,this.logService=f,this.cache=this._register(new u(h,f)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const p=await this.cache.getLanguagePacks(),h=["en",...Object.keys(p)];return(0,_.distinct)(h)}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const h=await this.cache.getLanguagePacks();Object.keys(h).some(f=>h[f]&&h[f].extensions.some(c=>(0,A.areSameExtensions)(c.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,h]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(h);return!(0,_.equals)(Object.keys(p),Object.keys(f))}};o=Le([Xe(0,i.IExtensionManagementService),Xe(1,y.INativeEnvironmentService),Xe(2,b.ILogService)],o),e.LocalizationsService=o;let u=class extends k.Disposable{constructor(p,h){super();this.logService=h,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new g.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(h=>{Object.keys(h).forEach(f=>delete h[f]),this.createLanguagePacksFromExtensions(h,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...h){for(const f of h)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,f);Object.keys(p).forEach(f=>this.updateHash(p[f]))}createLanguagePacksFromExtension(p,h){const f=h.identifier,c=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const a of c)if(h.location.scheme===C.Schemas.file&&(0,E.isValidLocalization)(a)){let t=p[a.languageId];t||(t={hash:"",extensions:[],translations:{}},p[a.languageId]=t);let s=t.extensions.filter(n=>(0,A.areSameExtensions)(n.extensionIdentifier,f))[0];s?s.version=h.manifest.version:t.extensions.push({extensionIdentifier:f,version:h.manifest.version});for(const n of a.translations)t.translations[n.id]=(0,D.join)(h.location.fsPath,n.path)}}updateHash(p){if(p){const h=(0,S.createHash)("md5");for(const f of p.extensions)h.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);p.hash=h.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let h=null;return d.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(c){return{}}}).then(f=>(h=p(f),f)).then(f=>{for(const a of Object.keys(f))f[a]||delete f[a];this.languagePacks=f,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),d.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>h,f=>this.logService.error(f))})}};u=Le([Xe(0,y.INativeEnvironmentService),Xe(1,b.ILogService)],u)}),define(me[90],ge([0,1,7,4,14]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(E){this.service=E,this.onDidChangeLogLevel=S.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(E,b,o){switch(b){case"setLevel":return this.service.setLevel(o)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=k;class C{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){C.setLevel(this.channel,E)}static setLevel(E,b){return E.call("setLevel",b)}}e.LogLevelChannelClient=C;class D{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,b){throw new Error(`Event not found: ${b}`)}async call(E,b,o){switch(b){case"createLogger":this.createLogger(_.URI.revive(o[0]),o[1]);return;case"log":return this.log(_.URI.revive(o[0]),o[1]);case"consoleLog":return this.consoleLog(o[0],o[1])}throw new Error(`Call not found: ${b}`)}createLogger(E,b){this.loggers.set(E.toString(),this.loggerService.createLogger(E,b))}consoleLog(E,b){let o=console.log;switch(E){case g.LogLevel.Error:o=console.error;break;case g.LogLevel.Warning:o=console.warn;break;case g.LogLevel.Info:o=console.info;break}o.call(console,...b)}log(E,b){const o=this.loggers.get(E.toString());if(!o)throw new Error("Create the logger before logging");for(const[u,w]of b)switch(u){case g.LogLevel.Trace:o.trace(w);break;case g.LogLevel.Debug:o.debug(w);break;case g.LogLevel.Info:o.info(w);break;case g.LogLevel.Warning:o.warn(w);break;case g.LogLevel.Error:o.error(w);break;case g.LogLevel.Critical:o.critical(w);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=D;class d extends g.AbstractLoggerService{constructor(E,b,o){super(E,b);this.channel=o}createConsoleMainLogger(){return new g.AdapterLogger({log:(E,b)=>{this.channel.call("consoleLog",[E,b])}})}doCreateLogger(E,b,o){return new y(this.channel,E,b,o)}}e.LoggerChannelClient=d;class y extends g.AbstractMessageLogger{constructor(E,b,o,u){super(u?.always);this.channel=E,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(o),this.channel.call("createLogger",[b,u]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,b){const o=[[E,b]];this.isLoggerCreated?this.doLog(o):this.buffer.push(...o)}doLog(E){this.channel.call("log",[this.file,E])}}class i extends g.LogService{constructor(E,b){super(b);this.parent=E,this._register(E.onDidChangeLogLevel(o=>b.setLevel(o)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=i}),define(me[91],ge([0,1,21,14]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function g(d,y,i,A){try{const E=await new Promise((b,o)=>{Q(["spdlog"],b,o)});return E.setFlushOn(_.LogLevel.Trace),E.createAsyncRotatingLogger(d,y,i,A)}catch(E){console.error(E)}return null}function k(d,y,i,A){const E=Q.__$__nodeRequire("spdlog");return E.setFlushOn(_.LogLevel.Trace),E.createRotatingLogger(d,y,i,A)}e.createRotatingLogger=k;function C(d,y,i){switch(y){case _.LogLevel.Trace:d.trace(i);break;case _.LogLevel.Debug:d.debug(i);break;case _.LogLevel.Info:d.info(i);break;case _.LogLevel.Warning:d.warn(i);break;case _.LogLevel.Error:d.error(i);break;case _.LogLevel.Critical:d.critical(i);break;default:throw new Error("Invalid log level")}}class D extends _.AbstractMessageLogger{constructor(y,i,A,E){super();this.name=y,this.filepath=i,this.rotating=A,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}_createSpdLogLogger(){const y=this.rotating?6:1,i=30/y*S.ByteSize.MB;return g(this.name,this.filepath,i,y).then(A=>{if(A){this._logger=A,this._logger.setLevel(this.getLevel());for(const{level:E,message:b}of this.buffer)C(this._logger,E,b);this.buffer=[]}})}log(y,i){this._logger?C(this._logger,y,i):this.getLevel()<=y&&this.buffer.push({level:y,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(me[188],ge([0,1,73,153,6]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var k;(function(d){d[d.Unnecessary=1]="Unnecessary",d[d.Deprecated=2]="Deprecated"})(k=e.MarkerTag||(e.MarkerTag={}));var C;(function(d){d[d.Hint=1]="Hint",d[d.Info=2]="Info",d[d.Warning=4]="Warning",d[d.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(d){function y(o,u){return u-o}d.compare=y;const i=Object.create(null);i[d.Error]=(0,_.localize)(0,null),i[d.Warning]=(0,_.localize)(1,null),i[d.Info]=(0,_.localize)(2,null);function A(o){return i[o]||""}d.toString=A;function E(o){switch(o){case S.default.Error:return d.Error;case S.default.Warning:return d.Warning;case S.default.Info:return d.Info;case S.default.Ignore:return d.Hint}}d.fromSeverity=E;function b(o){switch(o){case d.Error:return S.default.Error;case d.Warning:return S.default.Warning;case d.Info:return S.default.Info;case d.Hint:return S.default.Ignore}}d.toSeverity=b}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(d){const y="";function i(E){return A(E,!0)}d.makeKey=i;function A(E,b){let o=[y];return E.source?o.push(E.source.replace("\xA6","\\\xA6")):o.push(y),E.code?typeof E.code=="string"?o.push(E.code.replace("\xA6","\\\xA6")):o.push(E.code.value.replace("\xA6","\\\xA6")):o.push(y),E.severity!==void 0&&E.severity!==null?o.push(C.toString(E.severity)):o.push(y),E.message&&b?o.push(E.message.replace("\xA6","\\\xA6")):o.push(y),E.startLineNumber!==void 0&&E.startLineNumber!==null?o.push(E.startLineNumber.toString()):o.push(y),E.startColumn!==void 0&&E.startColumn!==null?o.push(E.startColumn.toString()):o.push(y),E.endLineNumber!==void 0&&E.endLineNumber!==null?o.push(E.endLineNumber.toString()):o.push(y),E.endColumn!==void 0&&E.endColumn!==null?o.push(E.endColumn.toString()):o.push(y),o.push(y),o.join("\xA6")}d.makeKeyOptionalMessage=A})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,g.createDecorator)("markerService")}),define(me[189],ge([0,1,7,73,6]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,g.createDecorator)("notificationService");var k;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.GLOBAL=1]="GLOBAL"})(k=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(y){y[y.OFF=0]="OFF",y[y.SILENT=1]="SILENT",y[y.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new d,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=D;class d{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=d}),define(me[30],ge([0,1,8,3,22,19]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof _.globals.vscode!="undefined"&&typeof _.globals.vscode.context!="undefined"){const D=_.globals.vscode.context.configuration();if(D)C=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const D=(0,k.dirname)(S.FileAccess.asFileUri("",Q));C=Q.__$__nodeRequire((0,k.joinPath)(D,"product.json").fsPath);const d=Q.__$__nodeRequire((0,k.joinPath)(D,"package.json").fsPath);g.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`}),Object.assign(C,{version:d.version})}else C={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://vscodeweb.azureedge.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-webview.net/{{quality}}/{{commit}}",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","msjsdiag.debugger-for-chrome":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","austin.code-gnu-global":"{**/*.c,**/*.cpp,**/*.h}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","dbaeumer.jshint":"{**/*.js,**/*.jsx,**/*.es6,**/.babelrc,**/jsconfig.json,**/.jshintrc,**/.jshintignore}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","felixfbecker.php-intellisense":"{**/*.php,**/php.ini}","felixfbecker.php-debug":"{**/*.php,**/php.ini}","ikappas.phpcs":"{**/*.php,**/php.ini}","rust-lang.rust":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc,**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.babelrc,**/jsconfig.json}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","shinnn.stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","bajdzis.vscode-database":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","hiro-sun.vscode-emacs","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","octref.vetur","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",telemetryOptOutUrl:"https://go.microsoft.com/fwlink/?linkid=870136",npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionAllowedProposedApi:["GitHub.codespaces","GitHub.copilot-nightly","GitHub.copilot","GitHub.vscode-pull-request-github-insiders","GitHub.vscode-pull-request-github","GitHub.remotehub","GitHub.remotehub-insiders","Microsoft.vscode-nmake-tools","ms-ai-tools.notebook-renderers","ms-dotnettools.dotnet-interactive-vscode","ms-python.gather","ms-python.python","ms-toolsai.jupyter","ms-toolsai.vscode-ai","ms-toolsai.vscode-ai-remote","ms-vscode-remote.remote-containers-nightly","ms-vscode-remote.remote-containers","ms-vscode-remote.remote-ssh-edit-nightly","ms-vscode-remote.remote-ssh-edit","ms-vscode-remote.remote-ssh-nightly","ms-vscode-remote.remote-ssh","ms-vscode-remote.remote-wsl-nightly","ms-vscode-remote.remote-wsl","ms-vscode-remote.remote-wsl-recommender","ms-vscode-remote.vscode-remote-extensionpack-nightly","ms-vscode-remote.vscode-remote-extensionpack","ms-vscode.anycode","ms-vscode.azure-account","ms-vscode.azure-sphere-tools-ui","ms-vscode.azure-sphere-tools","ms-vscode.remotehub","ms-vscode.remotehub-insiders","ms-vscode.js-debug-nightly","ms-vscode.js-debug","ms-vscode.lsif-browser","ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.vscode-selfhost-test-provider","ms-vscode.test-adapter-converter","ms-vsliveshare.cloudenv-explorer","ms-vsliveshare.cloudenv","ms-vsliveshare.vsliveshare","ms-vsonline.vsonline","dbaeumer.vscode-eslint","tanhakabir.rest-book","ms-playwright.playwright","VisualStudioExptTeam.vscodeintellicode","VisualStudioExptTeam.vscodeintellicode-insiders","VisualStudioExptTeam.vscodeintellicode-completions","vscode.vscode-web-playground","ms-azuretools.vscode-azureappservice","sandy081.999-test-github-issue-notebooks"],tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"manasxx.background-cover":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"liviuschera.noctis":["ui","workspace"],"vscodevim.vim":["ui"],"tuttieee.emacs-mcx":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"redhat.vscode-yaml":{default:!1},"felixfbecker.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"felixfbecker.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"batisteo.vscode-django":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://client-auth-staging-14a768b.herokuapp.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.references-view",version:"0.0.80",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.15",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.60.2",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.18",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.11",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.60.1",commit:"83bd43bc519d15e50c4272c6cf5c1479df196a4d",date:"2021-09-10T16:53:56.778Z"},Object.keys(C).length===0&&Object.assign(C,{version:"1.60.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=C}),define(me[92],ge([0,1,17,11,151,21,30]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(A,E,b,o,u,w){let p;try{await d(A,E,b,o,u,w)}catch(h){p=h}finally{p&&u.errorTransformer&&(p=u.errorTransformer(p)),typeof p!="undefined"&&b.error(p),b.end()}}e.readFileIntoStream=D;async function d(A,E,b,o,u,w){y(w);const p=await A.open(E,{create:!1});try{y(w);let h=0,f=0,c=u&&typeof u.length=="number"?u.length:void 0,a=S.VSBuffer.alloc(Math.min(u.bufferSize,typeof c=="number"?c:u.bufferSize)),t=u&&typeof u.position=="number"?u.position:0,s=0;do f=await A.read(p,t,a.buffer,s,a.byteLength-s),t+=f,s+=f,h+=f,typeof c=="number"&&(c-=f),s===a.byteLength&&(await b.write(o(a)),a=S.VSBuffer.alloc(Math.min(u.bufferSize,typeof c=="number"?c:u.bufferSize)),s=0);while(f>0&&(typeof c!="number"||c>0)&&y(w)&&i(h,u));if(s>0){let n=s;typeof c=="number"&&(n=Math.min(s,c)),b.write(o(a.slice(0,n)))}}catch(h){throw(0,k.ensureFileSystemProviderError)(h)}finally{await A.close(p)}}function y(A){if(A.isCancellationRequested)throw(0,_.canceled)();return!0}function i(A,E){if(E?.limits){if(typeof E.limits.memory=="number"&&A>E.limits.memory)throw(0,k.createFileSystemProviderError)((0,g.localize)(0,null,C.default.nameShort),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&A>E.limits.size)throw(0,k.createFileSystemProviderError)((0,g.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(me[93],ge([0,1,20,13,17,25,7,51,2,27,8,48,19,42,149,21,92,14]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let h=class bt extends d.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new C.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new _.ThrottledWorker(bt.FILE_EVENTS_THROTTLING.maxChangesChunkSize,bt.FILE_EVENTS_THROTTLING.maxChangesBufferSize,bt.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new u.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new _.ThrottledWorker(bt.FILE_EVENTS_THROTTLING.maxChangesChunkSize,bt.FILE_EVENTS_THROTTLING.maxChangesBufferSize,bt.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new u.FileChangesEvent(a,!0)))),this.watchedResources=y.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new _.ResourceQueue)}registerProvider(c,a){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,A.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:a});const t=new d.DisposableStore;return t.add(a.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:c}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:a}),this.provider.delete(c),(0,d.dispose)(t)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(t){a.push(t)}}),!this.provider.has(c)&&await _.Promises.settled(a)}canHandleResource(c){return this.provider.has(c.scheme)}hasCapability(c,a){const t=this.provider.get(c.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return D.Iterable.map(this.provider,([c,a])=>({scheme:c,capabilities:a.capabilities}))}async withProvider(c){if(!(0,E.isAbsolutePath)(c))throw new u.FileOperationError((0,o.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const a=this.provider.get(c.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,o.localize)(1,null,c.toString()),t}return a}async withReadProvider(c){const a=await this.withProvider(c);if((0,u.hasOpenReadWriteCloseCapability)(a)||(0,u.hasReadWriteCapability)(a)||(0,u.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const a=await this.withProvider(c);if((0,u.hasOpenReadWriteCloseCapability)(a)||(0,u.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,a){try{return await this.doResolveFile(c,a)}catch(t){throw(0,u.toFileSystemProviderErrorCode)(t)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,o.localize)(2,null,this.resourceForError(c)),1):(0,u.ensureFileSystemProviderError)(t)}}async doResolveFile(c,a){const t=await this.withProvider(c),s=this.isPathCaseSensitive(t),n=a?.resolveTo,r=a?.resolveSingleChildDescendants,l=a?.resolveMetadata,v=await t.stat(c);let P;return this.toFileStat(t,c,v,void 0,!!l,(L,R)=>{if(!P&&(P=y.TernarySearchTree.forUris(()=>!s),P.set(c,!0),n))for(const m of n)P.set(m,!0);return P.get(L.resource)||P.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&r?R===1:!1})}async toFileStat(c,a,t,s,n,r){const{providerExtUri:l}=this.getExtUri(c),v={resource:a,name:l.basename(a),isFile:(t.type&u.FileType.File)!=0,isDirectory:(t.type&u.FileType.Directory)!=0,isSymbolicLink:(t.type&u.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&u.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,u.etag)({mtime:t.mtime,size:t.size})};if(v.isDirectory&&r(v,s)){try{const P=await c.readdir(a),L=await _.Promises.settled(P.map(async([R,m])=>{try{const T=l.joinPath(a,R),I=n?await c.stat(T):{type:m};return await this.toFileStat(c,T,I,P.length,n,r)}catch(T){return this.logService.trace(T),null}}));v.children=(0,S.coalesce)(L)}catch(P){this.logService.trace(P),v.children=[]}return v}return v}async resolveAll(c){return _.Promises.settled(c.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(c){const a=await this.withProvider(c);try{return!!await a.stat(c)}catch(t){return!1}}async canCreateFile(c,a){try{await this.doValidateCreateFile(c,a)}catch(t){return t}return!0}async doValidateCreateFile(c,a){if(!a?.overwrite&&await this.exists(c))throw new u.FileOperationError((0,o.localize)(3,null,this.resourceForError(c)),3,a)}async createFile(c,a=g.VSBuffer.fromString(""),t){await this.doValidateCreateFile(c,t);const s=await this.writeFile(c,a);return this._onDidRunOperation.fire(new u.FileOperationEvent(c,0,s)),s}async writeFile(c,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(s);try{await this.validateWriteFile(s,c,t)||await this.mkdirp(s,n.dirname(c));let l;if((0,u.hasReadWriteCapability)(s)&&!(a instanceof g.VSBuffer))if((0,b.isReadableStream)(a)){const v=await(0,b.peekStream)(a,3);v.ended?l=g.VSBuffer.concat(v.buffer):l=v}else l=(0,b.peekReadable)(a,v=>g.VSBuffer.concat(v),3);else l=a;!(0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s)&&l instanceof g.VSBuffer?await this.doWriteUnbuffered(s,c,t,l):await this.doWriteBuffered(s,c,t,l instanceof g.VSBuffer?(0,g.bufferToReadable)(l):l)}catch(r){throw new u.FileOperationError((0,o.localize)(4,null,this.resourceForError(c),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),t)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,a,t){if(!!t?.unlock&&!(c.capabilities&8192))throw new Error((0,o.localize)(5,null,this.resourceForError(a)));let n;try{n=await c.stat(a)}catch(r){return}if((n.type&u.FileType.Directory)!=0)throw new u.FileOperationError((0,o.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,n),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==u.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,u.etag)({mtime:t.mtime,size:n.size}))throw new u.FileOperationError((0,o.localize)(7,null),3,t);return n}async readFile(c,a){const t=await this.withReadProvider(c);return a?.atomic?this.doReadFileAtomic(t,c,a):this.doReadFile(t,c,a)}async doReadFileAtomic(c,a,t){return new Promise((s,n)=>{this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(c,a,t);s(r)}catch(r){n(r)}})})}async doReadFile(c,a,t){const s=await this.doReadFileStream(c,a,{...t,preferUnbuffered:!0});return{...s,value:await(0,g.streamToBuffer)(s.value)}}async readFileStream(c,a){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,a)}async doReadFileStream(c,a,t){const s=new k.CancellationTokenSource,n=this.validateReadFile(a,t).then(l=>l,l=>{throw s.cancel(),l});let r;try{return typeof t?.etag=="string"&&t.etag!==u.ETAG_DISABLED&&await n,!((0,u.hasOpenReadWriteCloseCapability)(c)||(0,u.hasFileReadStreamCapability)(c))||(0,u.hasReadWriteCapability)(c)&&t?.preferUnbuffered?r=this.readFileUnbuffered(c,a,t):(0,u.hasFileReadStreamCapability)(c)?r=this.readFileStreamed(c,a,s.token,t):r=this.readFileBuffered(c,a,s.token,t),{...await n,value:r}}catch(l){r&&await(0,b.consumeStream)(r);const v=(0,o.localize)(8,null,this.resourceForError(a),(0,u.ensureFileSystemProviderError)(l).toString());throw l instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(v,l.stat,t):new u.FileOperationError(v,(0,u.toFileOperationResult)(l),t)}}readFileStreamed(c,a,t,s=Object.create(null)){const n=c.readFileStream(a,s,t);return(0,b.transform)(n,{data:r=>r instanceof g.VSBuffer?r:g.VSBuffer.wrap(r),error:r=>new u.FileOperationError((0,o.localize)(9,null,this.resourceForError(a),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),s)},r=>g.VSBuffer.concat(r))}readFileBuffered(c,a,t,s=Object.create(null)){const n=(0,g.newWriteableBufferStream)();return(0,w.readFileIntoStream)(c,a,n,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new u.FileOperationError((0,o.localize)(10,null,this.resourceForError(a),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),s)},t),n}readFileUnbuffered(c,a,t){const s=(0,b.newWriteableStream)(n=>g.VSBuffer.concat(n));return(async()=>{try{let n=await c.readFile(a);typeof t?.position=="number"&&(n=n.slice(t.position)),typeof t?.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(a,n.byteLength,t),s.end(g.VSBuffer.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async validateReadFile(c,a){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new u.FileOperationError((0,o.localize)(11,null,this.resourceForError(c)),0,a);if(typeof a?.etag=="string"&&a.etag!==u.ETAG_DISABLED&&a.etag===t.etag)throw new u.NotModifiedSinceFileOperationError((0,o.localize)(12,null),t,a);return this.validateReadFileLimits(c,t.size,a),t}validateReadFileLimits(c,a,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&a>t.limits.size&&(s=7),typeof s=="number")throw new u.FileOperationError((0,o.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,a,t){return this.doCanMoveCopy(c,a,"move",t)}async canCopy(c,a,t){return this.doCanMoveCopy(c,a,"copy",t)}async doCanMoveCopy(c,a,t,s){if(c.toString()!==a.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(n,c,r,a,t,s)}catch(n){return n}return!0}async move(c,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,c,n,a,"move",!!t),l=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(c,r==="move"?2:3,l)),l}async copy(c,a,t){const s=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,c,n,a,"copy",!!t),l=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(c,r==="copy"?3:2,l)),l}async doMoveCopy(c,a,t,s,n,r){if(a.toString()===s.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:v}=await this.doValidateMoveCopy(c,a,t,s,n,r);if(l&&!v&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),n==="copy"){if(c===t&&(0,u.hasFileFolderCopyCapability)(c))await c.copy(a,s,{overwrite:r});else{const P=await this.resolve(a);P.isDirectory?await this.doCopyFolder(c,P,t,s):await this.doCopyFile(c,a,t,s)}return n}else return c===t?(await c.rename(a,s,{overwrite:r}),n):(await this.doMoveCopy(c,a,t,s,"copy",r),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(c,a,t,s){if((0,u.hasOpenReadWriteCloseCapability)(c)&&(0,u.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(c,a,t,s);if((0,u.hasOpenReadWriteCloseCapability)(c)&&(0,u.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(c,a,t,s);if((0,u.hasReadWriteCapability)(c)&&(0,u.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(c,a,t,s);if((0,u.hasReadWriteCapability)(c)&&(0,u.hasReadWriteCapability)(t))return this.doPipeUnbuffered(c,a,t,s)}async doCopyFolder(c,a,t,s){await t.mkdir(s),Array.isArray(a.children)&&await _.Promises.settled(a.children.map(async n=>{const r=this.getExtUri(t).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),t,r):this.doCopyFile(c,n.resource,t,r)}))}async doValidateMoveCopy(c,a,t,s,n,r){let l=!1;if(c===t){const{providerExtUri:P,isPathCaseSensitive:L}=this.getExtUri(c);if(L||(l=P.isEqual(a,s)),l&&n==="copy")throw new Error((0,o.localize)(14,null,this.resourceForError(a),this.resourceForError(s)));if(!l&&P.isEqualOrParent(s,a))throw new Error((0,o.localize)(15,null,this.resourceForError(a),this.resourceForError(s)))}const v=await this.exists(s);if(v&&!l){if(!r)throw new u.FileOperationError((0,o.localize)(16,null,this.resourceForError(a),this.resourceForError(s)),4);if(c===t){const{providerExtUri:P}=this.getExtUri(c);if(P.isEqualOrParent(a,s))throw new Error((0,o.localize)(17,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:v,isSameResourceWithDifferentPathCase:l}}getExtUri(c){const a=this.isPathCaseSensitive(c);return{providerExtUri:a?E.extUri:E.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(a,c);const t=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(c,0,t)),t}async mkdirp(c,a){const t=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(a,s.dirname(a));)try{if(((await c.stat(a)).type&u.FileType.Directory)==0)throw new Error((0,o.localize)(18,null,this.resourceForError(a)));break}catch(n){if((0,u.toFileSystemProviderErrorCode)(n)!==u.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(s.basename(a)),a=s.dirname(a)}for(let n=t.length-1;n>=0;n--){a=s.joinPath(a,t[n]);try{await c.mkdir(a)}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,a){try{await this.doValidateDelete(c,a)}catch(t){return t}return!0}async doValidateDelete(c,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,o.localize)(19,null,this.resourceForError(c)));let n;try{n=await t.stat(c)}catch(l){}if(n)this.throwIfFileIsReadonly(c,n);else throw new u.FileOperationError((0,o.localize)(20,null,this.resourceForError(c)),1);if(!!!a?.recursive){const l=await this.resolve(c);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,o.localize)(21,null,this.resourceForError(c)))}return t}async del(c,a){const t=await this.doValidateDelete(c,a),s=!!a?.useTrash,n=!!a?.recursive;await t.delete(c,{recursive:n,useTrash:s}),this._onDidRunOperation.fire(new u.FileOperationEvent(c,1))}onDidChangeFile(c,a){this._onDidChangeFilesRaw.fire({changes:c});let t,s;{for(const n of c)this.watchedResources.has(n.resource)?(t||(t=[]),t.push(n)):(s||(s=[]),s.push(n));t&&this._onDidFilesChange.fire(new u.FileChangesEvent(t,!a))}if(s){const n=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(s)&&bt.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,a={recursive:!1,excludes:[]}){const t=new d.DisposableStore;{let s=!1,n=()=>{s=!0};t.add((0,d.toDisposable)(()=>n())),this.doWatch(c,a).then(r=>{s?(0,d.dispose)(r):n=()=>(0,d.dispose)(r)},r=>this.logService.error(r))}return a.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),t.add((0,d.toDisposable)(()=>{const s=this.watchedResources.get(c);typeof s=="number"&&(s<=1?this.watchedResources.delete(c):this.watchedResources.set(c,s-1))}))),t}async doWatch(c,a){const t=await this.withProvider(c),s=this.toWatchKey(t,c,a),n=this.activeWatchers.get(s)||{count:0,disposable:t.watch(c,a)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,n),n.count+=1,(0,d.toDisposable)(()=>{n.count--,n.count===0&&((0,d.dispose)(n.disposable),this.activeWatchers.delete(s))})}toWatchKey(c,a,t){const{providerExtUri:s}=this.getExtUri(c);return[s.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,d.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,b.isReadableStream)(s)||(0,b.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,n,s):await this.doWriteReadableBufferedQueued(c,n,s)}catch(r){throw(0,u.ensureFileSystemProviderError)(r)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,a,t){let s=0,n;if((0,b.isReadableBufferedStream)(t)){if(t.buffer.length>0){const r=g.VSBuffer.concat(t.buffer);await this.doWriteBuffer(c,a,r,r.byteLength,s,0),s+=r.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(r,l)=>{(0,b.listenStream)(n,{onData:async v=>{n.pause();try{await this.doWriteBuffer(c,a,v,v.byteLength,s,0)}catch(P){return l(P)}s+=v.byteLength,setTimeout(()=>n.resume())},onError:v=>l(v),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,a,t){let s=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(c,a,n,n.byteLength,s,0),s+=n.byteLength}async doWriteBuffer(c,a,t,s,n,r){let l=0;for(;l<s;)l+=await c.write(a,n+l,t.buffer,r+l,s-l)}async doWriteUnbuffered(c,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,a,t,s))}async doWriteUnbufferedQueued(c,a,t,s){let n;s instanceof g.VSBuffer?n=s:(0,b.isReadableStream)(s)?n=await(0,g.streamToBuffer)(s):(0,b.isReadableBufferedStream)(s)?n=await(0,g.bufferedStreamToBuffer)(s):n=(0,g.readableToBuffer)(s),await c.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,a,t,s))}async doPipeBufferedQueued(c,a,t,s){let n,r;try{n=await c.open(a,{create:!1}),r=await t.open(s,{create:!0,unlock:!1});const l=g.VSBuffer.alloc(this.BUFFER_SIZE);let v=0,P=0,L=0;do L=await c.read(n,v,l.buffer,P,l.byteLength-P),await this.doWriteBuffer(t,r,l,L,v,P),v+=L,P+=L,P===l.byteLength&&(P=0);while(L>0)}catch(l){throw(0,u.ensureFileSystemProviderError)(l)}finally{await _.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof r=="number"?t.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,a,t,s))}async doPipeUnbufferedQueued(c,a,t,s){return t.writeFile(s,await c.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,a,t,s))}async doPipeUnbufferedToBufferedQueued(c,a,t,s){const n=await t.open(s,{create:!0,unlock:!1});try{const r=await c.readFile(a);await this.doWriteBuffer(t,n,g.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,u.ensureFileSystemProviderError)(r)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(c,a,t,s){const n=await(0,g.streamToBuffer)(this.readFileBuffered(c,a,k.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,n)}throwIfFileSystemIsReadonly(c,a){if(c.capabilities&2048)throw new u.FileOperationError((0,o.localize)(22,null,this.resourceForError(a)),6);return c}throwIfFileIsReadonly(c,a){if((a.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,o.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===i.Schemas.file?c.fsPath:c.toString(!0)}};h.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},h=Le([Xe(0,p.ILogService)],h),e.FileService=h}),define(me[65],ge([0,1,20,13,17,7,26,2,5,3,19,42,16,152,21,92,183,172,173,87,175,14]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w,p,h,f,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends D.Disposable{constructor(n,r){super();this.logService=n,this.options=r,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new _.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,y.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:r,symbolicLink:l}=await E.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(r,l),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(n){try{const r=await E.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),l=[];return await Promise.all(r.map(async v=>{try{let P;v.isSymbolicLink()?P=(await this.stat((0,i.joinPath)(n,v.name))).type:P=this.toType(v),l.push([v.name,P])}catch(P){this.logService.trace(P)}})),l}catch(r){throw this.toFileSystemProviderError(r)}}toType(n,r){let l;return r?.dangling?l=o.FileType.Unknown:n.isFile()?l=o.FileType.File:n.isDirectory()?l=o.FileType.Directory:l=o.FileType.Unknown,r&&(l|=o.FileType.SymbolicLink),l}async readFile(n){try{const r=this.toFilePath(n);return await E.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(n,r,l){const v=(0,A.newWriteableStream)(P=>g.VSBuffer.concat(P.map(L=>g.VSBuffer.wrap(L))).buffer);return(0,u.readFileIntoStream)(this,n,v,P=>P.buffer,{...r,bufferSize:this.BUFFER_SIZE},l),v}async writeFile(n,r,l){let v;try{const P=this.toFilePath(n);if(!l.create||!l.overwrite){if(await E.Promises.exists(P)){if(!l.overwrite)throw(0,o.createFileSystemProviderError)((0,b.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,o.createFileSystemProviderError)((0,b.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(n,{create:!0,unlock:l.unlock}),await this.write(v,0,r,0,r.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(n,P)}finally{typeof v=="number"&&await this.close(v)}}async open(n,r){try{const l=this.toFilePath(n);if((0,o.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:L}=await E.SymlinkSupport.stat(l);L.mode&128||await E.Promises.chmod(l,L.mode|128)}catch(L){this.logService.trace(L)}let v;if((0,o.isFileOpenForWriteOptions)(r)){if(y.isWindows)try{await E.Promises.truncate(l,0),v="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}v||(v="w")}else v="r";const P=await E.Promises.open(l,v);return this.mapHandleToPos.set(P,0),(0,o.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(P,n),P}catch(l){throw(0,o.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(n,l):this.toFileSystemProviderError(l)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await E.Promises.fdatasync(n)}catch(r){this.canFlush=!1,this.logService.error(r)}return await E.Promises.close(n)}catch(r){throw this.toFileSystemProviderError(r)}}async read(n,r,l,v,P){const L=this.normalizePos(n,r);let R=null;try{const m=await E.Promises.read(n,l,v,P,L);return typeof m=="number"?R=m:R=m.bytesRead,R}catch(m){throw this.toFileSystemProviderError(m)}finally{this.updatePos(n,L,R)}}normalizePos(n,r){return r===this.mapHandleToPos.get(n)?null:r}updatePos(n,r,l){const v=this.mapHandleToPos.get(n);typeof v=="number"&&(typeof r=="number"||(typeof l=="number"?this.mapHandleToPos.set(n,v+l):this.mapHandleToPos.delete(n)))}async write(n,r,l,v,P){return(0,_.retry)(()=>this.doWrite(n,r,l,v,P),100,3)}async doWrite(n,r,l,v,P){const L=this.normalizePos(n,r);let R=null;try{const m=await E.Promises.write(n,l,v,P,L);return typeof m=="number"?R=m:R=m.bytesWritten,R}catch(m){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),m)}finally{this.updatePos(n,L,R)}}async mkdir(n){try{await E.Promises.mkdir(this.toFilePath(n))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(n,r){try{const l=this.toFilePath(n);await this.doDelete(l,r)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(n,r){r.recursive?await E.Promises.rm(n,E.RimRafMode.MOVE):await E.Promises.unlink(n)}async rename(n,r,l){const v=this.toFilePath(n),P=this.toFilePath(r);if(v!==P)try{await this.validateTargetDeleted(n,r,"move",l.overwrite),await E.Promises.move(v,P)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,b.localize)(2,null,(0,d.basename)(v),(0,d.basename)((0,d.dirname)(P)),L.toString()))),this.toFileSystemProviderError(L)}}async copy(n,r,l){const v=this.toFilePath(n),P=this.toFilePath(r);if(v!==P)try{await this.validateTargetDeleted(n,r,"copy",l.overwrite),await E.Promises.copy(v,P,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,b.localize)(3,null,(0,d.basename)(v),(0,d.basename)((0,d.dirname)(P)),L.toString()))),this.toFileSystemProviderError(L)}}async validateTargetDeleted(n,r,l,v){const P=this.toFilePath(n),L=this.toFilePath(r);let R=!1;if(!!(this.capabilities&1024)||(R=(0,C.isEqual)(P,L,!0)),R&&l==="copy")throw(0,o.createFileSystemProviderError)((0,b.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(!R&&await E.Promises.exists(L)){if(!v)throw(0,o.createFileSystemProviderError)((0,b.localize)(5,null),o.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}watch(n,r){return r.recursive?this.watchRecursive(n,r.excludes):this.watchNonRecursive(n)}watchRecursive(n,r){const l={path:this.toFilePath(n),excludes:r},v=(0,S.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,D.toDisposable)(()=>{v(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof p.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,D.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,r;this.options?.watcher?.usePolling?(n=h.FileWatcher,r=this.options?.watcher):this.recursiveFoldersToWatch.length===1?y.isWindows?n=c.FileWatcher:n=h.FileWatcher:n=p.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,f.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===a.LogLevel.Trace,r),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))}}watchNonRecursive(n){const r=new w.FileWatcher(this.toFilePath(n),v=>this._onDidChangeFile.fire((0,f.toFileChanges)(v)),v=>{v.type==="error"&&this._onDidWatchErrorOccur.fire(v.message),this.logService[v.type](v.message)},this.logService.getLevel()===a.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{r.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)});return(0,D.combinedDisposable)(r,l)}toFilePath(n){return(0,d.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof o.FileSystemProviderError)return n;let r;switch(n.code){case"ENOENT":r=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=o.FileSystemProviderErrorCode.NoPermissions;break;default:r=o.FileSystemProviderErrorCode.Unknown}return(0,o.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(n,r){let l=this.toFileSystemProviderError(r);if(n&&l.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:v}=await E.SymlinkSupport.stat(this.toFilePath(n));v.mode&128||(l=(0,o.createFileSystemProviderError)(r,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(v){this.logService.trace(v)}return l}dispose(){super.dispose(),(0,D.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,D.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(me[45],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService")}),define(me[31],ge([0,1,111,12]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class g{constructor(){this.data=new Map}add(C,D){S.ok(_.isString(C)),S.ok(_.isObject(D)),S.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,D)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new g}),define(me[190],ge([0,1,7,31]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function g(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class k{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,y){this.schemasById[g(d)]=y,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new k;_.Registry.add(e.Extensions.JSONContribution,C)}),define(me[40],ge([0,1,7,12,139,190,31]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var d;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=C.Registry.as(k.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new S.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new S.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,f=!0){this.registerConfigurations([h],f)}registerConfigurations(h,f=!0){const c=[];h.forEach(a=>{c.push(...this.validateAndRegisterProperties(a,f,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(h){const f=[],c=a=>{if(a.properties)for(const t in a.properties)f.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,a.properties[t]);a.allOf&&a.allOf.forEach(t=>c(t))};for(const a of h){c(a);const t=this.configurationContributors.indexOf(a);t!==-1&&this.configurationContributors.splice(t,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(h){const f=[],c=[];for(const a of h)for(const t in a)if(f.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...a[t]};const s={type:"object",default:this.defaultValues[t],description:g.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};c.push(E(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=a[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(h){const f=[];for(const c of h)for(const a in c)if(f.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const f of h)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(h,f=!0,c,a=3){a=_.isUndefinedOrNull(h.scope)?a:h.scope;let t=[],s=h.properties;if(s)for(let r in s){if(f&&u(r)){delete s[r];continue}const l=s[r];if(this.updatePropertyDefaultValue(r,l),e.OVERRIDE_PROPERTY_PATTERN.test(r)?l.scope=void 0:(l.scope=_.isUndefinedOrNull(l.scope)?a:l.scope,l.restricted=_.isUndefinedOrNull(l.restricted)?!!c?.restrictedConfigurations?.includes(r):l.restricted),s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),t.push(r)}let n=h.allOf;if(n)for(let r of n)t.push(...this.validateAndRegisterProperties(r,f,c,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const f=c=>{let a=c.properties;if(a)for(const s in a)this.updateSchema(s,a[s]);let t=c.allOf;t&&t.forEach(f)};f(h)}updateSchema(h,f){switch(e.allSettings.properties[h]=f,f.scope){case 1:e.applicationSettings.properties[h]=f;break;case 2:e.machineSettings.properties[h]=f;break;case 6:e.machineOverridableSettings.properties[h]=f;break;case 3:e.windowSettings.properties[h]=f;break;case 4:e.resourceSettings.properties[h]=f;break;case 5:e.resourceSettings.properties[h]=f,this.resourceLanguageSettingsSchema.properties[h]=f;break}}removeFromSchema(h,f){switch(delete e.allSettings.properties[h],f.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const f=`[${h}]`,c={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,c),e.allSettings.properties[f]=c,e.applicationSettings.properties[f]=c,e.machineSettings.properties[f]=c,e.machineOverridableSettings.properties[f]=c,e.windowSettings.properties[f]=c,e.resourceSettings.properties[f]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,f){let c=this.defaultValues[h];_.isUndefined(c)&&(c=f.default),_.isUndefined(c)&&(c=b(f.type)),f.default=c}}const A="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(A);function E(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=E;function b(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const o=new i;C.Registry.add(e.Extensions.Configuration,o);function u(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?g.localize(5,null,p):o.getConfigurationProperties()[p]!==void 0?g.localize(6,null,p):null:g.localize(4,null)}e.validateProperty=u;function w(){const p=[],h=o.getConfigurationProperties();for(const f of Object.keys(h))p.push([f,h[f].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=w}),define(me[34],ge([0,1,18,12,4,40,6,31]),function(Q,e,S,_,g,k,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function d(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof g.URI)}e.isConfigurationOverrides=d;var y;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function A(s,n){const r=n?s?n.keys.filter(T=>s.keys.indexOf(T)===-1):[...n.keys]:[],l=s?n?s.keys.filter(T=>n.keys.indexOf(T)===-1):[...s.keys]:[],v=[];if(n&&s){for(const T of s.keys)if(n.keys.indexOf(T)!==-1){const I=p(s.contents,T),B=p(n.contents,T);S.equals(I,B)||v.push(T)}}const P=[],L=T=>{const I={};for(const B of T)for(const j of B.identifiers)I[a(j)]=B;return I},R=n?L(n.overrides):{},m=s?L(s.overrides):{};if(Object.keys(R).length)for(const T of r){const I=R[T];I&&P.push([(0,k.overrideIdentifierFromKey)(T),I.keys])}if(Object.keys(m).length)for(const T of l){const I=m[T];I&&P.push([(0,k.overrideIdentifierFromKey)(T),I.keys])}if(Object.keys(R).length&&Object.keys(m).length)for(const T of v){const I=m[T],B=R[T];if(I&&B){const j=A({contents:I.contents,keys:I.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});P.push([(0,k.overrideIdentifierFromKey)(T),[...j.added,...j.removed,...j.updated]])}}return{added:r,removed:l,updated:v,overrides:P}}e.compare=A;function E(s,n){const r=[];for(const l of Object.keys(s))if(k.OVERRIDE_PROPERTY_PATTERN.test(l)){const v={};for(const P in s[l])v[P]=s[l][P];r.push({identifiers:[(0,k.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(v),contents:b(v,n)})}return r}e.toOverrides=E;function b(s,n){const r=Object.create(null);for(let l in s)o(r,l,s[l],n);return r}e.toValuesTree=b;function o(s,n,r,l){const v=n.split("."),P=v.pop();let L=s;for(let R=0;R<v.length;R++){let m=v[R],T=L[m];switch(typeof T){case"undefined":T=L[m]=Object.create(null);break;case"object":break;default:l(`Ignoring ${n} as ${v.slice(0,R+1).join(".")} is ${JSON.stringify(T)}`);return}L=T}if(typeof L=="object"&&L!==null)try{L[P]=r}catch(R){l(`Ignoring ${n} as ${v.join(".")} is ${JSON.stringify(L)}`)}else l(`Ignoring ${n} as ${v.join(".")} is ${JSON.stringify(L)}`)}e.addToValueTree=o;function u(s,n){const r=n.split(".");w(s,r)}e.removeFromValueTree=u;function w(s,n){const r=n.shift();if(n.length===0){delete s[r];return}if(Object.keys(s).indexOf(r)!==-1){const l=s[r];typeof l=="object"&&!Array.isArray(l)&&(w(l,n),Object.keys(l).length===0&&delete s[r])}}function p(s,n,r){function l(L,R){let m=L;for(const T of R){if(typeof m!="object"||m===null)return;m=m[T]}return m}const v=n.split("."),P=l(s,v);return typeof P=="undefined"?r:P}e.getConfigurationValue=p;function h(s,n,r){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in s?_.isObject(s[l])&&_.isObject(n[l])?h(s[l],n[l],r):r&&(s[l]=n[l]):s[l]=n[l])})}e.merge=h;function f(){const s=D.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=f;function c(){const s=Object.create(null),n=D.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let r in n){let l=n[r].default;o(s,r,l,v=>console.error(`Conflict in default settings: ${v}`))}return s}e.getDefaultValues=c;function a(s){return`[${s}]`}e.keyFromOverrideIdentifier=a;function t(s,n,r){const l=s.inspect(n),v=s.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:l.defaultValue}e.getMigratedSettingValue=t}),define(me[191],ge([0,1,20,7,38,2,27,18,12,4,34,40,31]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},s=[],n=[]){this._contents=t,this._keys=s,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const n=this.getContentsForOverrideIdentifer(s);return n?t?(0,i.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let n={};for(const r of S.distinct([...Object.keys(this.contents),...Object.keys(s)])){let l=this.contents[r],v=s[r];v&&(typeof l=="object"&&typeof v=="object"?(l=D.deepClone(l),this.mergeContents(l,v)):l=v),n[r]=l}return new b(n,this.keys,this.overrides)}merge(...t){const s=D.deepClone(this.contents),n=D.deepClone(this.overrides),r=[...this.keys];for(const l of t){this.mergeContents(s,l.contents);for(const v of l.overrides){const[P]=n.filter(L=>S.equals(L.identifiers,v.identifiers));P?this.mergeContents(P.contents,v.contents):n.push(D.deepClone(v))}for(const v of l.keys)r.indexOf(v)===-1&&r.push(v)}return new b(s,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const n of Object.keys(s)){if(n in t&&d.isObject(t[n])&&d.isObject(s[n])){this.mergeContents(t[n],s[n]);continue}t[n]=D.deepClone(s[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?D.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,i.addToValueTree)(this.contents,t,s,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let n=0;n<s;n++)t.indexOf(this.keys[n])===0&&(s=n);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=b;class o extends b{constructor(){const t=(0,i.getDefaultValues)(),s=(0,i.getConfigurationKeys)(),n=[];for(const r of Object.keys(t))A.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,A.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,i.toValuesTree)(t[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,s,n)}}e.DefaultConfigurationModel=o;class u{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!d.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:n,keys:r,overrides:l,restricted:v}=this.doParseRaw(t,s);this._configurationModel=new b(n,r,l),this._restrictedConfigurations=v||[]}doParseContent(t){let s={},n=null,r=[],l=[],v=[];function P(R){Array.isArray(r)?r.push(R):n!==null&&(r[n]=R)}let L={onObjectBegin:()=>{let R={};P(R),l.push(r),r=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let R=[];P(R),l.push(r),r=R,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:P,onError:(R,m,T)=>{v.push({error:R,offset:m,length:T})}};if(t)try{g.visit(t,L),s=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return s}doParseRaw(t,s){const n=E.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,n,!0,s);t=r.raw;const l=(0,i.toValuesTree)(t,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),v=Object.keys(t),P=(0,i.toOverrides)(t,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:l,keys:v,overrides:P,restricted:r.restricted}}filter(t,s,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const l={},v=[];for(let P in t)if(A.OVERRIDE_PROPERTY_PATTERN.test(P)&&n){const L=this.filter(t[P],s,!1,r);l[P]=L.raw,v.push(...L.restricted)}else{const L=s[P],R=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&v.push(P),(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&(r.skipRestricted&&L?.restricted||(l[P]=t[P]))}return{raw:l,restricted:v}}}e.ConfigurationModelParser=u;class w extends k.Disposable{constructor(t,s,n,r){super();this.userSettingsResource=t,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(_.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class p{constructor(t,s,n=new b,r=new b,l=new C.ResourceMap,v=new b,P=new C.ResourceMap,L=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=v,this._memoryConfigurationByResource=P,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(t,s,n){return this.getConsolidateConfigurationModel(s,n).getValue(t)}updateValue(t,s,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new b,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(t):r.setValue(t,s),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,n){const r=this.getConsolidateConfigurationModel(s,n),l=this.getFolderConfigurationModelForResource(s.resource,n),v=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,P=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),L=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),R=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),m=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=n?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,I=l?s.overrideIdentifier?l.freeze().override(s.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,B=s.overrideIdentifier?v.override(s.overrideIdentifier).getValue(t):v.getValue(t),j=r.getValue(t),ue=S.distinct(S.flatten(r.overrides.map(ce=>ce.identifiers))).filter(ce=>r.getOverrideValue(t,ce)!==void 0);return{defaultValue:P,userValue:L,userLocalValue:R,userRemoteValue:m,workspaceValue:T,workspaceFolderValue:I,memoryValue:B,value:j,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:m!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:I!==void 0?{value:l?.freeze().getValue(t),override:s.overrideIdentifier?l?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:v.getValue(t),override:s.overrideIdentifier?v.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ue.length?ue:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const n=s.filter(r=>A.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,A.overrideIdentifierFromKey)(r),v=this._defaultConfiguration.getKeysForOverrideIdentifier(l),P=t.getKeysForOverrideIdentifier(l),L=[...P.filter(R=>v.indexOf(R)===-1),...v.filter(R=>P.indexOf(R)===-1),...v.filter(R=>!D.equals(this._defaultConfiguration.override(l).getValue(R),t.override(l).getValue(R)))];return[l,L]});return this.updateDefaultConfiguration(t),{keys:s,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:n,removed:r,overrides:l}=(0,i.compare)(this.localUserConfiguration,t),v=[...s,...n,...r];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:n,removed:r,overrides:l}=(0,i.compare)(this.remoteUserConfiguration,t);let v=[...s,...n,...r];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:n,removed:r,overrides:l}=(0,i.compare)(this.workspaceConfiguration,t);let v=[...s,...n,...r];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:l}}compareAndUpdateFolderConfiguration(t,s){const n=this.folderConfigurations.get(t),{added:r,updated:l,removed:v,overrides:P}=(0,i.compare)(n,s);let L=[...r,...l,...v];return(L.length||!n)&&this.updateFolderConfiguration(t,s),{keys:L,overrides:P}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:l,overrides:v}=(0,i.compare)(s,void 0);return{keys:[...n,...r,...l],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let n=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},s){let n=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const r=s.getFolder(t);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const l=this._memoryConfigurationByResource.get(t);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(s=n.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=n}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const n=s.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:n,overrides:r,keys:l}=this._folderConfigurations.get(s);return t.push([s,{contents:n,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((v,P)=>(v.set(y.URI.revive(P[0]),this.parseConfigurationModel(P[1])),v),new C.ResourceMap);return new p(s,n,new b,r,l,new b,new C.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function h(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,s=new Map;for(const r of a)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,v])=>{const P=(0,C.getOrSet)(s,l,new Set);v.forEach(L=>P.add(L))});const n=[];return s.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=h;class f{constructor(t,s,n,r){this.change=t,this.previous=s,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(P=>l.add(P)),t.overrides.forEach(([,P])=>P.forEach(L=>l.add(L))),this.affectedKeys=[...l.values()];const v=new b;this.affectedKeys.forEach(P=>v.setValue(P,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!D.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let n=(0,i.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(t=t[r],!t)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=f;class c extends f{constructor(t,s,n,r){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=n,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=c}),define(me[94],ge([0,1,13,7,2,19,34,191,40,31]),function(Q,e,S,_,g,k,C,D,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends g.Disposable{constructor(E,b){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new D.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,b)),this.configuration=new D.Configuration(new D.DefaultConfigurationModel,new D.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(y.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(o=>this.onDidDefaultConfigurationChange(o))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new D.Configuration(new D.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,b){const o=typeof E=="string"?E:void 0,u=(0,C.isConfigurationOverrides)(E)?E:(0,C.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(o,u,void 0)}updateValue(E,b,o,u){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const b=this.configuration.toData(),o=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(o,b,1)}onDidDefaultConfigurationChange(E){const b=this.configuration.toData(),o=this.configuration.compareAndUpdateDefaultConfiguration(new D.DefaultConfigurationModel,E);this.trigger(o,b,6)}trigger(E,b,o){const u=new D.ConfigurationChangeEvent(E,{data:b},this.configuration);u.source=o,u.sourceConfig=this.getTargetConfiguration(o),this._onDidChangeConfiguration.fire(u)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(me[95],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,S.createDecorator)("remoteAuthorityResolverService");var _;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(_=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class g extends Error{constructor(C,D=_.Unknown,d){super(C);this._message=C,this._code=D,this._detail=d,this.isHandled=D===_.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,g.prototype)}static isTemporarilyNotAvailable(C){return C instanceof g&&C._code===_.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof g&&C._code===_.NoResolverFound}static isHandled(C){return C instanceof g&&C.isHandled}}e.RemoteAuthorityResolverError=g}),define(me[192],ge([0,1,8]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function _(y){return y.scheme===S.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=_;function g(y){if(!y)return;const i=y.indexOf("+");return i<0?y:y.substr(0,i)}e.getRemoteName=g;function k(y){return y.scheme!==S.Schemas.file&&y.scheme!==S.Schemas.vscodeRemote}e.isVirtualResource=k;function C(y){if(y.folders.length)return y.folders.every(i=>k(i.uri))?y.folders[0].uri:void 0;if(y.configuration&&k(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=C;function D(y){return C(y)?.scheme}e.getVirtualWorkspaceScheme=D;function d(y){return C(y)!==void 0}e.isVirtualWorkspace=d}),define(me[66],ge([0,1,17,154,40,6,31]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function D(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}e.isSuccess=D;function d(o){return o.res.statusCode===204}async function y(o){if(!D(o))throw new Error("Server returned "+o.res.statusCode);return d(o)?null:(await(0,S.streamToBuffer)(o.stream)).toString()}e.asText=y;async function i(o){if(!D(o))throw new Error("Server returned "+o.res.statusCode);if(d(o))return null;const w=(await(0,S.streamToBuffer)(o.stream)).toString();try{return JSON.parse(w)}catch(p){throw p.message+=`:
`+w,p}}e.asJson=i;function A(o){b(o)}e.updateProxyConfigurationsScope=A;let E;function b(o){const u=C.Registry.as(g.Extensions.Configuration);E&&u.deregisterConfigurations([E]),E={id:"http",order:15,title:(0,_.localize)(0,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,_.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,_.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,_.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,_.localize)(4,null),(0,_.localize)(5,null),(0,_.localize)(6,null),(0,_.localize)(7,null)],default:"override",description:(0,_.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,_.localize)(9,null),restricted:!0}}},u.registerConfiguration(E)}b(2)}),define(me[193],ge([0,1,17,25]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class g{constructor(D){this.service=D}listen(D,d){throw new Error("Invalid listen")}call(D,d,y){switch(d){case"request":return this.service.request(y[0],_.CancellationToken.None).then(async({res:i,stream:A})=>{const E=await(0,S.streamToBuffer)(A);return[{statusCode:i.statusCode,headers:i.headers},E]})}throw new Error("Invalid call")}}e.RequestChannel=g;class k{constructor(D){this.channel=D}async request(D,d){return k.request(this.channel,D,d)}static async request(D,d,y){const[i,A]=await D.call("request",[d]);return{res:i,stream:(0,S.bufferToStream)(A)}}}e.RequestChannelClient=k}),define(me[194],ge([0,1,67,12]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function g(C,D){return C.protocol==="http:"?D.HTTP_PROXY||D.http_proxy||null:C.protocol==="https:"&&(D.HTTPS_PROXY||D.https_proxy||D.HTTP_PROXY||D.http_proxy)||null}async function k(C,D,d={}){const y=(0,S.parse)(C),i=d.proxyUrl||g(y,D);if(!i)return null;const A=(0,S.parse)(i);if(!/^https?:$/.test(A.protocol||""))return null;const E={host:A.hostname||"",port:A.port||(A.protocol==="https"?"443":"80"),auth:A.auth,rejectUnauthorized:(0,_.isBoolean)(d.strictSSL)?d.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((b,o)=>{Q(["http-proxy-agent"],b,o)}))(E):new(await new Promise((b,o)=>{Q(["https-proxy-agent"],b,o)}))(E)}e.getProxyAgent=k}),define(me[195],ge([0,1,17,23]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function g(k,C,D){let d=D&&D.get("storage.serviceMachineId",0)||null;if(d)return d;try{const i=(await C.readFile(k.serviceMachineIdResource)).value.toString();d=(0,_.isUUID)(i)?i:null}catch(y){d=null}if(!d){d=(0,_.generateUuid)();try{await C.writeFile(k.serviceMachineIdResource,S.VSBuffer.fromString(d))}catch(y){}}return D&&D.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=g}),define(me[196],ge([0,1,13,7,2,12,128,6]),function(Q,e,S,_,g,k,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";e.IStorageService=(0,D.createDecorator)("storageService");var y;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var A;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(A=e.StorageTarget||(e.StorageTarget={}));class E extends g.Disposable{constructor(w={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=w,this._onDidChangeValue=this._register(new _.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new _.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new _.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new S.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new g.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,S.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,g.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,p){p===d?(w===0?this._globalKeyTargets=void 0:w===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:w})):this._onDidChangeValue.fire({scope:w,key:p,target:this.getKeyTargets(w)[p]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,p,h){return this.getStorage(p)?.get(w,h)}getBoolean(w,p,h){return this.getStorage(p)?.getBoolean(w,h)}getNumber(w,p,h){return this.getStorage(p)?.getNumber(w,h)}store(w,p,h,f){if((0,k.isUndefinedOrNull)(p)){this.remove(w,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(w,h,f),this.getStorage(h)?.set(w,p)})}remove(w,p){this.withPausedEmitters(()=>{this.updateKeyTarget(w,p,void 0),this.getStorage(p)?.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,p){const h=[],f=this.getKeyTargets(w);for(const c of Object.keys(f))f[c]===p&&h.push(c);return h}updateKeyTarget(w,p,h){const f=this.getKeyTargets(p);typeof h=="number"?f[w]!==h&&(f[w]=h,this.getStorage(p)?.set(d,JSON.stringify(f))):typeof f[w]=="number"&&(delete f[w],this.getStorage(p)?.set(d,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(w){return w===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(w){const p=this.get(d,w);if(p)try{return JSON.parse(p)}catch(h){}return Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=y.NONE){this._onWillSaveState.fire({reason:w}),await S.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const w=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return o(w,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends E{constructor(){super();this.globalStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.globalStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w)))}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(w){}}e.InMemoryStorageService=b;async function o(u,w,p,h){const f=l=>{try{return JSON.parse(l)}catch(v){return l}},c=new Map,a=new Map;u.forEach((l,v)=>{c.set(v,l),a.set(v,f(l))});const t=new Map,s=new Map;w.forEach((l,v)=>{t.set(v,l),s.set(v,f(l))}),console.group(`Storage: Global (path: ${p})`);let n=[];c.forEach((l,v)=>{n.push({key:v,value:l})}),console.table(n),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${h})`);let r=[];t.forEach((l,v)=>{r.push({key:v,value:l})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=o}),define(me[197],ge([0,1,3,22,4,23]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(y){if(S.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function D(y,i,A,E,b,o,u,w,p,h){const f=Object.create(null);f["common.machineId"]=u,f.sessionID=(0,k.generateUuid)()+Date.now(),f.commitHash=b,f.version=o,f["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,S.PlatformToString)(S.platform),f["common.nodePlatform"]=_.platform,f["common.nodeArch"]=E,f["common.product"]=h||"desktop";const c=d(w||[]);c&&(f["common.msftInternal"]=c);let a=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),S.isLinuxSnap&&(f["common.snap"]="true");const s=C(A);s&&(f["common.platformDetail"]=s);try{const n=await y.readFile(g.URI.file(p));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}e.resolveCommonProperties=D;function d(y){const i=_.env.USERDNSDOMAIN;if(!i)return!1;const A=i.toLowerCase();return y.some(E=>A===E)}e.verifyMicrosoftInternalDomain=d}),define(me[198],ge([0,1,20,11,2,18]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var C;(function(d){function y(i,A){return i.callstack<A.callstack?-1:i.callstack>A.callstack?1:0}d.compare=y})(C=e.ErrorEvent||(e.ErrorEvent={}));class D{constructor(y,i=D.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new g.DisposableStore,this._telemetryService=y,this._flushDelay=i;const A=_.errorHandler.addListener(E=>this._onErrorEvent(E));this._disposables.add((0,g.toDisposable)(A)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(y){if(!y)return;y.detail&&y.detail.stack&&(y=y.detail);let i=Array.isArray(y.stack)?y.stack.join(`
`):y.stack,A=y.message?y.message:(0,k.safeStringify)(y);!i||this._enqueue({msg:A,callstack:i})}_enqueue(y){const i=(0,S.binarySearch)(this._buffer,y,C.compare);i<0?(y.count=1,this._buffer.splice(~i,0,y)):(this._buffer[i].count||(this._buffer[i].count=0),this._buffer[i].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let y of this._buffer)this._telemetryService.publicLogError2("UnhandledError",y);this._buffer.length=0}}e.default=D,D.ERROR_FLUSH_TIMEOUT=5*1e3}),define(me[37],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(me[199],ge([0,1,24,51,38,8,5,3,4,78,16,81,180,21,45,37]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function w(a,t){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,r=new Map,l=2e4;function v(R,m,T,I){const B=m.substring(R.length+1);return new Promise(async j=>{let ue;try{ue=await i.Promises.readdir(m,{withFileTypes:!0})}catch($){j();return}if(I.count>=l){I.count+=ue.length,I.maxReached=!0,j();return}let ce=ue.length;if(ce===0){j();return}let O=ue;I.count+ue.length>l&&(I.maxReached=!0,ce=l-I.count,O=ue.slice(0,ce)),I.count+=ue.length;for(const $ of O)if($.isDirectory()){if(T.includes($.name)||await v(R,(0,C.join)(m,$.name),T,I),--ce==0){j();return}}else{const z=$.name.lastIndexOf(".");if(z>=0){const ee=$.name.substring(z+1);ee&&n.set(ee,(n.get(ee)??0)+1)}for(const ee of s)ee.relativePathPattern?.test(B)!==!1&&ee.filePattern.test($.name)&&r.set(ee.tag,(r.get(ee.tag)??0)+1);if(--ce==0){j();return}}})}const P={count:0,maxReached:!1};await v(a,a,t,P);const L=await f(a);return{configFiles:p(r),fileTypes:p(n),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=w;function p(a){return[..._.Iterable.map(a.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function h(){const a={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},t=S.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=h;async function f(a){try{const t=new Map,s=(0,C.join)(a,".vscode","launch.json"),n=await i.Promises.readFile(s),r=[],l=(0,g.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,g.getNodeType)(l)==="object"&&l.configurations)for(const v of l.configurations){const P=v.type;P&&(t.has(P)?t.set(P,t.get(P)+1):t.set(P,1))}return p(t)}catch(t){return[]}}e.collectLaunchConfigs=f;let c=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const n=S.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(S.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||s.push(`Load (avg):       ${S.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,A.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async n=>{let[r,l]=n,v=this.formatProcessList(t,r);return s.forEach(P=>{if((0,E.isRemoteDiagnosticError)(P))v+=`
${P.errorMessage}`,l+=`
${P.errorMessage}`;else if(v+=`

Remote: ${P.hostName}`,P.processes&&(v+=`
${this.formatProcessList(t,P.processes)}`),P.workspaceMetadata){l+=`
|  Remote: ${P.hostName}`;for(const L of Object.keys(P.workspaceMetadata)){const R=P.workspaceMetadata[L];let m=`${R.fileCount} files`;R.maxFilesReached&&(m=`more than ${m}`),l+=`|    Folder (${L}): ${m}`,l+=this.formatWorkspaceStats(R)}}}),{processInfo:v,workspaceInfo:l}})}async getSystemInfo(t,s){const{memory:n,vmHint:r,os:l,cpus:v}=h(),P={os:l,memory:n,cpus:v,vmHint:r,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return D.isWindows||(P.load=`${S.loadavg().map(L=>Math.round(L)).join(", ")}`),D.isLinux&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(t,s){const n=[];return(0,A.listProcesses)(t.mainPID).then(async r=>(n.push(""),n.push(this.formatEnvironment(t)),n.push(""),n.push(this.formatProcessList(t,r)),t.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(t))),s.forEach(l=>{if((0,E.isRemoteDiagnosticError)(l))n.push(`
${l.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${l.hostName}`),n.push(this.formatMachineInfo(l.machineInfo)),l.processes&&n.push(this.formatProcessList(t,l.processes)),l.workspaceMetadata)for(const v of Object.keys(l.workspaceMetadata)){const P=l.workspaceMetadata[v];let L=`${P.fileCount} files`;P.maxFilesReached&&(L=`more than ${L}`),n.push(`Folder (${v}): ${L}`),n.push(this.formatWorkspaceStats(P))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(t){const s=[],n=60;let r=0;const l=(R,m)=>{const T=` ${R}(${m})`;r+T.length>n?(s.push(v),v="|                 ",r=v.length):r+=T.length,v+=T};let v="|      File types:";const P=10;let L=t.fileTypes.length>P?P:t.fileTypes.length;for(let R=0;R<L;R++){const m=t.fileTypes[R];l(m.name,m.count)}if(s.push(v),t.configFiles.length>=0&&(v="|      Conf files:",r=0,t.configFiles.forEach(R=>{l(R.name,R.count)}),s.push(v)),t.launchConfigFiles.length>0){let R="|      Launch Configs:";t.launchConfigFiles.forEach(m=>{R+=m.count>1?` ${m.name}(${m.count})`:` ${m.name}`}),s.push(R)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(n=>n.length));return Object.keys(t).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${t[n]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],n=[];return t.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(l=>{const v=d.URI.revive(l);if(v.scheme===k.Schemas.file){const P=v.fsPath;n.push(w(P,["node_modules",".git"]).then(L=>{let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),s.push(`|    Folder (${(0,C.basename)(P)}): ${R}`),s.push(this.formatWorkspaceStats(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${L.toString()})`)}))}else s.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(t,s){const n=new Map;t.windows.forEach(l=>n.set(l.pid,l.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,n,r,s,0),r.join(`
`)}formatProcessItem(t,s,n,r,l){const v=l===0;let P;v?P=r.pid===t?`${this.productService.applicationName} main`:"remote agent":(P=`${"  ".repeat(l)} ${r.name}`,r.name==="window"&&(P=`${P} (${s.get(r.pid)})`));const L=process.platform==="win32"?r.mem:S.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(L/b.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(r.children)&&r.children.forEach(R=>this.formatProcessItem(t,s,n,R,l+1))}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const n=d.URI.revive(s);if(n.scheme!==k.Schemas.file)continue;const r=n.fsPath;try{const l=await w(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),l.fileTypes.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})}),l.launchConfigFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})}),l.configFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})})}catch{}}}};c=Le([Xe(0,u.ITelemetryService),Xe(1,o.IProductService)],c),e.DiagnosticsService=c}),define(me[200],ge([0,1,20,13,25,11,7,2,3,4,142,32,33,14,30,37]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let w=class extends D.Disposable{constructor(a,t,s){super();this.galleryService=a,this.telemetryService=t,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new C.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new C.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new C.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new C.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,D.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(a,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(0,null));try{a=await this.checkAndGetCompatibleVersion(a,!t.installGivenVersion)}catch(n){throw this.logService.error((0,k.getErrorMessage)(n)),h(this.telemetryService,"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(!await this.canInstall(a)){const n=new A.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension as it is not supported.",a.identifier.id,n.message),h(this.telemetryService,"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(a),void 0,n),n}const s=await this.galleryService.getManifest(a,g.CancellationToken.None);if(s===null){const n=new A.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,n.message),h(this.telemetryService,"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(s.version!==a.version){const n=new A.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),h(this.telemetryService,"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(a),void 0,n),n}return this.installExtension(s,a,t)}async uninstall(a,t={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,t)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(1,null));const t=await this.findGalleryExtension(a);if(!t)throw new Error(i.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,t,s){if(!y.URI.isUri(t)){let P=this.installingExtensions.get(new E.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(P)return this.logService.info("Extensions is already requested to install",t.identifier.id),P.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],l=this.createInstallExtensionTask(a,t,s);y.URI.isUri(t)||this.installingExtensions.set(new E.ExtensionIdentifierWithVersion(l.identifier,a.version).key(),l),this._onInstallExtension.fire({identifier:l.identifier,source:t}),this.logService.info("Installing extension:",l.identifier.id),n.push({task:l,manifest:a});let v=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",l.identifier.id);else try{const L=await this.getAllDepsAndPackExtensionsToInstall(l.identifier,a,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:R,manifest:m}of L)if(v=v||!!m.extensionDependencies?.some(T=>(0,E.areSameExtensions)({id:T},l.identifier)),this.installingExtensions.has(new E.ExtensionIdentifierWithVersion(R.identifier,R.version).key()))this.logService.info("Extension is already requested to install",R.identifier.id);else{const T=this.createInstallExtensionTask(m,R,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new E.ExtensionIdentifierWithVersion(T.identifier,m.version).key(),T),this._onInstallExtension.fire({identifier:T.identifier,source:R}),this.logService.info("Installing extension:",T.identifier.id),n.push({task:T,manifest:m})}}catch(L){if(y.URI.isUri(l.source))(0,S.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",l.identifier.id,L.message),(0,S.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",l.identifier.id,L.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",l.identifier.id),this.logService.error(L),L}const P=n.reduce((L,{task:R,manifest:m})=>(L.set(R.identifier.id.toLowerCase(),{task:R,manifest:m}),L),new Map);for(;P.size;){let L;const R=[...P.values()].filter(({manifest:m})=>!m.extensionDependencies?.some(T=>P.has(T.toLowerCase())));R.length?L=P.size===1?R:R.filter(({task:m})=>!(m===l&&!v)):(this.logService.info("Found extensions with circular dependencies",R.map(({task:m})=>m.identifier.id)),L=[...P.values()]),await this.joinAllSettled(L.map(async({task:m})=>{const T=new Date().getTime();try{const I=await m.run();if(await this.joinAllSettled(this.participants.map(B=>B.postInstall(I,m.source,s,g.CancellationToken.None))),!y.URI.isUri(m.source)&&(h(this.telemetryService,m.operation===2?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(m.source),new Date().getTime()-T,void 0),d.isWeb&&m.operation===1))try{await this.galleryService.reportStatistic(I.manifest.publisher,I.manifest.name,I.manifest.version,"install")}catch(B){}r.push({local:I,identifier:m.identifier,operation:m.operation,source:m.source})}catch(I){throw y.URI.isUri(m.source)||h(this.telemetryService,m.operation===2?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(m.source),new Date().getTime()-T,I),this.logService.error("Error while installing the extension:",m.identifier.id),this.logService.error(I),I}finally{P.delete(m.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:L})=>this.logService.info("Extension installed successfully:",L.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:L})=>(0,E.areSameExtensions)(L,l.identifier))[0].local}catch(P){if(n.forEach(({task:L})=>L.cancel()),r.length)try{const L=await Promise.allSettled(r.map(({local:R})=>this.createUninstallExtensionTask(R,{versionOnly:!0}).run()));for(let R=0;R<L.length;R++){const m=L[R],{identifier:T}=r[R];m.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",T.id):this.logService.warn("Rollback: Error while uninstalling extension",T.id,(0,k.getErrorMessage)(m.reason))}}catch(L){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(L),r.map(({identifier:R})=>R.id))}throw this.logService.error("Failed to install extension:",l.identifier.id,(0,k.getErrorMessage)(P)),this._onDidInstallExtensions.fire(n.map(({task:L})=>({identifier:L.identifier,operation:1,source:L.source}))),P instanceof Error&&(P.name=P&&P.code?P.code:e.ERROR_UNKNOWN),P}finally{for(const{task:P,manifest:L}of n)if(!y.URI.isUri(P.source)){const R=new E.ExtensionIdentifierWithVersion(P.identifier,L.version).key();this.installingExtensions.delete(R)||this.logService.warn("Installation task is not found in the cache",R)}}}async joinAllSettled(a){const t=[],s=[],n=await Promise.allSettled(a);for(const r of n)r.status==="fulfilled"?t.push(r.value):s.push(r.reason);if(s.length)throw p(s);return t}async getAllDepsAndPackExtensionsToInstall(a,t,s){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[a,...n.map(P=>P.identifier)],l=[],v=async(P,L)=>{const R=L.extensionDependencies||[],m=[...R];if(L.extensionPack){const T=s?n.find(I=>(0,E.areSameExtensions)(I.identifier,P)):void 0;for(const I of L.extensionPack)T&&T.manifest.extensionPack&&T.manifest.extensionPack.some(B=>(0,E.areSameExtensions)({id:B},{id:I}))||m.every(B=>!(0,E.areSameExtensions)({id:B},{id:I}))&&m.push(I)}if(m.length){const T=[...r,...l.map(B=>B.gallery.identifier)],I=m.filter(B=>T.every(j=>!(0,E.areSameExtensions)(j,{id:B})));if(I.length){const B=await this.galleryService.query({names:I,pageSize:m.length},g.CancellationToken.None);for(const j of B.firstPage){if(T.find($=>(0,E.areSameExtensions)($,j.identifier)))continue;if(!R.some($=>(0,E.areSameExtensions)({id:$},j.identifier))&&!await this.canInstall(j)){this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}const ce=await this.checkAndGetCompatibleVersion(j,!0),O=await this.galleryService.getManifest(ce,g.CancellationToken.None);if(O===null)throw new A.ExtensionManagementError(`Missing manifest for extension ${ce.identifier.id}`,e.INSTALL_ERROR_VALIDATING);l.push({gallery:ce,manifest:O}),await v(ce.identifier,O)}}}};return await v(a,t),n=await this.getInstalled(),l.filter(P=>!n.some(L=>(0,E.areSameExtensions)(L.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(a,t){if(await this.isMalicious(a))throw new A.ExtensionManagementError(i.localize(3,null,a.identifier.id),A.INSTALL_ERROR_MALICIOUS);let s=null;if(await this.galleryService.isExtensionCompatible(a,A.CURRENT_TARGET_PLATFORM)&&(s=a),!s&&t&&(s=await this.galleryService.getCompatibleExtension(a,A.CURRENT_TARGET_PLATFORM)),!s)throw new A.ExtensionManagementError(i.localize(4,null,a.identifier.id,o.default.version),A.INSTALL_ERROR_INCOMPATIBLE);return s}async isMalicious(a){const t=await this.getExtensionsReport();return(0,E.getMaliciousExtensionsSet)(t).has(a.identifier.id)}async unininstallExtension(a,t){const s=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),s.waitUntilTaskIsFinished();const n=(P,L)=>{const R=this.createUninstallExtensionTask(P,L);return this.uninstallingExtensions.set(R.extension.identifier.id.toLowerCase(),R),this.logService.info("Uninstalling extension:",P.identifier.id),this._onUninstallExtension.fire(P.identifier),R},r=(P,L)=>{L?this.logService.error("Failed to uninstall extension:",P.identifier.id,L.message):this.logService.info("Successfully uninstalled extension:",P.identifier.id),h(this.telemetryService,"extensionGallery:uninstall",(0,E.getLocalExtensionTelemetryData)(P),void 0,L),this._onDidUninstallExtension.fire({identifier:P.identifier,error:L?.code})},l=[],v=[];try{l.push(n(a,{}));const P=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const L=this.getAllPackExtensionsToUninstall(a,P);for(const R of L)this.uninstallingExtensions.has(R.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",R.identifier.id):l.push(n(R,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(l.map(L=>L.extension),P,a),await this.joinAllSettled(l.map(async L=>{try{if(await L.run(),await this.joinAllSettled(this.participants.map(R=>R.postUninstall(L.extension,t,g.CancellationToken.None))),L.extension.identifier.uuid)try{await this.galleryService.reportStatistic(L.extension.manifest.publisher,L.extension.manifest.name,L.extension.manifest.version,"uninstall")}catch(R){}r(L.extension)}catch(R){const m=R instanceof A.ExtensionManagementError?R:new A.ExtensionManagementError((0,k.getErrorMessage)(R),e.ERROR_UNKNOWN);throw r(L.extension,m),m}finally{v.push(L)}}))}catch(P){const L=P instanceof A.ExtensionManagementError?P:new A.ExtensionManagementError((0,k.getErrorMessage)(P),e.ERROR_UNKNOWN);for(const R of l){try{R.cancel()}catch(m){}v.includes(R)||r(R.extension,L)}throw L}finally{for(const P of l)this.uninstallingExtensions.delete(P.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",P.extension.identifier.id)}}checkForDependents(a,t,s){for(const n of a){const r=this.getDependents(n,t);if(r.length){const l=r.filter(v=>!a.some(P=>(0,E.areSameExtensions)(P.identifier,v.identifier)));if(l.length)throw new Error(this.getDependentsErrorMessage(n,l,s))}}}getDependentsErrorMessage(a,t,s){return s===a?t.length===1?i.localize(5,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(8,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(9,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(10,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(a,t,s=[]){if(s.indexOf(a)!==-1)return[];s.push(a);const n=a.manifest.extensionPack?a.manifest.extensionPack:[];if(n.length){const r=t.filter(v=>!v.isBuiltin&&n.some(P=>(0,E.areSameExtensions)({id:P},v.identifier))),l=[];for(const v of r)l.push(...this.getAllPackExtensionsToUninstall(v,t,s));return[...r,...l]}return[]}getDependents(a,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(n=>(0,E.areSameExtensions)({id:n},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const t=await this.findGalleryExtensionById(a.identifier.uuid);return t||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},g.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},g.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};w=Le([Xe(0,A.IExtensionGalleryService),Xe(1,u.ITelemetryService),Xe(2,b.ILogService)],w),e.AbstractExtensionManagementService=w;function p(c){const a=Array.isArray(c)?c:[c];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=p;function h(c,a,t,s,n){const r=n?n instanceof A.ExtensionManagementError?n.code:e.ERROR_UNKNOWN:void 0;c.publicLogError(a,{...t,success:!n,duration:s,errorcode:r})}e.reportTelemetry=h;class f{constructor(){this.barrier=new _.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(a=>new Promise((t,s)=>{const n=a.onCancellationRequested(()=>{n.dispose(),s((0,k.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=f}),define(me[96],ge([0,1,20,25,11,18,3,4,29,32,33,58,21,6,14,45,66,195,196,37]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w,p,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var c;(function(W){W[W.None=0]="None",W[W.IncludeVersions=1]="IncludeVersions",W[W.IncludeFiles=2]="IncludeFiles",W[W.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",W[W.IncludeSharedAccounts=8]="IncludeSharedAccounts",W[W.IncludeVersionProperties=16]="IncludeVersionProperties",W[W.ExcludeNonValidated=32]="ExcludeNonValidated",W[W.IncludeInstallationTargets=64]="IncludeInstallationTargets",W[W.IncludeAssetUri=128]="IncludeAssetUri",W[W.IncludeStatistics=256]="IncludeStatistics",W[W.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",W[W.Unpublished=4096]="Unpublished"})(c||(c={}));function a(...W){return String(W.reduce((U,ie)=>U|ie,0))}var t;(function(W){W[W.Tag=1]="Tag",W[W.ExtensionId=4]="ExtensionId",W[W.Category=5]="Category",W[W.ExtensionName=7]="ExtensionName",W[W.Target=8]="Target",W[W.Featured=9]="Featured",W[W.SearchText=10]="SearchText",W[W.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class v{constructor(U=l){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(U,ie=this.state.pageSize){return new v({...this.state,pageNumber:U,pageSize:ie})}withFilter(U,...ie){const ne=[...this.state.criteria,...ie.length?ie.map(he=>({filterType:U,value:he})):[{filterType:U}]];return new v({...this.state,criteria:ne})}withSortBy(U){return new v({...this.state,sortBy:U})}withSortOrder(U){return new v({...this.state,sortOrder:U})}withFlags(...U){return new v({...this.state,flags:U.reduce((ie,ne)=>ie|ne,0)})}withAssetTypes(...U){return new v({...this.state,assetTypes:U})}get raw(){const{criteria:U,pageNumber:ie,pageSize:ne,sortBy:he,sortOrder:ve,flags:Ae,assetTypes:Ie}=this.state;return{filters:[{criteria:U,pageNumber:ie,pageSize:ne,sortBy:he,sortOrder:ve}],assetTypes:Ie,flags:Ae}}get searchText(){const U=this.state.criteria.filter(ie=>ie.filterType===t.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function P(W,U){const ie=(W||[]).filter(ne=>ne.statisticName===U)[0];return ie?ie.value:0}function L(W){const U="Microsoft.VisualStudio.Code.Translation.";return W.files.filter(ne=>ne.assetType.indexOf(U)===0).reduce((ne,he)=>{const ve=I(W,he.assetType);return ve&&ne.push([he.assetType.substring(U.length),ve]),ne},[])}function R(W){if(W.properties){const U=W.properties.filter(he=>he.key===s.Repository),ie=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ne=U.filter(he=>ie.test(he.value))[0];return ne?{uri:ne.value,fallbackUri:ne.value}:null}return I(W,s.Repository)}function m(W){return{uri:`${W.fallbackAssetUri}/${s.VSIX}?redirect=true${W.targetPlatform?`&targetPlatform=${W.targetPlatform}`:""}`,fallbackUri:`${W.fallbackAssetUri}/${s.VSIX}${W.targetPlatform?`?targetPlatform=${W.targetPlatform}`:""}`}}function T(W){const U=I(W,s.Icon);if(U)return U;const ie=y.DefaultIconPath;return{uri:ie,fallbackUri:ie}}function I(W,U){return W.files.filter(ne=>ne.assetType===U)[0]?{uri:`${W.assetUri}/${U}`,fallbackUri:`${W.fallbackAssetUri}/${U}`}:null}function B(W,U){const ie=W.properties?W.properties.filter(he=>he.key===U):[],ne=ie.length>0&&ie[0].value;return ne?ne.split(",").map(he=>(0,i.adoptToGalleryExtensionId)(he)):[]}function j(W){const U=W.properties?W.properties.filter(ie=>ie.key===n.Engine):[];return U.length>0&&U[0].value||""}function ue(W){const U=W.properties?W.properties.filter(ne=>ne.key===n.LocalizedLanguages):[],ie=U.length>0&&U[0].value||"";return ie?ie.split(","):[]}function ce(W){return W.indexOf("preview")!==-1}function O(W){return W.targetPlatform?(0,y.toTargetPlatform)(W.targetPlatform):"undefined"}function $(W){const U=(0,S.distinct)(W.versions.map(O)),ie=!!W.tags?.includes(y.WEB_EXTENSION_TAG),ne=U.indexOf("web");return ie?ne===-1&&U.push("web"):ne!==-1&&U.splice(ne,1),U}function z(W,U){return U==="web"&&!W.includes("web")}function ee(W,U,ie){if(z(U,ie))return!1;if(W==="undefined"||W==="universal")return!0;if(W==="unknown")return!1;if(W===ie)return!0;switch(ie){case"win32-x64":return W==="win32-ia32";case"win32-arm64":return W==="win32-ia32";default:return!1}}function J(W,U,ie,ne){const he=$(W);let ve=W.versions[0];return ve=W.versions.find(Ae=>Ae.version===ve.version&&ee(O(Ae),he,y.CURRENT_TARGET_PLATFORM))||ve,H(W,ve,he,U,ie,ne)}function H(W,U,ie,ne,he,ve){const Ae={manifest:I(U,s.Manifest),readme:I(U,s.Details),changelog:I(U,s.Changelog),license:I(U,s.License),repository:R(U),download:m(U),icon:T(U),coreTranslations:L(U)};return{identifier:{id:(0,i.getGalleryExtensionId)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},name:W.extensionName,version:U.version,displayName:W.displayName,publisherId:W.publisher.publisherId,publisher:W.publisher.publisherName,publisherDisplayName:W.publisher.displayName,description:W.shortDescription||"",installCount:P(W.statistics,"install"),rating:P(W.statistics,"averagerating"),ratingCount:P(W.statistics,"ratingcount"),categories:W.categories||[],tags:W.tags||[],releaseDate:Date.parse(W.releaseDate),lastUpdated:Date.parse(W.lastUpdated),allTargetPlatforms:ie,assets:Ae,properties:{dependencies:B(U,n.Dependency),extensionPack:B(U,n.ExtensionPack),engine:j(U),localizedLanguages:ue(U),targetPlatform:O(U)},preview:ce(W.flags),telemetryData:{index:(he.pageNumber-1)*he.pageSize+ne,querySource:ve}}}let X=class{constructor(U,ie,ne,he,ve,Ae,Ie){this.requestService=U,this.logService=ie,this.environmentService=ne,this.telemetryService=he,this.fileService=ve,this.productService=Ae;const Ue=Ae.extensionsGallery;this.extensionsGalleryUrl=Ue&&Ue.serviceUrl,this.extensionsControlUrl=Ue&&Ue.controlUrl,this.commonHeadersPromise=q(Ae.version,this.environmentService,this.fileService,Ie)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,ie){const ne=[];let he=new v().withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,U.length).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExtensionName,...U.map(({id:Ae})=>Ae.toLowerCase()));U.every(Ae=>!Ae.version)&&(he=he.withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties,c.IncludeLatestVersionOnly));const{galleryExtensions:ve}=await this.queryGallery(he,_.CancellationToken.None);for(let Ae=0;Ae<ve.length;Ae++){const Ie=ve[Ae];if(!Ie.versions.length)continue;const Ue=(0,i.getGalleryExtensionId)(Ie.publisher.publisherName,Ie.extensionName),qe=U.find(Ge=>(0,i.areSameExtensions)(Ge,{id:Ue}))?.version;if(qe){const Ge=Ie.versions.find(rt=>rt.version===qe);Ge&&ne.push(H(Ie,Ge,$(Ie),Ae,he))}else ne.push(J(Ie,Ae,he))}return ne}async getCompatibleExtension(U,ie){const ne=(0,y.isIExtensionIdentifier)(U)?null:U;if(ne){if(z(ne.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(ne,ie))return ne}const{id:he,uuid:ve}=ne?ne.identifier:U;let Ae=new v().withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");ve?Ae=Ae.withFilter(t.ExtensionId,ve):Ae=Ae.withFilter(t.ExtensionName,he);const{galleryExtensions:Ie}=await this.queryGallery(Ae,_.CancellationToken.None),[Ue]=Ie;if(!Ue||!Ue.versions.length)return null;const qe=$(Ue);if(z(qe,ie))return null;for(let Ge of Ue.versions){if(!j(Ge)){const rt=await this.getEngine(Ge);Ge={...Ge,properties:[...Ge.properties||[],{key:n.Engine,value:rt}]}}if(await this.isRawExtensionVersionCompatible(Ge,qe,ie))return H(Ue,Ge,qe,0,Ae)}return null}async isExtensionCompatible(U,ie){if(!ee(U.properties.targetPlatform,U.allTargetPlatforms,ie))return!1;let ne=U.properties.engine;if(!ne){const he=await this.getManifest(U,_.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ne=he.engines.vscode}return(0,A.isEngineValid)(ne,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(U,ie,ne){if(!ee(O(U),ie,ne))return!1;const he=await this.getEngine(U);return(0,A.isEngineValid)(he,this.productService.version,this.productService.date)}async query(U,ie){const ne=_.CancellationToken.isCancellationToken(U)?{}:U,he=_.CancellationToken.isCancellationToken(U)?U:ie;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ve=ne.text||"";const Ae=(0,k.getOrDefault)(ne,it=>it.pageSize,50);let Ie=new v().withFlags(c.IncludeLatestVersionOnly,c.IncludeAssetUri,c.IncludeStatistics,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,Ae).withFilter(t.Target,"Microsoft.VisualStudio.Code");ve?(ve=ve.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(it,de,be)=>(Ie=Ie.withFilter(t.Category,be||de),"")),ve=ve.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(it,de,be)=>(Ie=Ie.withFilter(t.Tag,be||de),"")),ve=ve.replace(/\bfeatured(\s+|\b|$)/g,()=>(Ie=Ie.withFilter(t.Featured),"")),ve=ve.trim(),ve&&(ve=ve.length<200?ve:ve.substring(0,200),Ie=Ie.withFilter(t.SearchText,ve)),Ie=Ie.withSortBy(0)):ne.ids?Ie=Ie.withFilter(t.ExtensionId,...ne.ids):ne.names?Ie=Ie.withFilter(t.ExtensionName,...ne.names):Ie=Ie.withSortBy(4),typeof ne.sortBy=="number"&&(Ie=Ie.withSortBy(ne.sortBy)),typeof ne.sortOrder=="number"&&(Ie=Ie.withSortOrder(ne.sortOrder));const{galleryExtensions:Ue,total:qe}=await this.queryGallery(Ie,he),Ge=Ue.map((it,de)=>J(it,de,Ie,ne.source)),rt=async(it,de)=>{if(de.isCancellationRequested)throw(0,g.canceled)();const be=Ie.withPage(it+1),{galleryExtensions:Pe}=await this.queryGallery(be,de);return Pe.map((Re,Ne)=>J(Re,Ne,be,ne.source))};return{firstPage:Ge,total:qe,pageSize:Ie.pageSize,getPage:rt}}async queryGallery(U,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,c.ExcludeNonValidated).withFilter(t.ExcludeWithFlags,a(c.Unpublished));const ne=await this.commonHeadersPromise,he=JSON.stringify(U.raw),ve={...ne,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},Ae=new Date().getTime();let Ie,Ue,qe=0;try{if(Ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:ve},ie),Ie.res.statusCode&&Ie.res.statusCode>=400&&Ie.res.statusCode<500)return{galleryExtensions:[],total:qe};const Ge=await(0,w.asJson)(Ie);if(Ge){const rt=Ge.results[0],it=rt.extensions,de=rt.resultMetadata&&rt.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return qe=de&&de.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:it,total:qe}}return{galleryExtensions:[],total:qe}}catch(Ge){throw Ue=Ge,Ge}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-Ae,success:!!Ie&&(0,w.isSuccess)(Ie),responseBodySize:Ie?.res.headers["Content-Length"],statusCode:Ie?String(Ie.res.statusCode):void 0,errorCode:Ue?(0,g.isPromiseCanceledError)(Ue)?"canceled":(0,g.getErrorMessage)(Ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(qe)})}}async reportStatistic(U,ie,ne,he){if(!this.isEnabled())return;const ve=C.isWeb?this.api(`/itemName/${U}.${ie}/version/${ne}/statType/${he==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${ie}/${ne}/stats?statType=${he}`),Ae=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ue={...await this.commonHeadersPromise,Accept:Ae};try{await this.requestService.request({type:"POST",url:ve,headers:Ue},_.CancellationToken.None)}catch(qe){}}async download(U,ie,ne){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const he=(0,i.getGalleryExtensionTelemetryData)(U),ve=new Date().getTime(),Ae=Ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...he,duration:Ge}),Ie=ne===1?"install":ne===2?"update":"",Ue=Ie?{uri:`${U.assets.download.uri}${D.URI.parse(U.assets.download.uri).query?"&":"?"}${Ie}=true`,fallbackUri:`${U.assets.download.fallbackUri}${D.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${Ie}=true`}:U.assets.download,qe=await this.getAsset(Ue);await this.fileService.writeFile(ie,qe.stream),Ae(new Date().getTime()-ve)}async getReadme(U,ie){if(U.assets.readme){const ne=await this.getAsset(U.assets.readme,{},ie);return await(0,w.asText)(ne)||""}return""}async getManifest(U,ie){if(U.assets.manifest){const ne=await this.getAsset(U.assets.manifest,{},ie),he=await(0,w.asText)(ne);return he?JSON.parse(he):null}return null}async getManifestFromRawExtensionVersion(U,ie){const ne=I(U,s.Manifest);if(!ne)throw new Error("Manifest was not found");const he={"Accept-Encoding":"gzip"},ve=await this.getAsset(ne,{headers:he});return await(0,w.asJson)(ve)}async getCoreTranslation(U,ie){const ne=U.assets.coreTranslations.filter(he=>he[0]===ie.toUpperCase())[0];if(ne){const he=await this.getAsset(ne[1]),ve=await(0,w.asText)(he);return ve?JSON.parse(ve):null}return null}async getChangelog(U,ie){if(U.assets.changelog){const ne=await this.getAsset(U.assets.changelog,{},ie);return await(0,w.asText)(ne)||""}return""}async getAllCompatibleVersions(U,ie){let ne=new v().withFlags(c.IncludeVersions,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");U.identifier.uuid?ne=ne.withFilter(t.ExtensionId,U.identifier.uuid):ne=ne.withFilter(t.ExtensionName,U.identifier.id);const{galleryExtensions:he}=await this.queryGallery(ne,_.CancellationToken.None);if(!he.length)return[];const ve=$(he[0]);if(z(ve,ie))return[];const Ae=[];for(const Ie of he[0].versions)try{await this.isRawExtensionVersionCompatible(Ie,ve,ie)&&Ae.push({version:Ie.version,date:Ie.lastUpdated})}catch(Ue){}return Ae}async getAsset(U,ie={},ne=_.CancellationToken.None){const he=await this.commonHeadersPromise,ve={type:"GET"},Ae={...he,...ie.headers||{}};ie={...ie,...ve,headers:Ae};const Ie=U.uri,Ue=U.fallbackUri,qe={...ie,url:Ie};try{const Ge=await this.requestService.request(qe,ne);if(Ge.res.statusCode===200)return Ge;const rt=await(0,w.asText)(Ge);throw new Error(`Expected 200, got back ${Ge.res.statusCode} instead.

${rt}`)}catch(Ge){if((0,g.isPromiseCanceledError)(Ge))throw Ge;const rt=(0,g.getErrorMessage)(Ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Ie,message:rt});const it={...ie,url:Ue};return this.requestService.request(it,ne)}}async getEngine(U){let ie=j(U);if(!ie){const ne=await this.getManifestFromRawExtensionVersion(U,_.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");ie=ne.engines.vscode}return ie}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},_.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const ie=await(0,w.asJson)(U),ne=new Map;if(ie)for(const he of ie.malicious){const ve=ne.get(he)||{id:{id:he},malicious:!0,slow:!1};ve.malicious=!0,ne.set(he,ve)}return[...ne.values()]}};X=Le([Xe(0,w.IRequestService),Xe(1,o.ILogService),Xe(2,d.IEnvironmentService),Xe(3,f.ITelemetryService),Xe(4,E.IFileService),Xe(5,u.IProductService),Xe(6,(0,b.optional)(h.IStorageService))],X),e.ExtensionGalleryService=X;async function q(W,U,ie,ne){const he={"X-Market-Client-Id":`VSCode ${W}`,"User-Agent":`VSCode ${W}`},ve=await(0,p.getServiceMachineId)(U,ie,ne);return he["X-Market-User-Id"]=ve,he}e.resolveMarketplaceHeaders=q}),define(me[201],ge([0,1,2,18,15,155,34,40,6,30,31]),function(Q,e,S,_,g,k,C,D,d,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let A=class{constructor(o,u){this._configurationService=u,this._experimentProperties={},this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appender=o.appender,this._commonProperties=o.commonProperties||Promise.resolve({}),this._piiPaths=o.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!o.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,g.escapeRegExpCharacters)(w),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(w=>{const p=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!p})}))}setExperimentProperty(o,u){this._experimentProperties[o]=u}setEnabled(o){this._enabled=o}_updateUserOptIn(){const o=this._configurationService?.getValue(E);this._userOptIn=o?o.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const o=await this._commonProperties;let u=o.sessionID,w=o["common.instanceId"],p=o["common.machineId"],h=o["common.firstSessionDate"],f=o["common.msftInternal"];return{sessionId:u,instanceId:w,machineId:p,firstSessionDate:h,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(o,u,w){return this.isOptedIn?this._commonProperties.then(p=>{u=(0,_.mixin)(u,p),u=(0,_.mixin)(u,this._experimentProperties),u=(0,_.cloneAndChange)(u,h=>{if(typeof h=="string")return this._cleanupInfo(h,w)}),this._appender.log(o,u)},p=>{console.error(p)}):Promise.resolve(void 0)}publicLog2(o,u,w){return this.publicLog(o,u,w)}publicLogError(o,u){return this.sendErrorTelemetry?this.publicLog(o,u,!0):Promise.resolve(void 0)}publicLogError2(o,u){return this.publicLogError(o,u)}_cleanupInfo(o,u){let w=o;if(u){const p=[];for(let a of this._cleanupPatterns)for(;;){const t=a.exec(o);if(!t)break;p.push([t.index,a.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(w="";;){const a=f.exec(o);if(!a)break;!h.test(a[0])&&p.every(([t,s])=>a.index<t||a.index>=s)&&(w+=o.substring(c,a.index)+"<REDACTED: user-file-path>",c=f.lastIndex)}c<o.length&&(w+=o.substr(c))}for(let p of this._cleanupPatterns)w=w.replace(p,"");return w}};A.IDLE_START_EVENT_NAME="UserIdleStart",A.IDLE_STOP_EVENT_NAME="UserIdleStop",A=Le([Xe(1,(0,d.optional)(C.IConfigurationService))],A),e.TelemetryService=A;const E="telemetry";i.Registry.as(D.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,k.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,k.localize)(2,null,y.default.nameLong,y.default.privacyStatementUrl):(0,k.localize)(1,null,y.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(me[68],ge([0,1,13,18,12,34]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(o,u){return Promise.resolve(void 0)}publicLog2(o,u){return this.publicLog(o,u)}publicLogError(o,u){return Promise.resolve(void 0)}publicLogError2(o,u){return this.publicLogError(o,u)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class C{async publicLog(u,w,p){}async publicLogError(u,w,p){}}e.NullEndpointTelemetryService=C;function D(...o){return{log:(u,w)=>o.forEach(p=>p.log(u,w)),flush:()=>S.Promises.settled(o.map(u=>u.flush()))}}e.combinedAppender=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(o,u){return u.onDidChangeConfiguration(w=>{w.source!==6&&o.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(w.source),configurationKeys:E(w.sourceConfig)})})}e.configurationTelemetry=d;function y(o){const u=Object.create(null),w=Object.create(null),p=Object.create(null);A(o,p);for(let h in p){h=h.length>150?h.substr(h.length-149):h;const f=p[h];typeof f=="number"?w[h]=f:typeof f=="boolean"?w[h]=f?1:0:typeof f=="string"?u[h]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(u[h]=f)}return{properties:u,measurements:w}}e.validateTelemetryData=y;function i(o){if(!o)return"none";let u="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(p=>{o.indexOf(`${p}+`)===0&&(u=p)}),u}e.cleanRemoteAuthority=i;function A(o,u,w=0,p){if(!!o)for(let h of Object.getOwnPropertyNames(o)){const f=o[h],c=p?p+h:h;Array.isArray(f)?u[c]=(0,_.safeStringify)(f):f instanceof Date?u[c]=f.toISOString():(0,g.isObject)(f)?w<2?A(f,u,w+1,c+"."):u[c]=(0,_.safeStringify)(f):u[c]=f}}function E(o){if(!o)return[];const u=[];return b(u,"",o),u}function b(o,u,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(p=>b(o,u?`${u}.${p}`:p,w[p])):o.push(u)}}),define(me[202],ge([0,1,11,18,68]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(D){const d=await new Promise((i,A)=>{Q(["applicationinsights"],i,A)});let y;return d.defaultClient?(y=new d.TelemetryClient(D),y.channel.setUseDiskRetryCaching(!0)):(d.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),y=d.defaultClient),D.indexOf("AIF-")===0&&(y.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),y}class C{constructor(d,y,i){this._eventPrefix=d,this._defaultData=y,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(d){if(!!this._aiClient){if(typeof this._aiClient!="string"){d(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(y=>{d(y)},y=>{(0,S.onUnexpectedError)(y),console.error(y)})}}log(d,y){!this._aiClient||(y=(0,_.mixin)(y,this._defaultData),y=(0,g.validateTelemetryData)(y),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+d,properties:y.properties,measurements:y.measurements})))}flush(){return this._aiClient?new Promise(d=>{this._withAIClient(y=>{y.flush({callback:()=>{this._aiClient=void 0,d(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=C}),define(me[203],ge([0,1,11,198]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class g extends _.default{installErrorListeners(){(0,S.setUnexpectedErrorHandler)(D=>console.error(D));const C=[];process.on("unhandledRejection",(D,d)=>{C.push(d),setTimeout(()=>{const y=C.indexOf(d);y>=0&&d.catch(i=>{C.splice(y,1),(0,S.isPromiseCanceledError)(i)||(console.warn(`rejected promise not handled within 1 second: ${i}`),i.stack&&console.warn(`stack trace: ${i.stack}`),(0,S.onUnexpectedError)(D))})},1e3)}),process.on("rejectionHandled",D=>{const d=C.indexOf(D);d>=0&&C.splice(d,1)}),process.on("uncaughtException",D=>{(0,S.onUnexpectedError)(D)})}}e.default=g}),define(me[204],ge([0,1,13,25,7,2,14]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let D=class extends k.Disposable{constructor(y,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new g.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=y===void 0?15e3:y}createRequest(y){return new Promise((i,A)=>{const E=++this._lastRequestId;this._pendingRequests.set(E,i),this._onCreateRequest.fire({requestId:E,...y});const b=new _.CancellationTokenSource;(0,S.timeout)(this._timeout,b.token).then(()=>A(`Request ${E} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(E,[(0,k.toDisposable)(()=>b.cancel())])})}acceptReply(y,i){const A=this._pendingRequests.get(y);A?(this._pendingRequests.delete(y),(0,k.dispose)(this._pendingRequestDisposables.get(y)||[]),this._pendingRequestDisposables.delete(y),A(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${y}`)}};D=Le([Xe(1,C.ILogService)],D),e.RequestStore=D}),define(me[97],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var _;(function(o){o.Shell="terminal.integrated.shell.",o.ShellArgs="terminal.integrated.shellArgs.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(_=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var g;(function(o){o.ShellLinux="terminal.integrated.shell.linux",o.ShellMacOs="terminal.integrated.shell.osx",o.ShellWindows="terminal.integrated.shell.windows",o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationShellLinux="terminal.integrated.automationShell.linux",o.AutomationShellMacOs="terminal.integrated.automationShell.osx",o.AutomationShellWindows="terminal.integrated.automationShell.windows",o.ShellArgsLinux="terminal.integrated.shellArgs.linux",o.ShellArgsMacOs="terminal.integrated.shellArgs.osx",o.ShellArgsWindows="terminal.integrated.shellArgs.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.TitleMode="terminal.integrated.titleMode",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",o.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",o.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",o.LocalEchoStyle="terminal.integrated.localEchoStyle",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.CustomGlyphs="terminal.integrated.customGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover"})(g=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(o){o.CommandPrompt="cmd",o.PowerShell="pwsh",o.Wsl="wsl",o.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var C;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence"})(C=e.TitleEventSource||(e.TitleEventSource={}));var D;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.Log="log",o.Heartbeat="heartbeat"})(D=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,S.createDecorator)("ptyService");var d;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(d=e.HeartbeatConstants||(e.HeartbeatConstants={}));var y;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(y=e.TerminalLocation||(e.TerminalLocation={}));var i;(function(o){o.TerminalView="view",o.Editor="editor"})(i=e.TerminalLocationString||(e.TerminalLocationString={}));var A;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(A=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var E;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(E=e.FlowControlConstants||(e.FlowControlConstants={}));var b;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(b=e.ProfileSource||(e.ProfileSource={}))}),define(me[205],ge([0,1,24,18,5,3,22,12,16]),function(Q,e,S,_,g,k,C,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const A=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let E=0;return A&&A.length===4&&(E=parseInt(A[3])),E}e.getWindowsBuildNumber=y;async function i(A,E,b,o=C.env,u=d.Promises.exists){if(g.isAbsolute(A))return await u(A)?A:void 0;if(E===void 0&&(E=C.cwd()),g.dirname(A)!=="."){const f=g.join(E,A);return await u(f)?f:void 0}const p=(0,_.getCaseInsensitive)(o,"PATH");if(b===void 0&&(0,D.isString)(p)&&(b=p.split(g.delimiter)),b===void 0||b.length===0){const f=g.join(E,A);return await u(f)?f:void 0}for(let f of b){let c;if(g.isAbsolute(f)?c=g.join(f,A):c=g.join(E,f,A),await u(c))return c;if(k.isWindows){let a=c+".com";if(await u(a)||(a=c+".exe",await u(a)))return a}}const h=g.join(E,A);return await u(h)?h:void 0}e.findExecutable=i}),define(me[206],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var S;(function(_){_.DARK="dark",_.LIGHT="light",_.HIGH_CONTRAST="hc"})(S=e.ColorScheme||(e.ColorScheme={}))}),define(me[98],ge([0,1,39,7,2,6,31,206]),function(Q,e,S,_,g,k,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var d;(function(w){function p(h){return h&&typeof h=="object"&&typeof h.id=="string"}w.isThemeColor=p})(d=e.ThemeColor||(e.ThemeColor={}));function y(w){return{id:w}}e.themeColorFromId=y;var i;(function(w){function p(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||d.isThemeColor(s.color))}w.isThemeIcon=p;const h=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function f(s){const n=h.exec(s);if(!n)return;let[,r]=n;return{id:r}}w.fromString=f;function c(s,n){let r=s.id;const l=r.lastIndexOf("~");return l!==-1&&(r=r.substring(0,l)),n&&(r=`${r}~${n}`),{id:r}}w.modify=c;function a(s,n){return s.id===n.id&&s.color?.id===n.color?.id}w.isEqual=a;function t(s,n){return{id:s.id,color:n?y(n):void 0}}w.asThemeIcon=t,w.asClassNameArray=S.CSSIcon.asClassNameArray,w.asClassName=S.CSSIcon.asClassName,w.asCSSSelector=S.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function A(w){switch(w){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new _.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,g.toDisposable)(()=>{const h=this.themingParticipants.indexOf(p);this.themingParticipants.splice(h,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new E;C.Registry.add(e.Extensions.ThemingContribution,b);function o(w){return b.onColorThemeChange(w)}e.registerThemingParticipant=o;class u extends g.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(h=>this.onThemeChange(h)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,h){let f=this.theme.getColor(p);return f&&h&&(f=h(f,this.theme)),f?f.toString():null}}e.Themable=u}),define(me[207],ge([0,1,39,98]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function g(D,d){const y=D.map(i=>({name:i.profileName,description:k(i)}));return d&&y.push(...d.map(i=>({name:i.title,description:C(i)}))),{values:y.map(i=>i.name),markdownDescriptions:y.map(i=>i.description)}}e.createProfileSchemaEnums=g;function k(D){let d=`$(${_.ThemeIcon.isThemeIcon(D.icon)?D.icon.id:D.icon?D.icon:S.Codicon.terminal.id}) ${D.profileName}
- path: ${D.path}`;return D.args&&(typeof D.args=="string"?d+=`
- args: "${D.args}"`:d+=`
- args: [${D.args.length===0?"":`'${D.args.join("','")}'`}]`),D.overrideName!==void 0&&(d+=`
- overrideName: ${D.overrideName}`),D.color&&(d+=`
- color: ${D.color}`),D.env&&(d+=`
- env: ${JSON.stringify(D.env)}`),d}function C(D){return`$(${_.ThemeIcon.isThemeIcon(D.icon)?D.icon.id:D.icon?D.icon:S.Codicon.terminal.id}) ${D.title}
- extensionIdenfifier: ${D.extensionIdentifier}`}}),define(me[208],ge([0,1,39,156,40,31,207]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const D={args:{description:(0,_.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,_.localize)(1,null),type:"boolean"},icon:{description:(0,_.localize)(2,null),type:"string",enum:Array.from(S.iconRegistry.all,w=>w.id),markdownEnumDescriptions:Array.from(S.iconRegistry.all,w=>`$(${w.id})`)},color:{description:(0,_.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,_.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},d={type:"object",required:["path"],properties:{path:{description:(0,_.localize)(5,null),type:["string","array"],items:{type:"string"}},...D}},y=(0,_.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,_.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),A=(0,_.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),E={id:"terminal",order:100,title:(0,_.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:A},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:y},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,_.localize)(19,null)}},{type:"string",markdownDescription:(0,_.localize)(20,null)}],default:[],markdownDeprecationMessage:A},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,_.localize)(22,null),enum:["PowerShell","Git Bash"]},...D}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(23,null),type:"string"},id:{description:(0,_.localize)(24,null),type:"string"},title:{description:(0,_.localize)(25,null),type:"string"},...D}},{type:"null"},d]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(27,null),type:"string"},id:{description:(0,_.localize)(28,null),type:"string"},title:{description:(0,_.localize)(29,null),type:"string"},...D}},{type:"null"},d]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(31,null),type:"string"},id:{description:(0,_.localize)(32,null),type:"string"},title:{description:(0,_.localize)(33,null),type:"string"},...D}},{type:"null"},d]}},["terminal.integrated.useWslProfiles"]:{description:(0,_.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,_.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,_.localize)(36,null),type:"number",default:100},["terminal.integrated.persistentSessionExperimentalSerializer"]:{scope:1,description:(0,_.localize)(37,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,_.localize)(38,null),type:"boolean",default:!0}}};function b(){k.Registry.as(g.Extensions.Configuration).registerConfiguration(E),u()}e.registerTerminalPlatformConfiguration=b;let o;function u(w,p){const h=k.Registry.as(g.Extensions.Configuration);o&&h.deregisterConfigurations([o]);let f;w&&(f=(0,C.createProfileSchemaEnums)(w?.profiles,p)),o={id:"terminal",order:100,title:(0,_.localize)(39,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(40,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:w?.os===3?f?.values:void 0,markdownEnumDescriptions:w?.os===3?f?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(41,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:w?.os===2?f?.values:void 0,markdownEnumDescriptions:w?.os===2?f?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(42,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:w?.os===1?f?.values:void 0,markdownEnumDescriptions:w?.os===1?f?.markdownDescriptions:void 0}}},h.registerConfiguration(o)}e.registerTerminalDefaultProfileConfiguration=u}),define(me[209],ge([0,1,35,39,5,3,16,80,205,98]),function(Q,e,S,_,g,k,C,D,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function A(t,s,n,r,l=process.env,v,P,L,R){return v=v||{existsFile:C.SymlinkSupport.existsFile,readFile:C.Promises.readFile},k.isWindows?E(n,v,l,P,r.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:r.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:r.getValue("terminal.integrated.defaultProfile.windows"),R,L):f(v,P,n,t&&typeof t=="object"?{...t}:r.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:r.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),R,L,l)}e.detectAvailableProfiles=A;async function E(t,s,n,r,l,v,P,L,R){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),T=`${process.env.windir}\\${m?"Sysnative":"System32"}`;let I=!1;(0,d.getWindowsBuildNumber)()>=16299&&(I=!0),await u(L);const B=new Map;t&&(B.set("PowerShell",{source:"PowerShell",icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),B.set("Windows PowerShell",{path:`${T}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),B.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),B.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),B.set("Command Prompt",{path:`${T}\\cmd.exe`,icon:_.Codicon.terminalCmd,isAutoDetected:!0})),c(v,B);const j=await b(B.entries(),P,s,n,r,R);if(t||!t&&l)try{const ue=await p(`${T}\\${I?"wsl":"bash"}.exe`,P);for(const ce of ue)(!v||!(ce.profileName in v))&&j.push(ce)}catch(ue){r?.info("WSL is not installed, so could not detect WSL profiles")}return j}async function b(t,s,n,r=process.env,l,v){const P=[];for(const[L,R]of t){if(R===null)continue;let m,T,I;if("source"in R){const ue=i?.get(R.source);if(!ue)continue;m=ue.paths,T=R.args||ue.args,R.icon?I=o(R.icon):ue.icon&&(I=ue.icon)}else m=Array.isArray(R.path)?R.path:[R.path],T=k.isWindows||Array.isArray(R.args)?R.args:void 0,I=o(R.icon)||void 0;const B=await v?.(m)||m.slice(),j=await a(L,s,B,n,r,T,R.env,R.overrideName,R.isAutoDetected,l);j?(j.isAutoDetected=R.isAutoDetected,j.icon=I,j.color=R.color,P.push(j)):l?.trace("profile not validated",L,m)}return P}function o(t){return typeof t=="string"?{id:t}:t}async function u(t){i&&!t||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:t||await w(),icon:y.ThemeIcon.asThemeIcon(_.Codicon.terminalPowershell)}))}async function w(){const t=[];for await(const s of(0,D.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function p(t,s){const n=[],r=await new Promise((P,L)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le"},(R,m)=>{if(R)return L("Problem occurred when getting wsl distros");P(m)})});if(!r)return[];const l=new RegExp(/[\r?\n]/),v=r.split(l).filter(P=>P.trim().length>0&&P!=="");for(const P of v){if(P===""||P.startsWith("docker-desktop"))continue;const L=`${P} (WSL)`,R={profileName:L,path:t,args:["-d",`${P}`],isDefault:L===s,icon:h(P)};n.push(R)}return n}function h(t){return t.includes("Ubuntu")?y.ThemeIcon.asThemeIcon(_.Codicon.terminalUbuntu):t.includes("Debian")?y.ThemeIcon.asThemeIcon(_.Codicon.terminalDebian):y.ThemeIcon.asThemeIcon(_.Codicon.terminalLinux)}async function f(t,s,n,r,l,v,P,L){const R=new Map;if(n){const m=(await t.readFile("/etc/shells")).toString(),T=v||m.split(`
`).filter(B=>B.trim().indexOf("#")!==0&&B.trim().length>0),I=new Map;for(const B of T){let j=(0,g.basename)(B),ue=I.get(j)||0;ue++,ue>1&&(j=`${j} (${ue})`),I.set(j,ue),R.set(j,{path:B,isAutoDetected:!0})}}return c(r,R),await b(R.entries(),l,t,L,s,P)}function c(t,s){if(!!t)for(const[n,r]of Object.entries(t))r===null||!("path"in r)&&!("source"in r)?s.delete(n):s.set(n,r)}async function a(t,s,n,r,l,v,P,L,R,m){if(n.length===0)return Promise.resolve(void 0);const T=n.shift();if(T==="")return a(t,s,n,r,l,v,P,L,R);const I={profileName:t,path:T,args:v,env:P,overrideName:L,isAutoDetected:R,isDefault:t===s};if((0,g.basename)(T)===T){const j=l.PATH?l.PATH.split(g.delimiter):void 0;return await(0,d.findExecutable)(T,void 0,j,void 0,r.existsFile)?I:a(t,s,n,r,l,v)}return await r.existsFile((0,g.normalize)(T))?I:a(t,s,n,r,l,v,P,L,R)}}),define(me[210],ge([0,1,7,2,8,3,36,56,34,61,14,90,37,204,97,208,209]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var p;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let h=0,f=class extends _.Disposable{constructor(a,t,s,n){super();this._reconnectConstants=a,this._configurationService=t,this._logService=s,this._telemetryService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new S.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new S.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new S.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new S.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new S.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new S.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new S.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new S.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new S.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new S.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new S.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new S.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new S.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new S.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,(0,u.registerTerminalPlatformConfiguration)(),this._shellEnv=k.isWindows?Promise.resolve(process.env):(0,y.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,_.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new b.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new D.Client(g.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:h,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback,VSCODE_RECONNECT_EXPERIMENTAL_SERIALIZATION:this._reconnectConstants.useExperimentalSerialization?1:0}});this._onPtyHostStart.fire(),C.ProxyChannel.toService(a.getChannel(o.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=p.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const s=a.getChannel(o.TerminalIpcChannels.Log);A.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{A.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const n=C.ProxyChannel.toService(a.getChannel(o.TerminalIpcChannels.PtyHost));return this._register(n.onProcessData(r=>this._onProcessData.fire(r))),this._register(n.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(n.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(n.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(n.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(n.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(n.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(n.onProcessDidChangeHasChildProcesses(r=>this._onProcessDidChangeHasChildProcesses.fire(r))),this._register(n.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(n.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),this._register(n.onDidRequestDetach(r=>this._onDidRequestDetach.fire(r))),[a,n]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,t,s,n,r,l,v,P,L,R,m){const T=setTimeout(()=>this._handleUnresponsiveCreateProcess(),o.HeartbeatConstants.CreateProcessTimeout),I=await this._proxy.createProcess(a,t,s,n,r,l,v,P,L,R,m);return clearTimeout(T),h=Math.max(h,I),I}updateTitle(a,t,s){return this._proxy.updateTitle(a,t,s)}updateIcon(a,t,s){return this._proxy.updateIcon(a,t,s)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,t){return this._proxy.shutdown(a,t)}input(a,t){return this._proxy.input(a,t)}processBinary(a,t){return this._proxy.processBinary(a,t)}resize(a,t,s){return this._proxy.resize(a,t,s)}acknowledgeDataEvent(a,t){return this._proxy.acknowledgeDataEvent(a,t)}setUnicodeVersion(a,t){return this._proxy.setUnicodeVersion(a,t)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,t,s,n=!1){const r=await this._shellEnv;return(0,w.detectAvailableProfiles)(t,s,n,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,t){return this._proxy.requestDetachInstance(a,t)}async acceptDetachInstanceReply(a,t){return this._proxy.acceptDetachInstanceReply(a,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),o.HeartbeatConstants.BeatInterval*o.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${o.HeartbeatConstants.BeatInterval*o.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),o.HeartbeatConstants.BeatInterval*o.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(o.HeartbeatConstants.BeatInterval*o.HeartbeatConstants.FirstWaitMultiplier+o.HeartbeatConstants.BeatInterval*o.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${o.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:t})}async acceptPtyHostResolvedVariables(a,t){this._resolveVariablesRequestStore.acceptReply(a,t)}};f=Le([Xe(1,d.IConfigurationService),Xe(2,i.ILogService),Xe(3,E.ITelemetryService)],f),e.PtyHostService=f}),define(me[99],ge([0,1,27,19,4,6]),function(Q,e,S,_,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var C;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function D(E){const b=E;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=D;function d(E){const b=E;return!!(b&&typeof b=="object"&&g.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=d;class y{constructor(b,o,u,w){this._id=b,this._configuration=u,this._ignorePathCasing=w,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(b){this._id=b.id,this._configuration=b.configuration,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b.with({scheme:b.scheme,authority:b.authority,path:b.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=y;class i{constructor(b,o){this.raw=o,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,_.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function A(E){return new i({uri:E,index:0,name:(0,_.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=A}),define(me[211],ge([0,1,26,38,113,52,8,5,3,19,4,157,6,192,99]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(O){return(typeof O=="string"?(0,D.extname)(O):(0,y.extname)(O))===u}e.hasWorkspaceFileExtension=w,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function p(O){return O.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function h(O){return O.hasOwnProperty("folderUri")}e.isRecentFolder=h;function f(O){return O.hasOwnProperty("fileUri")}e.isRecentFile=f;function c(O){const $=O;return typeof $?.id=="string"&&i.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=c;function a(O){if(O.configuration)return{id:O.id,configPath:O.configuration};if(O.folders.length===1)return{id:O.id,uri:O.folders[0].uri}}e.toWorkspaceIdentifier=a;function t(O){const $=O;return typeof $?.id=="string"&&i.URI.isUri($.configPath)}e.isWorkspaceIdentifier=t;function s(O){const $=O;if($?.uri)return{id:$.id,uri:i.URI.revive($.uri)};const z=O;if(z?.configPath)return{id:z.id,configPath:i.URI.revive(z.configPath)};if(O?.id)return{id:O.id}}e.reviveIdentifier=s;function n(O,$){return y.extUriBiasedIgnorePathCase.isEqualOrParent(O,$.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function r(O){return l(O)||v(O)}e.isStoredWorkspaceFolder=r;function l(O){const $=O;return typeof $?.path=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=l;function v(O){const $=O;return typeof $?.uri=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=v;function P(O,$,z,ee,J=!d.isWindows,H){if(O.scheme!==ee.scheme)return{name:z,uri:O.toString(!0)};let X=$?void 0:H.relativePath(ee,O);if(X!==void 0)X.length===0?X=".":d.isWindows&&O.scheme===C.Schemas.file&&!J&&(X=X.replace(/\//g,"\\"));else if(O.scheme===C.Schemas.file)X=O.fsPath,d.isWindows&&(X=(0,k.normalizeDriveLetter)(X),J&&(X=(0,S.toSlashes)(X)));else{if(!H.isEqualAuthority(O.authority,ee.authority))return{name:z,uri:O.toString(!0)};X=O.path}return{name:z,path:X}}e.getStoredWorkspaceFolder=P;function L(O,$,z){let ee=[],J=new Set;const H=z.dirname($);for(let X of O){let q;if(l(X))X.path&&(q=z.resolvePath(H,X.path));else if(v(X))try{q=i.URI.parse(X.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(W){console.warn(W)}if(q){let W=z.getComparisonKey(q);if(!J.has(W)){J.add(W);const U=X.name||z.basenameOrAuthority(q);ee.push(new o.WorkspaceFolder({uri:q,name:U,index:ee.length},X))}}}return ee}e.toWorkspaceFolders=L;function R(O,$,z,ee,J){let H=m($,O);const X=J.dirname($),q=J.dirname(ee),W=[],U=T(H.folders);for(const ve of H.folders){const Ae=l(ve)?J.resolvePath(X,ve.path):i.URI.parse(ve.uri);let Ie;z?Ie=!1:Ie=!l(ve)||(0,D.isAbsolute)(ve.path),W.push(P(Ae,Ie,ve.name,q,U,J))}const ie={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},ne=g.setProperty(O,["folders"],W,ie);let he=g.applyEdits(O,ne);return H.remoteAuthority===(0,b.getRemoteAuthority)(ee)&&(he=g.applyEdits(he,g.removeProperty(he,["remoteAuthority"],ie))),he}e.rewriteWorkspaceFileForNewLocation=R;function m(O,$){let z=_.parse($);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(ee=>r(ee));else throw new Error(`${O} looks like an invalid workspace file.`);return z}function T(O){return d.isWindows?O.some($=>l($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function I(O){return O.workspace&&typeof O.workspace=="object"&&typeof O.workspace.id=="string"&&typeof O.workspace.configPath=="string"}function B(O){return typeof O.folderUri=="string"}function j(O){return typeof O.fileUri=="string"}function ue(O,$){const z={workspaces:[],files:[]};if(O){const ee=function(H,X){for(let q=0;q<H.length;q++)try{X(H[q],q)}catch(W){$.warn(`Error restoring recent entry ${JSON.stringify(H[q])}: ${W.toString()}. Skip entry.`)}},J=O;if(Array.isArray(J.entries))ee(J.entries,H=>{const X=H.label,q=H.remoteAuthority;I(H)?z.workspaces.push({label:X,remoteAuthority:q,workspace:{id:H.workspace.id,configPath:i.URI.parse(H.workspace.configPath)}}):B(H)?z.workspaces.push({label:X,remoteAuthority:q,folderUri:i.URI.parse(H.folderUri)}):j(H)&&z.files.push({label:X,remoteAuthority:q,fileUri:i.URI.parse(H.fileUri)})});else{const H=O;Array.isArray(H.workspaces3)&&ee(H.workspaces3,(X,q)=>{const W=Array.isArray(H.workspaceLabels)&&H.workspaceLabels[q]||void 0;typeof X=="object"&&typeof X.id=="string"&&typeof X.configURIPath=="string"?z.workspaces.push({label:W,workspace:{id:X.id,configPath:i.URI.parse(X.configURIPath)}}):typeof X=="string"&&z.workspaces.push({label:W,folderUri:i.URI.parse(X)})}),Array.isArray(H.files2)&&ee(H.files2,(X,q)=>{const W=Array.isArray(H.fileLabels)&&H.fileLabels[q]||void 0;typeof X=="string"&&z.files.push({label:W,fileUri:i.URI.parse(X)})})}}return z}e.restoreRecentlyOpened=ue;function ce(O){const $={entries:[]};for(const z of O.workspaces)h(z)?$.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):$.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of O.files)$.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return $}e.toStoreData=ce}),define(me[212],ge([0,1,7,13]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function g(C){let D=0,d=0,y=0;C>=1e3&&(y=Math.floor(C/1e3),C-=y*1e3),y>=60&&(d=Math.floor(y/60),y-=d*60),d>=60&&(D=Math.floor(d/60),d-=D*60);const i=D?`${D}h`:"",A=d?`${d}m`:"",E=y?`${y}s`:"",b=C?`${C}ms`:"";return`${i}${A}${E}${b}`}e.printTime=g;class k{constructor(D,d,y,i){this._logService=D,this._reconnectionToken=d,this._onClose=new S.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=y,this.protocol=i,this._disposed=!1,this._disconnectRunner1=new _.RunOnceScheduler(()=>{this._log(`The reconnection grace time of ${g(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new _.RunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${g(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${g(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(D){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${D}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${g(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const D=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),D.end(),this._onClose.fire(void 0)}acceptReconnection(D,d,y){this._remoteAddress=D,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(d,y),this.protocol.endAcceptReconnection()}}e.ManagementConnection=k}),define(me[100],ge([0,1,28,8,5,122,30]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const D=g.join(_.FileAccess.asFileUri("",Q).fsPath,"nls.metadata.json"),d=new Map;function y(E){return new Promise(b=>S.exists(E,b))}function i(E,b){return y(D).then(o=>{if(!o||!C.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let u=`${E}||${b}`,w=d.get(u);return w||(w=k.getNLSConfiguration(C.default.commit,b,D,E).then(p=>(A.is(p)&&(p._languagePackSupport=!0),p)),d.set(u,w)),w})}e.getNLSConfiguration=i;var A;(function(E){function b(o){let u=o;return u&&typeof u._languagePackId=="string"}E.is=b})(A=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(me[41],ge([0,1,54,8]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createRemoteURITransformer=e.uriTransformerPath=void 0,e.uriTransformerPath=_.FileAccess.asFileUri("vs/server/uriTransformer.js",Q).fsPath;function g(k){const D=Q.__$__nodeRequire(e.uriTransformerPath)(k);return new S.URITransformer(D)}e.createRemoteURITransformer=g}),define(me[213],ge([0,1,7,2,4,41,65,17,5,42,25]),function(Q,e,S,_,g,k,C,D,d,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemChannel=void 0;class A extends _.Disposable{constructor(o,u,w,p){super();this.logService=o,this.environmentService=u,this.uriTransformer=w,this.watcherRequests=new Map,this.fileWatcher=this._register(new C.DiskFileSystemProvider(this.logService,{watcher:this.getWatcherOptions()})),this.registerListeners(p)}registerListeners(o){const u=this._register(new S.Emitter);this._register(u.event(w=>{o.fire(w.map(p=>({resource:this.uriTransformer.transformOutgoingURI(p.resource),type:p.type})))})),this._register(this.fileWatcher.onDidChangeFile(w=>u.fire(w))),this._register(this.fileWatcher.onDidErrorOccur(w=>o.fire(w)))}getWatcherOptions(){const o=this.environmentService.args.fileWatcherPolling;if(o){const u=o.split(d.delimiter),w=Number(u[0]);if(w>0)return{usePolling:u.length>1?u.slice(1):!0,pollingInterval:w}}}watch(o,u,w){const p=g.URI.revive(this.uriTransformer.transformIncoming(u));return this.environmentService.extensionsPath&&(w.excludes=[...w.excludes||[],d.posix.join(this.environmentService.extensionsPath,"**")]),this.watcherRequests.set(o,this.fileWatcher.watch(p,w)),(0,_.toDisposable)(()=>{(0,_.dispose)(this.watcherRequests.get(o)),this.watcherRequests.delete(o)})}dispose(){super.dispose(),this.watcherRequests.forEach(o=>(0,_.dispose)(o)),this.watcherRequests.clear()}}class E extends _.Disposable{constructor(o,u){super();this.logService=o,this.environmentService=u,this.BUFFER_SIZE=256*1024,this.uriTransformerCache=new Map,this.fileWatchers=new Map,this.fsProvider=this._register(new C.DiskFileSystemProvider(this.logService,{bufferSize:this.BUFFER_SIZE})),this.watchRequests=new Map}call(o,u,w){const p=this.getUriTransformer(o.remoteAuthority);switch(u){case"stat":return this.stat(p,w[0]);case"readdir":return this.readdir(p,w[0]);case"open":return this.open(p,w[0],w[1]);case"close":return this.close(w[0]);case"read":return this.read(w[0],w[1],w[2]);case"readFile":return this.readFile(p,w[0]);case"write":return this.write(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.writeFile(p,w[0],w[1],w[2]);case"rename":return this.rename(p,w[0],w[1],w[2]);case"copy":return this.copy(p,w[0],w[1],w[2]);case"mkdir":return this.mkdir(p,w[0]);case"delete":return this.delete(p,w[0],w[1]);case"watch":return Promise.resolve(this.watch(w[0],w[1],w[2],w[3]));case"unwatch":return Promise.resolve(this.unwatch(w[0],w[1]))}throw new Error(`IPC Command ${u} not found`)}listen(o,u,w){const p=this.getUriTransformer(o.remoteAuthority);switch(u){case"filechange":return this.onFileChange(p,w[0]);case"readFileStream":return this.onReadFileStream(p,w[0],w[1])}throw new Error(`Unknown event ${u}`)}onFileChange(o,u){const w=new S.Emitter({onFirstListenerAdd:()=>{this.fileWatchers.set(u,new A(this.logService,this.environmentService,o,w))},onLastListenerRemove:()=>{(0,_.dispose)(this.fileWatchers.get(u)),this.fileWatchers.delete(u)}});return w.event}onReadFileStream(o,u,w){const p=this.transformIncoming(o,u,!0),h=new i.CancellationTokenSource,f=new S.Emitter({onLastListenerRemove:()=>{h.cancel()}}),c=this.fsProvider.readFileStream(p,w,h.token);return(0,y.listenStream)(c,{onData:a=>f.fire(D.VSBuffer.wrap(a)),onError:a=>f.fire(a),onEnd:()=>{f.fire("end"),f.dispose(),h.dispose()}}),f.event}getUriTransformer(o){let u=this.uriTransformerCache.get(o);return u||(u=(0,k.createRemoteURITransformer)(o),this.uriTransformerCache.set(o,u)),u}stat(o,u){const w=this.transformIncoming(o,u,!0);return this.fsProvider.stat(w)}readdir(o,u){const w=this.transformIncoming(o,u);return this.fsProvider.readdir(w)}open(o,u,w){const p=this.transformIncoming(o,u,!0);return this.fsProvider.open(p,w)}close(o){return this.fsProvider.close(o)}async read(o,u,w){const p=D.VSBuffer.alloc(w),h=0,f=await this.fsProvider.read(o,u,p.buffer,h,w);return[p,f]}async readFile(o,u){const w=this.transformIncoming(o,u,!0),p=await this.fsProvider.readFile(w);return D.VSBuffer.wrap(p)}write(o,u,w,p,h){return this.fsProvider.write(o,u,w.buffer,p,h)}writeFile(o,u,w,p){const h=this.transformIncoming(o,u);return this.fsProvider.writeFile(h,w.buffer,p)}rename(o,u,w,p){const h=g.URI.revive(o.transformIncoming(u)),f=g.URI.revive(o.transformIncoming(w));return this.fsProvider.rename(h,f,p)}copy(o,u,w,p){const h=this.transformIncoming(o,u),f=this.transformIncoming(o,w);return this.fsProvider.copy(h,f,p)}mkdir(o,u){const w=this.transformIncoming(o,u);return this.fsProvider.mkdir(w)}delete(o,u,w){const p=this.transformIncoming(o,u);return this.fsProvider.delete(p,w)}transformIncoming(o,u,w=!1){if(w&&u.path==="/vscode-resource"&&u.query){const p=JSON.parse(u.query).requestResourcePath;return g.URI.from({scheme:"file",path:p})}return g.URI.revive(o.transformIncoming(u))}watch(o,u,w,p){const h=o+u,f=this.fileWatchers.get(o);if(f){const c=f.watch(u,w,p);this.watchRequests.set(h,c)}}unwatch(o,u){const w=o+u,p=this.watchRequests.get(w);p&&((0,_.dispose)(p),this.watchRequests.delete(w))}dispose(){super.dispose(),this.watchRequests.forEach(o=>(0,_.dispose)(o)),this.watchRequests.clear(),this.fileWatchers.forEach(o=>(0,_.dispose)(o)),this.fileWatchers.clear()}}e.RemoteAgentFileSystemChannel=E}),define(me[69],ge([0,1,159,168,57,6,29]),function(Q,e,S,_,g,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={port:{type:"string"},connectionToken:{type:"string"},"connection-secret":{type:"string",description:S.localize(0,null)},host:{type:"string"},"socket-path":{type:"string"},driver:{type:"string"},"start-server":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"disable-websocket-compression":{type:"boolean"},fileWatcherPolling:{type:"string"},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"without-browser-env-var":{type:"boolean"},"disable-telemetry":g.OPTIONS["disable-telemetry"],"extensions-dir":g.OPTIONS["extensions-dir"],"extensions-download-dir":g.OPTIONS["extensions-download-dir"],"install-extension":g.OPTIONS["install-extension"],"install-builtin-extension":g.OPTIONS["install-builtin-extension"],"uninstall-extension":g.OPTIONS["uninstall-extension"],"locate-extension":g.OPTIONS["locate-extension"],"list-extensions":g.OPTIONS["list-extensions"],force:g.OPTIONS.force,"show-versions":g.OPTIONS["show-versions"],category:g.OPTIONS.category,"do-not-sync":g.OPTIONS["do-not-sync"],"force-disable-user-env":g.OPTIONS["force-disable-user-env"],folder:{type:"string"},workspace:{type:"string"},"web-user-data-dir":{type:"string"},"use-host-proxy":{type:"string"},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},log:{type:"string"},logsPath:{type:"string"},_:g.OPTIONS._},e.IServerEnvironmentService=(0,k.refineServiceDecorator)(C.IEnvironmentService);class D extends _.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=D}),define(me[214],ge([0,1,28,67,124,245,64,26,53,3,4,41,30,5,8,23,22]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.serveError=void 0;const p={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function h(t,s,n,r){s.writeHead(n,{"Content-Type":"text/plain"}),s.end(r)}e.serveError=h;async function f(t,s,n,r,l=Object.create(null)){try{const v=await g.promisify(S.stat)(r),P=`W/"${[v.ino,v.size,v.mtime.getTime()].join("-")}"`;if(s.headers["if-none-match"]===P)return n.writeHead(304),n.end();l["Content-Type"]=p[(0,b.extname)(r)]||(0,d.getMediaMime)(r)||"text/plain",l.Etag=P,n.writeHead(200,l),S.createReadStream(r).pipe(n)}catch(v){return v.code!=="ENOENT"&&(t.error(v),console.error(v.toString())),n.writeHead(404,{"Content-Type":"text/plain"}),n.end("Not found")}}e.serveFile=f;const c=(0,b.dirname)(o.FileAccess.asFileUri("",Q).fsPath);class a{constructor(s,n,r){this._connectionToken=s,this._environmentService=n,this._logService=r,this._mapCallbackUriToRequestId=new Map}async handle(s,n,r){try{const l=r.pathname;return l==="/favicon.ico"||l==="/manifest.json"||l==="/code-192.png"||l==="/code-512.png"?f(this._logService,s,n,(0,b.join)(c,"resources","server",l.substr(1))):/^\/static\//.test(l)?this._handleStatic(s,n,r):l==="/"?this._handleRoot(s,n,r):l==="/callback"?this._handleCallback(s,n,r):l==="/fetch-callback"?this._handleFetchCallback(s,n,r):h(s,n,404,"Not found.")}catch(l){return this._logService.error(l),console.error(l.toString()),h(s,n,500,"Internal Server Error.")}}_hasCorrectTokenCookie(s){return k.parse(s.headers.cookie||"")["vscode-tkn"]===this._connectionToken}async _handleStatic(s,n,r){const l=Object.create(null),v=decodeURIComponent(r.pathname),P=(0,b.normalize)(v.substr("/static/".length)),L=(0,b.join)(c,P);return(0,D.isEqualOrParent)(L,c,!y.isLinux)?f(this._logService,s,n,L,l):h(s,n,400,"Bad request.")}async _handleRoot(s,n,r){if(!s.headers.host)return h(s,n,400,"Bad request.");const l=r.query.tkn;if(typeof l=="string"){const ce=Object.create(null);ce["Set-Cookie"]=k.serialize("vscode-tkn",l,{sameSite:"strict",maxAge:60*60*24*7});const O=Object.create(null);for(let z in r.query)z!=="tkn"&&(O[z]=r.query[z]);const $=_.format({pathname:"/",query:O});return ce.Location=$,n.writeHead(302,ce),n.end()}if(this._environmentService.isBuilt&&!this._hasCorrectTokenCookie(s))return h(s,n,403,"Forbidden.");const v=s.headers.host,P=(0,A.createRemoteURITransformer)(v),{workspacePath:L,isFolder:R}=await this._getWorkspaceFromCLI();function m(ce){return ce.replace(/"/g,"&quot;")}let T;this._environmentService.driverHandle&&(T=!1);const I=o.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",Q).fsPath,B=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,u.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,j=(await g.promisify(S.readFile)(I)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",m(JSON.stringify({folderUri:L&&R?P.transformOutgoing(i.URI.file(L)):void 0,workspaceUri:L&&!R?P.transformOutgoing(i.URI.file(L)):void 0,remoteAuthority:v,_wrapWebWorkerExtHostInIframe:T,developmentOptions:{enableSmokeTestDriver:this._environmentService.driverHandle==="web"?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>B?m(JSON.stringify(B)):""),ue=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' 'unsafe-eval' https://az416426.vo.msecnd.net ${this._getScriptCspHashes(j).join(" ")} 'sha256-cb2sg39EJV8ABaSNFfWu/ou8o1xVXYK7jp90oZ9vpcg=' http://${v};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview-test.com https://vscodeweb.azureedge.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ");return n.writeHead(200,{"Content-Type":"text/html","Set-Cookie":k.serialize("vscode-tkn",this._connectionToken,{sameSite:"strict",maxAge:60*60*24*7}),"Content-Security-Policy":ue}),n.end(j)}_getScriptCspHashes(s){const n=/<script>([\s\S]+?)<\/script>/img,r=[];let l;for(;l=n.exec(s);){const v=C.createHash("sha256"),P=l[1].replace(/\r\n/g,`
`),L=v.update(Buffer.from(P)).digest().toString("base64");r.push(`'sha256-${L}'`)}return r}async _getWorkspaceFromCLI(){const s=this._environmentService.args.workspace;if(s&&s.length>0){const r=(0,D.sanitizeFilePath)(s,(0,w.cwd)());if(await g.promisify(S.exists)(r))return{workspacePath:r}}const n=this._environmentService.args.folder;if(n&&n.length>0){const r=(0,D.sanitizeFilePath)(n,(0,w.cwd)());if(await g.promisify(S.exists)(r))return{workspacePath:r,isFolder:!0}}return{}}_getFirstQueryValue(s,n){const r=s.query[n];return Array.isArray(r)?r[0]:r}_getFirstQueryValues(s,n){const r=new Map;for(const l in s.query){if(n&&n.indexOf(l)>=0)continue;const v=this._getFirstQueryValue(s,l);typeof v=="string"&&r.set(l,v)}return r}async _handleCallback(s,n,r){const l=["vscode-requestId","vscode-scheme","vscode-authority","vscode-path","vscode-query","vscode-fragment"],[v,P,L,R,m,T]=l.map(j=>{const ue=this._getFirstQueryValue(r,j);return ue&&decodeURIComponent(ue)});if(!v)return n.writeHead(400,{"Content-Type":"text/plain"}),n.end("Bad request.");let I=m,B=0;return this._getFirstQueryValues(r,l).forEach((j,ue)=>{I||(I=""),I+=`${B++==0?"":"&"}${ue}=${j}`}),this._mapCallbackUriToRequestId.set(v,i.URI.from({scheme:P||E.default.urlProtocol,authority:L,path:R,query:I,fragment:T}).toJSON()),f(this._logService,s,n,o.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",Q).fsPath,{"Content-Type":"text/html"})}async _handleFetchCallback(s,n,r){const l=this._getFirstQueryValue(r,"vscode-requestId");if(!l)return n.writeHead(400,{"Content-Type":"text/plain"}),n.end("Bad request.");const v=this._mapCallbackUriToRequestId.get(l);return v&&this._mapCallbackUriToRequestId.delete(l),n.writeHead(200,{"Content-Type":"text/json"}),n.end(JSON.stringify(v))}}e.WebClientServer=a}),define(me[215],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,S.createDecorator)("IExtHostRpcService");class _{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.ExtHostRpcService=_}),define(me[216],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var S;(function(h){h[h.Upsert=0]="Upsert",h[h.RemoveChild=1]="RemoveChild",h[h.Invalidated=2]="Invalidated",h[h.SetProp=3]="SetProp",h[h.Bulk=4]="Bulk"})(S=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const _=new WeakMap,g=(h,f)=>{const c={controllerId:f};return _.set(h,c),c};e.createPrivateApiFor=g;const k=h=>_.get(h);e.getPrivateApiFor=k;const C=(h,f,c,a)=>{let t=c;return{enumerable:!0,configurable:!1,get(){return t},set(s){if(!a(t,s)){const n=t;t=s,h.listener?.({op:3,key:f,value:s,previous:n})}}}},D=(h,f)=>h===f,d={range:(h,f)=>h===f?!0:!h||!f?!1:h.isEqual(f),label:D,description:D,busy:D,error:D,canResolveChildren:D,tags:(h,f)=>!(h.length!==f.length||h.some(c=>!f.find(a=>c.id===a.id)))},y=Object.keys(d),i=(h,f)=>({range:C(h,"range",void 0,d.range),label:C(h,"label",f,d.label),description:C(h,"description",void 0,d.description),canResolveChildren:C(h,"canResolveChildren",!1,d.canResolveChildren),busy:C(h,"busy",!1,d.busy),error:C(h,"error",void 0,d.error),tags:C(h,"tags",[],d.tags)}),A=(h,f)=>{const c=new Map;for(const a of y)d[a](h[a],f[a])||c.set(a,f[a]);return c};e.diffTestItems=A;class E extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=E;class b extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class o extends Error{constructor(f,c,a){super(`TestItem with ID "${f}" is from controller "${c}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=o;const u=h=>{const f=(0,e.getPrivateApiFor)(h);let c=new Map;return{get size(){return c.size},forEach(a,t){for(const s of c.values())a.call(t,s,this)},replace(a){const t=new Map,s=new Set(c.keys()),n={op:4,ops:[]};for(const r of a){if(!(r instanceof w))throw new b(r.id);const l=(0,e.getPrivateApiFor)(r).controllerId;if(l!==f.controllerId)throw new o(r.id,l,f.controllerId);if(t.has(r.id))throw new E(r.id);t.set(r.id,r),s.delete(r.id),n.ops.push({op:0,item:r})}for(const r of s.keys())n.ops.push({op:1,id:r});f.listener?.(n),c=t},add(a){if(!(a instanceof w))throw new b(a.id);c.set(a.id,a),f.listener?.({op:0,item:a})},delete(a){c.delete(a)&&f.listener?.({op:1,id:a})},get(a){return c.get(a)},toJSON(){return Array.from(c.values())},[Symbol.iterator](){return c.values()}}};class w{constructor(f,c,a,t){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const s=(0,e.createPrivateApiFor)(this,f);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof p?void 0:s.parent}},children:{value:u(this),enumerable:!0,writable:!1},...i(s,a)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=w;class p extends w{constructor(f,c){super(f,f,c,void 0)}}e.TestItemRootImpl=p});var It=this&&this.__classPrivateFieldSet||function(Q,e,S,_,g){if(_==="m")throw new TypeError("Private method is not writable");if(_==="a"&&!g)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!g:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return _==="a"?g.call(Q,S):g?g.value=S:e.set(Q,S),S},lt=this&&this.__classPrivateFieldGet||function(Q,e,S,_){if(S==="a"&&!_)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!_:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?_:S==="a"?_.call(Q):_?_.value:e.get(Q)};define(me[101],ge([0,1,20,11,74,27,53,12,4,23,21,95]),function(Q,e,S,_,g,k,C,D,d,y,i,A){"use strict";var E,b,o,u,w,p,h,f,c,a,t,s,n,r,l,v,P,L,R,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function T(N){function F(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(F,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(F,N),Object.setPrototypeOf(F.prototype,N.prototype),F}let I=w=class{constructor(F){E.set(this,void 0),It(this,E,F,"f")}static from(...F){let G=F;return new w(function(){if(G){for(const ye of G)ye&&typeof ye.dispose=="function"&&ye.dispose();G=void 0}})}dispose(){typeof lt(this,E,"f")=="function"&&(lt(this,E,"f").call(this),It(this,E,void 0,"f"))}};E=new WeakMap,I=w=Le([T],I),e.Disposable=I;let B=p=class{constructor(F,G){if(F<0)throw(0,_.illegalArgument)("line must be non-negative");if(G<0)throw(0,_.illegalArgument)("character must be non-negative");this._line=F,this._character=G}static Min(...F){if(F.length===0)throw new TypeError;let G=F[0];for(let ye=1;ye<F.length;ye++){const $e=F[ye];$e.isBefore(G)&&(G=$e)}return G}static Max(...F){if(F.length===0)throw new TypeError;let G=F[0];for(let ye=1;ye<F.length;ye++){const $e=F[ye];$e.isAfter(G)&&(G=$e)}return G}static isPosition(F){if(!F)return!1;if(F instanceof p)return!0;let{line:G,character:ye}=F;return typeof G=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,G=0){if(F===null||G===null)throw(0,_.illegalArgument)();let ye;return typeof F=="undefined"?ye=0:typeof F=="number"?ye=F:(ye=typeof F.lineDelta=="number"?F.lineDelta:0,G=typeof F.characterDelta=="number"?F.characterDelta:0),ye===0&&G===0?this:new p(this.line+ye,this.character+G)}with(F,G=this.character){if(F===null||G===null)throw(0,_.illegalArgument)();let ye;return typeof F=="undefined"?ye=this.line:typeof F=="number"?ye=F:(ye=typeof F.line=="number"?F.line:this.line,G=typeof F.character=="number"?F.character:this.character),ye===this.line&&G===this.character?this:new p(ye,G)}toJSON(){return{line:this.line,character:this.character}}};B=p=Le([T],B),e.Position=B;let j=h=class{constructor(F,G,ye,$e){let Ye,et;if(typeof F=="number"&&typeof G=="number"&&typeof ye=="number"&&typeof $e=="number"?(Ye=new B(F,G),et=new B(ye,$e)):F instanceof B&&G instanceof B&&(Ye=F,et=G),!Ye||!et)throw new Error("Invalid arguments");Ye.isBefore(et)?(this._start=Ye,this._end=et):(this._start=et,this._end=Ye)}static isRange(F){return F instanceof h?!0:F?B.isPosition(F.start)&&B.isPosition(F.end):!1}get start(){return this._start}get end(){return this._end}contains(F){return F instanceof h?this.contains(F._start)&&this.contains(F._end):F instanceof B?!(F.isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const G=B.Max(F.start,this._start),ye=B.Min(F.end,this._end);if(!G.isAfter(ye))return new h(G,ye)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const G=B.Min(F.start,this._start),ye=B.Max(F.end,this.end);return new h(G,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,G=this.end){if(F===null||G===null)throw(0,_.illegalArgument)();let ye;return F?B.isPosition(F)?ye=F:(ye=F.start||this.start,G=F.end||this.end):ye=this.start,ye.isEqual(this._start)&&G.isEqual(this.end)?this:new h(ye,G)}toJSON(){return[this.start,this.end]}};j=h=Le([T],j),e.Range=j;let ue=f=class extends j{constructor(F,G,ye,$e){let Ye,et;if(typeof F=="number"&&typeof G=="number"&&typeof ye=="number"&&typeof $e=="number"?(Ye=new B(F,G),et=new B(ye,$e)):F instanceof B&&G instanceof B&&(Ye=F,et=G),!Ye||!et)throw new Error("Invalid arguments");super(Ye,et);this._anchor=Ye,this._active=et}static isSelection(F){return F instanceof f?!0:F?j.isRange(F)&&B.isPosition(F.anchor)&&B.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ue=f=Le([T],ue),e.Selection=ue;class ce{constructor(F,G,ye){if(typeof F!="string"||F.length===0)throw(0,_.illegalArgument)("host");if(typeof G!="number"||G===0||Math.round(G)!==G)throw(0,_.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,_.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(G),this.connectionToken=ye}}e.ResolvedAuthority=ce;class O extends Error{constructor(F,G=A.RemoteAuthorityResolverErrorCode.Unknown,ye){super(F);this._message=F,this._code=G,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,O.prototype)}static NotAvailable(F,G){return new O(F,A.RemoteAuthorityResolverErrorCode.NotAvailable,G)}static TemporarilyNotAvailable(F){return new O(F,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=O;var $;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var z;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=c=class{constructor(F,G){this._range=F,this._newText=G}static isTextEdit(F){return F instanceof c?!0:F?j.isRange(F)&&typeof F.newText=="string":!1}static replace(F,G){return new c(F,G)}static insert(F,G){return c.replace(new j(F,F),G)}static delete(F){return c.replace(F,"")}static setEndOfLine(F){const G=new c(new j(new B(0,0),new B(0,0)),"");return G.newEol=F,G}get range(){return this._range}set range(F){if(F&&!j.isRange(F))throw(0,_.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,_.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,_.illegalArgument)("newEol");this._newEol=F}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=c=Le([T],ee),e.TextEdit=ee;var J;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(J=e.FileEditType||(e.FileEditType={}));let H=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,G,ye,$e){this._edits.push({_type:1,from:F,to:G,options:ye,metadata:$e})}createFile(F,G,ye){this._edits.push({_type:1,from:void 0,to:F,options:G,metadata:ye})}deleteFile(F,G,ye){this._edits.push({_type:1,from:F,to:void 0,options:G,metadata:ye})}replaceNotebookMetadata(F,G,ye){this._edits.push({_type:3,metadata:ye,uri:F,edit:{editType:5,metadata:G},notebookMetadata:G})}replaceNotebookCells(F,G,ye,$e,Ye){let et,nt,ft=[],ht;if(kt.isNotebookRange(G)&&St.isNotebookCellDataArray(ye)&&!St.isNotebookCellDataArray($e)?(et=G.start,nt=G.end,ft=ye,ht=$e):typeof G=="number"&&typeof ye=="number"&&St.isNotebookCellDataArray($e)&&(et=G,nt=ye,ft=$e,ht=Ye),et===void 0||nt===void 0)throw new Error("Invalid arguments");(et!==nt||ft.length>0)&&this._edits.push({_type:5,uri:F,index:et,count:nt-et,cells:ft,metadata:ht})}replaceNotebookCellMetadata(F,G,ye,$e){this._edits.push({_type:3,metadata:$e,uri:F,edit:{editType:8,index:G,metadata:ye}})}replace(F,G,ye,$e){this._edits.push({_type:2,uri:F,edit:new ee(G,ye),metadata:$e})}insert(F,G,ye,$e){this.replace(F,new j(G,G),ye,$e)}delete(F,G,ye){this.replace(F,G,"",ye)}has(F){return this._edits.some(G=>G._type===2&&G.uri.toString()===F.toString())}set(F,G){if(G)for(const ye of G)ye&&this._edits.push({_type:2,uri:F,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const $e=this._edits[ye];$e._type===2&&$e.uri.toString()===F.toString()&&(this._edits[ye]=void 0)}(0,S.coalesceInPlace)(this._edits)}}get(F){const G=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===F.toString()&&G.push(ye.edit);return G}entries(){const F=new k.ResourceMap;for(let G of this._edits)if(G._type===2){let ye=F.get(G.uri);ye||(ye=[G.uri,[]],F.set(G.uri,ye)),ye[1].push(G.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};H=Le([T],H),e.WorkspaceEdit=H;let X=a=class{constructor(F){this._tabstop=1,this.value=F||""}static isSnippetString(F){return F instanceof a?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}appendText(F){return this.value+=a._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,G=this._tabstop++){if(typeof F=="function"){const ye=new a;ye._tabstop=this._tabstop,F(ye),this._tabstop=ye._tabstop,F=ye.value}else F=a._escape(F);return this.value+="${",this.value+=G,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,G=this._tabstop++){const ye=F.map($e=>$e.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=G,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(F,G){if(typeof G=="function"){const ye=new a;ye._tabstop=this._tabstop,G(ye),this._tabstop=ye._tabstop,G=ye.value}else typeof G=="string"&&(G=G.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,G&&(this.value+=":",this.value+=G),this.value+="}",this}};X=a=Le([T],X),e.SnippetString=X;var q;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(q=e.DiagnosticTag||(e.DiagnosticTag={}));var W;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(W=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let U=t=class{constructor(F,G){if(this.uri=F,G)if(G instanceof j)this.range=G;else if(G instanceof B)this.range=new j(G,G);else throw new Error("Illegal argument")}static isLocation(F){return F instanceof t?!0:F?j.isRange(F.range)&&d.URI.isUri(F.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};U=t=Le([T],U),e.Location=U;let ie=class{constructor(F,G){this.location=F,this.message=G}static is(F){return F?typeof F.message=="string"&&F.location&&j.isRange(F.location.range)&&d.URI.isUri(F.location.uri):!1}static isEqual(F,G){return F===G?!0:!F||!G?!1:F.message===G.message&&F.location.range.isEqual(G.location.range)&&F.location.uri.toString()===G.location.uri.toString()}};ie=Le([T],ie),e.DiagnosticRelatedInformation=ie;let ne=class{constructor(F,G,ye=W.Error){if(!j.isRange(F))throw new TypeError("range must be set");if(!G)throw new TypeError("message must be set");this.range=F,this.message=G,this.severity=ye}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,G){return F===G?!0:!F||!G?!1:F.message===G.message&&F.severity===G.severity&&F.code===G.code&&F.severity===G.severity&&F.source===G.source&&F.range.isEqual(G.range)&&(0,S.equals)(F.tags,G.tags)&&(0,S.equals)(F.relatedInformation,G.relatedInformation,ie.isEqual)}};ne=Le([T],ne),e.Diagnostic=ne;let he=class{constructor(F,G){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=G}};he=Le([T],he),e.Hover=he;var ve;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ae=class{constructor(F,G=ve.Text){this.range=F,this.kind=G}toJSON(){return{range:this.range,kind:ve[this.kind]}}};Ae=Le([T],Ae),e.DocumentHighlight=Ae;var Ie;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Ie=e.SymbolKind||(e.SymbolKind={}));var Ue;(function(N){N[N.Deprecated=1]="Deprecated"})(Ue=e.SymbolTag||(e.SymbolTag={}));let qe=s=class{constructor(F,G,ye,$e,Ye){this.name=F,this.kind=G,this.containerName=Ye,typeof ye=="string"&&(this.containerName=ye),$e instanceof U?this.location=$e:ye instanceof j&&(this.location=new U($e,ye)),s.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};qe=s=Le([T],qe),e.SymbolInformation=qe;let Ge=n=class{constructor(F,G,ye,$e,Ye){this.name=F,this.detail=G,this.kind=ye,this.range=$e,this.selectionRange=Ye,this.children=[],n.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children&&F.children.forEach(n.validate)}};Ge=n=Le([T],Ge),e.DocumentSymbol=Ge;var rt;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(rt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let it=class{constructor(F,G){this.title=F,this.kind=G}};it=Le([T],it),e.CodeAction=it;let de=r=class{constructor(F){this.value=F}append(F){return new r(this.value?this.value+r.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+r.sep)}};de.sep=".",de=r=Le([T],de),e.CodeActionKind=de,de.Empty=new de(""),de.QuickFix=de.Empty.append("quickfix"),de.Refactor=de.Empty.append("refactor"),de.RefactorExtract=de.Refactor.append("extract"),de.RefactorInline=de.Refactor.append("inline"),de.RefactorRewrite=de.Refactor.append("rewrite"),de.Source=de.Empty.append("source"),de.SourceOrganizeImports=de.Source.append("organizeImports"),de.SourceFixAll=de.Source.append("fixAll");let be=class{constructor(F,G){if(this.range=F,this.parent=G,G&&!G.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=Le([T],be),e.SelectionRange=be;class Pe{constructor(F,G,ye,$e,Ye,et){this.kind=F,this.name=G,this.detail=ye,this.uri=$e,this.range=Ye,this.selectionRange=et}}e.CallHierarchyItem=Pe;class Re{constructor(F,G){this.fromRanges=G,this.from=F}}e.CallHierarchyIncomingCall=Re;class Ne{constructor(F,G){this.fromRanges=G,this.to=F}}e.CallHierarchyOutgoingCall=Ne;var He;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(He=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ke=class{constructor(F,G){this.range=F,this.command=G}get isResolved(){return!!this.command}};Ke=Le([T],Ke),e.CodeLens=Ke;let Je=l=class{constructor(F,G=!1){b.set(this,void 0),It(this,b,new g.MarkdownString(F,{supportThemeIcons:G}),"f")}static isMarkdownString(F){return F instanceof l?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}get value(){return lt(this,b,"f").value}set value(F){lt(this,b,"f").value=F}get isTrusted(){return lt(this,b,"f").isTrusted}set isTrusted(F){lt(this,b,"f").isTrusted=F}get supportThemeIcons(){return lt(this,b,"f").supportThemeIcons}set supportThemeIcons(F){lt(this,b,"f").supportThemeIcons=F}appendText(F){return lt(this,b,"f").appendText(F),this}appendMarkdown(F){return lt(this,b,"f").appendMarkdown(F),this}appendCodeblock(F,G){return lt(this,b,"f").appendCodeblock(G??"",F),this}};b=new WeakMap,Je=l=Le([T],Je),e.MarkdownString=Je;let st=class{constructor(F,G){this.label=F,this.documentation=G}};st=Le([T],st),e.ParameterInformation=st;let oe=class{constructor(F,G){this.label=F,this.documentation=G,this.parameters=[]}};oe=Le([T],oe),e.SignatureInformation=oe;let pe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};pe=Le([T],pe),e.SignatureHelp=pe;var Se;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Be;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Be=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor(F,G,ye){this.text=F,this.position=G,this.kind=ye}};xe=Le([T],xe),e.InlayHint=xe;var ot;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ot=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Qe;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Qe=e.CompletionItemKind||(e.CompletionItemKind={}));var at;(function(N){N[N.Deprecated=1]="Deprecated"})(at=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(F,G){this.label=F,this.kind=G}toJSON(){return{label:this.label,kind:this.kind&&Qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=Le([T],Ze),e.CompletionItem=Ze;let K=class{constructor(F=[],G=!1){this.items=F,this.isIncomplete=G}};K=Le([T],K),e.CompletionList=K;let we=class{constructor(F,G,ye){this.text=F,this.range=G,this.command=ye}};we=Le([T],we),e.InlineSuggestion=we;let ke=class{constructor(F){this.items=F}};ke=Le([T],ke),e.InlineSuggestions=ke;var Oe;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(Oe=e.ViewColumn||(e.ViewColumn={}));var Te;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Te=e.StatusBarAlignment||(e.StatusBarAlignment={}));var We;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(We=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Z;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var te;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var le;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var V;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(V=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var x;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function F(G){switch(G){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=F}(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let se=class{constructor(F,G){if(G&&!d.URI.isUri(G))throw(0,_.illegalArgument)("target");if(!j.isRange(F)||F.isEmpty)throw(0,_.illegalArgument)("range");this.range=F,this.target=G}};se=Le([T],se),e.DocumentLink=se;let re=class{constructor(F,G,ye,$e){this.red=F,this.green=G,this.blue=ye,this.alpha=$e}};re=Le([T],re),e.Color=re;let Ee=class{constructor(F,G){if(G&&!(G instanceof re))throw(0,_.illegalArgument)("color");if(!j.isRange(F)||F.isEmpty)throw(0,_.illegalArgument)("range");this.range=F,this.color=G}};Ee=Le([T],Ee),e.ColorInformation=Ee;let Fe=class{constructor(F){if(!F||typeof F!="string")throw(0,_.illegalArgument)("label");this.label=F}};Fe=Le([T],Fe),e.ColorPresentation=Fe;var _e;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(_e=e.ColorFormat||(e.ColorFormat={}));var Me;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Me=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class je{constructor(F,G,ye){if(this.startIndex=F,this.length=G,this.tooltip=ye,typeof F!="number"||F<0)throw(0,_.illegalArgument)("startIndex");if(typeof G!="number"||G<1)throw(0,_.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,_.illegalArgument)("tooltip")}}e.TerminalLink=je;var ae;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(ae=e.TerminalLocation||(e.TerminalLocation={}));class fe{constructor(F){this.options=F,typeof F!="object"&&(0,_.illegalArgument)("options")}}e.TerminalProfile=fe;var Y;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Y=e.TaskRevealKind||(e.TaskRevealKind={}));var M;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(M=e.TaskPanelKind||(e.TaskPanelKind={}));let De=v=class{constructor(F,G){if(this.label=G,typeof F!="string"||typeof G!="string")throw(0,_.illegalArgument)("name");this._id=F}static from(F){switch(F){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}get id(){return this._id}};De.Clean=new v("clean","Clean"),De.Build=new v("build","Build"),De.Rebuild=new v("rebuild","Rebuild"),De.Test=new v("test","Test"),De=v=Le([T],De),e.TaskGroup=De;function Ce(N){let F="";for(let G=0;G<N.length;G++)F+=N[G].replace(/,/g,",,")+",";return F}let Ve=class{constructor(F,G,ye){if(typeof F!="string")throw(0,_.illegalArgument)("process");this._args=[],this._process=F,G!==void 0&&(Array.isArray(G)?(this._args=G,this._options=ye):this._options=G)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,_.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(let G of this._args)F.push(G);return Ce(F)}};Ve=Le([T],Ve),e.ProcessExecution=Ve;let ze=class{constructor(F,G,ye){if(this._args=[],Array.isArray(G)){if(!F)throw(0,_.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,_.illegalArgument)("command");this._command=F,this._args=G,this._options=ye}else{if(typeof F!="string")throw(0,_.illegalArgument)("commandLine");this._commandLine=F,this._options=G}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,_.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,_.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let G of this._args)F.push(typeof G=="string"?G:G.value);return Ce(F)}};ze=Le([T],ze),e.ShellExecution=ze;var tt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(tt=e.ShellQuoting||(e.ShellQuoting={}));var ct;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(ct=e.TaskScope||(e.TaskScope={}));class gt{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=gt;let ut=P=class{constructor(F,G,ye,$e,Ye,et){this.__deprecated=!1,this._definition=this.definition=F;let nt;typeof G=="string"?(this._name=this.name=G,this._source=this.source=ye,this.execution=$e,nt=Ye,this.__deprecated=!0):G===ct.Global||G===ct.Workspace?(this.target=G,this._name=this.name=ye,this._source=this.source=$e,this.execution=Ye,nt=et):(this.target=G,this._name=this.name=ye,this._source=this.source=$e,this.execution=Ye,nt=et),typeof nt=="string"?(this._problemMatchers=[nt],this._hasDefinedMatchers=!0):Array.isArray(nt)?(this._problemMatchers=nt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ve?this._definition={type:P.ProcessType,id:this._execution.computeId()}:this._execution instanceof ze?this._definition={type:P.ShellType,id:this._execution.computeId()}:this._execution instanceof gt?this._definition={type:P.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:P.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,_.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,_.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const G=this._definition.type;(P.EmptyType===G||P.ProcessType===G||P.ShellType===G||P.ExtensionCallbackType===G)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,_.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};ut.ExtensionCallbackType="customExecution",ut.ProcessType="process",ut.ShellType="shell",ut.EmptyType="$empty",ut=P=Le([T],ut),e.Task=ut;var dt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor(F,G=Pt.None){this.collapsibleState=G,d.URI.isUri(F)?this.resourceUri=F:this.label=F}};mt=Le([T],mt),e.TreeItem=mt;var Pt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Et=class{constructor(F,G){this.id=F,this.color=G}};Et=Le([T],Et),e.ThemeIcon=Et,Et.File=new Et("file"),Et.Folder=new Et("folder");let Lt=class{constructor(F){this.id=F}};Lt=Le([T],Lt),e.ThemeColor=Lt;var an;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(an=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ft=class{constructor(F,G){if(typeof F!="string"&&(!F||!d.URI.isUri(F)&&!d.URI.isUri(F.uri)))throw(0,_.illegalArgument)("base");if(typeof G!="string")throw(0,_.illegalArgument)("pattern");typeof F=="string"?(this.baseFolder=d.URI.file(F),this.base=F):d.URI.isUri(F)?(this.baseFolder=F,this.base=F.fsPath):(this.baseFolder=F.uri,this.base=F.uri.fsPath),this.pattern=G}};Ft=Le([T],Ft),e.RelativePattern=Ft;let Dt=class{constructor(F,G,ye,$e){this.enabled=typeof F=="boolean"?F:!0,typeof G=="string"&&(this.condition=G),typeof ye=="string"&&(this.hitCondition=ye),typeof $e=="string"&&(this.logMessage=$e)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};Dt=Le([T],Dt),e.Breakpoint=Dt;let Ot=class extends Dt{constructor(F,G,ye,$e,Ye){super(G,ye,$e,Ye);if(F===null)throw(0,_.illegalArgument)("location");this.location=F}};Ot=Le([T],Ot),e.SourceBreakpoint=Ot;let Nt=class extends Dt{constructor(F,G,ye,$e,Ye){super(G,ye,$e,Ye);this.functionName=F}};Nt=Le([T],Nt),e.FunctionBreakpoint=Nt;let Mt=class extends Dt{constructor(F,G,ye,$e,Ye,et,nt){super($e,Ye,et,nt);if(!G)throw(0,_.illegalArgument)("dataId");this.label=F,this.dataId=G,this.canPersist=ye}};Mt=Le([T],Mt),e.DataBreakpoint=Mt;let Ut=class{constructor(F,G,ye){this.command=F,this.args=G||[],this.options=ye}};Ut=Le([T],Ut),e.DebugAdapterExecutable=Ut;let Bt=class{constructor(F,G){this.port=F,this.host=G}};Bt=Le([T],Bt),e.DebugAdapterServer=Bt;let zt=class{constructor(F){this.path=F}};zt=Le([T],zt),e.DebugAdapterNamedPipeServer=zt;let $t=class{constructor(F){this.implementation=F}};$t=Le([T],$t),e.DebugAdapterInlineImplementation=$t;let Wt=class{constructor(F,G){this.range=F,this.expression=G}};Wt=Le([T],Wt),e.EvaluatableExpression=Wt;var ln;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(ln=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let jt=class{constructor(F,G){this.range=F,this.text=G}};jt=Le([T],jt),e.InlineValueText=jt;let Ht=class{constructor(F,G,ye=!0){this.range=F,this.variableName=G,this.caseSensitiveLookup=ye}};Ht=Le([T],Ht),e.InlineValueVariableLookup=Ht;let qt=class{constructor(F,G){this.range=F,this.expression=G}};qt=Le([T],qt),e.InlineValueEvaluatableExpression=qt;let Vt=class{constructor(F,G){this.frameId=F,this.stoppedLocation=G}};Vt=Le([T],Vt),e.InlineValueContext=Vt;var cn;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(cn=e.FileChangeType||(e.FileChangeType={}));let xt=L=class extends Error{constructor(F,G=i.FileSystemProviderErrorCode.Unknown,ye){super(d.URI.isUri(F)?F.toString(!0):F);this.code=ye?.name??"Unknown",(0,i.markAsFileSystemProviderError)(this,G),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(F){return new L(F,i.FileSystemProviderErrorCode.FileExists,L.FileExists)}static FileNotFound(F){return new L(F,i.FileSystemProviderErrorCode.FileNotFound,L.FileNotFound)}static FileNotADirectory(F){return new L(F,i.FileSystemProviderErrorCode.FileNotADirectory,L.FileNotADirectory)}static FileIsADirectory(F){return new L(F,i.FileSystemProviderErrorCode.FileIsADirectory,L.FileIsADirectory)}static NoPermissions(F){return new L(F,i.FileSystemProviderErrorCode.NoPermissions,L.NoPermissions)}static Unavailable(F){return new L(F,i.FileSystemProviderErrorCode.Unavailable,L.Unavailable)}};xt=L=Le([T],xt),e.FileSystemError=xt;let Gt=class{constructor(F,G,ye){this.start=F,this.end=G,this.kind=ye}};Gt=Le([T],Gt),e.FoldingRange=Gt;var un;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(un=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var hn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(hn=e.CommentMode||(e.CommentMode={}));class dn{constructor(F,G=[]){this.tokenTypes=F,this.tokenModifiers=G}}e.SemanticTokensLegend=dn;function mn(N){return typeof N=="undefined"||(0,D.isStringArray)(N)}class Kt{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let G=0,ye=F.tokenTypes.length;G<ye;G++)this._tokenTypeStrToInt.set(F.tokenTypes[G],G);for(let G=0,ye=F.tokenModifiers.length;G<ye;G++)this._tokenModifierStrToInt.set(F.tokenModifiers[G],G)}}push(F,G,ye,$e,Ye){if(typeof F=="number"&&typeof G=="number"&&typeof ye=="number"&&typeof $e=="number"&&(typeof Ye=="number"||typeof Ye=="undefined"))return typeof Ye=="undefined"&&(Ye=0),this._pushEncoded(F,G,ye,$e,Ye);if(j.isRange(F)&&typeof G=="string"&&mn(ye))return this._push(F,G,ye);throw(0,_.illegalArgument)()}_push(F,G,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(G))throw new Error("`tokenType` is not in the provided legend");const $e=F.start.line,Ye=F.start.character,et=F.end.character-F.start.character,nt=this._tokenTypeStrToInt.get(G);let ft=0;if(ye)for(const ht of ye){if(!this._tokenModifierStrToInt.has(ht))throw new Error("`tokenModifier` is not in the provided legend");const pt=this._tokenModifierStrToInt.get(ht);ft|=1<<pt>>>0}this._pushEncoded($e,Ye,et,nt,ft)}_pushEncoded(F,G,ye,$e,Ye){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&G<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const ft=this._data.length/5|0;let ht=0,pt=0;for(let yt=0;yt<ft;yt++){let wt=this._data[5*yt],_t=this._data[5*yt+1];wt===0?(wt=ht,_t+=pt):wt+=ht,this._data[5*yt]=wt,this._data[5*yt+1]=_t,ht=wt,pt=_t}}let et=F,nt=G;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(et-=this._prevLine,et===0&&(nt-=this._prevChar)),this._data[this._dataLen++]=et,this._data[this._dataLen++]=nt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=$e,this._data[this._dataLen++]=Ye,this._prevLine=F,this._prevChar=G}static _sortAndDeltaEncode(F){let G=[];const ye=F.length/5|0;for(let nt=0;nt<ye;nt++)G[nt]=nt;G.sort((nt,ft)=>{const ht=F[5*nt],pt=F[5*ft];if(ht===pt){const yt=F[5*nt+1],wt=F[5*ft+1];return yt-wt}return ht-pt});const $e=new Uint32Array(F.length);let Ye=0,et=0;for(let nt=0;nt<ye;nt++){const ft=5*G[nt],ht=F[ft+0],pt=F[ft+1],yt=F[ft+2],wt=F[ft+3],_t=F[ft+4],on=ht-Ye,Wn=on===0?pt-et:pt,At=5*nt;$e[At+0]=on,$e[At+1]=Wn,$e[At+2]=yt,$e[At+3]=wt,$e[At+4]=_t,Ye=ht,et=pt}return $e}build(F){return this._dataIsSortedAndDeltaEncoded?new Xt(new Uint32Array(this._data),F):new Xt(Kt._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=Kt;class Xt{constructor(F,G){this.resultId=G,this.data=F}}e.SemanticTokens=Xt;class gn{constructor(F,G,ye){this.start=F,this.deleteCount=G,this.data=ye}}e.SemanticTokensEdit=gn;class vn{constructor(F,G){this.resultId=G,this.edits=F}}e.SemanticTokensEdits=vn;var pn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(pn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(yn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Rt=class{constructor(){}};Rt.Back={iconPath:new Et("arrow-left")},Rt=Le([T],Rt),e.QuickInputButtons=Rt;var wn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(wn=e.ExtensionKind||(e.ExtensionKind={}));class En{constructor(F,G,ye){this.badge=F,this.tooltip=G,this.color=ye}static validate(F){if(F.badge&&F.badge.length!==1&&F.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=En;let Yt=class{constructor(F){this.kind=F}};Yt=Le([T],Yt),e.ColorTheme=Yt;var bn;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(bn=e.ColorThemeKind||(e.ColorThemeKind={}));class kt{constructor(F,G){if(F<0)throw(0,_.illegalArgument)("start must be positive");if(G<0)throw(0,_.illegalArgument)("end must be positive");F<=G?(this._start=F,this._end=G):(this._start=G,this._end=F)}static isNotebookRange(F){return F instanceof kt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(F){let G=this._start,ye=this._end;return F.start!==void 0&&(G=F.start),F.end!==void 0&&(ye=F.end),G===this._start&&ye===this._end?this:new kt(G,ye)}}e.NotebookRange=kt;class St{constructor(F,G,ye,$e,Ye,et,nt){this.kind=F,this.value=G,this.languageId=ye,this.mime=$e,this.outputs=Ye??[],this.metadata=et,this.executionSummary=nt,St.validate(this)}static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(G=>St.isNotebookCellData(G))}static isNotebookCellData(F){return!0}}e.NotebookCellData=St;class Sn{constructor(F){this.cells=F}}e.NotebookData=Sn;class vt{constructor(F,G){this.data=F,this.mime=G;const ye=(0,C.normalizeMimeType)(G,!0);if(!ye)throw new Error(`INVALID mime type: ${G}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}static isNotebookCellOutputItem(F){return F instanceof vt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const G={name:F.name,message:F.message,stack:F.stack};return vt.json(G,"application/vnd.code.notebook.error")}static stdout(F){return vt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return vt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,G="application/octet-stream"){return new vt(F,G)}static text(F,G=C.Mimes.text){const ye=lt(vt,o,"f",u).encode(String(F));return new vt(ye,G)}static json(F,G="application/json"){const ye=JSON.stringify(F,void 0,"	");return vt.text(ye,G)}}e.NotebookCellOutputItem=vt,o=vt,u={value:new TextEncoder};class Tt{constructor(F,G,ye){this.items=Tt.ensureUniqueMimeTypes(F,!0),typeof G=="string"?(this.id=G,this.metadata=ye):(this.id=(0,y.generateUuid)(),this.metadata=G??ye)}static isNotebookCellOutput(F){return F instanceof Tt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&(0,D.isArray)(F.items)}static ensureUniqueMimeTypes(F,G=!1){const ye=new Set,$e=new Set;for(let Ye=0;Ye<F.length;Ye++){const et=F[Ye],nt=(0,C.normalizeMimeType)(et.mime);if(!ye.has(nt)){ye.add(nt);continue}$e.add(Ye),G&&console.warn(`DUPLICATED mime type '${et.mime}' will be dropped`)}return $e.size===0?F:F.filter((Ye,et)=>!$e.has(et))}}e.NotebookCellOutput=Tt;var Dn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Dn=e.NotebookCellKind||(e.NotebookCellKind={}));var Cn;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Cn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class kn{constructor(F,G){this.text=F,this.alignment=G}}e.NotebookCellStatusBarItem=kn;var _n;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(_n=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(F,G=[]){this.uri=F,this.provides=(0,S.asArray)(G)}}e.NotebookRendererScript=An;let Qt=class{constructor(F,G){this.label=F,this.timestamp=G}};Qt=Le([T],Qt),e.TimelineItem=Qt;var Rn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Rn=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class Fn{constructor(F,G){this.ranges=F,this.wordPattern=G}}e.LinkedEditingRanges=Fn;class On{constructor(F,G){this._port=F,this._autoForwardAction=G}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=On;var Nn;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Nn=e.TestResultState||(e.TestResultState={}));var Mn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Mn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Jt=class{constructor(F,G,ye){this.include=F,this.exclude=G,this.profile=ye}};Jt=Le([T],Jt),e.TestRunRequest=Jt;let Zt=R=class{constructor(F){this.message=F}static diff(F,G,ye){const $e=new R(F);return $e.expectedOutput=G,$e.actualOutput=ye,$e}};Zt=R=Le([T],Zt),e.TestMessage=Zt;let en=class{constructor(F,G){if(this.id=F,this.label=G,/\s/.test(F))throw new Error(`Test tag ID "${F}" may not include whitespace`)}};en=Le([T],en),e.TestTag=en;let Ct=class{constructor(F,G){this.covered=F,this.total=G}};Ct=Le([T],Ct),e.CoveredCount=Ct;let tn=m=class{constructor(F,G,ye,$e){this.uri=F,this.statementCoverage=G,this.branchCoverage=ye,this.functionCoverage=$e}static fromDetails(F,G){const ye=new Ct(0,0),$e=new Ct(0,0),Ye=new Ct(0,0);for(const nt of G)if("branches"in nt){ye.total+=1,ye.covered+=nt.executionCount>0?1:0;for(const ft of nt.branches)$e.total+=1,$e.covered+=ft.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=nt.executionCount>0?1:0;const et=new m(F,ye,$e.total>0?$e:void 0,Ye.total>0?Ye:void 0);return et.detailedCoverage=G,et}};tn=m=Le([T],tn),e.FileCoverage=tn;let nn=class{constructor(F,G,ye=[]){this.executionCount=F,this.location=G,this.branches=ye}};nn=Le([T],nn),e.StatementCoverage=nn;let rn=class{constructor(F,G){this.executionCount=F,this.location=G}};rn=Le([T],rn),e.BranchCoverage=rn;let sn=class{constructor(F,G){this.executionCount=F,this.location=G}};sn=Le([T],sn),e.FunctionCoverage=sn;var Un;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Un=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Bn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var zn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(zn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class $n{constructor(F,G,ye,$e,Ye,et){this.kind=F,this.name=G,this.detail=ye,this.uri=$e,this.range=Ye,this.selectionRange=et}}e.TypeHierarchyItem=$n}),define(me[102],ge([0,1,160,12,4,2,6,60,31,20,8]),function(Q,e,S,_,g,k,C,D,d,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.ActiveEditorDirtyContext=new D.RawContextKey("activeEditorIsDirty",!1,(0,S.localize)(2,null)),e.ActiveEditorPinnedContext=new D.RawContextKey("activeEditorIsNotPreview",!1,(0,S.localize)(3,null)),e.ActiveEditorStickyContext=new D.RawContextKey("activeEditorIsPinned",!1,(0,S.localize)(4,null)),e.ActiveEditorReadonlyContext=new D.RawContextKey("activeEditorIsReadonly",!1,(0,S.localize)(5,null)),e.ActiveEditorCanRevertContext=new D.RawContextKey("activeEditorCanRevert",!1,(0,S.localize)(6,null)),e.ActiveEditorContext=new D.RawContextKey("activeEditor",null,{type:"string",description:(0,S.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new D.RawContextKey("activeEditorAvailableEditorIds","",(0,S.localize)(8,null)),e.TextCompareEditorVisibleContext=new D.RawContextKey("textCompareEditorVisible",!1,(0,S.localize)(9,null)),e.TextCompareEditorActiveContext=new D.RawContextKey("textCompareEditorActive",!1,(0,S.localize)(10,null)),e.EditorGroupEditorsCountContext=new D.RawContextKey("groupEditorsCount",0,(0,S.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new D.RawContextKey("activeEditorGroupEmpty",!1,(0,S.localize)(12,null)),e.ActiveEditorGroupIndexContext=new D.RawContextKey("activeEditorGroupIndex",0,(0,S.localize)(13,null)),e.ActiveEditorGroupLastContext=new D.RawContextKey("activeEditorGroupLast",!1,(0,S.localize)(14,null)),e.ActiveEditorGroupLockedContext=new D.RawContextKey("activeEditorGroupLocked",!1,(0,S.localize)(15,null)),e.MultipleEditorGroupsContext=new D.RawContextKey("multipleEditorGroups",!1,(0,S.localize)(16,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new D.RawContextKey("editorIsOpen",!1,(0,S.localize)(17,null)),e.InEditorZenModeContext=new D.RawContextKey("inZenMode",!1,(0,S.localize)(18,null)),e.IsCenteredLayoutContext=new D.RawContextKey("isCenteredLayout",!1,(0,S.localize)(19,null)),e.SplitEditorsVertically=new D.RawContextKey("splitEditorsVertically",!1,(0,S.localize)(20,null)),e.EditorAreaVisibleContext=new D.RawContextKey("editorAreaVisible",!0,(0,S.localize)(21,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function A(m){return typeof m?.getViewState=="function"}e.isTextEditorPane=A;function E(m){if(f(m))return!1;const T=m;return g.URI.isUri(T?.resource)}e.isResourceEditorInput=E;function b(m){if(f(m))return!1;const T=m;return T?.original!==void 0&&T.modified!==void 0}e.isResourceDiffEditorInput=b;function o(m){if(f(m))return!1;const T=m;return T?T.resource===void 0||T.resource.scheme===i.Schemas.untitled||T.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=o;var u;(function(m){m[m.SHORT=0]="SHORT",m[m.MEDIUM=1]="MEDIUM",m[m.LONG=2]="LONG"})(u=e.Verbosity||(e.Verbosity={}));var w;(function(m){m[m.EXPLICIT=1]="EXPLICIT",m[m.AUTO=2]="AUTO",m[m.FOCUS_CHANGE=3]="FOCUS_CHANGE",m[m.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var p;(function(m){m[m.None=0]="None",m[m.Readonly=2]="Readonly",m[m.Untitled=4]="Untitled",m[m.Singleton=8]="Singleton",m[m.RequiresTrust=16]="RequiresTrust"})(p=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class h extends k.Disposable{}e.AbstractEditorInput=h;function f(m){return m instanceof h}e.isEditorInput=f;function c(m){const T=m;return g.URI.isUri(T?.preferredResource)}function a(m){const T=m;return f(T?.primary)&&f(T?.secondary)}e.isSideBySideEditorInput=a;function t(m){return f(m?.editor)}e.isEditorInputWithOptions=t;function s(m){const T=m;return t(m)&&T?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function n(m){const T=m;return typeof T?.groupId=="number"&&f(T.editor)}e.isEditorIdentifier=n;var r;(function(m){m[m.PRIMARY=1]="PRIMARY",m[m.SECONDARY=2]="SECONDARY",m[m.BOTH=3]="BOTH"})(r=e.SideBySideEditor||(e.SideBySideEditor={}));class l{getOriginalUri(T,I){if(!T)return;const B=a(T)?T.primary:b(T)?T.modified:void 0,j=a(T)?T.secondary:b(T)?T.original:void 0;if(I?.supportSideBySide&&B&&j){if(I?.supportSideBySide===r.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:I.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:I.filterByScheme})};T=I.supportSideBySide===r.PRIMARY?B:j}if(b(T))return;const ue=c(T)?T.preferredResource:T.resource;return!ue||!I||!I.filterByScheme?ue:this.filterUri(ue,I.filterByScheme)}getCanonicalUri(T,I){if(!T)return;const B=a(T)?T.primary:b(T)?T.modified:void 0,j=a(T)?T.secondary:b(T)?T.original:void 0;if(I?.supportSideBySide&&B&&j){if(I?.supportSideBySide===r.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:I.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:I.filterByScheme})};T=I.supportSideBySide===r.PRIMARY?B:j}if(b(T))return;const ue=T.resource;return!ue||!I||!I.filterByScheme?ue:this.filterUri(ue,I.filterByScheme)}filterUri(T,I){if(Array.isArray(I)){if(I.some(B=>T.scheme===B))return T}else if(I===T.scheme)return T}}e.EditorResourceAccessor=new l;var v;(function(m){m[m.LEFT=0]="LEFT",m[m.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class P{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(T){const I=this.instantiationService=T.get(C.IInstantiationService);for(const[B,j]of this.editorSerializerConstructors)this.createEditorSerializer(B,j,I);this.editorSerializerConstructors.clear()}createEditorSerializer(T,I,B){const j=B.createInstance(I);this.editorSerializerInstances.set(T,j)}registerFileEditorFactory(T){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=T}getFileEditorFactory(){return(0,_.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(T,I){if(this.editorSerializerConstructors.has(T)||this.editorSerializerInstances.has(T))throw new Error(`A editor serializer with type ID '${T}' was already registered.`);return this.instantiationService?this.createEditorSerializer(T,I,this.instantiationService):this.editorSerializerConstructors.set(T,I),(0,k.toDisposable)(()=>{this.editorSerializerConstructors.delete(T),this.editorSerializerInstances.delete(T)})}getEditorSerializer(T){return this.editorSerializerInstances.get(typeof T=="string"?T:T.typeId)}}d.Registry.add(e.EditorExtensions.EditorFactory,new P);async function L(m,T){if(!m||!m.length)return[];const I=await Promise.all(m.map(async B=>{const j=g.URI.revive(B.fileUri);if(!j||(await T.activateProvider(j.scheme),!T.canHandleResource(j)))return;const ue=typeof B.exists=="boolean"?B.exists:await T.exists(j);if(!ue&&B.openOnlyIfExists)return;const ce=ue&&!(0,_.isUndefined)(B.selection)?{selection:B.selection,pinned:!0,override:B.editorOverrideId}:{pinned:!0,override:B.editorOverrideId};let O;return ue?O={resource:j,options:ce,forceFile:!0}:O={resource:j,options:ce,forceUntitled:!0},O}));return(0,y.coalesce)(I)}e.pathsToEditors=L;var R;(function(m){m[m.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",m[m.SEQUENTIAL=1]="SEQUENTIAL"})(R=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[217],ge([0,1,47,53,8,5,3,60]),function(Q,e,S,_,g,k,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var d;(function(m){m[m.Markup=1]="Markup",m[m.Code=2]="Code"})(d=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",_.Mimes.markdown,"image/png","image/jpeg",_.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[_.Mimes.markdown,"application/json",_.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(m){m[m.Running=1]="Running",m[m.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(m){m[m.Pending=2]="Pending",m[m.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var A;(function(m){m[m.WithHardKernelDependency=0]="WithHardKernelDependency",m[m.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",m[m.Pure=2]="Pure",m[m.Never=3]="Never"})(A=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(m){m.Always="always",m.Never="never",m.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var b;(function(m){m[m.ModelChange=1]="ModelChange",m[m.Move=2]="Move",m[m.ChangeLanguage=5]="ChangeLanguage",m[m.Initialize=6]="Initialize",m[m.ChangeCellMetadata=7]="ChangeCellMetadata",m[m.Output=8]="Output",m[m.OutputItem=9]="OutputItem",m[m.ChangeCellContent=10]="ChangeCellContent",m[m.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",m[m.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",m[m.ChangeCellMime=13]="ChangeCellMime",m[m.Unknown=100]="Unknown"})(b=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(m){m[m.Handle=0]="Handle",m[m.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(m){m[m.Replace=1]="Replace",m[m.Output=2]="Output",m[m.Metadata=3]="Metadata",m[m.CellLanguage=4]="CellLanguage",m[m.DocumentMetadata=5]="DocumentMetadata",m[m.Move=6]="Move",m[m.OutputItems=7]="OutputItems",m[m.PartialMetadata=8]="PartialMetadata",m[m.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var w;(function(m){m.scheme=g.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function I(O,$){return O.with({scheme:m.scheme,fragment:`ch${$.toString().padStart(7,"0")}${O.scheme!==g.Schemas.file?O.scheme:""}`})}m.generate=I;function B(O){if(O.scheme!==m.scheme)return;const $=T.exec(O.fragment);return $?{handle:Number($[1]),notebook:O.with({scheme:O.fragment.substr($[0].length)||g.Schemas.file,fragment:null})}:void 0}m.parse=B;function j(O){if(O.scheme!==g.Schemas.vscodeNotebookCellMetadata)return;const $=T.exec(O.fragment);return $?{handle:Number($[1]),notebook:O.with({scheme:O.fragment.substr($[0].length)||g.Schemas.file,fragment:null})}:void 0}m.parseCellMetadataUri=j;function ue(O,$,z){return O.with({scheme:z,fragment:`ch${$.toString().padStart(7,"0")}${O.scheme!==g.Schemas.file?O.scheme:""}`})}m.generateCellUri=ue;function ce(O,$){if(O.scheme!==$)return;const z=T.exec(O.fragment);return z?{handle:Number(z[1]),notebook:O.with({scheme:O.fragment.substr(z[0].length)||g.Schemas.file,fragment:null})}:void 0}m.parseCellUri=ce})(w=e.CellUri||(e.CellUri={}));const p=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function h(m){return p.get(m)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=h;function f(m){return p.get(m)?.supportedByCore??!1}e.mimeTypeSupportedByCore=f;function c(m){return p.get(m)?.mergeable??!1}e.mimeTypeIsMergeable=c;function a(m,T){return C.isWindows&&(m=m.replace(/\//g,"\\"),T=T.replace(/\//g,"\\")),S.match(m,T)}function t(m,T,I){let B=0;for(let j=0;j<T.length;j++){if(a(T[j],m))return B;B++}for(let j=0;j<I.length;j++){if(a(I[j],m))return B;B++}return B}function s(m,T,I){return m.sort((B,j)=>t(B,T,I)-t(j,T,I))}e.sortMimeTypes=s;function n(m,T,I,B=(j,ue)=>j===ue){const j=[];function ue($,z,ee){if(z===0&&ee.length===0)return;const J=j[j.length-1];J&&J.start+J.deleteCount===$?(J.deleteCount+=z,J.toInsert.push(...ee)):j.push({start:$,deleteCount:z,toInsert:ee})}let ce=0,O=0;for(;;){if(ce===m.length){ue(ce,0,T.slice(O));break}if(O===T.length){ue(ce,m.length-ce,[]);break}const $=m[ce],z=T[O];if(B($,z)){ce+=1,O+=1;continue}I(z)?(ue(ce,1,[]),ce+=1):(ue(ce,0,[z]),O+=1)}return j}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(m){m.default="default",m.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(m){const T=m;return!!((typeof T.include=="string"||S.isRelativePattern(T.include))&&(typeof T.exclude=="string"||S.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=l;function v(m,T,I){if(Array.isArray(m.viewType)&&m.viewType.indexOf(T)>=0||m.viewType===T)return!0;if(m.filenamePattern){let B=l(m.filenamePattern)?m.filenamePattern.include:m.filenamePattern,j=l(m.filenamePattern)?m.filenamePattern.exclude:void 0;if(S.match(B,(0,k.basename)(I.fsPath).toLowerCase()))return!(j&&S.match(j,(0,k.basename)(I.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=v;class P{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let I=0;I<this.textModel.cells.length;I++)T[I]=this.textModel.cells[I].getHashValue();return T}}e.CellSequence=P,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var L;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(L=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class R{static create(T){return`${R._prefix}${T}`}static parse(T){if(T.startsWith(R._prefix))return T.substr(R._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=R,R._prefix="notebook/"}),define(me[103],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,S.createDecorator)("environmentVariableService");var _;(function(g){g[g.Replace=1]="Replace",g[g.Append=2]="Append",g[g.Prepend=3]="Prepend"})(_=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(me[218],ge([0,1,3,103]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class g{constructor(d){this.map=new Map,d.forEach((y,i)=>{const A=y.map.entries();let E=A.next();for(;!E.done;){const b=E.value[0];let o=this.map.get(b);if(o||(o=[],this.map.set(b,o)),o.length>0&&o[0].type===_.EnvironmentVariableMutatorType.Replace){E=A.next();continue}const u=E.value[1];o.unshift({extensionIdentifier:i,value:u.value,type:u.type}),E=A.next()}})}applyToProcessEnvironment(d,y){let i;S.isWindows&&(i={},Object.keys(d).forEach(A=>i[A.toLowerCase()]=A)),this.map.forEach((A,E)=>{const b=S.isWindows&&i[E.toLowerCase()]||E;A.forEach(o=>{const u=y?y(o.value):o.value;switch(o.type){case _.EnvironmentVariableMutatorType.Append:d[b]=(d[b]||"")+u;break;case _.EnvironmentVariableMutatorType.Prepend:d[b]=u+(d[b]||"");break;case _.EnvironmentVariableMutatorType.Replace:d[b]=u;break}})})}diff(d){const y=new Map,i=new Map,A=new Map;if(d.map.forEach((E,b)=>{const o=this.map.get(b),u=k(E,o);u&&y.set(b,u)}),this.map.forEach((E,b)=>{const o=d.map.get(b),u=k(E,o);u&&A.set(b,u)}),this.map.forEach((E,b)=>{const o=d.map.get(b),u=C(E,o);u&&i.set(b,u)}),!(y.size===0&&i.size===0&&A.size===0))return{added:y,changed:i,removed:A}}}e.MergedEnvironmentVariableCollection=g;function k(D,d){if(!d)return D;const y=new Set;d.forEach(A=>y.add(A.extensionIdentifier));const i=[];return D.forEach(A=>{y.has(A.extensionIdentifier)||i.push(A)}),i.length===0?void 0:i}function C(D,d){if(!d)return;const y=new Map;d.forEach(A=>y.set(A.extensionIdentifier,A));const i=[];return D.forEach(A=>{const E=y.get(A.extensionIdentifier);E&&(A.type!==E.type||A.value!==E.value)&&i.push(E)}),i.length===0?void 0:i}}),define(me[104],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function S(g){return[...g.entries()]}e.serializeEnvironmentVariableCollection=S;function _(g){return new Map(g)}e.deserializeEnvironmentVariableCollection=_}),define(me[219],ge([0,1,5,116,3]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function k(c,a){if(!!a)if(g.isWindows)for(const t in a){let s=t;for(const r in c)if(t.toLowerCase()===r.toLowerCase()){s=r;break}const n=a[t];n!==void 0&&C(c,s,n)}else Object.keys(a).forEach(t=>{const s=a[t];s!==void 0&&C(c,t,s)})}e.mergeEnvironments=k;function C(c,a,t){typeof t=="string"?c[a]=t:delete c[a]}function D(c,a,t,s){c.TERM_PROGRAM="vscode",a&&(c.TERM_PROGRAM_VERSION=a),i(c,s)&&(c.LANG=A(t)),c.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=D;function d(c,a){if(!!a)for(const t of Object.keys(a)){const s=a[t];s&&(c[t]=s)}}function y(c,a){return Object.keys(a).forEach(t=>{const s=a[t];if(typeof s=="string")try{a[t]=c(s)}catch(n){a[t]=s}}),a}function i(c,a){if(a==="on")return!0;if(a==="auto"){const t=c.LANG;return!t||t.search(/\.UTF\-8$/)===-1&&t.search(/\.utf8$/)===-1&&t.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=i;function A(c){const a=c?c.split("-"):[],t=a.length;if(t===0)return"en_US.UTF-8";if(t===1){const s={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};a[0]in s&&a.push(s[a[0]])}else a[1]=a[1].toUpperCase();return a.join("_")+".UTF-8"}e.getLangEnvVariable=A;function E(c,a,t,s,n,r){if(c.cwd){const v=typeof c.cwd=="object"?c.cwd.fsPath:c.cwd,P=b(v,t);return o(P||v)}let l;return!c.ignoreConfigurationCwd&&n&&(t&&(n=b(n,t,r)),n&&(S.isAbsolute(n)?l=n:s&&(l=S.join(s.fsPath,n)))),l||(l=s?s.fsPath:a||""),o(l)}e.getCwd=E;function b(c,a,t){if(a)try{return a(c)}catch(s){t?.error("Could not resolve terminal cwd",s);return}return c}function o(c){return g.OS===1&&c&&c[1]===":"?c[0].toUpperCase()+c.substr(1):c}function u(c,a,t){if(!!t)return s=>t.resolveWithEnvironment(a,c,s)}e.createVariableResolver=u;function w(c,a,t,s,n,r,l,v=g.platform){let P;l&&(P=h(c,"automationShell",v)),P||(P=h(c,"shell",v));let L=P||a;if(v===3&&!t&&s){const R=S.join(s,"Sysnative").replace(/\//g,"\\").toLowerCase();L&&L.toLowerCase().indexOf(R)===0&&(L=S.join(s,"System32",L.substr(R.length+1)))}if(L&&v===3&&(L=L.replace(/\//g,"\\")),n)try{L=n(L)}catch(R){r.error("Could not resolve shell",R)}return L}e.getDefaultShell=w;function p(c,a,t,s,n=g.platform){if(a&&h(c,"automationShell",n))return[];const r=n===3?"windows":n===1?"osx":"linux";let l=c(`terminal.integrated.shellArgs.${r}`);if(!l)return[];if(typeof l=="string"&&n===3)return t?t(l):l;if(t){const v=[];for(const P of l)try{v.push(t(P))}catch(L){s.error(`Could not resolve terminal.integrated.shellArgs.${r}`,L),v.push(P)}l=v}return l}e.getDefaultShellArgs=p;function h(c,a,t=g.platform){return c(`terminal.integrated.${a}.${t===3?"windows":t===1?"osx":"linux"}`)}function f(c,a,t,s,n,r){const l={};if(c.strictEnv)d(l,c.env);else{d(l,r);const v={...a};t&&(v&&y(t,v),c.env&&y(t,c.env)),(0,_.sanitizeProcessEnvironment)(l,"VSCODE_IPC_HOOK_CLI"),k(l,v),k(l,c.env),D(l,s,g.locale,n)}return l}e.createTerminalEnvironment=f}),define(me[220],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(k){k.Delimiter="\0"})(S=e.TestIdPathParts||(e.TestIdPathParts={}));var _;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(_=e.TestPosition||(e.TestPosition={}));class g{constructor(C,D=C.length){if(this.path=C,this.viewEnd=D,C.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(C,D,d=C.parent){if(C.id===D)return new g([D]);let y=[C.id];for(let i=d;i&&i.id!==D;i=i.parent)y.push(i.id);return y.push(D),new g(y.reverse())}static isRoot(C){return!C.includes("\0")}static fromString(C){return new g(C.split("\0"))}static join(C,D){return new g([...C.path,D])}static joinToString(C,D){return C.toString()+"\0"+D}static compare(C,D){return C===D?0:D.startsWith(C+"\0")?2:C.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new g(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let C=1;C<=this.viewEnd;C++)yield new g(this.path,C)}compare(C){if(typeof C=="string")return g.compare(this.toString(),C);for(let D=0;D<C.viewEnd&&D<this.viewEnd;D++)if(C.path[D]!==this.path[D])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=g}),define(me[221],ge([0,1,34,6]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,_.refineServiceDecorator)(S.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(me[222],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,S.createDecorator)("configurationResolverService")}),define(me[223],ge([0,1,5,22,12,18,3,52,161]),function(Q,e,S,_,g,k,C,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(A,E,b){this._contributedVariables=new Map,this._context=A,this._labelService=E,b&&(this._envVariablesPromise=b.then(o=>this.prepareEnv(o)))}prepareEnv(A){if(C.isWindows){const E=Object.create(null);return Object.keys(A).forEach(b=>{E[b.toLowerCase()]=A[b]}),E}return A}resolveWithEnvironment(A,E,b){return this.recursiveResolve(this.prepareEnv(A),E?E.uri:void 0,b)}async resolveAsync(A,E){return this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,E)}async resolveAnyBase(A,E,b,o){const u=k.deepClone(E);return C.isWindows&&u.windows?Object.keys(u.windows).forEach(w=>u[w]=u.windows[w]):C.isMacintosh&&u.osx?Object.keys(u.osx).forEach(w=>u[w]=u.osx[w]):C.isLinux&&u.linux&&Object.keys(u.linux).forEach(w=>u[w]=u.linux[w]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,u,b,o)}async resolveAnyAsync(A,E,b){return this.resolveAnyBase(A,E,b)}async resolveAnyMap(A,E,b){const o=new Map;return{newConfig:await this.resolveAnyBase(A,E,b,o),resolvedVariables:o}}resolveWithInteractionReplace(A,E,b,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,E,b,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,E){if(this._contributedVariables.has(A))throw new Error("Variable "+A+" is contributed twice.");this._contributedVariables.set(A,E)}recursiveResolve(A,E,b,o,u){if(g.isString(b))return this.resolveString(A,E,b,o,u);if(g.isArray(b))return b.map(w=>this.recursiveResolve(A,E,w,o,u));if(g.isObject(b)){let w=Object.create(null);return Object.keys(b).forEach(p=>{const h=this.resolveString(A,E,p,o,u);w[h]=this.recursiveResolve(A,E,b[p],o,u)}),w}return b}resolveString(A,E,b,o,u){return b.replace(y.VARIABLE_REGEXP,(p,h)=>{if(h.includes(y.VARIABLE_LHS))return p;let f=this.evaluateSingleVariable(A,p,h,E,o);return u&&u.set(h,f),f!==p&&g.isString(f)&&f.match(y.VARIABLE_REGEXP)&&(f=this.resolveString(A,E,f,o,u)),f})}fsPath(A){return this._labelService?this._labelService.getUriLabel(A,{noPrefix:!0}):A.fsPath}evaluateSingleVariable(A,E,b,o,u){let w;const p=b.split(":");p.length>1&&(b=p[0],w=p[1]);const h=()=>{const a=this._context.getFilePath();if(a)return a;throw new Error((0,d.localize)(0,null,E))},f=()=>{const a=h();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,d.localize)(1,null,E,S.basename(a)))},c=()=>{if(w){const a=this._context.getFolderUri(w);if(a)return a;throw new Error((0,d.localize)(2,null,E,w))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,d.localize)(3,null,E)):new Error((0,d.localize)(4,null,E))};switch(b){case"env":if(w){if(A){const a=A[C.isWindows?w.toLowerCase():w];if(g.isString(a))return a}return""}throw new Error((0,d.localize)(5,null,E));case"config":if(w){const a=this._context.getConfigurationValue(o,w);if(g.isUndefinedOrNull(a))throw new Error((0,d.localize)(6,null,E,w));if(g.isObject(a))throw new Error((0,d.localize)(7,null,E,w));return a}throw new Error((0,d.localize)(8,null,E));case"command":return this.resolveFromMap(E,w,u,"command");case"input":return this.resolveFromMap(E,w,u,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return o||w?(0,D.normalizeDriveLetter)(this.fsPath(c())):_.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return S.basename(this.fsPath(c()));case"lineNumber":const a=this._context.getLineNumber();if(a)return a;throw new Error((0,d.localize)(9,null,E));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,d.localize)(10,null,E));case"file":return h();case"fileWorkspaceFolder":return f();case"relativeFile":return o||w?S.relative(this.fsPath(c()),h()):h();case"relativeFileDirname":const s=S.dirname(h());if(o||w){const v=S.relative(this.fsPath(c()),s);return v.length===0?".":v}return s;case"fileDirname":return S.dirname(h());case"fileExtname":return S.extname(h());case"fileBasename":return S.basename(h());case"fileBasenameNoExtension":const n=S.basename(h());return n.slice(0,n.length-S.extname(n).length);case"fileDirnameBasename":return S.basename(S.dirname(h()));case"execPath":const r=this._context.getExecPath();return r||E;case"execInstallFolder":const l=this._context.getAppRoot();return l||E;case"pathSeparator":return S.sep;default:try{const v=w?`${b}:${w}`:b;return this.resolveFromMap(E,v,u,void 0)}catch(v){return E}}}}resolveFromMap(A,E,b,o){if(E&&b){const u=o===void 0?b[E]:b[o+":"+E];if(typeof u=="string")return u;throw new Error((0,d.localize)(11,null,A))}return A}}e.AbstractVariableResolverService=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[224],ge([0,1,6,102]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,S.createDecorator)("editorGroupsService");var g;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(g=e.GroupDirection||(e.GroupDirection={}));var k;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(k=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var D;(function(u){u[u.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",u[u.EVEN=1]="EVEN",u[u.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var d;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(d=e.MergeGroupMode||(e.MergeGroupMode={}));function y(u){const w=u;return(0,_.isEditorInput)(w?.editor)&&(0,_.isEditorInput)(w?.replacement)}e.isEditorReplacement=y;var i;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var A;(function(u){u[u.GROUP_ACTIVE=0]="GROUP_ACTIVE",u[u.GROUP_INDEX=1]="GROUP_INDEX",u[u.GROUP_LOCKED=2]="GROUP_LOCKED",u[u.EDITOR_OPEN=3]="EDITOR_OPEN",u[u.EDITOR_CLOSE=4]="EDITOR_CLOSE",u[u.EDITOR_MOVE=5]="EDITOR_MOVE",u[u.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",u[u.EDITOR_LABEL=7]="EDITOR_LABEL",u[u.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",u[u.EDITOR_PIN=9]="EDITOR_PIN",u[u.EDITOR_STICKY=10]="EDITOR_STICKY",u[u.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(A=e.GroupChangeKind||(e.GroupChangeKind={}));var E;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(E=e.OpenEditorContext||(e.OpenEditorContext={}));function b(u){const w=u;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=b;function o(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=o}),define(me[105],ge([0,1,6,224]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,S.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function g(k){const C=k;return typeof k=="number"||(0,_.isEditorGroup)(C)}e.isPreferredGroup=g}),define(me[225],ge([0,1,20,17,74,246,46,18,12,4,55,179,165,188,216,217,220,105,101]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var f;(function(ae){function fe(M){const{selectionStartLineNumber:De,selectionStartColumn:Ce,positionLineNumber:Ve,positionColumn:ze}=M,tt=new h.Position(De-1,Ce-1),ct=new h.Position(Ve-1,ze-1);return new h.Selection(tt,ct)}ae.to=fe;function Y(M){const{anchor:De,active:Ce}=M;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Ce.line+1,positionColumn:Ce.character+1}}ae.from=Y})(f=e.Selection||(e.Selection={}));var c;(function(ae){function fe(M){if(!M)return;const{start:De,end:Ce}=M;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Ce.line+1,endColumn:Ce.character+1}}ae.from=fe;function Y(M){if(!M)return;const{startLineNumber:De,startColumn:Ce,endLineNumber:Ve,endColumn:ze}=M;return new h.Range(De-1,Ce-1,Ve-1,ze-1)}ae.to=Y})(c=e.Range||(e.Range={}));var a;(function(ae){function fe(Y){switch(Y){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 4:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}ae.to=fe})(a=e.TokenType||(e.TokenType={}));var t;(function(ae){function fe(M){return new h.Position(M.lineNumber-1,M.column-1)}ae.to=fe;function Y(M){return{lineNumber:M.line+1,column:M.character+1}}ae.from=Y})(t=e.Position||(e.Position={}));var s;(function(ae){function fe(M){switch(M){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}ae.from=fe;function Y(M){switch(M){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}ae.to=Y})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(ae){function fe(M){let De;return M.code&&((0,d.isString)(M.code)||(0,d.isNumber)(M.code)?De=String(M.code):De={value:String(M.code.value),target:M.code.target}),{...c.from(M.range),message:M.message,source:M.source,code:De,severity:l.from(M.severity),relatedInformation:M.relatedInformation&&M.relatedInformation.map(r.from),tags:Array.isArray(M.tags)?(0,S.coalesce)(M.tags.map(s.from)):void 0}}ae.from=fe;function Y(M){const De=new h.Diagnostic(c.to(M),M.message,l.to(M.severity));return De.source=M.source,De.code=(0,d.isString)(M.code)?M.code:M.code?.value,De.relatedInformation=M.relatedInformation&&M.relatedInformation.map(r.to),De.tags=M.tags&&(0,S.coalesce)(M.tags.map(s.to)),De}ae.to=Y})(n=e.Diagnostic||(e.Diagnostic={}));var r;(function(ae){function fe(M){return{...c.from(M.location.range),message:M.message,resource:M.location.uri}}ae.from=fe;function Y(M){return new h.DiagnosticRelatedInformation(new h.Location(M.resource,c.to(M)),M.message)}ae.to=Y})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(ae){function fe(M){switch(M){case h.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}ae.from=fe;function Y(M){switch(M){case b.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}ae.to=Y})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var v;(function(ae){function fe(M){return typeof M=="number"&&M>=h.ViewColumn.One?M-1:M===h.ViewColumn.Beside?p.SIDE_GROUP:p.ACTIVE_GROUP}ae.from=fe;function Y(M){if(typeof M=="number"&&M>=0)return M+1;throw new Error("invalid 'EditorGroupColumn'")}ae.to=Y})(v=e.ViewColumn||(e.ViewColumn={}));function P(ae){return typeof ae.range!="undefined"}function L(ae){return ae.length===0?!0:!!P(ae[0])}e.isDecorationOptionsArr=L;var R;(function(ae){function fe(ze){return ze.map(ae.from)}ae.fromMany=fe;function Y(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function M(ze){let tt;if(Y(ze)){const{language:dt,value:mt}=ze;tt={value:"```"+dt+`
`+mt+"\n```\n"}}else h.MarkdownString.isMarkdownString(ze)?tt={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons}:typeof ze=="string"?tt={value:ze}:tt={value:""};const ct=Object.create(null);tt.uris=ct;const gt=dt=>{try{let mt=y.URI.parse(dt,!0);mt=mt.with({query:De(mt.query,ct)}),ct[dt]=mt}catch(mt){}return""},ut=new k.Renderer;return ut.link=gt,ut.image=dt=>gt(g.parseHrefAndDimensions(dt).href),k(tt.value,{renderer:ut}),tt}ae.from=M;function De(ze,tt){if(!ze)return ze;let ct;try{ct=(0,C.parse)(ze)}catch(ut){}if(!ct)return ze;let gt=!1;return ct=(0,D.cloneAndChange)(ct,ut=>{if(y.URI.isUri(ut)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[dt]=ut,gt=!0,dt}else return}),gt?JSON.stringify(ct):ze}function Ce(ze){const tt=new h.MarkdownString(ze.value,ze.supportThemeIcons);return tt.isTrusted=ze.isTrusted,tt}ae.to=Ce;function Ve(ze){if(!!ze)return typeof ze=="string"?ze:ae.from(ze)}ae.fromStrict=Ve})(R=e.MarkdownString||(e.MarkdownString={}));function m(ae){return L(ae)?ae.map(fe=>({range:c.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?R.fromMany(fe.hoverMessage):fe.hoverMessage?R.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):ae.map(fe=>({range:c.from(fe)}))}e.fromRangeOrRangeWithMessage=m;function T(ae){return typeof ae=="undefined"?ae:typeof ae=="string"?y.URI.file(ae):ae}e.pathOrURIToURI=T;var I;(function(ae){function fe(Y){return typeof Y=="undefined"?Y:{contentText:Y.contentText,contentIconPath:Y.contentIconPath?T(Y.contentIconPath):void 0,border:Y.border,borderColor:Y.borderColor,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,color:Y.color,backgroundColor:Y.backgroundColor,margin:Y.margin,width:Y.width,height:Y.height}}ae.from=fe})(I=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(ae){function fe(Y){return typeof Y=="undefined"?Y:{backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?T(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?I.from(Y.before):void 0,after:Y.after?I.from(Y.after):void 0}}ae.from=fe})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(ae){function fe(Y){if(typeof Y=="undefined")return Y;switch(Y){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}ae.from=fe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ue;(function(ae){function fe(Y){return{isWholeLine:Y.isWholeLine,rangeBehavior:Y.rangeBehavior?j.from(Y.rangeBehavior):void 0,overviewRulerLane:Y.overviewRulerLane,light:Y.light?B.from(Y.light):void 0,dark:Y.dark?B.from(Y.dark):void 0,backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?T(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?I.from(Y.before):void 0,after:Y.after?I.from(Y.after):void 0}}ae.from=fe})(ue=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ce;(function(ae){function fe(M){return{text:M.newText,eol:M.newEol&&pe.from(M.newEol),range:c.from(M.range)}}ae.from=fe;function Y(M){const De=new h.TextEdit(c.to(M.range),M.text);return De.newEol=typeof M.eol=="undefined"?void 0:pe.to(M.eol),De}ae.to=Y})(ce=e.TextEdit||(e.TextEdit={}));var O;(function(ae){function fe(M,De,Ce){const Ve={edits:[]};if(M instanceof h.WorkspaceEdit)for(let ze of M._allEntries())if(ze._type===1)Ve.edits.push({_type:1,oldUri:ze.from,newUri:ze.to,options:ze.options,metadata:ze.metadata});else if(ze._type===2){const tt=De?.getDocument(ze.uri);Ve.edits.push({_type:2,resource:ze.uri,edit:ce.from(ze.edit),modelVersionId:tt?.version,metadata:ze.metadata})}else ze._type===3?Ve.edits.push({_type:3,metadata:ze.metadata,resource:ze.uri,edit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Ce?.getNotebookDocument(ze.uri,!0)?.apiNotebook.version}):ze._type===5&&Ve.edits.push({_type:3,metadata:ze.metadata,resource:ze.uri,notebookVersionId:Ce?.getNotebookDocument(ze.uri,!0)?.apiNotebook.version,edit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(Oe.from)}});return Ve}ae.from=fe;function Y(M){const De=new h.WorkspaceEdit;for(const Ce of M.edits)Ce.edit?De.replace(y.URI.revive(Ce.resource),c.to(Ce.edit.range),Ce.edit.text):De.renameFile(y.URI.revive(Ce.oldUri),y.URI.revive(Ce.newUri),Ce.options);return De}ae.to=Y})(O=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(ae){const fe=Object.create(null);fe[h.SymbolKind.File]=0,fe[h.SymbolKind.Module]=1,fe[h.SymbolKind.Namespace]=2,fe[h.SymbolKind.Package]=3,fe[h.SymbolKind.Class]=4,fe[h.SymbolKind.Method]=5,fe[h.SymbolKind.Property]=6,fe[h.SymbolKind.Field]=7,fe[h.SymbolKind.Constructor]=8,fe[h.SymbolKind.Enum]=9,fe[h.SymbolKind.Interface]=10,fe[h.SymbolKind.Function]=11,fe[h.SymbolKind.Variable]=12,fe[h.SymbolKind.Constant]=13,fe[h.SymbolKind.String]=14,fe[h.SymbolKind.Number]=15,fe[h.SymbolKind.Boolean]=16,fe[h.SymbolKind.Array]=17,fe[h.SymbolKind.Object]=18,fe[h.SymbolKind.Key]=19,fe[h.SymbolKind.Null]=20,fe[h.SymbolKind.EnumMember]=21,fe[h.SymbolKind.Struct]=22,fe[h.SymbolKind.Event]=23,fe[h.SymbolKind.Operator]=24,fe[h.SymbolKind.TypeParameter]=25;function Y(De){return typeof fe[De]=="number"?fe[De]:6}ae.from=Y;function M(De){for(const Ce in fe)if(fe[Ce]===De)return Number(Ce);return h.SymbolKind.Property}ae.to=M})($=e.SymbolKind||(e.SymbolKind={}));var z;(function(ae){function fe(M){switch(M){case h.SymbolTag.Deprecated:return 1}}ae.from=fe;function Y(M){switch(M){case 1:return h.SymbolTag.Deprecated}}ae.to=Y})(z=e.SymbolTag||(e.SymbolTag={}));var ee;(function(ae){function fe(M){return{name:M.name,kind:$.from(M.kind),tags:M.tags&&M.tags.map(z.from),containerName:M.containerName,location:W.from(M.location)}}ae.from=fe;function Y(M){const De=new h.SymbolInformation(M.name,$.to(M.kind),M.containerName,W.to(M.location));return De.tags=M.tags&&M.tags.map(z.to),De}ae.to=Y})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var J;(function(ae){function fe(M){const De={name:M.name||"!!MISSING: name!!",detail:M.detail,range:c.from(M.range),selectionRange:c.from(M.selectionRange),kind:$.from(M.kind),tags:M.tags?.map(z.from)??[]};return M.children&&(De.children=M.children.map(fe)),De}ae.from=fe;function Y(M){const De=new h.DocumentSymbol(M.name,M.detail,$.to(M.kind),c.to(M.range),c.to(M.selectionRange));return(0,S.isNonEmptyArray)(M.tags)&&(De.tags=M.tags.map(z.to)),M.children&&(De.children=M.children.map(Y)),De}ae.to=Y})(J=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(ae){function fe(M){const De=new h.CallHierarchyItem($.to(M.kind),M.name,M.detail||"",y.URI.revive(M.uri),c.to(M.range),c.to(M.selectionRange));return De._sessionId=M._sessionId,De._itemId=M._itemId,De}ae.to=fe;function Y(M,De,Ce){if(De=De??M._sessionId,Ce=Ce??M._itemId,De===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Ce,name:M.name,detail:M.detail,kind:$.from(M.kind),uri:M.uri,range:c.from(M.range),selectionRange:c.from(M.selectionRange),tags:M.tags?.map(z.from)}}ae.from=Y})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var X;(function(ae){function fe(Y){return new h.CallHierarchyIncomingCall(H.to(Y.from),Y.fromRanges.map(M=>c.to(M)))}ae.to=fe})(X=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var q;(function(ae){function fe(Y){return new h.CallHierarchyOutgoingCall(H.to(Y.to),Y.fromRanges.map(M=>c.to(M)))}ae.to=fe})(q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var W;(function(ae){function fe(M){return{range:M.range&&c.from(M.range),uri:M.uri}}ae.from=fe;function Y(M){return new h.Location(y.URI.revive(M.uri),c.to(M.range))}ae.to=Y})(W=e.location||(e.location={}));var U;(function(ae){function fe(M){const De=M,Ce=M;return{originSelectionRange:De.originSelectionRange?c.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Ce.uri,range:c.from(De.targetRange?De.targetRange:Ce.range),targetSelectionRange:De.targetSelectionRange?c.from(De.targetSelectionRange):void 0}}ae.from=fe;function Y(M){return{targetUri:y.URI.revive(M.uri),targetRange:c.to(M.range),targetSelectionRange:M.targetSelectionRange?c.to(M.targetSelectionRange):void 0,originSelectionRange:M.originSelectionRange?c.to(M.originSelectionRange):void 0}}ae.to=Y})(U=e.DefinitionLink||(e.DefinitionLink={}));var ie;(function(ae){function fe(M){return{range:c.from(M.range),contents:R.fromMany(M.contents)}}ae.from=fe;function Y(M){return new h.Hover(M.contents.map(R.to),c.to(M.range))}ae.to=Y})(ie=e.Hover||(e.Hover={}));var ne;(function(ae){function fe(M){return{range:c.from(M.range),expression:M.expression}}ae.from=fe;function Y(M){return new h.EvaluatableExpression(c.to(M.range),M.expression)}ae.to=Y})(ne=e.EvaluatableExpression||(e.EvaluatableExpression={}));var he;(function(ae){function fe(M){if(M instanceof h.InlineValueText)return{type:"text",range:c.from(M.range),text:M.text};if(M instanceof h.InlineValueVariableLookup)return{type:"variable",range:c.from(M.range),variableName:M.variableName,caseSensitiveLookup:M.caseSensitiveLookup};if(M instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(M.range),expression:M.expression};throw new Error("Unknown 'InlineValue' type")}ae.from=fe;function Y(M){switch(M.type){case"text":return{range:c.to(M.range),text:M.text};case"variable":return{range:c.to(M.range),variableName:M.variableName,caseSensitiveLookup:M.caseSensitiveLookup};case"expression":return{range:c.to(M.range),expression:M.expression}}}ae.to=Y})(he=e.InlineValue||(e.InlineValue={}));var ve;(function(ae){function fe(M){return{frameId:M.frameId,stoppedLocation:c.from(M.stoppedLocation)}}ae.from=fe;function Y(M){return new h.InlineValueContext(M.frameId,c.to(M.stoppedLocation))}ae.to=Y})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(ae){function fe(M){return{range:c.from(M.range),kind:M.kind}}ae.from=fe;function Y(M){return new h.DocumentHighlight(c.to(M.range),M.kind)}ae.to=Y})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var Ie;(function(ae){function fe(Y){switch(Y){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}ae.to=fe})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(ae){function fe(Y){return{triggerKind:Ie.to(Y.triggerKind),triggerCharacter:Y.triggerCharacter}}ae.to=fe})(Ue=e.CompletionContext||(e.CompletionContext={}));var qe;(function(ae){function fe(M){switch(M){case h.CompletionItemTag.Deprecated:return 1}}ae.from=fe;function Y(M){switch(M){case 1:return h.CompletionItemTag.Deprecated}}ae.to=Y})(qe=e.CompletionItemTag||(e.CompletionItemTag={}));var Ge;(function(ae){const fe=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function Y(Ce){return fe.get(Ce)??9}ae.from=Y;const M=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function De(Ce){return M.get(Ce)??h.CompletionItemKind.Property}ae.to=De})(Ge=e.CompletionItemKind||(e.CompletionItemKind={}));var rt;(function(ae){function fe(Y,M){const De=new h.CompletionItem(Y.label);return De.insertText=Y.insertText,De.kind=Ge.to(Y.kind),De.tags=Y.tags?.map(qe.to),De.detail=Y.detail,De.documentation=g.isMarkdownString(Y.documentation)?R.to(Y.documentation):Y.documentation,De.sortText=Y.sortText,De.filterText=Y.filterText,De.preselect=Y.preselect,De.commitCharacters=Y.commitCharacters,i.Range.isIRange(Y.range)?De.range=c.to(Y.range):typeof Y.range=="object"&&(De.range={inserting:c.to(Y.range.insert),replacing:c.to(Y.range.replace)}),De.keepWhitespace=typeof Y.insertTextRules=="undefined"?!1:Boolean(Y.insertTextRules&1),typeof Y.insertTextRules!="undefined"&&Y.insertTextRules&4?De.insertText=new h.SnippetString(Y.insertText):(De.insertText=Y.insertText,De.textEdit=De.range instanceof h.Range?new h.TextEdit(De.range,De.insertText):void 0),Y.additionalTextEdits&&Y.additionalTextEdits.length>0&&(De.additionalTextEdits=Y.additionalTextEdits.map(Ce=>ce.to(Ce))),De.command=M&&Y.command?M.fromInternal(Y.command):void 0,De}ae.to=fe})(rt=e.CompletionItem||(e.CompletionItem={}));var it;(function(ae){function fe(M){return{label:M.label,documentation:M.documentation?R.fromStrict(M.documentation):void 0}}ae.from=fe;function Y(M){return{label:M.label,documentation:g.isMarkdownString(M.documentation)?R.to(M.documentation):M.documentation}}ae.to=Y})(it=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(ae){function fe(M){return{label:M.label,documentation:M.documentation?R.fromStrict(M.documentation):void 0,parameters:Array.isArray(M.parameters)?M.parameters.map(it.from):[],activeParameter:M.activeParameter}}ae.from=fe;function Y(M){return{label:M.label,documentation:g.isMarkdownString(M.documentation)?R.to(M.documentation):M.documentation,parameters:Array.isArray(M.parameters)?M.parameters.map(it.to):[],activeParameter:M.activeParameter}}ae.to=Y})(de=e.SignatureInformation||(e.SignatureInformation={}));var be;(function(ae){function fe(M){return{activeSignature:M.activeSignature,activeParameter:M.activeParameter,signatures:Array.isArray(M.signatures)?M.signatures.map(de.from):[]}}ae.from=fe;function Y(M){return{activeSignature:M.activeSignature,activeParameter:M.activeParameter,signatures:Array.isArray(M.signatures)?M.signatures.map(de.to):[]}}ae.to=Y})(be=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(ae){function fe(M){return{text:M.text,position:t.from(M.position),kind:Re.from(M.kind??h.InlayHintKind.Other),whitespaceBefore:M.whitespaceBefore,whitespaceAfter:M.whitespaceAfter}}ae.from=fe;function Y(M){const De=new h.InlayHint(M.text,t.to(M.position),Re.to(M.kind));return De.whitespaceAfter=M.whitespaceAfter,De.whitespaceBefore=M.whitespaceBefore,De}ae.to=Y})(Pe=e.InlayHint||(e.InlayHint={}));var Re;(function(ae){function fe(M){return M}ae.from=fe;function Y(M){return M}ae.to=Y})(Re=e.InlayHintKind||(e.InlayHintKind={}));var Ne;(function(ae){function fe(M){return{range:c.from(M.range),url:M.target,tooltip:M.tooltip}}ae.from=fe;function Y(M){let De;if(M.url)try{De=typeof M.url=="string"?y.URI.parse(M.url,!0):y.URI.revive(M.url)}catch(Ce){}return new h.DocumentLink(c.to(M.range),De)}ae.to=Y})(Ne=e.DocumentLink||(e.DocumentLink={}));var He;(function(ae){function fe(M){const De=new h.ColorPresentation(M.label);return M.textEdit&&(De.textEdit=ce.to(M.textEdit)),M.additionalTextEdits&&(De.additionalTextEdits=M.additionalTextEdits.map(Ce=>ce.to(Ce))),De}ae.to=fe;function Y(M){return{label:M.label,textEdit:M.textEdit?ce.from(M.textEdit):void 0,additionalTextEdits:M.additionalTextEdits?M.additionalTextEdits.map(De=>ce.from(De)):void 0}}ae.from=Y})(He=e.ColorPresentation||(e.ColorPresentation={}));var Ke;(function(ae){function fe(M){return new h.Color(M[0],M[1],M[2],M[3])}ae.to=fe;function Y(M){return[M.red,M.green,M.blue,M.alpha]}ae.from=Y})(Ke=e.Color||(e.Color={}));var Je;(function(ae){function fe(M){return{range:c.from(M.range)}}ae.from=fe;function Y(M){return new h.SelectionRange(c.to(M.range))}ae.to=Y})(Je=e.SelectionRange||(e.SelectionRange={}));var st;(function(ae){function fe(Y){switch(Y){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}ae.to=fe})(st=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var oe;(function(ae){function fe(M){switch(M){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}ae.from=fe;function Y(M){switch(M){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}ae.to=Y})(oe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pe;(function(ae){function fe(M){if(M===h.EndOfLine.CRLF)return 1;if(M===h.EndOfLine.LF)return 0}ae.from=fe;function Y(M){if(M===1)return h.EndOfLine.CRLF;if(M===0)return h.EndOfLine.LF}ae.to=Y})(pe=e.EndOfLine||(e.EndOfLine={}));var Se;(function(ae){function fe(Y){if(typeof Y=="object")return Y.viewId;switch(Y){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ae.from=fe})(Se=e.ProgressLocation||(e.ProgressLocation={}));var Be;(function(ae){function fe(Y){const M={start:Y.start+1,end:Y.end+1};return Y.kind&&(M.kind=xe.from(Y.kind)),M}ae.from=fe})(Be=e.FoldingRange||(e.FoldingRange={}));var xe;(function(ae){function fe(Y){if(Y)switch(Y){case h.FoldingRangeKind.Comment:return A.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return A.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return A.FoldingRangeKind.Region}}ae.from=fe})(xe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ot;(function(ae){function fe(Y){if(Y)return{pinned:typeof Y.preview=="boolean"?!Y.preview:void 0,inactive:Y.background,preserveFocus:Y.preserveFocus,selection:typeof Y.selection=="object"?c.from(Y.selection):void 0,override:typeof Y.override=="boolean"?E.EditorResolution.DISABLED:void 0}}ae.from=fe})(ot=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Qe;(function(ae){function fe(M){return M instanceof h.RelativePattern||typeof M=="string"?M:Y(M)?new h.RelativePattern(M.base,M.pattern):M}ae.from=fe;function Y(M){const De=M;return De&&typeof De.base=="string"&&typeof De.pattern=="string"}})(Qe=e.GlobPattern||(e.GlobPattern={}));var at;(function(ae){function fe(Y){if(Y){if(Array.isArray(Y))return Y.map(fe);if(typeof Y=="string")return Y;{const M=Y;return{language:M.language,scheme:M.scheme,pattern:typeof M.pattern=="undefined"?void 0:Qe.from(M.pattern),exclusive:M.exclusive}}}else return}ae.from=fe})(at=e.LanguageSelector||(e.LanguageSelector={}));var Ze;(function(ae){function fe(M){return{start:M.start,end:M.end}}ae.from=fe;function Y(M){return new h.NotebookRange(M.start,M.end)}ae.to=Y})(Ze=e.NotebookRange||(e.NotebookRange={}));var K;(function(ae){function fe(M){return{timing:typeof M.runStartTime=="number"&&typeof M.runEndTime=="number"?{startTime:M.runStartTime,endTime:M.runEndTime}:void 0,executionOrder:M.executionOrder,success:M.lastRunSuccess}}ae.to=fe;function Y(M){return{lastRunSuccess:M.success,runStartTime:M.timing?.startTime,runEndTime:M.timing?.endTime,executionOrder:M.executionOrder}}ae.from=Y})(K=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var we;(function(ae){function fe(M){switch(M){case h.NotebookCellKind.Markup:return u.CellKind.Markup;case h.NotebookCellKind.Code:default:return u.CellKind.Code}}ae.from=fe;function Y(M){switch(M){case u.CellKind.Markup:return h.NotebookCellKind.Markup;case u.CellKind.Code:default:return h.NotebookCellKind.Code}}ae.to=Y})(we=e.NotebookCellKind||(e.NotebookCellKind={}));var ke;(function(ae){function fe(M){const De={metadata:M.metadata??Object.create(null),cells:[]};for(let Ce of M.cells)h.NotebookCellData.validate(Ce),De.cells.push(Oe.from(Ce));return De}ae.from=fe;function Y(M){const De=new h.NotebookData(M.cells.map(Oe.to));return(0,d.isEmptyObject)(M.metadata)||(De.metadata=M.metadata),De}ae.to=Y})(ke=e.NotebookData||(e.NotebookData={}));var Oe;(function(ae){function fe(M){return{cellKind:we.from(M.kind),language:M.languageId,mime:M.mime,source:M.value,metadata:M.metadata,internalMetadata:K.from(M.executionSummary??{}),outputs:M.outputs?M.outputs.map(We.from):[]}}ae.from=fe;function Y(M){return new h.NotebookCellData(we.to(M.cellKind),M.source,M.language,M.mime,M.outputs?M.outputs.map(We.to):void 0,M.metadata,M.internalMetadata?K.to(M.internalMetadata):void 0)}ae.to=Y})(Oe=e.NotebookCellData||(e.NotebookCellData={}));var Te;(function(ae){function fe(M){return{mime:M.mime,valueBytes:_.VSBuffer.wrap(M.data)}}ae.from=fe;function Y(M){return new h.NotebookCellOutputItem(M.valueBytes.buffer,M.mime)}ae.to=Y})(Te=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var We;(function(ae){function fe(M){return{outputId:M.id,items:M.items.map(Te.from),metadata:M.metadata}}ae.from=fe;function Y(M){const De=M.items.map(Te.to);return new h.NotebookCellOutput(De,M.outputId,M.metadata)}ae.to=Y})(We=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Z;(function(ae){function fe(Ce){if(Ce!=null){if(Ce instanceof h.RelativePattern||typeof Ce=="string")return Ce;if(De(Ce))return new h.RelativePattern(Ce.base,Ce.pattern);if(M(Ce))return{include:Qe.from(Ce.include)||void 0,exclude:Qe.from(Ce.exclude)||void 0}}}ae.from=fe;function Y(Ce){return typeof Ce=="string"?Ce:De(Ce)?{base:Ce.base,pattern:Ce.pattern}:{include:Ce.include,exclude:Ce.exclude}}ae.to=Y;function M(Ce){const Ve=Ce,ze=Qe.from(Ve.include);if(!(ze&&ze instanceof h.RelativePattern||typeof ze=="string"))return!1;const tt=Qe.from(Ve.exclude);return!!(tt&&tt instanceof h.RelativePattern||typeof tt=="string")}function De(Ce){const Ve=Ce;return Ve&&typeof Ve.base=="string"&&typeof Ve.pattern=="string"}})(Z=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var te;(function(ae){function fe(Y){return{backgroundColor:Y.backgroundColor,borderColor:Y.borderColor,top:Y.top?I.from(Y.top):void 0}}ae.from=fe})(te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var le;(function(ae){function fe(Y,M,De){const Ce=typeof Y.command=="string"?{title:"",command:Y.command}:Y.command;return{alignment:Y.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:M.toInternal(Ce,De),text:Y.text,tooltip:Y.tooltip,accessibilityInformation:Y.accessibilityInformation,priority:Y.priority}}ae.from=fe})(le=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var V;(function(ae){function fe(Y){return{transientOutputs:Y?.transientOutputs??!1,transientCellMetadata:Y?.transientCellMetadata??{},transientDocumentMetadata:Y?.transientDocumentMetadata??{}}}ae.from=fe})(V=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var x;(function(ae){function fe(M){return{uri:M.uri,provides:M.provides}}ae.from=fe;function Y(M){return new h.NotebookRendererScript(y.URI.revive(M.uri),M.provides)}ae.to=Y})(x=e.NotebookRendererScript||(e.NotebookRendererScript={}));var se;(function(ae){function fe(M){return{message:R.fromStrict(M.message)||"",type:0,expected:M.expectedOutput,actual:M.actualOutput,location:M.location?W.from(M.location):void 0}}ae.from=fe;function Y(M){const De=new h.TestMessage(typeof M.message=="string"?M.message:R.to(M.message));return De.actualOutput=M.actual,De.expectedOutput=M.expected,De}ae.to=Y})(se=e.TestMessage||(e.TestMessage={}));var re;(function(ae){let fe;(function(Y){Y.Delimiter="\0"})(fe||(fe={})),ae.namespace=(Y,M)=>Y+"\0"+M,ae.denamespace=Y=>{const M=Y.indexOf("\0");return{ctrlId:Y.slice(0,M),tagId:Y.slice(M+1)}}})(re=e.TestTag||(e.TestTag={}));var Ee;(function(ae){function fe(Ce){const Ve=(0,o.getPrivateApiFor)(Ce).controllerId;return{extId:w.TestId.fromExtHostTestItem(Ce,Ve).toString(),label:Ce.label,uri:Ce.uri,tags:Ce.tags.map(ze=>re.namespace(Ve,ze.id)),range:c.from(Ce.range)||null,description:Ce.description||null,error:Ce.error&&R.fromStrict(Ce.error)||null}}ae.from=fe;function Y(Ce){return{id:w.TestId.fromString(Ce.extId).localId,label:Ce.label,uri:y.URI.revive(Ce.uri),tags:(Ce.tags||[]).map(Ve=>{const{tagId:ze}=re.denamespace(Ve);return new h.TestTag(ze,ze)}),range:c.to(Ce.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ce.description||void 0}}ae.toPlain=Y;function M(Ce){const Ve=w.TestId.fromString(Ce.extId),ze=new o.TestItemImpl(Ve.controllerId,Ve.localId,Ce.label,y.URI.revive(Ce.uri));return ze.range=c.to(Ce.range||void 0),ze.description=Ce.description||void 0,ze}function De(Ce){let Ve;for(const ze of Ce.tests){const tt=M(ze.item);(0,o.getPrivateApiFor)(tt).parent=Ve,Ve=tt}return Ve}ae.toItemFromContext=De})(Ee=e.TestItem||(e.TestItem={})),function(ae){function fe(M){return{id:M.id,label:M.label}}ae.from=fe;function Y(M){return new h.TestTag(M.id,M.label)}ae.to=Y}(re=e.TestTag||(e.TestTag={}));var Fe;(function(ae){const fe=(M,De)=>{const Ce={...Ee.toPlain(M.item),parent:void 0,taskStates:M.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(ze=>ze.type===0).map(se.to)})),children:M.children.map(Ve=>De.get(Ve)).filter(d.isDefined).map(Ve=>fe(Ve,De))};for(const Ve of Ce.children)Ve.parent=Ce;return Ce};function Y(M){const De=[],Ce=new Map;for(const Ve of M.items)Ce.set(Ve.item.extId,Ve),M.request.targets.some(ze=>ze.controllerId===Ve.controllerId&&ze.testIds.includes(Ve.item.extId))&&De.push(Ve);return{completedAt:M.completedAt,results:De.map(Ve=>fe(Ve,Ce))}}ae.to=Y})(Fe=e.TestResults||(e.TestResults={}));var _e;(function(ae){function fe(Ce){return{covered:Ce.covered,total:Ce.covered}}function Y(Ce){return"line"in Ce?t.from(Ce):c.from(Ce)}function M(Ce){return"branches"in Ce?{count:Ce.executionCount,location:Y(Ce.location),type:1,branches:Ce.branches.length?Ce.branches.map(Ve=>({count:Ve.executionCount,location:Ve.location&&Y(Ve.location)})):void 0}:{type:0,count:Ce.executionCount,location:Y(Ce.location)}}ae.fromDetailed=M;function De(Ce){return{uri:Ce.uri,statement:fe(Ce.statementCoverage),branch:Ce.branchCoverage&&fe(Ce.branchCoverage),function:Ce.functionCoverage&&fe(Ce.functionCoverage),details:Ce.detailedCoverage?.map(M)}}ae.fromFile=De})(_e=e.TestCoverage||(e.TestCoverage={}));var Me;(function(ae){function fe(Y){switch(Y){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}ae.to=fe})(Me=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var je;(function(ae){function fe(M){const De=new h.TypeHierarchyItem($.to(M.kind),M.name,M.detail||"",y.URI.revive(M.uri),c.to(M.range),c.to(M.selectionRange));return De._sessionId=M._sessionId,De._itemId=M._itemId,De}ae.to=fe;function Y(M,De,Ce){if(De=De??M._sessionId,Ce=Ce??M._itemId,De===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Ce,kind:$.from(M.kind),name:M.name,detail:M.detail??"",uri:M.uri,range:c.from(M.range),selectionRange:c.from(M.selectionRange),tags:M.tags?.map(z.from)}}ae.from=Y})(je=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[226],ge([0,1,12,221,14,95,99,104,222,102,105,8,184,103]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let o=class{constructor(w,p,h,f,c,a,t,s,n,r){this._remoteAuthority=w,this._channel=p,this._configurationService=h,this._workspaceContextService=f,this._resolverService=c,this._environmentVariableService=a,this._remoteAuthorityResolverService=t,this._logService=s,this._editorService=n,this._labelService=r}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessTitleChanged(){return this._channel.listen("$onProcessTitleChangedEvent")}get onProcessShellTypeChanged(){return this._channel.listen("$onProcessShellTypeChangedEvent")}get onProcessOverrideDimensions(){return this._channel.listen("$onProcessOverrideDimensionsEvent")}get onProcessResolvedShellLaunchConfig(){return this._channel.listen("$onProcessResolvedShellLaunchConfigEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onProcessDidChangeHasChildProcesses(){return this._channel.listen("$onProcessDidChangeHasChildProcesses")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(w,p,h,f,c,a,t){await this._configurationService.whenRemoteConfigurationLoaded();const s=Object.create(null),n=h?(0,S.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(h)):void 0;let r;try{r=(await this._resolverService.resolveAnyMap(n,{shellLaunchConfig:w,configuration:p})).resolvedVariables}catch(B){this._logService.error(B)}if(r)for(const[B,j]of r.entries())(/^config:/.test(B)||B==="selectedText"||B==="lineNumber")&&(s[B]=j);const l=[];for(const[B,j]of this._environmentVariableService.collections.entries())l.push([B,(0,D.serializeEnvironmentVariableCollection)(j.map)]);const v=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),P=v.options&&v.options.extensionHostEnv,L=this._workspaceContextService.getWorkspace(),R=L.folders,m=h?this._workspaceContextService.getWorkspaceFolder(h):null,T=y.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:y.SideBySideEditor.PRIMARY,filterByScheme:[A.Schemas.file,A.Schemas.userData,A.Schemas.vscodeRemote]}),I={configuration:p,resolvedVariables:s,envVariableCollections:l,shellLaunchConfig:w,workspaceId:L.id,workspaceName:this._labelService.getWorkspaceLabel(L),workspaceFolders:R,activeWorkspaceFolder:m,activeFileResource:T,shouldPersistTerminal:f,cols:c,rows:a,unicodeVersion:t,resolverEnv:P};return await this._channel.call("$createProcess",I)}requestDetachInstance(w,p){return this._channel.call("$requestDetachInstance",[w,p])}acceptDetachInstanceReply(w,p){return this._channel.call("$acceptDetachInstanceReply",[w,p])}attachToProcess(w){return this._channel.call("$attachToProcess",[w])}detachFromProcess(w){return this._channel.call("$detachFromProcess",[w])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(w,p){return this._channel.call("$processBinary",[w,p])}start(w){return this._channel.call("$start",[w])}input(w,p){return this._channel.call("$input",[w,p])}acknowledgeDataEvent(w,p){return this._channel.call("$acknowledgeDataEvent",[w,p])}setUnicodeVersion(w,p){return this._channel.call("$setUnicodeVersion",[w,p])}shutdown(w,p){return this._channel.call("$shutdown",[w,p])}resize(w,p,h){return this._channel.call("$resize",[w,p,h])}getInitialCwd(w){return this._channel.call("$getInitialCwd",[w])}getCwd(w){return this._channel.call("$getCwd",[w])}orphanQuestionReply(w){return this._channel.call("$orphanQuestionReply",[w])}sendCommandResult(w,p,h){return this._channel.call("$sendCommandResult",[w,p,h])}getDefaultSystemShell(w){return this._channel.call("$getDefaultSystemShell",[w])}getProfiles(w,p,h){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,w,p,h])}acceptPtyHostResolvedVariables(w,p){return this._channel.call("$acceptPtyHostResolvedVariables",[w,p])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(w){return this._channel.call("$getWslPath",[w])}setTerminalLayoutInfo(w){const h={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:w.tabs};return this._channel.call("$setTerminalLayoutInfo",h)}updateTitle(w,p){return this._channel.call("$updateTitle",[w,p])}updateIcon(w,p,h){return this._channel.call("$updateIcon",[w,p,h])}getTerminalLayoutInfo(){const p={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",p)}};o=Le([Xe(2,_.IWorkbenchConfigurationService),Xe(3,C.IWorkspaceContextService),Xe(4,d.IConfigurationResolverService),Xe(5,b.IEnvironmentVariableService),Xe(6,k.IRemoteAuthorityResolverService),Xe(7,g.ILogService),Xe(8,i.IEditorService),Xe(9,E.ILabelService)],o),e.RemoteTerminalChannelClient=o}),define(me[227],ge([0,1,189]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var _;(function(k){function C(D,d){if(D===d)return!0;let y=Object.keys(D),i=new Set;for(let A of Object.keys(d))i.add(A);if(y.length!==i.size)return!1;for(let A of y){if(D[A]!==d[A])return!1;i.delete(A)}return i.size===0}k.equals=C})(_=e.Translations||(e.Translations={}));class g{constructor(C){this._messageHandler=C}error(C,D){this._messageHandler(S.Severity.Error,C,D)}warn(C,D){this._messageHandler(S.Severity.Warning,C,D)}info(C,D){this._messageHandler(S.Severity.Info,C,D)}}e.Logger=g}),define(me[228],ge([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class S{constructor(y,i){this._proxyIdentifierBrand=void 0,this.isMain=y,this.sid=i,this.nid=++S.count}}e.ProxyIdentifier=S,S.count=0;const _=[];function g(d){const y=new S(!0,d);return _[y.nid]=y,y}e.createMainContextProxyIdentifier=g;function k(d){const y=new S(!1,d);return _[y.nid]=y,y}e.createExtHostContextProxyIdentifier=k;function C(d){return _[d].sid}e.getStringIdentifierForProxy=C;class D{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=D}),define(me[229],ge([0,1,46,4,228]),function(Q,e,S,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var k;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var C;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var d;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(d=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));var E;(function(f){f.name="$ident";function c(t,s){return Object.defineProperty(t,f.name,{value:s,enumerable:!0}),t}f.mixin=c;function a(t){return t[f.name]}f.of=a})(E=e.ObjectIdentifier||(e.ObjectIdentifier={}));class b{static mixin(c){return c._id=b._n++,c}}e.IdObject=b,b._n=0;var o;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(f){f[f.File=1]="File",f[f.Text=2]="Text",f[f.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function p(f){if(f&&f.edits)for(const c of f.edits)typeof c.resource=="object"?c.resource=_.URI.revive(c.resource):(c.newUri=_.URI.revive(c.newUri),c.oldUri=_.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,S.revive)(c.metadata));return f}e.reviveWorkspaceEditDto=p;var h;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(h=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,g.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,g.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,g.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,g.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,g.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,g.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,g.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,g.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,g.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,g.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,g.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,g.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,g.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,g.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,g.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,g.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,g.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,g.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,g.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,g.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,g.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,g.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,g.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,g.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,g.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,g.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,g.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,g.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,g.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,g.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,g.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,g.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,g.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,g.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,g.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,g.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,g.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,g.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,g.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,g.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,g.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,g.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,g.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,g.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,g.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,g.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,g.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,g.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,g.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,g.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,g.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,g.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,g.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,g.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,g.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,g.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,g.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,g.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,g.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,g.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,g.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,g.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,g.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,g.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,g.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,g.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,g.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,g.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,g.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,g.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,g.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,g.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,g.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,g.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,g.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,g.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,g.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,g.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,g.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,g.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,g.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,g.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,g.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,g.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,g.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,g.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,g.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,g.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,g.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,g.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,g.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,g.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,g.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,g.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,g.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,g.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,g.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,g.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,g.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,g.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,g.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,g.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,g.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,g.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,g.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,g.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[230],ge([0,1,12,101,225,18,229,20,14,46,55,83,4,2,6,215]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(C.MainContext.MainThreadCommands),this._logService=s,this.converter=new p(this,n=>{const r=this._apiCommands.get(n);return r?.result===f.Void?r:void 0},s),this._argumentProcessors=[{processArgument(n){return(0,y.revive)(n)}},{processArgument(n){return(0,k.cloneAndChange)(n,function(r){if(i.Range.isIRange(r))return g.Range.to(r);if(A.Position.isIPosition(r))return g.Position.to(r);if(i.Range.isIRange(r.range)&&E.URI.isUri(r.uri))return g.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const s=this.registerCommand(!1,t.id,async(...n)=>{const r=t.args.map((v,P)=>{if(!v.validate(n[P]))throw new Error(`Invalid argument '${v.name}' when running '${t.id}', received: ${n[P]}`);return v.convert(n[P])}),l=await this.executeCommand(t.internalId,...r);return t.result.convert(l,n,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new _.Disposable(()=>{s.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,s,n,r,l){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:n,thisArg:r,description:l}),t&&this._proxy.$registerCommand(s),new _.Disposable(()=>{this._commands.delete(s)&&t&&this._proxy.$unregisterCommand(s)})}executeCommand(t,...s){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,s,!0)}async _doExecuteCommand(t,s,n){if(this._commands.has(t))return this._executeContributedCommand(t,s);{const r=(0,k.cloneAndChange)(s,function(l){if(l instanceof _.Position)return g.Position.from(l);if(l instanceof _.Range)return g.Range.from(l);if(l instanceof _.Location)return g.location.from(l);if(_.NotebookRange.isNotebookRange(l))return g.NotebookRange.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,r,n);return(0,y.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,s,!1);throw l}}}async _executeContributedCommand(t,s){const n=this._commands.get(t);if(!n)throw new Error("Unknown command");let{callback:r,thisArg:l,description:v}=n;if(v)for(let P=0;P<v.args.length;P++)try{(0,S.validateConstraint)(s[P],v.args[P].constraint)}catch(L){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${v.args[P].name}' - ${v.args[P].description}`)}try{return await r.apply(l,s)}catch(P){if(t===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...s);L&&(t=L.command)}throw this._logService.error(P,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(s=s.map(n=>this._argumentProcessors.reduce((r,l)=>l.processArgument(r),n)),this._executeContributedCommand(t,s)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(s=>(t&&(s=s.filter(n=>n[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[s,n]of this._commands){let{description:r}=n;r&&(t[s]=r)}return Promise.resolve(t)}};w=Le([Xe(0,u.IExtHostRpcService),Xe(1,d.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class p{constructor(t,s,n){this._commands=t,this._lookupApiCommand=s,this._logService=n,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,s){if(!t)return;const n={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return n;const r=this._lookupApiCommand(t.command);if(r)n.id=r.internalId,n.arguments=r.args.map((l,v)=>l.convert(t.arguments&&t.arguments[v]));else if((0,D.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),s.add((0,b.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),n.$ident=l,n.id=this.delegatingCommandId,n.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return n}fromInternal(t){const s=C.ObjectIdentifier.of(t);return typeof s=="number"?this._cache.get(s):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const s=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=p;class h{constructor(t,s,n,r){this.name=t,this.description=s,this.validate=n,this.convert=r}optional(){return new h(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,s){return new h(t??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=h,h.Uri=new h("uri","Uri of a text document",a=>E.URI.isUri(a),a=>a),h.Position=new h("position","A position in a text document",a=>_.Position.isPosition(a),g.Position.from),h.Range=new h("range","A range in a text document",a=>_.Range.isRange(a),g.Range.from),h.Selection=new h("selection","A selection in a text document",a=>_.Selection.isSelection(a),g.Selection.from),h.Number=new h("number","",a=>typeof a=="number",a=>a),h.String=new h("string","",a=>typeof a=="string",a=>a),h.CallHierarchyItem=new h("item","A call hierarchy item",a=>a instanceof _.CallHierarchyItem,g.CallHierarchyItem.from),h.TypeHierarchyItem=new h("item","A type hierarchy item",a=>a instanceof _.TypeHierarchyItem,g.TypeHierarchyItem.from);class f{constructor(t,s){this.description=t,this.convert=s}}e.ApiCommandResult=f,f.Void=new f("no result",a=>a);class c{constructor(t,s,n,r,l){this.id=t,this.internalId=s,this.description=n,this.args=r,this.result=l}}e.ApiCommand=c}),define(me[231],ge([0,1,162,5,49,38,20,135,12,4,16,33,58,44,227]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const u="package.json";class w{constructor(n,r,l,v,P,L){this._ourVersion=n,this._ourProductDate=r,this._log=l,this._absoluteFolderPath=v,this._isBuiltin=P,this._isUnderDevelopment=L,this._absoluteManifestPath=_.join(v,u)}}class p extends w{static _fastParseJSON(n,r){try{return JSON.parse(n)}catch(l){return k.parse(n,r)}}parse(){return i.Promises.readFile(this._absoluteManifestPath).then(n=>{const r=[],l=p._fastParseJSON(n.toString(),r);if(k.getNodeType(l)!=="object")this._log.error(this._absoluteFolderPath,S.localize(0,null,this._absoluteManifestPath));else{if(r.length===0)return l.__metadata&&(l.uuid=l.__metadata.id),l.isUserBuiltin=!!l.__metadata?.isBuiltin,delete l.__metadata,l;r.forEach(v=>{this._log.error(this._absoluteFolderPath,S.localize(1,null,this._absoluteManifestPath,v.offset,v.length,(0,D.getParseErrorMessage)(v.error)))})}return null},n=>(n.code==="ENOENT"||this._log.error(this._absoluteFolderPath,S.localize(2,null,this._absoluteManifestPath,n.message)),null))}}class h extends w{constructor(n,r,l,v,P,L,R){super(n,r,l,v,P,L);this._nlsConfig=R}replaceNLS(n){const r=(T,I)=>{I.forEach(B=>{this._log.error(this._absoluteFolderPath,S.localize(3,null,T,(0,D.getParseErrorMessage)(B.error)))})},l=T=>{this._log.error(this._absoluteFolderPath,S.localize(4,null,T))};let v=_.extname(this._absoluteManifestPath),P=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-v.length);const L=`${n.publisher}.${n.name}`;let R=this._nlsConfig.translations[L],m;return R?m=i.Promises.readFile(R,"utf8").then(T=>{let I=[],B=k.parse(T,I);return I.length>0?(r(R,I),{values:void 0,default:`${P}.nls.json`}):k.getNodeType(B)!=="object"?(l(R),{values:void 0,default:`${P}.nls.json`}):{values:B.contents?B.contents.package:void 0,default:`${P}.nls.json`}},T=>({values:void 0,default:`${P}.nls.json`})):m=i.SymlinkSupport.existsFile(P+".nls"+v).then(T=>{if(!!T)return h.findMessageBundles(this._nlsConfig,P).then(I=>I.localized?i.Promises.readFile(I.localized,"utf8").then(B=>{let j=[],ue=k.parse(B,j);return j.length>0?(r(I.localized,j),{values:void 0,default:I.original}):k.getNodeType(ue)!=="object"?(l(I.localized),{values:void 0,default:I.original}):{values:ue,default:I.original}},B=>({values:void 0,default:I.original})):{values:void 0,default:I.original},I=>{})}),m.then(T=>{if(T===void 0)return n;let I=[];return h.resolveOriginalMessageBundle(T.default,I).then(B=>{if(I.length>0)return r(T.default,I),n;if(k.getNodeType(T)!=="object")return l(T.default),n;const j=T.values||Object.create(null);return h._replaceNLStrings(this._nlsConfig,n,j,B,this._log,this._absoluteFolderPath),n})},T=>n)}static resolveOriginalMessageBundle(n,r){return new Promise((l,v)=>{n?i.Promises.readFile(n).then(P=>{l(k.parse(P.toString(),r))},P=>{l(null)}):l(null)})}static findMessageBundles(n,r){return new Promise((l,v)=>{function P(L,R){let m=`${L}.nls.${R}.json`;i.SymlinkSupport.existsFile(m).then(T=>{T&&l({localized:m,original:`${L}.nls.json`});let I=R.lastIndexOf("-");I===-1?l({localized:`${L}.nls.json`,original:null}):(R=R.substring(0,I),P(L,R))})}if(n.devMode||n.pseudo||!n.locale)return l({localized:r+".nls.json",original:null});P(r,n.locale)})}static _replaceNLStrings(n,r,l,v,P,L){function R(m,T,I){const B=m[T];if(d.isString(B)){const j=B,ue=j.length;if(ue>1&&j[0]==="%"&&j[ue-1]==="%"){const ce=j.substr(1,ue-2);let O=l[ce];O===void 0&&v&&(O=v[ce]);let $=typeof O=="string"?O:typeof O?.message=="string"?O.message:void 0;$!==void 0?(n.pseudo&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),m[T]=I&&(T==="title"||T==="category")&&v?{value:$,original:v[ce]}:$):P.warn(L,S.localize(5,null,ce))}}else if(d.isObject(B))for(let j in B)B.hasOwnProperty(j)&&(j==="commands"?R(B,j,!0):R(B,j,I));else if(d.isArray(B))for(let j=0;j<B.length;j++)R(B,j,I)}for(let m in r)r.hasOwnProperty(m)&&R(r,m)}}class f extends w{validate(n){let r=n;r.isBuiltin=this._isBuiltin,r.isUserBuiltin=!this._isBuiltin&&!!r.isUserBuiltin,r.isUnderDevelopment=this._isUnderDevelopment;let l=[];return f.isValidExtensionDescription(this._ourVersion,this._ourProductDate,this._absoluteFolderPath,r,l)?(l.forEach(v=>{this._log.warn(this._absoluteFolderPath,v)}),r.publisher||(r.publisher="undefined_publisher"),r.id=(0,A.getExtensionId)(r.publisher,r.name),r.identifier=new b.ExtensionIdentifier(r.id),r.extensionLocation=y.URI.file(this._absoluteFolderPath),r):(l.forEach(v=>{this._log.error(this._absoluteFolderPath,v)}),null)}static isValidExtensionDescription(n,r,l,v,P){return f.baseIsValidExtensionDescription(l,v,P)?g.valid(v.version)?(0,E.isValidExtensionVersion)(n,r,v,P):(P.push(S.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(n,r,l){if(!r)return l.push(S.localize(7,null)),!1;if(typeof r.publisher!="undefined"&&typeof r.publisher!="string")return l.push(S.localize(8,null)),!1;if(typeof r.name!="string")return l.push(S.localize(9,null,"name")),!1;if(typeof r.version!="string")return l.push(S.localize(10,null,"version")),!1;if(!r.engines)return l.push(S.localize(11,null,"engines")),!1;if(typeof r.engines.vscode!="string")return l.push(S.localize(12,null,"engines.vscode")),!1;if(typeof r.extensionDependencies!="undefined"&&!f._isStringArray(r.extensionDependencies))return l.push(S.localize(13,null,"extensionDependencies")),!1;if(typeof r.activationEvents!="undefined"){if(!f._isStringArray(r.activationEvents))return l.push(S.localize(14,null,"activationEvents")),!1;if(typeof r.main=="undefined"&&typeof r.browser=="undefined")return l.push(S.localize(15,null,"activationEvents","main")),!1}if(typeof r.main!="undefined"){if(typeof r.main!="string")return l.push(S.localize(16,null,"main")),!1;{const v=_.join(n,r.main);v.startsWith(n)||l.push(S.localize(17,null,v,n))}if(typeof r.activationEvents=="undefined")return l.push(S.localize(18,null,"activationEvents","main")),!1}if(typeof r.browser!="undefined"){if(typeof r.browser!="string")return l.push(S.localize(19,null,"browser")),!1;{const v=_.join(n,r.browser);v.startsWith(n)||l.push(S.localize(20,null,v,n))}if(typeof r.activationEvents=="undefined")return l.push(S.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(n){if(!Array.isArray(n))return!1;for(let r=0,l=n.length;r<l;r++)if(typeof n[r]!="string")return!1;return!0}}class c{constructor(n,r,l,v,P,L,R,m,T){this.ourVersion=n,this.ourProductDate=r,this.commit=l,this.locale=v,this.devMode=P,this.absoluteFolderPath=L,this.isBuiltin=R,this.isUnderDevelopment=m,this.translations=T}static createNLSConfig(n){return{devMode:n.devMode,locale:n.locale,pseudo:n.locale==="pseudo",translations:n.translations}}static equals(n,r){return n.ourVersion===r.ourVersion&&n.ourProductDate===r.ourProductDate&&n.commit===r.commit&&n.locale===r.locale&&n.devMode===r.devMode&&n.absoluteFolderPath===r.absoluteFolderPath&&n.isBuiltin===r.isBuiltin&&n.isUnderDevelopment===r.isUnderDevelopment&&n.mtime===r.mtime&&o.Translations.equals(n.translations,r.translations)}}e.ExtensionScannerInput=c;class a{constructor(n){this.root=n}resolveExtensions(){return i.Promises.readDirsInDir(this.root).then(n=>n.map(r=>({name:r,path:_.join(this.root,r)})))}}class t{static scanExtension(n,r,l,v,P,L,R){return v=_.normalize(v),new p(n,r,l,v,P,L).parse().then(T=>T===null?null:new h(n,r,l,v,P,L,R).replaceNLS(T)).then(T=>T===null?null:new f(n,r,l,v,P,L).validate(T))}static async scanExtensions(n,r,l=null){const v=n.absoluteFolderPath,P=n.isBuiltin,L=n.isUnderDevelopment;l||(l=new a(v));try{let R={};if(!P)try{const j=await i.Promises.readFile(_.join(v,".obsolete"),"utf8");R=JSON.parse(j)}catch(j){}let m=await l.resolveExtensions();m.sort((j,ue)=>j.name<ue.name?-1:1),P||(m=m.filter(j=>j.name.indexOf(".")!==0));const T=c.createNLSConfig(n);let I=await Promise.all(m.map(j=>this.scanExtension(n.ourVersion,n.ourProductDate,r,j.path,P,L,T))),B=C.coalesce(I);return B=B.filter(j=>j!==null&&!R[new A.ExtensionIdentifierWithVersion({id:(0,A.getGalleryExtensionId)(j.publisher,j.name)},j.version).key()]),P||(B=(0,A.groupByExtension)(B,ue=>({id:ue.identifier.value,uuid:ue.uuid})).map(ue=>ue.sort((ce,O)=>g.rcompare(ce.version,O.version))[0])),B.sort((j,ue)=>j.extensionLocation.fsPath<ue.extensionLocation.fsPath?-1:1),B}catch(R){return r.error(v,R),[]}}static scanOneOrMultipleExtensions(n,r){const l=n.absoluteFolderPath,v=n.isBuiltin,P=n.isUnderDevelopment;return i.SymlinkSupport.existsFile(_.join(l,u)).then(L=>{if(L){const R=c.createNLSConfig(n);return this.scanExtension(n.ourVersion,n.ourProductDate,r,l,v,P,R).then(m=>m===null?[]:[m])}return this.scanExtensions(n,r)},L=>(r.error(l,L),[]))}static scanSingleExtension(n,r){const l=n.absoluteFolderPath,v=n.isBuiltin,P=n.isUnderDevelopment,L=c.createNLSConfig(n);return this.scanExtension(n.ourVersion,n.ourProductDate,r,l,v,P,L)}static mergeBuiltinExtensions(n,r){return Promise.all([n,r]).then(([l,v])=>{let P=Object.create(null);for(let R=0,m=l.length;R<m;R++)P[b.ExtensionIdentifier.toKey(l[R].identifier)]=l[R];for(let R=0,m=v.length;R<m;R++)P[b.ExtensionIdentifier.toKey(v[R].identifier)]=v[R];let L=Object.keys(P).map(R=>P[R]);return L.sort((R,m)=>{const T=_.basename(R.extensionLocation.fsPath),I=_.basename(m.extensionLocation.fsPath);return T<I?-1:T>I?1:0}),L})}}e.ExtensionScanner=t}),define(me[232],ge([0,1,3,48,4,41,158,28,8,30,231,44,54,100,60,81,199,5,22]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let f=null;function c(){return f||(f=(0,p.normalize)((0,p.join)(d.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))),f}let a=null;function t(){return a||(a=(0,p.normalize)((0,p.join)(d.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions"))),a}class s{constructor(r,l,v,P,L,R){this._connectionToken=r,this.environmentService=l,this.logService=P,this.telemetryService=L,this.telemetryAppender=R,this._logger=new class{error(T,I){P.error(T,I)}warn(T,I){P.warn(T,I)}info(T,I){P.info(T,I)}},l.args["install-builtin-extension"]?this.whenExtensionsReady=v.installExtensions([],l.args["install-builtin-extension"],!!l.args["do-not-sync"],!!l.args.force).then(null,T=>{P.error(T)}):this.whenExtensionsReady=Promise.resolve();const m=l.args["install-extension"];if(m){const T=m.map(I=>/\.vsix$/i.test(I)?g.URI.file((0,p.isAbsolute)(I)?I:(0,p.join)((0,h.cwd)(),I)):I);this.whenExtensionsReady.then(()=>v.installExtensions(T,[],!!l.args["do-not-sync"],!!l.args.force)).then(null,I=>{P.error(I)})}}async call(r,l,v){switch(l){case"disableTelemetry":{this.telemetryService.setEnabled(!1);return}case"getEnvironmentData":{const P=v,L=(0,k.createRemoteURITransformer)(P.remoteAuthority);let R=await this._getEnvironmentData();return R=(0,E.transformOutgoingURIs)(R,L),R}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const P=v,L=P.language;this.logService.trace(`Scanning extensions using UI language: ${L}`);const R=(0,k.createRemoteURITransformer)(P.remoteAuthority),m=P.extensionDevelopmentPath&&P.extensionDevelopmentPath.map(B=>g.URI.revive(R.transformIncoming(B))),T=m?m.filter(B=>B.scheme===d.Schemas.file).map(B=>B.fsPath):void 0;let I=await this._scanExtensions(L,T);return I=(0,E.transformOutgoingURIs)(I,R),this.logService.trace("Scanned Extensions",I),s._massageWhenConditions(I),I}case"scanSingleExtension":{await this.whenExtensionsReady;const P=v,L=P.language,R=P.isBuiltin,m=(0,k.createRemoteURITransformer)(P.remoteAuthority),T=g.URI.revive(m.transformIncoming(P.extensionLocation)),I=T.scheme===d.Schemas.file?T.fsPath:null;if(!I)return null;const B=await this._getTranslations(L);let j=await this._scanSingleExtension(I,R,L,B);return j?(j=(0,E.transformOutgoingURIs)(j,m),s._massageWhenConditions([j]),j):null}case"getDiagnosticInfo":{const P=v,L={machineInfo:(0,w.getMachineInfo)()},R=P.includeProcesses?(0,u.listProcesses)(process.pid):Promise.resolve();let m=[];const T={};if(P.folders){const I=(0,k.createRemoteURITransformer)("");m=P.folders.map(j=>g.URI.revive(I.transformIncoming(j))).filter(j=>j.scheme==="file").map(j=>(0,w.collectWorkspaceStats)(j.fsPath,["node_modules",".git"]).then(ue=>{T[(0,p.basename)(j.fsPath)]=ue}))}return Promise.all([R,...m]).then(([I,B])=>(L.processes=I||void 0,L.workspaceMetadata=P.folders?T:void 0,L))}case"logTelemetry":{const{eventName:P,data:L}=v;return this.telemetryAppender?this.telemetryAppender.log(P,L):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${l} not found`)}listen(r,l,v){throw new Error("Not supported")}static _massageWhenConditions(r){const l=(T,I)=>T.replace(/file/g,"vscode-remote"),v=T=>{let I="";return I+=T.global?"g":"",I+=T.ignoreCase?"i":"",I+=T.multiline?"m":"",new RegExp(l(T.source,!0),I)},P=new class{mapDefined(T){return o.ContextKeyDefinedExpr.create(T)}mapNot(T){return o.ContextKeyNotExpr.create(T)}mapEquals(T,I){return T==="resourceScheme"&&typeof I=="string"?o.ContextKeyEqualsExpr.create(T,l(I,!1)):o.ContextKeyEqualsExpr.create(T,I)}mapNotEquals(T,I){return T==="resourceScheme"&&typeof I=="string"?o.ContextKeyNotEqualsExpr.create(T,l(I,!1)):o.ContextKeyNotEqualsExpr.create(T,I)}mapGreater(T,I){return o.ContextKeyGreaterExpr.create(T,I)}mapGreaterEquals(T,I){return o.ContextKeyGreaterEqualsExpr.create(T,I)}mapSmaller(T,I){return o.ContextKeySmallerExpr.create(T,I)}mapSmallerEquals(T,I){return o.ContextKeySmallerEqualsExpr.create(T,I)}mapRegex(T,I){return T==="resourceScheme"&&I?o.ContextKeyRegexExpr.create(T,v(I)):o.ContextKeyRegexExpr.create(T,I)}mapIn(T,I){return o.ContextKeyInExpr.create(T,I)}},L=T=>{if(!T||!T.when||!/resourceScheme/.test(T.when))return;const I=o.ContextKeyExpr.deserialize(T.when);if(!I)return;const B=I.map(P);T.when=B.serialize()},R=T=>{if(Array.isArray(T))for(let I of T)L(I);else L(T)},m=T=>{for(let I in T)R(T[I])};r.forEach(T=>{T.contributes&&(T.contributes.menus&&m(T.contributes.menus),T.contributes.keybindings&&R(T.contributes.keybindings),T.contributes.views&&m(T.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken,appRoot:g.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:g.URI.file(this.environmentService.logsPath),extensionsPath:g.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:g.URI.file((0,p.join)(this.environmentService.logsPath,`exthost${s._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:S.OS,arch:process.arch,marks:_.getMarks(),useHostProxy:this.environmentService.args["use-host-proxy"]!==void 0}}async _getTranslations(r){const l=await(0,b.getNLSConfiguration)(r,this.environmentService.userDataPath);if(b.InternalNLSConfiguration.is(l))try{const v=await D.promises.readFile(l._translationsConfigFile,"utf8");return JSON.parse(v)}catch(v){return Object.create(null)}else return Object.create(null)}async _scanExtensions(r,l){const v=await this._getTranslations(r),[P,L,R]=await Promise.all([this._scanBuiltinExtensions(r,v),this._scanInstalledExtensions(r,v),this._scanDevelopedExtensions(r,v,l)]);let m=new Map;P.forEach(I=>{!I||m.set(A.ExtensionIdentifier.toKey(I.identifier),I)}),L.forEach(I=>{!I||(m.has(A.ExtensionIdentifier.toKey(I.identifier))&&console.warn(C.localize(0,null,m.get(A.ExtensionIdentifier.toKey(I.identifier)).extensionLocation.fsPath,I.extensionLocation.fsPath)),m.set(A.ExtensionIdentifier.toKey(I.identifier),I))}),R.forEach(I=>{!I||m.set(A.ExtensionIdentifier.toKey(I.identifier),I)});const T=[];return m.forEach(I=>T.push(I)),T}_scanDevelopedExtensions(r,l,v){if(v){const P=v.map(L=>i.ExtensionScanner.scanOneOrMultipleExtensions(new i.ExtensionScannerInput(y.default.version,y.default.date,y.default.commit,r,!0,L,!1,!0,l),this._logger));return Promise.all(P).then(L=>{let R=[];for(let m of L)R=R.concat(m);return R})}return Promise.resolve([])}_scanBuiltinExtensions(r,l){const v=y.default.version,P=y.default.commit,L=y.default.date,R=!!process.env.VSCODE_DEV,m=new i.ExtensionScannerInput(v,L,P,r,R,c(),!0,!1,l),T=i.ExtensionScanner.scanExtensions(m,this._logger);let I=T;if(R){class B{constructor($){this.builtInExtensions=$}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map($=>({name:$.name,path:(0,p.join)(t(),$.name)})))}}const j=Promise.resolve(y.default.builtInExtensions||[]),ue=new i.ExtensionScannerInput(v,L,P,r,R,t(),!0,!1,{}),ce=j.then(O=>new B(O)).then(O=>i.ExtensionScanner.scanExtensions(ue,this._logger,O));I=i.ExtensionScanner.mergeBuiltinExtensions(T,ce)}return I}_scanInstalledExtensions(r,l){const v=!!process.env.VSCODE_DEV,P=new i.ExtensionScannerInput(y.default.version,y.default.date,y.default.commit,r,v,this.environmentService.extensionsPath,!1,!1,l);return i.ExtensionScanner.scanExtensions(P,this._logger)}_scanSingleExtension(r,l,v,P){const L=!!process.env.VSCODE_DEV,R=new i.ExtensionScannerInput(y.default.version,y.default.date,y.default.commit,v,L,r,l,!1,P);return i.ExtensionScanner.scanSingleExtension(R,this._logger)}}e.RemoteAgentEnvironmentChannel=s,s._namePool=1}),define(me[233],ge([0,1,171]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProvider=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class _ extends S.IPCFileSystemProvider{constructor(k){super(k.getConnection().getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME));this.setCaseSensitive(!0),(async()=>{const C=await k.getEnvironment();this.setCaseSensitive(C?.os===3)})()}}e.RemoteFileSystemProvider=_}),define(me[106],ge([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,S.createDecorator)("remoteAgentService")}),define(me[70],ge([0,1,28,13,5,12,16,138,247,248]),function(Q,e,S,_,g,k,C,D,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,s){let n=s.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=s}}e.ExtractError=i;function A(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,n)=>s+n,t&61440)}function E(a){if(a instanceof i)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new i(t,a)}function b(a,t,s,n,r,l){const v=g.dirname(t),P=g.join(n,v);if(!P.startsWith(n))return Promise.reject(new Error(D.localize(0,null,t)));const L=g.join(n,t);let R;return l.onCancellationRequested(()=>{R&&R.destroy()}),Promise.resolve(C.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((m,T)=>{if(!l.isCancellationRequested)try{R=(0,S.createWriteStream)(L,{mode:s}),R.once("close",()=>m()),R.once("error",T),a.once("error",T),a.pipe(R)}catch(I){T(I)}}))}function o(a,t,s,n){let r=(0,_.createCancelablePromise)(()=>Promise.resolve()),l=0;return n.onCancellationRequested(()=>{r.cancel(),a.close()}),new Promise((v,P)=>{const L=new _.Sequencer,R=m=>{m.isCancellationRequested||(l++,a.readEntry())};a.once("error",P),a.once("close",()=>r.then(()=>{n.isCancellationRequested||a.entryCount===l?v():P(new i("Incomplete",new Error(D.localize(1,null,l,a.entryCount))))},P)),a.readEntry(),a.on("entry",m=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(m.fileName)){R(n);return}const T=m.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(T)){const j=g.join(t,T);r=(0,_.createCancelablePromise)(ue=>C.Promises.mkdir(j,{recursive:!0}).then(()=>R(ue)).then(void 0,P));return}const I=w(a,m),B=A(m);r=(0,_.createCancelablePromise)(j=>L.queue(()=>I.then(ue=>b(ue,T,B,t,s,j).then(()=>R(j)))).then(null,P))})})}function u(a,t=!1){return new Promise((s,n)=>{(0,d.open)(a,t?{lazyEntries:!0}:void 0,(r,l)=>{r?n(E(r)):s((0,k.assertIsDefined)(l))})})}function w(a,t){return new Promise((s,n)=>{a.openReadStream(t,(r,l)=>{r?n(E(r)):s((0,k.assertIsDefined)(l))})})}function p(a,t){return new Promise((s,n)=>{const r=new y.ZipFile;t.forEach(v=>{v.contents?r.addBuffer(typeof v.contents=="string"?Buffer.from(v.contents,"utf8"):v.contents,v.path):v.localPath&&r.addFile(v.localPath,v.path)}),r.end();const l=(0,S.createWriteStream)(a);r.outputStream.pipe(l),r.outputStream.once("error",n),l.once("error",n),l.once("finish",()=>s(a))})}e.zip=p;function h(a,t,s={},n){const r=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let l=u(a,!0);return s.overwrite&&(l=l.then(v=>C.Promises.rm(t).then(()=>v))),l.then(v=>o(v,t,{sourcePathRegex:r},n))}e.extract=h;function f(a,t){return u(a).then(s=>new Promise((n,r)=>{s.on("entry",l=>{l.fileName===t&&w(s,l).then(v=>n(v),v=>r(v))}),s.once("close",()=>r(new Error(D.localize(2,null,t))))}))}function c(a,t){return f(a,t).then(s=>new Promise((n,r)=>{const l=[];s.once("error",r),s.on("data",v=>l.push(v)),s.on("end",()=>n(Buffer.concat(l)))}))}e.buffer=c}),define(me[234],ge([0,1,70,146]),function(Q,e,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function g(k){return(0,S.buffer)(k,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch(D){throw new Error((0,_.localize)(0,null))}})}e.getManifest=g}),define(me[235],ge([0,1,20,13,11,2,8,5,3,19,49,4,23,16,70,147,29,32,33,170,21,14,45]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w,p,h,f,c,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",n="scanningUser",r="extracting",l="deleting",v="renaming";let P=class extends k.Disposable{constructor(R,m,T,I,B){super();this.beforeRemovingExtension=R,this.fileService=m,this.logService=T,this.environmentService=I,this.productService=B,this._devSystemExtensionsPath=null,this.systemExtensionsPath=I.builtinExtensionsPath,this.extensionsPath=I.extensionsPath,this.uninstalledPath=D.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new _.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(R){const m=[];(R===null||R===0)&&m.push(this.scanSystemExtensions().then(null,T=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(T).message,s)))),(R===null||R===1)&&m.push(this.scanUserExtensions(!0).then(null,T=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(T).message,n))));try{const T=await Promise.all(m);return(0,S.flatten)(T)}catch(T){throw this.joinErrors(T)}}async scanUserExtensions(R){this.logService.trace("Started scanning user extensions");let[m,T]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return T=T.filter(I=>!m[new h.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]),R&&(T=(0,h.groupByExtension)(T,B=>B.identifier).map(B=>B.sort((j,ue)=>i.rcompare(j.manifest.version,ue.manifest.version))[0])),this.logService.trace("Scanned user extensions:",T.length),T}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(R,m,T){const I=R.key(),B=D.join(this.extensionsPath,`.${(0,E.generateUuid)()}`),j=D.join(this.extensionsPath,I);try{await b.Promises.rm(j)}catch(ce){try{await b.Promises.rm(j)}catch(O){}throw new p.ExtensionManagementError((0,u.localize)(0,null,j,R.id),l)}await this.extractAtLocation(R,m,B,T);let ue=await this.scanExtension(A.URI.file(B),1);if(!ue)throw new Error((0,u.localize)(1,null,B));await this.storeMetadata(ue,{installedTimestamp:Date.now()});try{await this.rename(R,B,j,Date.now()+2*60*1e3),this.logService.info("Renamed to",j)}catch(ce){try{await b.Promises.rm(B)}catch(O){}if(ce.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",R.id);else throw this.logService.info(`Rename failed because of ${(0,g.getErrorMessage)(ce)}. Deleted from extracted location`,B),ce}try{ue=await this.scanExtension(A.URI.file(j),1)}catch(ce){}if(ue)return ue;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(R,m){return this.setMetadata(R,m),await this.storeMetadata(R,{...m,installedTimestamp:R.installedTimestamp}),R}async storeMetadata(R,m){m.isMachineScoped=m.isMachineScoped||void 0,m.isBuiltin=m.isBuiltin||void 0,m.installedTimestamp=m.installedTimestamp||void 0;const T=D.join(R.location.fsPath,"package.json"),I=await b.Promises.readFile(T,"utf8"),{manifest:B}=await this.parseManifest(I);return B.__metadata=m,await b.Promises.writeFile(T,JSON.stringify(B,null,"	")),R}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...R){const m=R.map(T=>new h.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version));await this.withUninstalledExtensions(T=>{m.forEach(I=>T[I.key()]=!0)})}async setInstalled(R){await this.withUninstalledExtensions(I=>delete I[R.key()]);const T=(await this.scanExtensions(1)).find(I=>new h.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).equals(R))||null;return T?(await this.storeMetadata(T,{installedTimestamp:Date.now()}),this.scanExtension(T.location,1)):null}async withUninstalledExtensions(R){return this.uninstalledFileLimiter.queue(async()=>{let m;try{m=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(I){if(I.code!=="ENOENT")throw I}let T={};if(m)try{T=JSON.parse(m)}catch(I){}return R&&(R(T),Object.keys(T).length?await b.Promises.writeFile(this.uninstalledPath,JSON.stringify(T)):await b.Promises.rm(this.uninstalledPath)),T})}async removeExtension(R,m){this.logService.trace(`Deleting ${m} extension from disk`,R.identifier.id,R.location.fsPath),await b.Promises.rm(R.location.fsPath),this.logService.info("Deleted from disk",R.identifier.id,R.location.fsPath)}async removeUninstalledExtension(R){await this.removeExtension(R,"uninstalled"),await this.withUninstalledExtensions(m=>delete m[new h.ExtensionIdentifierWithVersion(R.identifier,R.manifest.version).key()])}async extractAtLocation(R,m,T,I){this.logService.trace(`Started extracting the extension from ${m} to ${T}`);try{await b.Promises.rm(T)}catch(B){throw new p.ExtensionManagementError(this.joinErrors(B).message,l)}try{await(0,o.extract)(m,T,{sourcePath:"extension",overwrite:!0},I),this.logService.info(`Extracted extension to ${T}:`,R.id)}catch(B){try{await b.Promises.rm(T)}catch(j){}throw new p.ExtensionManagementError(B.message,B instanceof o.ExtractError&&B.type?B.type:r)}}async rename(R,m,T,I){try{await b.Promises.rename(m,T)}catch(B){if(d.isWindows&&B&&B.code==="EPERM"&&Date.now()<I)return this.logService.info(`Failed renaming ${m} to ${T} with 'EPERM' error. Trying again...`,R.id),this.rename(R,m,T,I);throw new p.ExtensionManagementError(B.message||(0,u.localize)(3,null,m,T),B.code||v)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const R=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return R;const m=this.scanDevSystemExtensions(),[T,I]=await Promise.all([R,m]);return[...T,...I]}async scanExtensionsInDir(R,m){const T=new _.Limiter(10),I=await this.fileService.resolve(A.URI.file(R));return I.children?(await Promise.all(I.children.filter(j=>j.isDirectory).map(j=>T.queue(async()=>m===1&&(0,y.basename)(j.resource).indexOf(".")===0?null:this.scanExtension(j.resource,m))))).filter(j=>j&&j.identifier):[]}async scanExtension(R,m){try{const T=await this.fileService.resolve(R);if(T.children){const{manifest:I,metadata:B}=await this.readManifest(R.fsPath),j=T.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,ue=T.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource,ce={id:(0,h.getGalleryExtensionId)(I.publisher,I.name)},O={type:m,identifier:ce,manifest:I,location:R,readmeUrl:j,changelogUrl:ue,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:m===0};return B&&(this.setMetadata(O,B),O.installedTimestamp=B.installedTimestamp),O}}catch(T){m!==0&&this.logService.trace(T)}return null}async scanDefaultSystemExtensions(){const R=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",R.length),R}async scanDevSystemExtensions(){const R=this.getDevSystemExtensionsList();if(R.length){const m=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",m.length),m.filter(T=>R.some(I=>(0,h.areSameExtensions)(T.identifier,{id:I})))}else return[]}setMetadata(R,m){R.publisherDisplayName=m.publisherDisplayName||null,R.publisherId=m.publisherId||null,R.identifier.uuid=m.id,R.isMachineScoped=!!m.isMachineScoped,R.isBuiltin=R.type===0||!!m.isBuiltin}async removeUninstalledExtensions(){const R=await this.getUninstalledExtensions(),m=await this.scanAllUserExtensions(),T=new Set;for(const j of m)R[new h.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]||T.add(j.identifier.id.toLowerCase());const I=(0,h.groupByExtension)(m,j=>j.identifier);await _.Promises.settled(I.map(async j=>{const ue=j.sort((ce,O)=>i.rcompare(ce.manifest.version,O.manifest.version))[0];T.has(ue.identifier.id.toLowerCase())||await this.beforeRemovingExtension(ue)}));const B=m.filter(j=>R[new h.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]);await _.Promises.settled(B.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const R=await this.scanAllUserExtensions(),m=[],T=(0,h.groupByExtension)(R,I=>I.identifier);m.push(...(0,S.flatten)(T.map(I=>I.sort((B,j)=>i.rcompare(B.manifest.version,j.manifest.version)).slice(1)))),await _.Promises.settled(m.map(I=>this.removeExtension(I,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(R=>R.name)}joinErrors(R){const m=Array.isArray(R)?R:[R];return m.length===1?m[0]instanceof Error?m[0]:new Error(m[0]):m.reduce((T,I)=>new Error(`${T.message}${T.message?",":""}${I instanceof Error?I.message:I}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=D.normalize(D.join(C.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(R){const m=[b.Promises.readFile(D.join(R,"package.json"),"utf8").then(j=>this.parseManifest(j)),b.Promises.readFile(D.join(R,"package.nls.json"),"utf8").then(void 0,j=>j.code!=="ENOENT"?Promise.reject(j):"{}").then(j=>JSON.parse(j))],[{manifest:T,metadata:I},B]=await Promise.all(m);return{manifest:(0,f.localizeManifest)(T,B),metadata:I}}parseManifest(R){return new Promise((m,T)=>{try{const I=JSON.parse(R),B=I.__metadata||null;m({manifest:I,metadata:B})}catch(I){T(new Error((0,u.localize)(4,null)))}})}};P=Le([Xe(1,c.IFileService),Xe(2,a.ILogService),Xe(3,w.INativeEnvironmentService),Xe(4,t.IProductService)],P),e.ExtensionsScanner=P}),define(me[107],ge([0,1,43,8,5,3,19,49,4,23,16,70,145,85,29,200,32,33,185,186,234,181,235,187,58,21,6,14,30,37]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w,p,h,f,c,a,t,s,n,r,l,v,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const R="unsetUninstalled",m="downloading";let T=class extends u.AbstractExtensionManagementService{constructor(O,$,z,ee,J,H,X){super(O,$,z);this.environmentService=ee,this.downloadService=J;const q=this._register(H.createInstance(f.ExtensionsLifecycle));this.extensionsScanner=this._register(H.createInstance(t.ExtensionsScanner,U=>q.postUninstall(U))),this.manifestCache=this._register(new a.ExtensionsManifestCache(ee,this)),this.extensionsDownloader=this._register(H.createInstance(h.ExtensionsDownloader));const W=this._register(new s.ExtensionsWatcher(this,X,ee,z));this._register(W.onDidChangeExtensionsByAnotherSource(({added:U,removed:ie})=>{U.length&&this._onDidInstallExtensions.fire(U.map(ne=>({identifier:ne.identifier,operation:0,local:ne}))),ie.forEach(ne=>this._onDidUninstallExtension.fire({identifier:ne}))}))}async zip(O){this.logService.trace("ExtensionManagementService#zip",O.identifier.id);const $=await this.collectFiles(O),z=await(0,A.zip)((0,C.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)()).fsPath,$);return d.URI.file(z)}async unzip(O){return this.logService.trace("ExtensionManagementService#unzip",O.toString()),(await this.install(O)).identifier}async getManifest(O){const $=await this.downloadVsix(O),z=g.resolve($.fsPath);return(0,c.getManifest)(z)}getInstalled(O=null){return this.extensionsScanner.scanExtensions(O)}async canInstall(O){return!0}async install(O,$={}){this.logService.trace("ExtensionManagementService#install",O.toString());const z=await this.downloadVsix(O),ee=await(0,c.getManifest)(g.resolve(z.fsPath));if(ee.engines&&ee.engines.vscode&&!(0,n.isEngineValid)(ee.engines.vscode,P.default.version,P.default.date))throw new Error(E.localize(0,null,(0,p.getGalleryExtensionId)(ee.publisher,ee.name),P.default.version));return this.installExtension(ee,z,$)}async updateMetadata(O,$){return this.logService.trace("ExtensionManagementService#updateMetadata",O.identifier.id),O=await this.extensionsScanner.saveMetadataForLocalExtension(O,{...O.manifest.__metadata||{},...$}),this.manifestCache.invalidate(),O}async updateExtensionScope(O,$){return this.logService.trace("ExtensionManagementService#updateExtensionScope",O.identifier.id),O=await this.extensionsScanner.saveMetadataForLocalExtension(O,{...O.manifest.__metadata||{},isMachineScoped:$}),this.manifestCache.invalidate(),O}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(O){if(O.scheme===_.Schemas.file)return O;if(!this.downloadService)throw new Error("Download service is not available");const $=(0,C.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)());return await this.downloadService.download(O,$),$}createInstallExtensionTask(O,$,z){return d.URI.isUri($)?new j(O,$,z,this.galleryService,this.extensionsScanner,this.logService):new B($,z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(O,$){return new ue(O,$,this.extensionsScanner)}async collectFiles(O){const $=async ee=>{let J=await i.Promises.readdir(ee);J=J.map(q=>g.join(ee,q));const H=await Promise.all(J.map(q=>i.Promises.stat(q)));let X=Promise.resolve([]);return H.forEach((q,W)=>{const U=J[W];q.isFile()&&(X=X.then(ie=>[...ie,U])),q.isDirectory()&&(X=X.then(ie=>$(U).then(ne=>[...ie,...ne])))}),X};return(await $(O.location.fsPath)).map(ee=>({path:`extension/${g.relative(O.location.fsPath,ee)}`,localPath:ee}))}};T=Le([Xe(0,w.IExtensionGalleryService),Xe(1,L.ITelemetryService),Xe(2,v.ILogService),Xe(3,o.INativeEnvironmentService),Xe(4,(0,l.optional)(b.IDownloadService)),Xe(5,l.IInstantiationService),Xe(6,r.IFileService)],T),e.ExtensionManagementService=T;class I extends u.AbstractExtensionTask{constructor(O,$,z,ee){super();this.identifier=O,this.source=$,this.extensionsScanner=z,this.logService=ee,this._operation=1}get operation(){return this._operation}async installExtension(O,$){try{const z=await this.unsetUninstalledAndGetLocal(O.identifierWithVersion);if(z)return O.metadata?this.extensionsScanner.saveMetadataForLocalExtension(z,O.metadata):z}catch(z){throw k.isMacintosh?new w.ExtensionManagementError(E.localize(1,null),R):new w.ExtensionManagementError(E.localize(2,null),R)}return this.extract(O,$)}async unsetUninstalledAndGetLocal(O){if(!await this.isUninstalled(O))return null;this.logService.trace("Removing the extension from uninstalled list:",O.id);const z=await this.extensionsScanner.setInstalled(O);return this.logService.info("Removed the extension from uninstalled list:",O.id),z}async isUninstalled(O){return!!(await this.extensionsScanner.getUninstalledExtensions())[O.key()]}async extract({zipPath:O,identifierWithVersion:$,metadata:z},ee){let J=await this.extensionsScanner.extractUserExtension($,O,ee);return this.logService.info("Extracting completed.",$.id),z&&(J=await this.extensionsScanner.saveMetadataForLocalExtension(J,z)),J}}class B extends I{constructor(O,$,z,ee,J){super(O.identifier,O,ee,J);this.gallery=O,this.options=$,this.extensionsDownloader=z}async doRun(O){const z=(await this.extensionsScanner.scanExtensions(null)).find(H=>(0,p.areSameExtensions)(H.identifier,this.gallery.identifier));z&&(this._operation=2);const ee=await this.downloadInstallableExtension(this.gallery,this._operation);ee.metadata.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,ee.metadata.isBuiltin=this.options.isBuiltin||z?.isBuiltin;const J=await this.installExtension(ee,O);z&&D.neq(z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(z);try{await this.extensionsDownloader.delete(d.URI.file(ee.zipPath))}catch(H){}return J}async downloadInstallableExtension(O,$){const z={id:O.identifier.uuid,publisherId:O.publisherId,publisherDisplayName:O.publisherDisplayName};let ee;try{this.logService.trace("Started downloading extension:",O.identifier.id),ee=(await this.extensionsDownloader.downloadExtension(O,$)).fsPath,this.logService.info("Downloaded extension:",O.identifier.id,ee)}catch(J){throw new w.ExtensionManagementError((0,u.joinErrors)(J).message,m)}try{const J=await(0,c.getManifest)(ee);return{zipPath:ee,identifierWithVersion:new p.ExtensionIdentifierWithVersion(O.identifier,J.version),metadata:z}}catch(J){throw new w.ExtensionManagementError((0,u.joinErrors)(J).message,u.INSTALL_ERROR_VALIDATING)}}}class j extends I{constructor(O,$,z,ee,J,H){super({id:(0,p.getGalleryExtensionId)(O.publisher,O.name)},$,J,H);this.manifest=O,this.location=$,this.options=z,this.galleryService=ee}async doRun(O){const $=new p.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),ee=(await this.extensionsScanner.scanExtensions(1)).find(H=>(0,p.areSameExtensions)(this.identifier,H.identifier)),J=await this.getMetadata(this.identifier.id,O);if(ee)if(J.isMachineScoped=this.options.isMachineScoped||ee.isMachineScoped,J.isBuiltin=this.options.isBuiltin||ee.isBuiltin,this._operation=2,$.equals(new p.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version)))try{await this.extensionsScanner.removeExtension(ee,"existing")}catch(H){throw new Error(E.localize(3,null,this.manifest.displayName||this.manifest.name))}else D.gt(ee.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(ee);else{const H=await this.unsetUninstalledAndGetLocal($);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch(X){throw new Error(E.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:g.resolve(this.location.fsPath),identifierWithVersion:$,metadata:J},O)}async getMetadata(O,$){try{const z=(await this.galleryService.query({names:[O],pageSize:1},$)).firstPage[0];if(z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId}}catch(z){}return{}}}class ue extends u.AbstractExtensionTask{constructor(O,$,z){super();this.extension=O,this.options=$,this.extensionsScanner=z}async doRun(O){const $=[],z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const ee=new p.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);$.push(...z.filter(J=>ee.equals(new p.ExtensionIdentifierWithVersion(J.identifier,J.manifest.version))))}else $.push(...z.filter(ee=>(0,p.areSameExtensions)(ee.identifier,this.extension.identifier)));if(!$.length)throw new Error(E.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...$),this.options.remove)for(const ee of $)try{O.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(ee)}catch(J){throw new Error(E.localize(6,null,(0,S.toErrorMessage)(J)))}}}}),define(me[50],ge([0,1,64,79,24,17,11,7,2,5,3,23,36,82,236]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class u{constructor(P){this.socket=P,this._errorListener=L=>{if(L){if(L.code==="EPIPE")return;(0,C.onUnexpectedError)(L)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(P){const L=R=>P(k.VSBuffer.wrap(R));return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(P){const L=R=>{P({type:0,hadError:R,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(P){return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(P){if(!this.socket.destroyed)try{this.socket.write(P.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,C.onUnexpectedError)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,C.onUnexpectedError)(L)}}end(){this.socket.end()}drain(){return new Promise((P,L)=>{if(this.socket.bufferSize===0){P();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),P()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=u;var w;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var p;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(p||(p={}));class h extends d.Disposable{constructor(P,L,R,m){super();this._onDidZlibFlush=this._register(new D.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=P,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=L,this._recordInflateBytes=m,L?(this._zlibInflate=o.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),(0,C.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=o.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),(0,C.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new b.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){this._totalOutgoingDataBytes+=P.byteLength,this._zlibDeflate?(this._zlibDeflate.write(P.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let L=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,L=L.slice(0,L.length-4),this._isEnded||this._write(k.VSBuffer.wrap(L),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(P,!1)}_write(P,L){let R=2;P.byteLength<126?R+=0:P.byteLength<2**16?R+=2:R+=8;const m=k.VSBuffer.alloc(R);if(L?m.writeUInt8(194,0):m.writeUInt8(130,0),P.byteLength<126)m.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){m.writeUInt8(126,1);let T=1;m.writeUInt8(P.byteLength>>>8&255,++T),m.writeUInt8(P.byteLength>>>0&255,++T)}else{m.writeUInt8(127,1);let T=1;m.writeUInt8(0,++T),m.writeUInt8(0,++T),m.writeUInt8(0,++T),m.writeUInt8(0,++T),m.writeUInt8(P.byteLength>>>24&255,++T),m.writeUInt8(P.byteLength>>>16&255,++T),m.writeUInt8(P.byteLength>>>8&255,++T),m.writeUInt8(P.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=m.byteLength+P.byteLength,this.socket.write(k.VSBuffer.concat([m,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._totalIncomingWireBytes+=P.byteLength,this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const L=this._incomingData.peek(this._state.readLen),m=(L.readUInt8(0)&128)>>>7,T=L.readUInt8(1),I=(T&128)>>>7,B=T&127;this._state.state=2,this._state.readLen=2+(I?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=m,this._state.mask=0}else if(this._state.state===2){const L=this._incomingData.read(this._state.readLen),R=L.readUInt8(1),m=(R&128)>>>7;let T=R&127,I=1;T===126?T=L.readUInt8(++I)*2**8+L.readUInt8(++I):T===127&&(T=L.readUInt8(++I)*0+L.readUInt8(++I)*0+L.readUInt8(++I)*0+L.readUInt8(++I)*0+L.readUInt8(++I)*2**24+L.readUInt8(++I)*2**16+L.readUInt8(++I)*2**8+L.readUInt8(++I));let B=0;m&&(B=L.readUInt8(++I)*2**24+L.readUInt8(++I)*2**16+L.readUInt8(++I)*2**8+L.readUInt8(++I)),this._state.state=3,this._state.readLen=T,this._state.mask=B}else if(this._state.state===3){const L=this._incomingData.read(this._state.readLen);f(L,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(L.buffer)),this._zlibInflate.write(L.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(k.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=L.byteLength,this._onData.fire(L))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await D.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=h;function f(v,P){if(P===0)return;let L=v.byteLength>>>2;for(let j=0;j<L;j++){const ue=v.readUInt32BE(j*4);v.writeUInt32BE(ue^P,j*4)}let R=L*4,m=v.byteLength-R;const T=P>>>24&255,I=P>>>16&255,B=P>>>8&255;m>=1&&v.writeUInt8(v.readUInt8(R)^T,R),m>=2&&v.writeUInt8(v.readUInt8(R+1)^I,R+1),m>=3&&v.writeUInt8(v.readUInt8(R+2)^B,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function a(){const v=(0,A.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let P;return e.XDG_RUNTIME_DIR?P=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):P=(0,y.join)((0,g.tmpdir)(),`vscode-ipc-${v}.sock`),s(P),P}e.createRandomIPCHandle=a;function t(v,P,L){const R=(0,S.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${L}-${P}-sock`;let m;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?m=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${L}-${P}.sock`):m=(0,y.join)(v,`${L}-${P}.sock`),s(m),m}e.createStaticIPCHandle=t;function s(v){const P=c[i.platform];typeof P=="number"&&v.length>=P&&console.warn(`WARNING: IPC handle "${v}" is longer than ${P} chars, try a shorter --user-data-dir`)}class n extends E.IPCServer{constructor(P){super(n.toClientConnectionEvent(P));this.server=P}static toClientConnectionEvent(P){const L=D.Event.fromNodeEventEmitter(P,"connection");return D.Event.map(L,R=>({protocol:new b.Protocol(new u(R)),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function r(v){return new Promise((P,L)=>{const R=(0,_.createServer)();R.on("error",L),R.listen(v,()=>{R.removeListener("error",L),P(new n(R))})})}e.serve=r;function l(v,P){return new Promise((L,R)=>{const m=(0,_.createConnection)(v,()=>{m.removeListener("error",R),L(b.Client.fromSocket(new u(m),P))});m.once("error",R)})}e.connect=l}),define(me[108],ge([0,1,67,17,11,2,12,34,29,61,14,194,236]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let b=class extends k.Disposable{constructor(u,w,p){super();this.environmentService=w,this.logService=p,this.configure(u.getValue()),this._register(u.onDidChangeConfiguration(()=>this.configure(u.getValue()),this))}configure(u){this.proxyUrl=u.http&&u.http.proxy,this.strictSSL=!!(u.http&&u.http.proxyStrictSSL),this.authorization=u.http&&u.http.proxyAuthorization}async request(u,w){this.logService.trace("RequestService#request",u.url);const{proxyUrl:p,strictSSL:h}=this,f={...process.env,...await(0,y.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},c=u.agent?u.agent:await(0,A.getProxyAgent)(u.url||"",f,{proxyUrl:p,strictSSL:h});return u.agent=c,u.strictSSL=h,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this._request(u,w)}async getNodeRequest(u){return((0,S.parse)(u.url).protocol==="https:"?await new Promise((h,f)=>{Q(["https"],h,f)}):await new Promise((h,f)=>{Q(["http"],h,f)})).request}_request(u,w){return new Promise(async(p,h)=>{let f;const c=(0,S.parse)(u.url),a=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),t={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,C.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(t.auth=u.user+":"+u.password),f=a(t,s=>{const n=(0,C.isNumber)(u.followRedirects)?u.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&n>0&&s.headers.location)this._request({...u,url:s.headers.location,followRedirects:n-1},w).then(p,h);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,E.createGunzip)())),p({res:s,stream:(0,_.streamToBufferReadableStream)(r)})}}),f.on("error",h),u.timeout&&f.setTimeout(u.timeout),u.data&&typeof u.data=="string"&&f.write(u.data),f.end(),w.onCancellationRequested(()=>{f.abort(),h((0,g.canceled)())})})}async resolveProxy(u){}};b=Le([Xe(0,D.IConfigurationService),Xe(1,d.INativeEnvironmentService),Xe(2,i.ILogService)],b),e.RequestService=b}),define(me[109],ge([0,1,35,100,41,8,5,17,7,50,61,3]),function(Q,e,S,_,g,k,C,D,d,y,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function E(p={},h,f,c,a){const t=await(0,_.getNLSConfiguration)(h,c.userDataPath),s=await(0,i.resolveShellEnv)(a,c.args,process.env),n=c.isBuilt?(0,C.join)(c.appRoot,"bin"):(0,C.join)(c.appRoot,"resources","server","bin-dev"),r=process.env;let l=p.PATH||(s?s.PATH:void 0)||r.PATH;l?l=n+C.delimiter+l:l=n;const v={...r,...s,VSCODE_LOG_NATIVE:String(f),VSCODE_AMD_ENTRYPOINT:"vs/server/remoteExtensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(t,void 0,0),...p};return c.args["without-browser-env-var"]||(v.BROWSER=(0,C.join)(n,"helpers",A.isWindows?"browser.cmd":"browser.sh")),u(v,"PATH",l),w(v),v}e.buildUserEnvironment=E;class b{constructor(h,f,c,a,t,s){this.socket=h,this.socketDrain=f,this.initialDataChunk=c,this.skipWebSocketFrames=a,this.permessageDeflate=t,this.inflateBytes=s}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}class o{constructor(h,f,c,a,t,s){this._environmentService=h,this._logService=f,this._reconnectionToken=c,this._onClose=new d.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=a,this._extensionHostProcess=null,this._connectionData=o._toConnectionData(t,s),this._connectionData.socket.pause(),this._log("New connection established.")}_log(h){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${h}`)}_logError(h){this._logService.error(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${h}`)}static _toConnectionData(h,f){return h instanceof y.NodeSocket?new b(h.socket,h.drain(),f,!0,!1,D.VSBuffer.alloc(0)):new b(h.socket.socket,h.drain(),f,!1,h.permessageDeflate,h.recordedInflateBytes)}async _sendSocketToExtensionHost(h,f){await f.socketDrain;const c=f.toIExtHostSocketMessage();h.send(c,f.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const h={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(h)}acceptReconnection(h,f,c){this._remoteAddress=h,this._log("The client has reconnected.");const a=o._toConnectionData(f,c);if(a.socket.pause(),!this._extensionHostProcess){this._connectionData=a;return}this._sendSocketToExtensionHost(this._extensionHostProcess,a)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(h){try{let f=[];h.port&&!process.pkg&&(f=[`--inspect${h.break?"-brk":""}=0.0.0.0:${h.port}`]);const a={env:await E(h.env,h.language,!!h.debugId,this._environmentService,this._logService),execArgv:f,silent:!0},t=["--type=extensionHost",`--uriTransformerPath=${g.uriTransformerPath}`],s=this._environmentService.args["use-host-proxy"];s!==void 0&&t.push(`--useHostProxy=${s}`),this._extensionHostProcess=S.fork(k.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,t,a);const n=this._extensionHostProcess.pid;this._log(`<${n}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const r=d.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),l=d.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");r(P=>console.log("EXTHOST-STDOUT::::::::"+P)),l(P=>console.log("EXTHOST-STDERR::::::::"+P)),this._extensionHostProcess.on("message",P=>{P&&P.type==="__$console"&&(console.log("EXTHOST-LOG:::::"),console.log(P.arguments))}),this._extensionHostProcess.on("error",P=>{this._logError(`<${n}> Extension Host Process had an error`),this._logService.error(P),this._cleanResources()}),this._extensionHostProcess.on("exit",(P,L)=>{this._log(`<${n}> Extension Host Process exited with code: ${P}, signal: ${L}.`),this._cleanResources()});const v=P=>{P.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",v),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",v)}catch(f){console.error("ExtensionHostConnection errored"),f&&console.error(f)}}}e.ExtensionHostConnection=o;function u(p,h,f){const c=Object.keys(p).filter(t=>t.toLowerCase()===h.toLowerCase()),a=c.length>0?c[0]:h;p[a]=f}function w(p){for(let h of Object.keys(p))p[h]===null&&delete p[h]}}),define(me[237],ge([0,1,62,14,59,94,34,66,108,68,37,32,96,107,88,30,2,93,65,8,21,45,91,106,69,86,63,89,11,4,5,22]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w,p,h,f,c,a,t,s,n,r,l,v,P,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class T extends w.Disposable{constructor(ue,ce){super();this.args=ue,this.remoteDataFolder=ce,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async ce=>{const O=ce.get(_.ILogService),$=ce.get(A.IExtensionManagementCLIService);try{await this.doRun($)}catch(z){throw O.error(z),console.error((0,P.getErrorMessage)(z)),z}})}async initServices(){const ue=new S.ServiceCollection,ce={_serviceBrand:void 0,...u.default};ue.set(a.IProductService,ce);const O=new n.ServerEnvironmentService(this.args,ce);ue.set(n.IServerEnvironmentService,O);const $=new _.LogService(new t.SpdLogLogger(s.RemoteExtensionLogFileName,(0,R.join)(O.logsPath,`${s.RemoteExtensionLogFileName}.log`),!0,(0,_.getLogLevel)(O)));ue.set(_.ILogService,$),$.trace(`Remote configuration data at ${this.remoteDataFolder}`),$.trace("process arguments:",this.args);const z=this._register(new p.FileService($));ue.set(c.IFileService,z),z.registerProvider(f.Schemas.file,this._register(new h.DiskFileSystemProvider($)));const ee=this._register(new k.ConfigurationService(O.settingsResource,z));return await ee.initialize(),ue.set(C.IConfigurationService,ee),ue.set(D.IRequestService,new g.SyncDescriptor(d.RequestService)),ue.set(i.ITelemetryService,y.NullTelemetryService),ue.set(A.IExtensionGalleryService,new g.SyncDescriptor(E.ExtensionGalleryService)),ue.set(A.IExtensionManagementService,new g.SyncDescriptor(b.ExtensionManagementService)),ue.set(A.IExtensionManagementCLIService,new g.SyncDescriptor(r.ExtensionManagementCLIService)),ue.set(l.ILocalizationsService,new g.SyncDescriptor(v.LocalizationsService)),new o.InstantiationService(ue)}async doRun(ue){if(this.args["list-extensions"])return ue.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"])return ue.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],!!this.args["do-not-sync"],!!this.args.force);if(this.args["uninstall-extension"])return ue.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return ue.locateExtension(this.args["locate-extension"])}asExtensionIdOrVSIX(ue){return ue.map(ce=>/\.vsix$/i.test(ce)?L.URI.file((0,R.isAbsolute)(ce)?ce:(0,R.join)((0,m.cwd)(),ce)):ce)}}function I(j){setTimeout(()=>process.exit(j),0)}async function B(j,ue){const ce=new T(j,ue);try{await ce.run(),I(0)}catch(O){I(1)}finally{ce.dispose()}}e.run=B}),define(me[238],ge([0,1,50,249,28,230,4,211,14]),function(Q,e,S,_,g,k,C,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(E,b,o){this._commands=E,this.logService=b,this._ipcHandlePath=o,this._server=_.createServer((u,w)=>this.onRequest(u,w)),this.setup().catch(u=>(b.error(u),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch(E){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,b){const o=[];E.setEncoding("utf8"),E.on("data",u=>o.push(u)),E.on("end",()=>{const u=JSON.parse(o.join(""));switch(u.type){case"open":this.open(u,b);break;case"openExternal":this.openExternal(u,b);break;case"status":this.getStatus(u,b);break;case"extensionManagement":this.manageExtensions(u,b).catch(this.logService.error);break;default:b.writeHead(404),b.write(`Unknown message type: ${u.type}`,w=>{w&&this.logService.error(w)}),b.end();break}})}open(E,b){let{fileURIs:o,folderURIs:u,forceNewWindow:w,diffMode:p,addMode:h,forceReuseWindow:f,gotoLineMode:c,waitMarkerFilePath:a}=E;const t=[];if(Array.isArray(u))for(const s of u)try{t.push({folderUri:C.URI.parse(s)})}catch(n){}if(Array.isArray(o))for(const s of o)try{(0,D.hasWorkspaceFileExtension)(s)?t.push({workspaceUri:C.URI.parse(s)}):t.push({fileUri:C.URI.parse(s)})}catch(n){}if(t.length){const s=a?C.URI.file(a):void 0,r={forceNewWindow:w,diffMode:p,addMode:h,gotoLineMode:c,forceReuseWindow:f,preferNewWindow:!f&&!s&&!h,waitMarkerFileURI:s};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}b.writeHead(200),b.end()}async openExternal(E,b){for(const o of E.uris){const u=C.URI.parse(o),w=u.scheme==="file"?u:o;await this._commands.executeCommand("_remoteCLI.openExternal",w)}b.writeHead(200),b.end()}async manageExtensions(E,b){try{const o=p=>p?.map(h=>/\.vsix$/i.test(h)?C.URI.parse(h):h),u={list:E.list,install:o(E.install),uninstall:o(E.uninstall),force:E.force},w=await this._commands.executeCommand("_remoteCLI.manageExtensions",u);b.writeHead(200),b.write(w)}catch(o){b.writeHead(500),b.write(String(o),u=>{u&&this.logService.error(u)})}b.end()}async getStatus(E,b){try{const o=await this._commands.executeCommand("_remoteCLI.getSystemStatus");b.writeHead(200),b.write(o),b.end()}catch(o){b.writeHead(500),b.write(String(o),u=>{u&&this.logService.error(u)}),b.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&g.existsSync(this._ipcHandlePath)&&g.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=y;let i=class extends y{constructor(E,b){super(E,b,(0,S.createRandomIPCHandle)())}};i=Le([Xe(0,k.IExtHostCommands),Xe(1,d.ILogService)],i),e.CLIServer=i}),define(me[239],ge([0,1,24,7,18,2,5,3,4,50,30,41,238,218,104,219,223,109]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class h extends w.AbstractVariableResolverService{constructor(a,t,s,n){super({getFolderUri:r=>{const l=t.filter(v=>v.name===r);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.length,getConfigurationValue:(r,l)=>n[`config:${l}`],getExecPath:()=>a.VSCODE_EXEC_PATH,getAppRoot:()=>a.VSCODE_CWD,getFilePath:()=>{if(s)return C.normalize(s.fsPath)},getSelectedText:()=>n.selectedText,getLineNumber:()=>n.lineNumber},void 0,Promise.resolve(a))}}class f extends k.Disposable{constructor(a,t,s){super();this._environmentService=a,this._logService=t,this._ptyService=s,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new _.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(a,t,s){switch(t){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,s);case"$createProcess":{const n=(0,A.createRemoteURITransformer)(a.remoteAuthority);return this._createProcess(n,s)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,s);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,s);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,s);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,s);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,s);case"$start":return this._ptyService.start.apply(this._ptyService,s);case"$input":return this._ptyService.input.apply(this._ptyService,s);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,s);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,s);case"$resize":return this._ptyService.resize.apply(this._ptyService,s);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,s);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,s);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,s);case"$sendCommandResult":return this._sendCommandResult(s[0],s[1],s[2]);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,s);case"$getProfiles":return this._getProfiles.apply(this,s);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(s[0]);case"$getTerminalLayoutInfo":return this._getTerminalLayoutInfo(s);case"$setTerminalLayoutInfo":return this._setTerminalLayoutInfo(s);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,s);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,s);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(s[0],s[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(s[0],s[1])}throw new Error(`IPC Command ${t} not found`)}listen(a,t,s){switch(t){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||_.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||_.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||_.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||_.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||_.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessTitleChangedEvent":return this._ptyService.onProcessTitleChanged;case"$onProcessShellTypeChangedEvent":return this._ptyService.onProcessShellTypeChanged;case"$onProcessOverrideDimensionsEvent":return this._ptyService.onProcessOverrideDimensions;case"$onProcessResolvedShellLaunchConfigEvent":return this._ptyService.onProcessResolvedShellLaunchConfig;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onProcessDidChangeHasChildProcesses":return this._ptyService.onProcessDidChangeHasChildProcesses;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||_.Event.None;default:break}throw new Error("Not supported")}async _createProcess(a,t){const s={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:typeof t.shellLaunchConfig.cwd=="string"||typeof t.shellLaunchConfig.cwd=="undefined"?t.shellLaunchConfig.cwd:d.URI.revive(a.transformIncoming(t.shellLaunchConfig.cwd)),env:t.shellLaunchConfig.env,useShellEnvironment:t.shellLaunchConfig.useShellEnvironment};let n;t.shellLaunchConfig.useShellEnvironment?(this._logService.trace("*"),n=await(0,p.buildUserEnvironment)(t.resolverEnv,D.language,!1,this._environmentService,this._logService)):n=this._getEnvironment(),this._logService.trace("baseEnv",n);const r=$=>({uri:d.URI.revive(a.transformIncoming($.uri)),name:$.name,index:$.index,toResource:()=>{throw new Error("Not implemented")}}),l=t.workspaceFolders.map(r),v=t.activeWorkspaceFolder?r(t.activeWorkspaceFolder):void 0,P=t.activeFileResource?d.URI.revive(a.transformIncoming(t.activeFileResource)):void 0,L=new h(n,l,P,t.resolvedVariables),R=u.createVariableResolver(v,process.env,L),m=u.getCwd(s,S.homedir(),R,v?.uri,t.configuration["terminal.integrated.cwd"],this._logService);s.cwd=m;const T=D.isWindows?"terminal.integrated.env.windows":D.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",I=t.configuration[T],B=u.createTerminalEnvironment(s,I,R,i.default.version,t.configuration["terminal.integrated.detectLocale"],n);if(!s.strictEnv){const $=[];for(const[J,H]of t.envVariableCollections)$.push([J,{map:(0,o.deserializeEnvironmentVariableCollection)(H)}]);const z=new Map($);new b.MergedEnvironmentVariableCollection(z).applyToProcessEnvironment(B)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:s,initialCwd:m,cols:t.cols,rows:t.rows,env:B});const j=(0,y.createRandomIPCHandle)();B.VSCODE_IPC_HOOK_CLI=j;const ue={executeCommand:($,...z)=>this._executeCommand($,z,a)},ce=new E.CLIServerBase(ue,this._logService,j),O=await this._ptyService.createProcess(s,m,t.cols,t.rows,t.unicodeVersion,B,n,!1,t.shouldPersistTerminal,t.workspaceId,t.workspaceName);return this._ptyService.onProcessExit($=>$.id===O&&ce.dispose()),{persistentTerminalId:O,resolvedShellLaunchConfig:s}}_executeCommand(a,t,s){let n,r;const l=new Promise((L,R)=>{n=L,r=R}),v=++this._lastReqId;this._pendingCommands.set(v,{resolve:n,reject:r,uriTransformer:s});const P=(0,g.cloneAndChange)(t,L=>{if(L&&L.$mid===1)return s.transformOutgoing(L);if(L&&L instanceof d.URI)return s.transformOutgoingURI(L)});return this._onExecuteCommand.fire({reqId:v,commandId:a,commandArgs:P}),l}_sendCommandResult(a,t,s){const n=this._pendingCommands.get(a);if(!n)return;this._pendingCommands.delete(a);const r=(0,g.cloneAndChange)(s,l=>{if(l&&l.$mid===1)return n.uriTransformer.transformIncoming(l)});t?n.reject(r):n.resolve(r)}_getDefaultSystemShell(a){return this._ptyService.getDefaultSystemShell(a)}async _getProfiles(a,t,s,n){return this._ptyService.getProfiles?.(a,t,s,n)||[]}_getEnvironment(){return{...process.env}}_getWslPath(a){return this._ptyService.getWslPath(a)}_setTerminalLayoutInfo(a){this._ptyService.setTerminalLayoutInfo(a)}async _getTerminalLayoutInfo(a){return this._ptyService.getTerminalLayoutInfo(a)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=f}),define(me[240],ge([0,1,64,28,79,67,24,48,241,17,2,23,16,126,3,82,50,109,212,41,14,8,30,29,62,59,94,34,66,108,68,37,32,96,107,88,85,164,63,89,202,201,197,78,93,65,21,45,36,7,232,213,233,193,169,203,163,90,214,4,26,69,5,226,239,110,106,86,91,97,210]),function(Q,e,S,_,g,k,C,D,d,y,i,A,E,b,o,u,w,p,h,f,c,a,t,s,n,r,l,v,P,L,R,m,T,I,B,j,ue,ce,O,$,z,ee,J,H,X,q,W,U,ie,ne,he,ve,Ae,Ie,Ue,qe,Ge,rt,it,de,be,Pe,Re,Ne,He,Ke,Je,st,oe,pe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const Be=5*60*1e3,xe=`

*
* Visual Studio Code Server
*
* Reminder: You may only use this software with Visual Studio family products,
* as described in the license https://aka.ms/vscode-remote/license
*

`,ot="monacoworkbench";class Qe extends ie.IPCServer{constructor(){const Z=new ne.Emitter;super(Z.event);this._onDidConnectEmitter=Z}acceptConnection(Z,te){this._onDidConnectEmitter.fire({protocol:Z,onDidClientDisconnect:te})}}function at(We){return We<10?`0${We}`:String(We)}function Ze(){const We=new Date;return`${at(We.getHours())}:${at(We.getMinutes())}:${at(We.getSeconds())}`}class K extends c.AbstractLogger{constructor(Z=c.DEFAULT_LOG_LEVEL){super();this.setLevel(Z),this.useColors=Boolean(process.stdout.isTTY)}trace(Z,...te){this.getLevel()<=c.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Ze()}][0m`,Z,...te):console.log(`[${Ze()}]`,Z,...te))}debug(Z,...te){this.getLevel()<=c.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Ze()}][0m`,Z,...te):console.log(`[${Ze()}]`,Z,...te))}info(Z,...te){this.getLevel()<=c.LogLevel.Info&&(this.useColors?console.log(`[90m[${Ze()}][0m`,Z,...te):console.log(`[${Ze()}]`,Z,...te))}warn(Z,...te){this.getLevel()<=c.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Ze()}][0m`,Z,...te):console.warn(`[${Ze()}]`,Z,...te))}error(Z,...te){this.getLevel()<=c.LogLevel.Error&&(this.useColors?console.error(`[91m[${Ze()}][0m`,Z,...te):console.error(`[${Ze()}]`,Z,...te))}critical(Z,...te){this.getLevel()<=c.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Ze()}][0m`,Z,...te):console.error(`[${Ze()}]`,Z,...te))}dispose(){}flush(){}}class we extends i.Disposable{constructor(Z,te,le,V,x,se){super();this._environmentService=Z,this._productService=te,this._connectionToken=le,this._connectionTokenIsMandatory=V;const re=Te(this._environmentService);re.trace(`Remote configuration data at ${se}`),re.trace("process arguments:",this._environmentService.args),re.info(xe),this._logService=new c.MultiplexLogService([new K((0,c.getLogLevel)(this._environmentService)),re]),this._socketServer=new Qe,this._uriTransformerCache=Object.create(null),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),x?this._webClientServer=new it.WebClientServer(this._connectionToken,this._environmentService,this._logService):this._webClientServer=null,this._logService.info("Extension host agent started.")}async initialize(){const Z=await this._createServices();return setTimeout(()=>this._cleanupOlderLogs(this._environmentService.logsPath).then(null,te=>this._logService.error(te)),1e4),Z}async _createServices(){const Z=new n.ServiceCollection;this._socketServer.registerChannel(Ge.ExtensionHostDebugBroadcastChannel.ChannelName,new Ge.ExtensionHostDebugBroadcastChannel);const te=new ie.StaticRouter(_e=>_e.clientId==="renderer");this._socketServer.registerChannel("logger",new rt.LogLevelChannel(this._logService)),Z.set(s.IEnvironmentService,this._environmentService),Z.set(s.INativeEnvironmentService,this._environmentService),Z.set(c.ILogService,this._logService),Z.set(U.IProductService,this._productService);const le=this._register(new X.FileService(this._logService));Z.set(W.IFileService,le),le.registerProvider(a.Schemas.file,this._register(new q.DiskFileSystemProvider(this._logService)));const V=new l.ConfigurationService(this._environmentService.machineSettingsResource,le);Z.set(v.IConfigurationService,V),Z.set(P.IRequestService,new r.SyncDescriptor(L.RequestService));let x=R.NullAppender;if(!this._environmentService.args["disable-telemetry"]&&t.default.enableTelemetry){t.default.aiConfig&&t.default.aiConfig.asimovKey&&(x=new z.AppInsightsAppender(ot,null,t.default.aiConfig.asimovKey),this._register((0,i.toDisposable)(()=>x.flush())));const _e=await(0,H.getMachineId)(),Me={appender:x,commonProperties:(0,J.resolveCommonProperties)(le,(0,C.release)(),(0,C.hostname)(),process.arch,t.default.commit,t.default.version+"-remote",_e,t.default.msftInternalDomains,this._environmentService.installSourcePath,"remoteAgent"),piiPaths:[this._environmentService.appRoot]};Z.set(m.ITelemetryService,new r.SyncDescriptor(ee.TelemetryService,[Me]))}else Z.set(m.ITelemetryService,R.NullTelemetryService);Z.set(T.IExtensionGalleryService,new r.SyncDescriptor(I.ExtensionGalleryService));const se=this._socketServer.getChannel("download",te);Z.set(ue.IDownloadService,new ce.DownloadServiceChannelClient(se,()=>this._getUriTransformer("renderer"))),Z.set(T.IExtensionManagementService,new r.SyncDescriptor(B.ExtensionManagementService));const re=new j.InstantiationService(Z);Z.set(O.ILocalizationsService,re.createInstance($.LocalizationsService));const Ee=re.createInstance(st.ExtensionManagementCLIService);Z.set(T.IExtensionManagementCLIService,Ee);const Fe=re.createInstance(Se.PtyHostService,{GraceTime:108e5,ShortGraceTime:3e5,scrollback:V.getValue("terminal.integrated.persistentSessionScrollback")??100,useExperimentalSerialization:V.getValue("terminal.integrated.persistentSessionExperimentalSerializer")??!0});return Z.set(pe.IPtyService,Fe),re.invokeFunction(_e=>{const Me=new he.RemoteAgentEnvironmentChannel(this._connectionToken,this._environmentService,Ee,this._logService,_e.get(m.ITelemetryService),x);this._socketServer.registerChannel("remoteextensionsenvironment",Me),this._socketServer.registerChannel(Ne.REMOTE_TERMINAL_CHANNEL_NAME,new He.RemoteTerminalChannel(this._environmentService,this._logService,Fe));const je=new ve.RemoteAgentFileSystemChannel(this._logService,this._environmentService);this._socketServer.registerChannel(Ae.REMOTE_FILE_SYSTEM_CHANNEL_NAME,je),this._socketServer.registerChannel("request",new Ie.RequestChannel(_e.get(P.IRequestService)));const ae=_e.get(T.IExtensionManagementService),fe=new Ue.ExtensionManagementChannel(ae,Y=>this._getUriTransformer(Y.remoteAuthority));return this._socketServer.registerChannel("extensions",fe),ae.removeDeprecatedExtensions(),this._register(new qe.default(_e.get(m.ITelemetryService))),{telemetryService:_e.get(m.ITelemetryService)}})}_getUriTransformer(Z){return this._uriTransformerCache[Z]||(this._uriTransformerCache[Z]=(0,f.createRemoteURITransformer)(Z)),this._uriTransformerCache[Z]}async handleRequest(Z,te){if(Z.method!=="GET")return(0,it.serveError)(Z,te,405,`Unsupported method ${Z.method}`);if(!Z.url)return(0,it.serveError)(Z,te,400,"Bad request.");const le=k.parse(Z.url,!0),V=le.pathname;if(!V)return(0,it.serveError)(Z,te,400,"Bad request.");if(V==="/version")return te.writeHead(200,{"Content-Type":"text/plain"}),te.end(t.default.commit||"");if(V==="/delay-shutdown")return this._delayShutdown(),te.writeHead(200),te.end("OK");if(V==="/vscode-remote-resource"){if(le.query.tkn!==this._connectionToken)return(0,it.serveError)(Z,te,403,"Forbidden.");const x=le.query.path;if(typeof x!="string")return(0,it.serveError)(Z,te,400,"Bad request.");let se;try{se=de.URI.from({scheme:a.Schemas.file,path:x}).fsPath}catch(Ee){return(0,it.serveError)(Z,te,400,"Bad request.")}const re=Object.create(null);return this._environmentService.isBuilt&&((0,be.isEqualOrParent)(se,this._environmentService.builtinExtensionsPath,!o.isLinux)||(0,be.isEqualOrParent)(se,this._environmentService.extensionsPath,!o.isLinux))&&(re["Cache-Control"]="public, max-age=31536000"),(0,it.serveFile)(this._logService,Z,te,se,re)}if(this._webClientServer){this._webClientServer.handle(Z,te,le);return}return te.writeHead(404,{"Content-Type":"text/plain"}),te.end("Not found")}handleUpgrade(Z,te){let le=(0,A.generateUuid)(),V=!1,x=!1;if(Z.url){const Me=k.parse(Z.url,!0).query;typeof Me.reconnectionToken=="string"&&(le=Me.reconnectionToken),Me.reconnection==="true"&&(V=!0),Me.skipWebSocketFrames==="true"&&(x=!0)}if(Z.headers.upgrade!=="websocket"){te.end("HTTP/1.1 400 Bad Request");return}const se=Z.headers["sec-websocket-key"],re=S.createHash("sha1");re.update(se+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const Ee=re.digest("base64"),Fe=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${Ee}`];let _e=!1;if(!x&&!this._environmentService.args["disable-websocket-compression"]&&Z.headers["sec-websocket-extensions"]){const Me=Array.isArray(Z.headers["sec-websocket-extensions"])?Z.headers["sec-websocket-extensions"]:[Z.headers["sec-websocket-extensions"]];for(const je of Me)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(je)){if(/\b(permessage-deflate)\b/.test(je)){_e=!0,Fe.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(je)){_e=!0,Fe.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}te.write(Fe.join(`\r
`)+`\r
\r
`),te.setTimeout(0),x?this._handleWebSocketConnection(new w.NodeSocket(te),V,le):this._handleWebSocketConnection(new w.WebSocketNodeSocket(new w.NodeSocket(te),_e,null,!0),V,le)}handleServerError(Z){this._logService.error("Error occurred in server"),this._logService.error(Z)}async _cleanupOlderLogs(Z){const te=(0,Re.basename)(Z),le=(0,Re.dirname)(Z),se=(await E.Promises.readdir(le)).filter(Ee=>/^\d{8}T\d{6}$/.test(Ee)).sort().filter(Ee=>Ee!==te),re=se.slice(0,Math.max(0,se.length-9));await Promise.all(re.map(Ee=>E.Promises.rm((0,Re.join)(le,Ee))))}_getRemoteAddress(Z){let te;return Z instanceof w.NodeSocket?te=Z.socket:te=Z.socket.socket,te.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(Z,te,le){const V=te.getSocket();this._logService.error(`${Z} ${le}.`);const x={type:"error",reason:le};te.sendControl(y.VSBuffer.fromString(JSON.stringify(x))),te.dispose(),await V.drain(),V.dispose()}_handleWebSocketConnection(Z,te,le){const V=this._getRemoteAddress(Z),x=`[${V}][${le.substr(0,8)}]`,se=new u.PersistentProtocol(Z);let re;try{const je=Q.__$__nodeRequire("vsda");re=new je.validator}catch(je){}let Ee;(function(je){je[je.WaitingForAuth=0]="WaitingForAuth",je[je.WaitingForConnectionType=1]="WaitingForConnectionType",je[je.Done=2]="Done",je[je.Error=3]="Error"})(Ee||(Ee={}));let Fe=0;const _e=je=>{Fe=3,Me.dispose(),this._rejectWebSocketConnection(x,se,je)},Me=se.onControlMessage(je=>{if(Fe===0){let ae;try{ae=JSON.parse(je.toString())}catch(M){return _e("Malformed first message")}if(ae.type!=="auth")return _e("Invalid first message");if(this._connectionTokenIsMandatory&&ae.auth!==this._connectionToken)return _e("Unauthorized client refused: auth mismatch");let fe="VS Code Headless is cool";if(re)try{fe=re.createNewMessage(fe)}catch(M){}const Y={type:"sign",data:fe};se.sendControl(y.VSBuffer.fromString(JSON.stringify(Y))),Fe=1}else if(Fe===1){let ae;try{ae=JSON.parse(je.toString())}catch(De){return _e("Malformed second message")}if(ae.type!=="connectionType")return _e("Invalid second message");if(typeof ae.signedData!="string")return _e("Invalid second message field type");const fe=ae.commit,Y=t.default.commit;if(fe&&Y&&fe!==Y)return _e("Client refused: version mismatch");let M=!1;if(ae.signedData===this._connectionToken)M=!0;else if(re)try{M=re.validate(ae.signedData)==="ok"}catch(De){}if(!M){if(this._environmentService.isBuilt)return _e("Unauthorized client refused");this._logService.error(`${x} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let De in this._managementConnections)this._managementConnections[De].shortenReconnectionGraceTimeIfNecessary();for(let De in this._extHostConnections)this._extHostConnections[De].shortenReconnectionGraceTimeIfNecessary();Fe=2,Me.dispose(),this._handleConnectionType(V,x,se,Z,te,le,ae)}})}async _handleConnectionType(Z,te,le,V,x,se,re){const Ee=re.desiredConnectionType===1?`${te}[ManagementConnection]`:re.desiredConnectionType===2?`${te}[ExtensionHostConnection]`:te;if(re.desiredConnectionType===1)if(x){if(!this._managementConnections[se])return this._rejectWebSocketConnection(Ee,le,"Unknown reconnection token");le.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const Fe=le.readEntireBuffer();le.dispose(),this._managementConnections[se].acceptReconnection(Z,V,Fe)}else{if(this._managementConnections[se])return this._rejectWebSocketConnection(Ee,le,"Duplicate reconnection token");le.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const Fe=new h.ManagementConnection(this._logService,se,Z,le);this._socketServer.acceptConnection(Fe.protocol,Fe.onClose),this._managementConnections[se]=Fe,Fe.onClose(()=>{delete this._managementConnections[se]})}else if(re.desiredConnectionType===2){const Fe=re.args||{language:"en"},_e=await this._updateWithFreeDebugPort(Fe);if(_e.port&&this._logService.trace(`${Ee} - startParams debug port ${_e.port}`),this._logService.trace(`${Ee} - startParams language: ${_e.language}`),this._logService.trace(`${Ee} - startParams env: ${JSON.stringify(_e.env)}`),x){if(!this._extHostConnections[se])return this._rejectWebSocketConnection(Ee,le,"Unknown reconnection token");le.sendControl(y.VSBuffer.fromString(JSON.stringify(_e.port?{debugPort:_e.port}:{})));const Me=le.readEntireBuffer();le.dispose(),this._extHostConnections[se].acceptReconnection(Z,V,Me)}else{if(this._extHostConnections[se])return this._rejectWebSocketConnection(Ee,le,"Duplicate reconnection token");le.sendControl(y.VSBuffer.fromString(JSON.stringify(_e.port?{debugPort:_e.port}:{})));const Me=le.readEntireBuffer();le.dispose();const je=new p.ExtensionHostConnection(this._environmentService,this._logService,se,Z,V,Me);this._extHostConnections[se]=je,je.onClose(()=>{delete this._extHostConnections[se],this._onDidCloseExtHostConnection()}),je.start(_e)}}else if(re.desiredConnectionType===3){const Fe=re.args;this._createTunnel(le,Fe)}else return this._rejectWebSocketConnection(Ee,le,"Unknown initial data received")}async _createTunnel(Z,te){const le=Z.getSocket().socket,V=Z.readEntireBuffer();Z.dispose(),le.pause();const x=await this._connectTunnelSocket(te.host,te.port);V.byteLength>0&&x.write(V.buffer),x.on("end",()=>le.end()),x.on("close",()=>le.end()),x.on("error",()=>le.destroy()),le.on("end",()=>x.end()),le.on("close",()=>x.end()),le.on("error",()=>x.destroy()),x.pipe(le),le.pipe(x)}_connectTunnelSocket(Z,te){return new Promise((le,V)=>{const x=g.createConnection({host:Z,port:te},()=>{x.removeListener("error",V),x.pause(),le(x)});x.once("error",V)})}_updateWithFreeDebugPort(Z){return typeof Z.port=="number"?(0,b.findFreePort)(Z.port,10,5e3).then(te=>(Z.port=te,Z)):(Z.debugId=void 0,Z.port=void 0,Z.break=void 0,Promise.resolve(Z))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},Be))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}}e.RemoteExtensionHostAgentServer=we;function ke(We){if(We["connection-secret"]){We.connectionToken&&(console.warn("Please do not use the argument connectionToken at the same time as connection-secret."),process.exit(1));let Z=_.readFileSync(We["connection-secret"]).toString();return Z=Z.replace(/\r?\n$/,""),/^[0-9A-Za-z\-]+$/.test(Z)||(console.warn(`The secret defined in ${We["connection-secret"]} does not adhere to the characters 0-9, a-z, A-Z or -.`),process.exit(1)),{connectionToken:Z,connectionTokenIsMandatory:!0}}else return{connectionToken:We.connectionToken||(0,A.generateUuid)(),connectionTokenIsMandatory:!1}}async function Oe(We,Z,te){const le={_serviceBrand:void 0,...t.default},V=new Pe.ServerEnvironmentService(Z,le);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Y=(0,Re.join)(process.env.HOMEDRIVE,"node_modules"),M=(0,Re.dirname)((0,Re.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),De=(0,Re.join)(M,"node_modules");if(_.existsSync(Y)||_.existsSync(De)){const Ce=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Y}
* ${De}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;Te(V).warn(Ce),console.warn(Ce),process.exit(0)}}const{connectionToken:x,connectionTokenIsMandatory:se}=ke(Z),re=_.existsSync(a.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",Q).fsPath);re&&We&&typeof We!="string"&&console.log(`Web UI available at http://localhost${We.port===80?"":`:${We.port}`}/?tkn=${x}`);const Ee=new we(V,le,x,se,re,te),Fe=await Ee.initialize(),{telemetryService:_e}=Fe;D.mark("code/server/ready");const Me=d.performance.now(),je=global.vscodeServerStartTime,ae=global.vscodeServerListenTime,fe=global.vscodeServerCodeLoadedTime;if(_e.publicLog2("serverStart",{startTime:je,startedTime:ae,codeLoadedTime:fe,readyTime:Me}),Z["print-startup-performance"]){const Y=Ke.LoaderStats.get();let M="";M+=`

### Load AMD-module
`,M+=Ke.LoaderStats.toMarkdownTable(["Module","Duration"],Y.amdLoad),M+=`

### Load commonjs-module
`,M+=Ke.LoaderStats.toMarkdownTable(["Module","Duration"],Y.nodeRequire),M+=`

### Invoke AMD-module factory
`,M+=Ke.LoaderStats.toMarkdownTable(["Module","Duration"],Y.amdInvoke),M+=`

### Invoke commonjs-module
`,M+=Ke.LoaderStats.toMarkdownTable(["Module","Duration"],Y.nodeEval),M+=`Start-up time: ${ae-je}
`,M+=`Code loading time: ${fe-je}
`,M+=`Initialized time: ${Me-je}
`,M+=`
`,console.log(M)}return Ee}e.createServer=Oe;const Te=function(){let We;return function(te){return We||(We=new c.LogService(new oe.SpdLogLogger(Je.RemoteExtensionLogFileName,(0,Re.join)(te.logsPath,`${Je.RemoteExtensionLogFileName}.log`),!0,(0,c.getLogLevel)(te)))),We}}()}),define(me[250],ge([0,1,24,28,8,237,240,57,5,241,69,48]),function(Q,e,S,_,g,k,C,D,d,y,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,A.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=y.performance.now();const E={onMultipleValues:(s,n)=>{console.error(`Option ${s} can only be defined once. Using value ${n}.`)},onUnknownOption:s=>{console.error(`Ignoring option ${s}: not supported for server.`)}},b=(0,D.parseArgs)(process.argv.slice(2),i.serverOptions,E),o=process.env.VSCODE_AGENT_FOLDER||(0,d.join)(S.homedir(),".vscode-remote"),u=(0,d.join)(o,"data"),w=(0,d.join)(u,"User"),p=(0,d.join)(w,"globalStorage"),h=(0,d.join)(u,"Machine");b["user-data-dir"]=u;const f=(0,d.dirname)(g.FileAccess.asFileUri("",Q).fsPath),c=(0,d.join)(f,"extensions");b["builtin-extensions-dir"]=c,b["extensions-dir"]=b["extensions-dir"]||(0,d.join)(o,"extensions"),[o,b["extensions-dir"],u,w,h,p].forEach(s=>{try{_.existsSync(s)||_.mkdirSync(s)}catch(n){console.error(n)}});function a(){(0,k.run)(b,o)}e.spawnCli=a;function t(s){return(0,C.createServer)(s,b,o)}e.createServer=t})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/83bd43bc519d15e50c4272c6cf5c1479df196a4d/core/vs/server/remoteExtensionHostAgent.js.map
